# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

'''
import sys
sys.path.append('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter')
import ArtistArtLoader as al
slentry = al.objectview({'artist':'Michelle','title':'So Sch?n Ist Die Zeit', 'filetype':'RADIODE'})
'''

from os import listdir as os_listdir, remove as os_remove
from os import access as os_access, W_OK as os_W_OK, utime as os_utime
from os.path import join as os_path_join, exists as os_path_exists, getmtime as os_path_getmtime
 
from PIL import Image
from threading import Thread
from ThreadQueue import ThreadQueue
from time import time as time_time
from urllib import quote
from random import randrange as random_randrange, randint as random_randint
from re import findall as re_findall
from difflib import SequenceMatcher
from requests import get as requests_get, codes as requests_codes, Session as requests_Session
from sys import getsizeof as sys_getsizeof 
from SQLConnector import execSQLCommand


try:
	from Globals import MCUSERAGNET
	from myLogger import logger
	from Tools.Directories import createDir
	from Components.config import config
	from enigma import ePythonMessagePump
	
	ENIGMA = True
	
except:

	print 'running outside e2'
	
	MCUSERAGNET = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36'
	
	class objectview(object):
		def __init__(self, d):
			self.__dict__ = d
	config=objectview({'plugins':objectview({'musiccenter':objectview({'downloadcache':objectview({'value':'/hoeck/cache-64gb/MusicCenterCache/'})})})})
	config=objectview({'plugins':objectview({'musiccenter':objectview({'setdebug':objectview({'value':'setdebug'})})})})
		
	class Logger(object):
		def exception(self,l):
			print '{}'.format(l)
		def info(self,l):
			print '{}'.format(l)
		def debug(self,l):
			print '{}'.format(l)			
		def error(self,l):
			print '{}'.format(l)
			
	logger=Logger()
	
	from os import mkdir, makedirs
	def createDir(path, makeParents = False):
		try:
			if makeParents:
				makedirs(path)
			else:
				mkdir(path)
		except:
			ret = 0
		else:
			ret = 1
		return ret

	ENIGMA = False

	
def saveresultOnFile(keyname, content):
	if config.plugins.musiccenter.setdebug.value == 'debug':
		try:
			fn = '/tmp/{}.log'.format(keyname)
			with open(fn, 'wb') as f:
				f.write(content)
		except:
			logger.exception('saveresultOnFile]exception...')
			pass


class ArtistArtLoader(Thread):


	def __init__(self):

		Thread.__init__(self)

		self.__running = False
		self.artistname_fitted=''
		self.current_artist_directory = ''
		self.current_artist_directory_name = ''
		self.artist_download_basedir = os_path_join(config.plugins.musiccenter.downloadcache.value, "artistpics/" )
		self.shazam_artist_image = ''
		self.s = requests_Session()
		self.s.headers.update({'User-Agent': MCUSERAGNET})
		if ENIGMA:
			self.__messages = ThreadQueue()
			self.__messagePump = ePythonMessagePump()


	def __getMessagePump(self):
		return self.__messagePump


	def __getMessageQueue(self):
		return self.__messages


	def __getRunning(self):
		return self.__running


	def Start(self, artist, id, shazam_artist_image = ''):

		if not self.__running:
			
			artist = artist.lower()
			
			if artist == 'n/a':
				self.artistname_fitted = artist
				logger.debug('ArtistArtLoader]Start]no valid artist given, call getDefaultArtistPic')
				
			else:
				for chs in ('feat.', 'feat', 'ft', 'ft.', ';', ',', 'vs', 'vs.', '&'):
					artist = artist.split(chs, 1)[0]
						
				self.artistname_fitted = artist.replace('_',' ').replace('/',' ').replace('|',' ').strip().title()
			self.__running = id
			self.shazam_artist_image = shazam_artist_image
			logger.info('ArtistArtLoader]Start]for artist:{} stripped to:{}'.format(artist, self.artistname_fitted))
			self.start()
			
		else:
			logger.error('ArtistArtLoader]Start]old thread running, skip artist:{}'.format(artist))


	if ENIGMA:
		MessagePump=property(__getMessagePump)
		Message=property(__getMessageQueue)


	isRunning=property(__getRunning)


	def run(self):
		
		if not self.artistname_fitted or self.artistname_fitted == 'n/a':
			logger.debug('ArtistArtLoader]run]no valid artist given, getDefaultArtistPic')
			self.getDefaultArtistPic()
		
		else:
			self.current_artist_directory = os_path_join(self.artist_download_basedir, self.artistname_fitted[:1] + '/', self.artistname_fitted + '/')

			if not os_path_exists(self.current_artist_directory):
				logger.debug('ArtistArtLoader]run]no folder with artistname, create directory and start external ArtistPic search')
				createDir(self.current_artist_directory, makeParents=True)
				self.getTheAudiodb()

			else:
				time_is = time_time()
				if os_path_getmtime(self.current_artist_directory)+60*60*24*7 < time_is: # 1x / Woche
					logger.debug('ArtistArtLoader]run]last search was > 7 days before, start new search')
					os_utime(self.current_artist_directory, (time_is, time_is)) # update timestamp
					self.getTheAudiodb()
				elif self.shazam_artist_image:
					urlliste = [self.shazam_artist_image,]
					self.downloadPiclist(urlliste, dl_limit = 1)
				else:
					if not self.tryPushPicFromFolder():
						logger.debug('ArtistArtLoader]run] Artistdir is empty, get now from default Artist pics')
						self.getDefaultArtistPic()		
					else:
						self.runFinished()


	def getDefaultArtistPic(self):
		#logger.debug('ArtistArtLoader]getDefaultArtistPic]start...')
		self.current_artist_directory_name = self.current_artist_directory
		self.current_artist_directory = os_path_join(self.artist_download_basedir,'Default/')
		if not os_path_exists(self.current_artist_directory):
			logger.debug('ArtistArtLoader]getDefaultArtistPic]create Default folder...')
			createDir(self.current_artist_directory, makeParents=True)

		time_is = time_time()
		if os_path_getmtime(self.current_artist_directory)+60*60*24 < time_is: # 1x / Tag 
			logger.debug('ArtistArtLoader]run]last search was > 7 days before, start new search')
			os_utime(self.current_artist_directory, (time_is, time_is)) # update timestamp			
			self.startGetDefaultArtistPics()
		else:	
			if not self.tryPushPicFromFolder():
				logger.info('ArtistArtLoader]getDefaultArtistPic]no default covers, start assistent')
				self.startGetDefaultArtistPics()
			else:
				self.runFinished()


	def tryPushPicFromFolder(self, message=None, showtime=5):
		#logger.info('ArtistArtLoader]tryPushPicFromFolder]from current_artist_directory:{}'.format(self.current_artist_directory))
		pics_found = [ pic for pic in os_listdir(self.current_artist_directory) if pic.lower().endswith(('.png', '.jpg', '.jpeg')) ]
		if pics_found:
			pic = pics_found[ random_randrange(len(pics_found)) ]
			pic_path = os_path_join(self.current_artist_directory, pic)
			logger.info('ArtistArtLoader]tryPushPicFromFolder]push now pic_path:{}'.format(pic_path))
			try:
				im=Image.open(pic_path)
				self.pushResult(True, self.__running, pic_path, message, showtime)
				return True
			except:
				logger.exception('ArtistArtLoader]tryPushPicFromFolder]exception...')
			
		return False

	
	def getTheAudiodb(self):
	
		url='http://www.theaudiodb.com/api/v1/json/137641636b2d653453323h/search.php?s={}'.format(quote(self.artistname_fitted))
		logger.debug('ArtistArtLoader]getTheAudiodb]url:{}'.format(url))
		urlliste=[]
		if self.shazam_artist_image:
			logger.debug('ArtistArtLoader]getTheAudiodb]add shazam_artist_image:{} to urlliste'.format(self.shazam_artist_image))
			urlliste = [self.shazam_artist_image,]
		
		try:
			result = self.s.get(url, timeout=(2, 4))
			
			if result.status_code==requests_codes.ok:

				result = result.json()
				#logger.debug('ArtistArtLoader]getTheAudiodb]result:{}'.format(result))			
				possible_artists = result.get(u'artists', '')
				strMusicBrainzID = ''
				
				if possible_artists:
				
					possible_artist = possible_artists[0]
					try: strArtist = possible_artist.get('strArtist', '').encode()
					except: strArtist = ''
					try: strArtistAlternate = possible_artist.get('strArtistAlternate', '').encode()
					except: strArtistAlternate = ''
					#logger.debug('ArtistArtLoader]getTheAudiodb]artistforart:{} strArtist:{} strArtistAlternate:{}'.format(self.artistname_fitted, strArtist, strArtistAlternate))
					
					
					if strArtist.lower() == self.artistname_fitted.lower() or strArtistAlternate.lower() == self.artistname_fitted.lower():
					
						artist = possible_artist
						try: strMusicBrainzID = artist.get('strMusicBrainzID', '').encode()
						except: strMusicBrainzID = ''
						#strArtistThumb = artist.get('strArtistThumb', '').encode()
						#strArtistLogo = artist.get('strArtistLogo', '').encode()
						#strArtistClearart = artist.get('strArtistClearart', '').encode()
						#strArtistWideThumb = artist.get('strArtistWideThumb', '').encode()
						strArtistFanart = artist.get('strArtistFanart', '')
						strArtistFanart2 = artist.get('strArtistFanart2', '')
						strArtistFanart3 = artist.get('strArtistFanart3', '')
						#strArtistBanner = artist.get('strArtistBanner', '').encode()
						
						if strArtistFanart:
							urlliste.append(strArtistFanart.encode())
						if strArtistFanart2:
							urlliste.append(strArtistFanart2.encode())
						if strArtistFanart3:
							urlliste.append(strArtistFanart3.encode())
						#if strArtistBanner: # "https://www.theaudiodb.com/images/media/artist/banner/rxwqur1505997311.jpg"
						#	urlliste.append(strArtistBanner)
		
						logger.debug('ArtistArtLoader]getTheAudiodb]strMusicBrainzID:{}, {} urls found'.format(strMusicBrainzID, len(urlliste)))
			
					if strMusicBrainzID:
						#logger.debug('ArtistArtLoader]getTheAudiodb]strMusicBrainzID present, try getFanarttv]...')
						self.getFanarttv(strMusicBrainzID, urlliste)
						return
						
					elif urlliste:
						#logger.debug('ArtistArtLoader]getTheAudiodb]urls found download now...')
						self.downloadPiclist(urlliste)
						return

		except:
			logger.exception('ArtistArtLoader]getTheAudiodb]exception...')

		self.getDefaultArtistPic()


	def getFanarttv(self, strMusicBrainzID, urlliste):
	
		lenurls_the_audiodb = len(urlliste)
		
		url='http://webservice.fanart.tv/v3/music/{}?api_key=4e86e15f0f9bdf88537a252908679822'.format(strMusicBrainzID)
		#url='http://webservice.fanart.tv/v3/music/{}?api_key={}&client_key={}'.format(strMusicBrainzID, api_key, client_key)
		logger.debug('ArtistArtLoader]getFanarttv]url %s' %url)
		
		try:
		
			result = self.s.get(url, timeout=(2, 4))
			
			if result.status_code==requests_codes.ok:

				result = result.json()	
				if result and result.has_key('artistbackground'):
					piclist=result['artistbackground']
					for pic in piclist:
						url=pic[u'url'].encode()
						urlliste.append(url)
						#logger.debug('CoverArtLoader]getFanarttv]found picurl->%s' %url)
			
		except:
			logger.exception('CoverArtLoader]getFanarttv]exception...')
	
		logger.debug('ArtistArtLoader]getFanarttv]found {} pictures'.format(len(urlliste) - lenurls_the_audiodb))
		
		if urlliste:
			self.downloadPiclist(urlliste)			
			return

		self.getDefaultArtistPic()


	def downloadPiclist(self, urlliste, dl_limit = 2):
		
		len_urlliste = len(urlliste)
		if len_urlliste <= dl_limit:
			len_dllist = len_urlliste
		else:
			len_dllist = dl_limit

		logger.debug('ArtistArtLoader]downloadPiclist]{} Pictures found, try now to download {} Pictures to directory:{}'.format(len_urlliste, len_dllist, self.current_artist_directory))
		
		#s = requests_Session()
		#s.auth = ('user', 'pass')
		#s.headers.update({'User-Agent': MCUSERAGNET})
		starting = True
		dl_counter = 0
		
		try:
		
			for url in urlliste:
			
				if dl_counter > dl_limit:
					#logger.debug('ArtistArtLoader]downloadPiclist]dl_counter linit:{} reached break'.format(dl_counter))			
					break
				
				picname=url.rsplit('/',1)[1]
				pic_path=os_path_join(self.current_artist_directory, picname)
				
				if os_path_exists(pic_path):
					#logger.debug('ArtistArtLoader]downloadPiclist]skip:{}'.format(pic_path))
					if starting:
						if self.tryPushPicFromFolder():
							starting = False
					continue
					
				result = self.s.get(url, stream=True)
				
				if result.status_code == requests_codes.ok:
								
					with open(pic_path, 'wb') as fd:
						for chunk in result.iter_content(chunk_size=128):
							fd.write(chunk)		
							
					#logger.debug('ArtistArtLoader]downloadPiclist]loaded url:%s' %(url))
					dl_counter +=1
					
					if starting:
						if self.tryPushPicFromFolder():
							starting = False
			
		except:
			logger.exception('ArtistArtLoader]getFanarttv]exception...')
			
			self.tryPushPicFromFolder()

		self.runFinished()
	

	def startGetDefaultArtistPics(self):
	
		urlliste = []
		url='''https://pixabay.com/api/?key=9368280-566404fc1952dad60c6fc4729&q=music%20instrument&per_page=200&orientation=horizontal'''
		logger.debug('ArtistArtLoader]startGetDefaultArtistPics]url %s' %url)
		headers = {'User-Agent': MCUSERAGNET}
		result = requests_get(url, headers = headers, timeout=(2, 4))
		
		if result.status_code==requests_codes.ok:
			res = result.json()	
			for entry_dict in res.get('hits',[]):
				urlliste.append(entry_dict.get('fullHDURL', '').encode())
						
		if urlliste:
			self.downloadPiclist(urlliste, dl_limit = 5)
		else:
			self.tryPushPicFromFolder()


	def pushResult(self, status, id, pic_path, message = None, showtime=5):
		if ENIGMA:
			self.__messages.push((status, id, pic_path, self.current_artist_directory, self.current_artist_directory_name, message, showtime))
			self.__messagePump.send(0)
		else:
			print 'Status:{} pic_path:{} current_artist_directory:{} current_artist_directory_name:{} message:{}'.format(True, id, pic_path, self.current_artist_directory, self.current_artist_directory_name, message)

			
	def runFinished(self):
		Thread.__init__(self)
		self.artistname_fitted=''
		self.current_artist_directory = ''
		self.current_artist_directory_name = ''
		self.shazam_artist_image = ''
		self.__running = False



def buildCoverfilename(artist, title, album, albumartist, cleannames=True):

	#logger.info('buildCoverfilename]artist->%s title->%s album->%s albumartist->%s' %(artist,title,album,albumartist))
	
	nogos=('','n/a','n a','n_a', 'soundcloud')
	
	if cleannames:
		albumartist=cleanName(albumartist)
		artist=cleanName(artist)
		album=cleanName(album)
		title=cleanName(title)
		
	trysampler=False
	
	if album.lower() not in nogos and albumartist.lower() not in nogos:
		nameforcoverfile=album.lower() + " " + albumartist.lower()
		trysampler=True
		if albumartist.lower() in ('sampler' 'various' 'artists' 'va' 'diverse'):
			nameforcoverfile=album.lower()
			trysampler=False
			
	elif album.lower() not in nogos and artist.lower() not in nogos:
		nameforcoverfile=album.lower() + " " + artist.lower()
		trysampler=True
		
	elif artist.lower() not in nogos and title.lower() not in nogos :
		nameforcoverfile=artist.lower() + " " + title.lower()
		
	elif title.lower() not in nogos:
	
		titlelist=list(title)
		
		if not titlelist:
			logger.error('buildCoverfilename]bad! Why nothing in title?')
			nameforcoverfile=''
			
		else:
			while titlelist:
				i=titlelist[0]
				if not i.isdigit() and i not in ('',' ','-','_'):
					break
				else:
					titlelist.pop(0)
					
			if titlelist:
				nameforcoverfile=''.join(titlelist).strip().rsplit('.',1)[0].lower()
			else:
				nameforcoverfile=''
				
	else:
		nameforcoverfile=''
		logger.error('buildCoverfilename]bad! Why nothing in title?')

	#logger.info('buildCoverfilename]->%s' %nameforcoverfile)

	return (nameforcoverfile, trysampler)


def buildCoverpath(folder, nameforcoverfile):
	fndir=os_path_join(folder, nameforcoverfile[0:1]+'/')
	#logger.info('buildCoverpath]dir is ' + fndir)
	if not os_path_exists(fndir):
		logger.info('buildCoverpath]directory no exist, create now->%s' %fndir)
		if not createDir(fndir, makeParents=True):
			logger.error('buildCoverpath] Error use /tmp/mc/')
			fndir="/tmp/mc/"
			
	return os_path_join(fndir, nameforcoverfile)


def cleanName(name):# fit all other names
	chars_to_remove = ['.', '!', '?', '_', '/', ':', '.', '*', '+', '-', '|', '!', '%', '&', '`', '=', '$', '§','#', '\\','{','}','[',']','(',')','>']
	for ch in chars_to_remove:
		if ch in name:
			name = name.replace(ch,' ')
	return ' '.join(name.split())




class CoverArtLoader(Thread):

	def __init__(self):

		Thread.__init__(self)

		self.__running = False
		self.name_for_coverfile=''
		self.current_cover_filename = ''
		self.cover_download_dir=os_path_join(config.plugins.musiccenter.downloadcache.value, "covers/" )
		self.__slentry = ''
		self.__shazamimage = ''
		self.s = requests_Session()
		self.s.headers.update({'User-Agent': MCUSERAGNET})
		
		if ENIGMA:
			self.__messages = ThreadQueue()
			self.__messagePump = ePythonMessagePump()


	def __getMessagePump(self):
		return self.__messagePump


	def __getMessageQueue(self):
		return self.__messages


	def __getRunning(self):
		return self.__running


	def Start(self, slentry, shazamimage):
	
		if not self.__running:
			self.__running = True
			logger.info('CoverArtLoader]Start] artist:{} title:{} album:{} albumartist:{}'.format(slentry.artist, slentry.title, slentry.album, slentry.albumartist))
			self.__slentry = slentry
			self.__shazamimage = shazamimage
			self.start()
			
		else:
			logger.error('CoverArtLoader]Start]old thread running, skip...')


	if ENIGMA:
		MessagePump=property(__getMessagePump)
		Message=property(__getMessageQueue)
	isRunning=property(__getRunning)


	def run(self):

		self.name_for_coverfile, trysampler = buildCoverfilename(self.__slentry.artist, self.__slentry.title, self.__slentry.album, self.__slentry.albumartist, cleannames=True)
		logger.info('CoverArtLoader]run]stripped to:{}'.format(self.name_for_coverfile))
		
		if not self.name_for_coverfile:
			logger.debug('CoverArtLoader]getLocalCover]no self.name_for_coverfile given, show no cover')
			self.pushResult(False, message = 'no valid searchterm given')
			
		else:
			self.current_cover_filename = buildCoverpath(self.cover_download_dir, self.name_for_coverfile)
			if os_path_exists(self.current_cover_filename):
				logger.debug('CoverArtLoader]getLocalCover]coverfile found:{}'.format(self.current_cover_filename))
				self.pushResult(True, message = 'local cover')
			else:
				if self.__shazamimage:
					logger.debug('CoverArtLoader]run]shazamimage found, download...')
					self.downloadPiclist([self.__shazamimage,], message = 'Shazam Cover')
				else:			
					self.getCoverFromGoogle(self.name_for_coverfile)


	def getCoverFromGoogle(self, searchterm):
	
		url='https://www.google.de/search?q=%s+-youtube&tbm=isch&source=lnt&tbs=isz:ex,iszw:500,iszh:500' %quote(searchterm)
		logger.info('CoverArtLoader]getCoverFromGoogle]url:{}'.format(url))
		
		urlliste=[]
		
		try:	
			result = self.s.get(url, timeout=(2, 4))# headers = headers,
			#result = requests_get(url, headers = headers, timeout=(2, 4))
			if result.status_code==requests_codes.ok:

				imageurls=re_findall(',"ou":"(.+?)","ow"',result.text) # new on 08.02.2017 urlsraw=re_findall('imgres\?imgurl.+?&amp;imgrefurl',result)
				logger.debug('CoverArtLoader]getCoverFromGoogle]imageurls:{}'.format(imageurls[:3]))			
				
				if imageurls:
						self.downloadPiclist(imageurls[:8], dl_limit = 1)
				else:
					'''
					logger.error('CoverArtLoader]getCoverFromGoogle]->No images found., try to short searchterm')
					if '(' in searchterm:
						searchterm=searchterm.rsplit('(',1)[0]
						self.buildImageSearchUrl(searchterm)
					elif '[' in searchterm:
						searchterm=searchterm.rsplit('[',1)[0]
						self.buildImageSearchUrl(searchterm)
					elif '{' in searchterm:
						searchterm=searchterm.rsplit('{',1)[0]
						self.buildImageSearchUrl(searchterm)
					elif '-' in searchterm:
						searchterm=searchterm.rsplit('-',1)[0]
						self.buildImageSearchUrl(searchterm)
					else:
					'''
					logger.error('CoverArtLoader]getCoverFromGoogle]show no cover')
					self.pushResult(False, message = 'No images found')

		except:
			logger.exception('CoverArtLoader]getCoverFromGoogle]exception...')
			self.pushResult(False, message = 'error...')


	def downloadPiclist(self, urlliste, dl_limit = 1,  message = 'Google Cover'):

		logger.debug('CoverArtLoader]downloadPiclist] {} Pics found, try to download now up to limit {} to current_cover_filename:{}'.format(len(urlliste), dl_limit, self.current_cover_filename))
		
		#s.auth = ('user', 'pass')
		starting = True
		dl_counter = 0
		status = False
		
		for url in urlliste:
		
			
			if dl_counter >= dl_limit:
				logger.debug('CoverArtLoader]downloadPiclist]dl_counter linit:{} reached break'.format(dl_counter))			
				break
	
			#logger.debug('CoverArtLoader]downloadPiclist]try url:{}'.format(url))
			try:
				result = self.s.get(url, timeout=(2, 4), stream=True)
				
				if result.status_code == requests_codes.ok:
								
					with open(self.current_cover_filename, 'wb') as fd:
						for chunk in result.iter_content(chunk_size=128):
							fd.write(chunk)		
							
					#logger.debug('CoverArtLoader]downloadPiclist]loaded url:{}'.format(url))
					dl_counter +=1
					status = True
				else:
					logger.error('CoverArtLoader]downloadPiclist]error url:{} result.status_code:{}'.format(url, result.status_code))
					
			except:
				logger.exception('CoverArtLoader]downloadPiclist]error!!!')
				status = False
		
		
		self.pushResult(status, message)
	

	def pushResult(self, status, message = None):
	
		if ENIGMA:
			self.__messages.push((status, self.__slentry, self.current_cover_filename, message))
			self.__messagePump.send(0)
		else:
			print 'Status:{} pic_path:{} current_artist_directory:{} message:{}'.format(status, self.__slentry, self.current_cover_filename, message)

		self.runFinished()

		
	def runFinished(self):
		Thread.__init__(self)
		self.__running = False
		self.__slentry = ''
		self.__shazamimage = ''
		#logger.info('CoverArtLoader]runFinished]done')


def get_size(obj, seen=None):
    """Recursively finds size of objects"""
    size = sys_getsizeof(obj)
    if seen is None:
        seen = set()
    obj_id = id(obj)
    if obj_id in seen:
        return 0
    # Important mark as seen *before* entering recursion to gracefully handle
    # self-referential objects
    seen.add(obj_id)
    if isinstance(obj, dict):
        size += sum([get_size(v, seen) for v in obj.values()])
        size += sum([get_size(k, seen) for k in obj.keys()])
    elif hasattr(obj, '__dict__'):
        size += get_size(obj.__dict__, seen)
    elif hasattr(obj, '__iter__') and not isinstance(obj, (str, bytes, bytearray)):
        size += sum([get_size(i, seen) for i in obj])
    return size


class ShazamResolver(Thread):

	def __init__(self):

		Thread.__init__(self)

		self.__running=False
		self.canceled=False
		self.__reload = False
		self.__slentry=''
		self.shazam_possible_tracks = []
		self.__cache={}
		self.s = requests_Session()
		self.s.headers.update({'User-Agent': MCUSERAGNET})
			
		if ENIGMA:
			self.__messages=ThreadQueue()
			self.__messagePump=ePythonMessagePump()


	def cancel(self, reason='no reason?'):
		logger.info('ShazamResolver]cancel]with {}'.format(reason))	
		self.canceled = reason

		
	def __getMessagePump(self):
		return self.__messagePump


	def __getMessageQueue(self):
		return self.__messages


	def __getRunning(self):
		return self.__running


	def Start(self, slentry, type='title', reload = False):
		
		if not self.__running:	
			logger.info('ShazamResolver]Start]for type:{} :artist:{} title:{} cachesize:{}'.format(type, slentry.artist, slentry.title, get_size(self.__cache)))
			self.__slentry = slentry
			self.__type = type
			self.__reload = reload
			self.start()
		else:
			logger.error('ShazamResolver]Start]old thread is running, skip artist:{} title:{}'.format(slentry.artist, slentry.title))


	if ENIGMA:
		MessagePump=property(__getMessagePump)
		Message=property(__getMessageQueue)
	isRunning=property(__getRunning)


	def run(self):
	
		self.__running=True
		cachename = '{}{}{}'.format(self.__type, self.__slentry.artist, self.__slentry.title)

		try:
			cache=self.__cache.get(cachename, None)			
			logger.info('ShazamResolver]run]is cache:{} | search for artist:{} title:{}'.format(cache, self.__slentry.artist, self.__slentry.title))
			
			if self.__reload and cache:
				logger.info('ShazamResolver]run]is reload, start new search for artist:{} title:{}'.format(self.__slentry.artist, self.__slentry.title))
				cache = None
			
			if cache:
			
				iscache='push from cache'
				ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image = cache
				
			else:
				iscache='push from resolver'
				
				if self.__type == 'title':
					ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image = self.getTitle(self.__slentry)
				elif self.__type == 'artist':
					ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image = self.getArtist(self.__slentry)
				else:
					logger.error('ShazamResolver]run]no valid searchtype:{}'.format(self.__type))
					self.__messages.push((False, self.__slentry, self.__type))
					self.__messagePump.send(0)
				if not self.canceled:	
					self.__cache[cachename] = (ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image)
				
				if config.plugins.musiccenter.setdebug.value == 'debug':
					self.writeResultTologfile(ratio, self.__slentry.artist, self.__slentry.title, shazam_artist_text, shazam_title_text)

			logger.info('ShazamResolver]run]{} -> status:{} slentry:{} shazam_artist_ID:{} shazam_title_ID:{} shazam_artist_text:{} shazam_title_text:{} shazam_title_image:{} shazam_artist_image:{} ratio:{}'.format(iscache, True, self.__slentry.artist+' '+self.__slentry.title, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_title_image, shazam_artist_image, ratio))
			
			if ENIGMA:
				self.__messages.push((True, self.__slentry, self.__type, ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image))
				self.__messagePump.send(0)

		except Exception, e:
			logger.exception('ShazamResolver]run]error:{}'.format(e))
			if ENIGMA:
				self.__messages.push((False, self.__slentry, self.__type))
				self.__messagePump.send(0)

		finally:
			Thread.__init__(self)
			self.canceled=False
			self.__slentry=''
			self.__running=False
			self.__reload = False
			self.shazam_possible_tracks = []
			logger.debug('ShazamResolver]run]done')


	def getTitle(self, slentry):
	
		self.shazam_possible_tracks=[]
		offset = 0
		match=False
		ratio = shazam_artist_ID = shazam_title_ID = shazam_artist_text = shazam_title_text = shazam_artist_image = shazam_title_image = ''
		ratio_positiv_tracks=[]

		while offset<20 and not match and not self.canceled:
		
			if slentry.artist == 'n/a':
				slentry.artist = ''

			slentry_removedunneededwords_artist = self.removeUnneededWords(slentry.artist)
			slentry_removedunneededwords_title = self.removeUnneededWords(slentry.title)
			countstoshow = random_randint(2, 6)
			url='''https://cdn.shazam.com/discovery/v2/de/DE/web/-/search/track?searchQuery={}%20{}&pageSize={}&startFrom={}'''.format(quote(slentry_removedunneededwords_artist), quote(slentry_removedunneededwords_title), countstoshow, offset)
			
			if offset == 0:
				logger.debug('ShazamResolver]getTitle]{}'.format(url))
				
			offset+=countstoshow

			resultraw = self.s.get(url, timeout=(2, 4))
			
			if resultraw.status_code == 200 and not self.canceled:

				result = resultraw.json()
				#logger.debug('ShazamResolver]getTitle]{}'.format(result))
				try:
					if result.has_key(u'tracks') and result[u'tracks'].has_key(u'hits'):
						shazam_possible_tracks = result[u'tracks'][u'hits']

						if result.has_key('topresult') and result['topresult'].has_key('track'):
							shazam_possible_tracks.append(result['topresult']['track'])
							logger.debug('ShazamResolver]getTitle]add topresult')
			
						sl_title_string='{} {}'.format(slentry_removedunneededwords_artist, slentry_removedunneededwords_title)
						sl_title_string = sl_title_string.split()
						sl_title_string.sort()
						sl_title_string = ' '.join(sl_title_string)
						
						for track in shazam_possible_tracks:
						
							if not self.canceled:
							
								shazam_title_string = '{} {}'.format(track['heading']['subtitle'], track['heading']['title'])
								shazam_removeunneededwords_title_string = self.removeUnneededWords(shazam_title_string)
								shazam_removeunneededwords_title_string = shazam_removeunneededwords_title_string.split()
								shazam_removeunneededwords_title_string.sort()
								shazam_removeunneededwords_title_string = ' '.join(shazam_removeunneededwords_title_string)
								
								ratio_title = SequenceMatcher(None, sl_title_string, shazam_removeunneededwords_title_string).ratio()
								logger.debug('ShazamResolver]getTitle]ratio:{} ->titlestr:{} <->shazamstr:{}'.format(round(ratio_title,2),  sl_title_string, shazam_removeunneededwords_title_string))

								if ratio_title>0.96:
									ratio_positiv_tracks.append((ratio_title, track))
									logger.info('ShazamResolver]getTitle]match found, break search add shazam_track_id to song_id on songs')
									match = True
									break

								elif ratio_title>0.86:
									logger.debug('ShazamResolver]getTitle]ratio >87% add to ratio_positiv_tracks')
									ratio_positiv_tracks.append((ratio_title, track))
									
								self.shazam_possible_tracks.append((ratio_title, track))
								
							else:
								break
					else:
						logger.error('ShazamResolver]getTitle]no valid result, save to file!!!')
						saveresultOnFile('shazam_search_{}-{}'.format(slentry.artist, slentry.title), resultraw.text)
								
				except:
					logger.exception('ShazamResolver]getTitle]exception, save result to file!!!')
					saveresultOnFile('shazam_search_{}-{}'.format(slentry.artist, slentry.title), resultraw.text)
			else:
				logger.debug('ShazamResolver]getTitle]canceled:{} or error code:{}'.format(self.canceled, resultraw.status_code))

		ratio='not'
		if ratio_positiv_tracks and not self.canceled:
			logger.info('ShazamResolver]getTitle]ratio_positiv_tracks found, sort now...')
			ratio_positiv_tracks.sort(key = lambda a:a[0], reverse = True)
			ratio, track = ratio_positiv_tracks[0]

			# title
			shazam_title_ID = track[u'key']
			shazam_title_text = track[u'heading'][u'title']
			if track.has_key('images') and track[u'images'].has_key('default'):
				shazam_title_image = track[u'images'][u'default']
			else:
				logger.error('ShazamResolver]getTitle]resolve image no keys images and default on:{}'.format(track))
			shazam_artist_text = track[u'heading'][u'subtitle']

			logger.debug('ShazamResolver]getTitle]use ratio:{} title:{}'.format(ratio_positiv_tracks[0][0], shazam_title_text))
			logger.debug('ShazamResolver]getTitle]artist found:alias:{}'.format(shazam_artist_text))

			if track.has_key('artists'):
			
				shazam_artist_ID = track[u'artists'][0][u'follow'][u'followkey']
				#shazam_artist_text = track[u'artists'][0][u'alias']

				if slentry.filetype not in ('RADIOBROWSER','RADIODE') and str(slentry.shazamtitleID)=='-1':
					self.addShazamIdOnArtistsTable(slentry, shazam_artist_ID)

			if track.has_key('share') and track[u'share'].has_key('avatar'):
				shazam_artist_image = track[u'share'][u'avatar']

			if slentry.filetype not in ('RADIOBROWSER','RADIODE'):
				self.addShazamIdOnSongsTable(slentry, shazam_title_ID)
		
		#else:
			#ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image = self.getTitleAlternative()
			
		return ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image


	def getTitleAlternative(self):

		ratio = shazam_artist_ID = shazam_title_ID = shazam_artist_text = shazam_title_text = shazam_title_image = shazam_artist_image = ''
		
		if self.shazam_possible_tracks and not self.canceled:
		
			logger.info('ShazamResolver]getTitleAlternative]shazam_possible_track found, sort now...')
			self.shazam_possible_tracks.sort(key = lambda a:a[0], reverse = True)
			ratio, track = self.shazam_possible_tracks[0]
			
			if ratio > 0.7:
				ratio = 'alternative_{}'.format(ratio)
				
				# title
				shazam_title_ID = track[u'key']
				shazam_title_text = track[u'heading'][u'title']
				if track.has_key('images') and track[u'images'].has_key('default'):
					shazam_title_image = track[u'images'][u'default']
				else:
					logger.error('ShazamResolver]getTitleAlternative]get image:{}'.format(track))
				shazam_artist_text = track[u'heading'][u'subtitle']

				logger.debug('ShazamResolver]getTitleAlternative]use ratio:{} title:{}'.format(ratio, shazam_title_text))
				logger.debug('ShazamResolver]getTitleAlternative]artist found:alias:{}'.format(shazam_artist_text))

				if track.has_key('artists'):
				
					shazam_artist_ID = track[u'artists'][0][u'follow'][u'followkey']

				if track.has_key('share') and track[u'share'].has_key('avatar'):
					shazam_artist_image = track[u'share'][u'avatar']
			
		return ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image
	

	def getArtist(self, slentry):
	
		#self.shazam_possible_artists=[]
		offset = 0
		match=False
		shazam_artist_ID = shazam_title_ID = shazam_artist_text = shazam_title_text = shazam_title_image = shazam_artist_image = ''
		ratio_positiv_artists=[]

		while offset<20 and not match and not self.canceled:
		
			if slentry.artist=='n/a':
				slentry.artist=''
				
			sl_artist_string = slentry.artist.lower()
			
			url = '''https://cdn.shazam.com/discovery/v2/de/DE/web/-/search/artist?searchQuery={}&pageSize=3&startFrom={}'''.format(quote(sl_artist_string), offset)			
			offset+=3
			logger.debug('ShazamResolver]getArtist]{}'.format(url))
			
			result = self.s.get(url, timeout=(2, 4))
			
			if result.status_code==requests_codes.ok and not self.canceled:

				result = result.json()
				#logger.debug('ShazamResolver]getArtist]{}'.format(result))
				try:
					sl_artist_string = sl_artist_string.split()
					sl_artist_string.sort()
					sl_artist_string = ' '.join(sl_artist_string)
					
					for artist in result [u'artists'][u'hits']:
					
						if not self.canceled:
						
							shazam_artist_string = artist['name'].lower()
							shazam_artist_string = shazam_artist_string.split()
							shazam_artist_string.sort()
							shazam_artist_string = ' '.join(shazam_artist_string)
							
							ratio_title = SequenceMatcher(None, sl_artist_string, shazam_artist_string).ratio()
							logger.debug('ShazamResolver]getArtist]ratio:{} ->artist:{} <->shazam:{}'.format(round(ratio_title,2), sl_artist_string, shazam_artist_string))

							if ratio_title>0.96:
								ratio_positiv_artists.append((ratio_title, artist))
								logger.info('ShazamResolver]getArtist]match found, break search add shazam_artist_id to artist_id on artists')
								match = True
								break

							elif ratio_title>0.86:
								logger.debug('ShazamResolver]getArtist]ratio >86% add to ratio_positiv_artists')
								ratio_positiv_artists.append((ratio_title, artist))								
				except:
					logger.exception('ShazamResolver]getArtist]...:')
			else:
				logger.debug('ShazamResolver]getArtist]error code:{}'.format(result.status_code))

		ratio='not'
		if ratio_positiv_artists and not self.canceled:
			logger.info('ShazamResolver]getArtist]ratio_positiv_artists found, sort now...')
			ratio_positiv_artists.sort(key = lambda a:a[0], reverse = True)
			ratio, artist = ratio_positiv_artists[0]
		
			shazam_artist_ID = artist[u'follow'][u'followkey']
			shazam_artist_text = artist[u'name']

			if slentry.filetype not in ('RADIOBROWSER','RADIODE'):
				self.addShazamIdOnArtistsTable(slentry, shazam_artist_ID)

			if artist.has_key('avatar') and artist[u'avatar'].has_key('default'):
				shazam_artist_image = artist[u'avatar']['default']

			#if slentry.filetype not in ('RADIOBROWSER','RADIODE'):
			#	self.addShazamIdOnSongsTable(slentry, shazam_title_ID)
		
		#else:
			#ratio, shazam_artist_ID, shazam_artist_text, shazam_artist_image = self.getTitleAlternative()
			
		return ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image


		
	def removeUnneededWords(self, words):
				
		def removeChars(word):
			result=''
			outsorted=''
			for char in word.lower():
				if char.isalpha() or char.isdigit():
					result+=char
				else:
					outsorted+=char
			#if outsorted:
			#	logger.debug('ShazamResolver]removeUnneededChars]removeChars:outsorted->{}'.format(outsorted))
			return result
		
		newwords=[]
		for word in words.split():
			word=removeChars(word.lower())
			if word not in('feat','ft', 'vs', 'aka', 'mit', 'with', 'und', 'and'):
				newwords.append(word.lower())
			#else:
			#	logger.debug ('ShazamResolver]removeUnneededWords]outsorted:{}'.format(word))
		newwords=' '.join((newwords))
		#logger.debug ('ShazamResolver]removeUnneededWords]{} -> {}'.format(words, newwords))
		return newwords


	def addShazamIdOnArtistsTable(self, slentry,  artist_followkey):
		logger.debug('ShazamResolver]addShazamIdOnArtistsTable]artist:{} shazam_id:{}'.format(slentry.artist, artist_followkey))
		sql='''UPDATE Artists SET shazam_id=? WHERE artist_text=?;'''
		args=(artist_followkey, slentry.artist)
		execSQLCommand(sql,args)


	def addShazamIdOnSongsTable(self, slentry,  shazam_title_ID):
		logger.debug('ShazamResolver]addShazamIdOnSongsTable]songID:{} shazam_title_ID:{}'.format(slentry.songID, shazam_title_ID))
		sql='''UPDATE Songs SET shazam_id=? WHERE song_id=?;'''
		args=(shazam_title_ID, slentry.songID)
		execSQLCommand(sql,args)


	def removeShazamIdFromSongsTable(self, slentry):
		logger.debug('ShazamResolver]removeShazamIdFromSongsTable]songID:{}'.format(slentry.songID))
		sql='''UPDATE Songs SET shazam_id='-1' WHERE song_id=?;'''
		args=(slentry.songID,)
		execSQLCommand(sql,args)

		
	def removeShazamIdFromArtistTable(self, slentry):
		logger.debug('ShazamResolver]addShazamIdOnArtistsTable]artist:{}'.format(slentry.artist))
		sql='''UPDATE Artists SET shazam_id='-1' WHERE artist_text=?;'''
		args=(slentry.artist,)
		execSQLCommand(sql,args)


	def writeResultTologfile(self, ratio, artist, title, shazam_artist_text, shazam_title_text):
		if ratio!='not':
			fn='/var/log/shazamsearches_pos.txt'
		else:
			fn='/var/log/shazamsearches_neg.txt'

		with open (fn, 'ab') as f:
			entry='{} -> {} | {} <-> {} | {}'.format(ratio, artist, title, shazam_artist_text, shazam_title_text)
			f.write(entry+'\n')

