# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.


		
from __future__ import print_function
from sys import getsizeof, stderr
from itertools import chain
from collections import deque
try:
    from reprlib import repr
except ImportError:
    pass

from Globals import *

# local plugin
from JobCenter import *
from JobCenter2 import *						
from myLogger import logger
from ItemClasses import *
from SelectPath import SelectPath
import Player
from Setup import MusicCenterSetup
from TaskViewScreen import MusicCenterTasksScreen

'''
# in global moved...
def save_obj(obj, filename):
    with open(filename, 'wb') as f:
        pickle.dump(obj, f)

def load_obj(filename):
    with open(filename, 'rb') as f:
        return pickle.load(f)
'''
class DatabaseBrowser(Screen, ConfigListScreen):

	skin='''
		<screen name="DatabaseBrowser" position="0,0" size="1920,1080" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
		<!-- Header -->
			<eLabel backgroundColor="#191919" position="20,20" size="1900,100" zPosition="1" /> 
			<widget name="headertext" position="140,39" size="1760,42" font="SansReg;35" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
			<ePixmap position="20,20" size="100,100" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/music.png" scale="1" zPosition="2"/>
		<!-- Buttons -->
			<eLabel position="20,135" size="1900,50" backgroundColor="#191919" zPosition="1" /> 
			<widget render="Label" font="SansReg;36" position="30,145" size="40,36" source="key_arrow_left" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
			<widget render="Label" font="SansReg;30" position="100,145" size="450,34" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
			<widget render="Label" font="SansReg;30" position="510,145" size="450,34" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
			<widget render="Label" font="SansReg;30" position="960,145" size="450,34" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
			<widget render="Label" font="SansReg;30" position="1410,145" size="450,34" source="key_blue" foregroundColor="#0026FF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>	
			<widget render="Label" font="SansReg;30" position="1870,145" size="40,36" source="key_arrow_right" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
		<!-- lists -->
			<widget name="config" position="150,180" zPosition="-2" size="1620,68" itemHeight="55" scrollbarMode="showNever" transparent="1"/>
			<widget name="list" position="75,195" zPosition="1" size="1770,855" scrollbarMode="showOnDemand" backgroundColor="#00000000"/>
		</screen>'''

	def __init__(self, session, player, startwithplaylist, currentService, serviceList):

		logger.info('DatabaseBrowser]init...')
		self.session=session
		self.currentService=currentService
		self.serviceList=serviceList
		self.skin_path='/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images'
		
		Screen.__init__(self, session)
		
		config.plugins.musiccenter.db_search =  NoSave(ConfigText(default = '', fixed_size = False))
		self.config = [] 
		self.config.append(getConfigListEntry(_("Enter Searchword here"), config.plugins.musiccenter.db_search))
		self['config'] = self.config
		ConfigListScreen.__init__(self, self.config, session)
		
		self['list']=DatabaseBrowserList([])
		# ,'MediaPlayerActions' 
		self["actions"]=ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions", "InfobarAudioSelectionActions"],
		{
			"ok": self.ok,
			"back": self.closing,
			"red": self.redPressed,
			"green": self.greenPressed,
			"yellow": self.yellowPressed,
			"blue": self.bluePressed,
			"input_date_time": self.menuPressed,
			"info" : self.infoPressed,
			"audioSelection": self.audioPressed,
			"nextBouquet": self.upBouquet,
			"prevBouquet": self.downBouquet,
			"prevService": self.arrowLeft,
			"nextService": self.arrowRight,
		}, -1)

		self["actions2"]=NumberActionMap(["InputActions"],
		{
			"0": self.keyNumberPressed,
		}, -1)
		#	"left": self.left,
		#	"right": self.right,
		#	"up": self.up,
		#	"down": self.down,		
		
		
		# search suggestion
		self["config_actions"] = NumberActionMap(["SetupActions", "InputAsciiActions", "KeyboardInputActions", "WizardActions"],
		{
			"gotAsciiCode": self.keyGotAscii,
			"ok": self.keyOK,
			"up": self.up,
			"down": self.down,
			"left": self.keyLeft,
			"right": self.keyRight,
			"home": self.keyHome,
			"end": self.keyEnd,
			"deleteForward": self.keyDelete,
			"deleteBackward": self.keyBackspace,
			"toggleOverwrite": self.keyToggleOW,
			"1": self.keyNumberGlobal,
			"2": self.keyNumberGlobal,
			"3": self.keyNumberGlobal,
			"4": self.keyNumberGlobal,
			"5": self.keyNumberGlobal,
			"6": self.keyNumberGlobal,
			"7": self.keyNumberGlobal,
			"8": self.keyNumberGlobal,
			"9": self.keyNumberGlobal,
			"0": self.keyNumberGlobal
		}, -1) # to prevent left/right overriding the listbox

		self.onLayoutFinish.append(self.startRun)
		self.onClose.append(self.__onClose)

		self.player=player
		self.favoriteList=[]
		self.mode='buildMainMenuListDB'
		self.cacheList=[]
		self.LastMethod=None
		self.lastplaylist=None
		self.hlp={}
		self.con=OpenDatabase()
		
		self["key_arrow_left"]=StaticText("<")
		self["key_red"]=StaticText("")
		self["key_green"]=StaticText("")
		self["key_yellow"]=StaticText("")
		self["key_blue"]=StaticText("")
		self["key_arrow_right"]=StaticText(">")
		self.keyslocked=True
		
		self['headertext']=BlinkingLabel()
		
		self.startwithplaylist=startwithplaylist
		self.suggestlen=0
		self.suggestword=''
		self.searchvalueTimer=eTimer()
		self.searchvalueTimer_mc_conn=self.searchvalueTimer.timeout.connect(self.searchvalueTimerAppend)
		self.suggestionsThread_mc_conn=suggestionsThread.MessagePump.recv_msg.connect(self.suggestionsThreadgotThreadMsg)
		
		self.headerpos=0
		self.headertextlist=[]
		self.cacheSql={}
		self.jukeboxfavoriten=[]	
		if fileExists(resolveFilename(SCOPE_CONFIG ,"mc_jukeboxfavoriten")):
			self.jukeboxfavoriten=load_obj(resolveFilename(SCOPE_CONFIG ,"mc_jukeboxfavoriten"))
			
	def startRun(self):
		logger.info('DatabaseBrowser]startRun]')
		self["config"].hide()
		self["actions"].setEnabled(True)
		self["actions2"].setEnabled(True)
		self["config_actions"].setEnabled(False)
		current = self["config"].getCurrent()
		if current[1].help_window.instance is not None:
			current[1].help_window.instance.hide()
		self['list'].selectionEnabled(1)
		if self.startwithplaylist:
			self['list'].setMode('buildPlaylistList')
			self.buildPlaylistList(False, False)
		else:
			#self.refreshMainmenulistDB()
			self['list'].setMode(self.mode)
			self.buildMainMenuListDB()

	def buildMainMenuListDB(self):
		self.getStatistiken()		
		if self.hlp.get('splitListview2', False):
			self.switchListView2()

		self.headertextlist=['Jukebox starten', 'Knstler browsen','Alben browsen', 'Songs browsen', 'Genres browsen', 'Jahre browsen', 'nach Sterne browsen', 'nach Playcounts browsen', 'Suche']
		self['headertext'].startBlinking()
		header='Willkommen in Deiner Musikdatenbank. Bitte warten, sammle Statistiken...'
		self.setListNow(list=[], header=header, stopBlinking=False, red=self.headertextlist[0], green=self.headertextlist[1], yellow=self.headertextlist[2], blue=self.headertextlist[3])
	
	def getStatistiken(self):
		t=SimpleThread(lambda:self.getDatabeseStatsOnThread())
		t.deferred.addCallback(self.buildMainMenuListDBCallback,)
		t.deferred.addErrback(self.errorMainMenu,)
		t.start()

	def getDatabeseStatsOnThread(self):
		logger.info('DatabaseBrowser]getDatabeseStatsOnThread]start')
		sql='''SELECT * FROM table_entry_counts;'''		
		res=self.execSQLCommandWithReturnCached(sql, threaded=True)
		logger.info('DatabaseBrowser]getDatabeseStatsOnThread]end')
		return res[0]
		
	def buildMainMenuListDBCallback(self, res):
		self.keyslocked=False
		logger.info('DatabaseBrowser]buildMainMenuListDBCallback]->%s' %str(res))
		playlists, artists, albums, genres, dates, songs, plays, favorited=res
		self.headertextlist=['Jukebox starten', '(%s) Kenstler browsen' %artists,'(%s) Alben browsen' %albums, '%s Songs browsen' %songs, '%s Genres browsen' %genres, '%s Jahre browsen' %dates, 'nach Sterne browsen', 'nach Playcounts browsen', 'Suche']
		header='Willkommen in Deiner Musikdatenbank. Statistiken erstellt'
		self.setListNow(list=[], header=header, red=self.headertextlist[0], green=self.headertextlist[1], yellow=self.headertextlist[2], blue=self.headertextlist[3])
			
	def errorMainMenu(self, error):
		self.keyslocked=False
		if error!=None:
			logger.error('DatabaseBrowser]errorMainMenu]error-->%s' %error) 
			header='Oh, was ist los->%s' %error
			self.setListNow(list=[], header=header, red=self.headertextlist[0], green=self.headertextlist[1], yellow=self.headertextlist[2], blue=self.headertextlist[3])

	def preparecleaningDatabase(self):
		logger.info('DatabaseBrowser]preparecleaningDatabase]Start')
		self.session.openWithCallback(self.clearCache, MusicCenterAddToDatabase, isCleanDB=True, autoclose=True, rescan=False)

	def getCurrentSelection(self):
		try: sel=self['list'].l.getCurrentSelection()[0]
		except: sel=None
		return sel

	def addListToPlaylistConfirmed(self, methodName, answer):
		if answer:
			playList=JCgetPlayList()
			if len(playList):
				self.session.openWithCallback(methodName, ChoiceBox,list=playList)
			else:
				self.session.openWithCallback(self.createPlaylistConfirmed, MessageBox, _("There are no playlists defined.\nDo you want to create a new playlist?"))

	def menuPressed(self):
		if self.keyslocked:
			return
		options=[(_("Configuration"), self.openConfig)]
		options.append((_("Scan Musiclibrary to add/update songs in database"), self.scanDir),)
		if self['list'].getDisplaySongMode():
			options.append((_("Delete song from database"), self.deleteSongFromDatabase),)
			options.append((_("Clear current songlist and play selected entry"), self.stopPlayingAndAppendFileToSongList),)
			options.append((_("Append file to current playing songlist"), self.appendFileToSongList),)
		options.append((_("Compress database and delete removed songs from database "), self.preparecleaningDatabase),)
		self.session.openWithCallback(self.menuCallback, ChoiceBox, title=_("Options:\n"), list=options, keys=MYKEYSORT, titlebartext=_("MusicCenter"))

	def menuCallback(self, ret):
		ret and ret[1]()

	def infoPressed(self):
		if self.keyslocked:
			return
		return

	def openHelp(self):
		if self.keyslocked:
			return
		pass # self.session.open(Helps, 'Database')

	def infoCallback(self, ret):
		ret and ret[1]()

	def scanDir(self):
		self.session.openWithCallback(self.pathSelected, SelectPath, config.plugins.musiccenter.defaultfilebrowserpath.value)

	def pathSelected(self, res):
		if res is not None:
			self.session.openWithCallback(self.filesAdded, MusicCenterAddToDatabase, res[0])

	def filesAdded(self):
		if pathToDatabase.isRunning:
			self.closing()
		else:
			self.redPressed()

	def addArtistToPlaylist(self):
		self.session.openWithCallback(boundFunction(self.addListToPlaylistConfirmed, self.addArtistToPlaylistConfirmedCallback), MessageBox, _("Do you really want to add all songs from that artist to a playlist?"))

	def deleteSongFromDatabase(self):
		self.session.openWithCallback(self.deleteSongFromDatabaseConfirmed, MessageBox, _("Do you really want to delete that song from the database?"))

	def deleteSongFromDatabaseConfirmed(self, answer):
		if answer:
			sel=self.getCurrentSelection()
			if sel:
				execSQLCommand('''DELETE FROM playlist_songs WHERE song_id=?''', (sel.songID,))
				execSQLCommand('''DELETE FROM songs WHERE song_id=?''', (sel.songID,))
				self['list'].removeItem(self['list'].getCurrentIndex())
				self.clearCache()

	def keyNumberPressed(self, number):
		if number == 0 and self.mode!=0:
			self['list'].moveToIndex(0)
			self.ok()
# ## Ok
	def ok(self, from_colorkey=False):
		if self.keyslocked:
			return
		logger.info('DatabaseBrowser]ok]start, old mode is:%s' %str(self.mode))
		try:
			sel=self['list'].l.getCurrentSelection()[0]
		except:
			sel=None
		if sel is None:
			return
		songList=self['list'].getList()
		index=self['list'].getCurrentIndex()
		if self.player is not None:
			if self.player.playermode not in (FILEMODE, DBMODE):
				logger.info('DatabaseBrowser]greenPressed]is not playermode 0, close now...')
				self.closePlayerNow()
			else:
				if self.player.playermode!=DBMODE:
					self.player.playermode=DBMODE
				logger.info('DatabaseBrowser]greenPressed]is playermode')
				if self.player.songList!=songList:
					logger.info('DatabaseBrowser]greenPressed]new songlist reset init to 2')
					self.player.init=2# scan covers
					self.player.songList=songList
				self.player.playSong(index)
		if self.player is None:
			try:
				if JCcheckModuleIsUpdated('Player'):
					reload(Player)
			except Exception, e:
				self.session.open(MessageBox, _("Error reload Player\n%s" %e), type=MessageBox.TYPE_ERROR, timeout=10 )
			self.player=self.session.instantiateDialogger.info(Player.Player, songList=songList, index=index, playermode=DBMODE, currentService=self.currentService, serviceList=self.serviceList)
			#self.player.setShowHideAnimation("zoom_and_fade")

		self.session.execDialogger.info(self.player)

# Songs
	def buildSongsAlphabetList(self, navigator):
		sql='''SELECT UPPER(SUBSTR(title, 1, 1)) AS firstchar, COUNT(*) AS char_count FROM Songs GROUP BY UPPER(SUBSTR(title, 1, 1));'''

	def buildSongsSongList(self, navigator):
		sql='''SELECT * FROM Songs WHERE title>=? AND title<? ORDER by title, filename;'''
		args=(firstChar, chr(ord(firstChar)+1))

	def buildArtistSongList(self, navigator, artistID, mode, addToCache):
		sql='''SELECT * FROM Songs WHERE artist_id=%d ORDER BY album, tracknumber, filename'''
		args=(artistID,)
		cursor=execSQLCommandWithReturn(sql, args, con=self.con)
# album
	def buildAlbumList(self, navigator, addToCache=True):
		sql='''SELECT album, albumartist, count(1) FROM Songs GROUP BY album ORDER by album;'''
		cursor=execSQLCommandWithReturn(sql, con=self.con)

	def buildAlbumSongList(self, navigator, addToCache=True):
		if artistID==-2: # from buildAlbumList
			sql='''SELECT * FROM Songs WHERE album=? order by tracknumber, filename;'''
			args=(album,)
		else:
			sql='''SELECT * FROM Songs  WHERE album=? AND artist=? order by tracknumber, filename;'''
			args=(album, artist,)
# artist
	def buildArtistOverviewList(self, navigator):
			titlecount=0

			args=(cur_artist,)

			sql='''SELECT album, COUNT(album)
			FROM songs
			WHERE artist=?
			GROUP BY album
			ORDER BY album;'''
			cursor=execSQLCommandWithReturn(sql, args, con=self.con)
			ltmp=[]
			for row in cursor:
				if row[1] == '' :
					row[1] == 'n/a'
				ltmp.append((Item(text="Album %s (%d) Tracks" % (row[0], row[1]), mode='buildAlbumSongList',  artist=cur_artist),))
				titlecount += row[1]
				
			artistlist += [(Item(text="All (%d)Tracks" %titlecount, mode='buildArtistSongList', artist=cur_artist),)]
			artistlist += ltmp
			sql='''SELECT genre, COUNT(genre)
			FROM songs
			WHERE artist=?
			GROUP BY genre
			ORDER BY genre;'''
			cursor=execSQLCommandWithReturn(sql, args, con=self.con)
			ltmp = [ (Item(text="Genre %s (%d) Tracks" % (row[0], row[1]), mode='buildArtistGenreSongList', artist=cur_artist, genre=row[0]),) for row in cursor ]
			artistlist += ltmp
			sql='''SELECT date, COUNT(date)
			FROM songs
			WHERE artist=?
			GROUP BY date
			ORDER BY date;'''
			cursor=execSQLCommandWithReturn(sql, args, con=self.con)
		
	def buildArtistGenreSongList(self, navigator):
			sql='''SELECT * FROM Songs WHERE genre=? AND artist='? ORDER BY title;'''
			args=(sel.genre, sel.artist,)
			cursor=execSQLCommandWithReturn(sql, args, con=self.con)

	def buildArtistSongList(self, navigator, oldmode=None):
			sql='''SELECT * FROM Songs WHERE artist=? ORDER BY title, filename;'''
			args=(artist,)
			cursor=execSQLCommandWithReturn(sql, args, con=self.con)
			artistsonglist += [ (buildSonglistEntry(row),) for row in cursor ]	
# genre
	def buildGenreListFinish(self):
		sql='''SELECT Genre, count(1) FROM Songs GROUP BY genre ORDER BY genre;'''
		cursor=execSQLCommandWithReturn(sql, con=self.con)
		lst +=[ (Item(text="%s (%d)" % (row[0], row[1]), mode='buildGenreSongList', genre=row[0], coverfn=drawImageJob(row[0][0], size=(100,100))),) for row in cursor ]
		self['headertext'].setText(_("%s Genres") %(l-1))

	def buildGenreSongList(self, navigator, addToCache=True):
			sql='''SELECT * FROM Songs WHERE genre=? ORDER by artist, title, filename;'''
			args=(genre,)
			cursor=execSQLCommandWithReturn(sql, args, con=self.con)
			if cursor is not None:
				lst += [ (buildSonglistEntry(row),) for row in cursor ]
			self['headertext'].setText(_("Genre (%s) -> Song List") % genre)
# date
	def buildDateListFinish(self):
		if not genres:
			sql='''SELECT date, count(*) FROM Songs GROUP BY date ORDER BY date'''
			cursor=execSQLCommandWithReturn(sql, con=self.con)
		else:
			sql='''SELECT date, count(*) FROM Songs WHERE genre IN (?) GROUP BY date ORDER BY date'''
			args=(str(genres[:-1]),)
			cursor=execSQLCommandWithReturn(sql, con=self.con)
		for row in cursor:
			logger.info('DatabaseBrowser]buildDateListFinish]date->%s' %row[1])
			dateList.append((Item(text="%s (%s)" % (row[0], row[1]), mode='buildDateSongList', date=row[0], coverfn=drawImageJob(row[0][0], size=(100,100))),))
		self['headertext'].setText(_("(%d) Date List") %(l-1))

	def buildDateSongList(self, navigator):
			if self.hlp.get('lastmode')=='buildDateList':
				mode='buildDateList'
				sql='''SELECT * FROM Songs WHERE date=? ORDER by artist, title, filename;''' 
				args=(date,)
				self['headertext'].setText(_("Date (%s) -> Song List") % date)
			elif self.hlp.get('lastmode')=='buildArtistOverviewList':
				mode='buildArtistOverviewList'
				sql='''SELECT * FROM Songs WHERE date=? and artist=? ORDER by artist, title, filename;'''
				args=(date, artist,)
				self['headertext'].setText(_("%s(%s) -> Song List") % (artist,date))
			dateSongList=[(Item(text=_("[back]"), mode=mode, navigator=True),)]
			cursor=execSQLCommandWithReturn(sql, args, con=self.con)
			logger.info('DatabaseBrowser]buildDateSongList]sql->%s cursorlen->%s'%(sql,cursor))
			if cursor is not None:
				if self.hlp.get('filter_genres'):
					genre=[e[1] for e in self.hlp.get('filter_genres')]
					logger.info('DatabaseBrowser]buildDateSongList]genreids filter->%s' %str(genre))
					dateSongList += [ (buildSonglistEntry(row),) for row in cursor if row["genre"] in genre]
				else:
					dateSongList += [ (buildSonglistEntry(row),) for row in cursor ]
# favorite
	def buildFavoriteListFinish(self):
		logger.info('Mainscreen]buildFavoriteListFinish]')
		tpl=((0, 0, 12),(1, 13, 38),(2, 39, 63),(3, 64, 89),(4, 90, 114),(5, 115, 140),(6, 141, 165),(7, 166, 191),(8, 192, 216),(9, 217, 242),(10, 243, 255),)
		sql='''SELECT rating FROM Songs WHERE rating  BETWEEN 0 AND 255'''
		logger.info('Database]buildFavoriteList]sql ->%s'%sql)
		cursor=sqlCommandWithReturn(sql)
		starlist=[0,0,0,0,0,0,0,0,0,0,0]
		if cursor is not None:
			for row in cursor.fetchall():
				star=calcRating(row[0])
				starlist[star]+=1
			for star, starcount in enumerate(starlist):
				lst.append((Item(text="%d Stars (%d)songs" %(star, starcount), mode='buildFavoriteSongList', rating=tpl[star][1], dateID=tpl[star][2], title=star),))
				logger.info('Database]buildFavoriteList]entry append c->%d row->%d' %(star, starcount))
		self.setListNow(lst[:1]+sorted(lst[1:], key=lambda a:a[0].title, reverse=True))
		l=len(lst)
		self['headertext'].setText(_("Favorites overview"))

	def buildFavoriteSongList(self, navigator, addToCache=True):
		self.setButtons(red=True, green=True, yellow=True, blue=True)
		sql=('''SELECT * FROM Songs WHERE rating  between %d and %d ORDER by artist, title, filename;''' %(a,b))
		cursor=sqlCommandWithReturn(sql)
		lst += [ (buildSonglistEntry(row),) for row in cursor ]
		self.setListNow(lst)
		self['headertext'].setText(_("Rating -> (%d) Songs") % len(lst))
# playcount
	def buildPlaycountListFinish(self):
		logger.info('Mainscreen]buildPlaycountListFinish]add to cache')
		lst=[(Item(text=_("[back]"), mode='buildMainMenuListDB', navigator=True),)]
		sql='''SELECT playcount, count(*) FROM songs GROUP by playcount ORDER by playcount desc;'''
		cursor=sqlCommandWithReturn(sql)
		lst +=[ (Item(text="%s Plays (%d) Songs" % (row[0], row[1]), mode='buildPlaycountSongList', playcount=row[0], coverfn=drawImageJob(str(row[0]), size=(100,100))),) for row in cursor ]
		self['headertext'].setText(_("%s different Playscounts") %(l-1))

	def buildPlaycountSongList(self, navigator, addToCache=True):
			sql='''SELECT * FROM Songs WHERE playcount=%d ORDER by artist, title, filename;''' % (playcount)
			cursor=sqlCommandWithReturn(sql)
			if cursor is not None:
				lst += [ (buildSonglistEntry(row),) for row in cursor ]
			self['headertext'].setText(_("With(%d) Plays  -> %d songs") %(playcount,(l-1)))
	
	def buildPlaycountDescSonglist(self, navigator, addToCache=True):
			sql='''SELECT * FROM Songs WHERE playcount>0 ORDER BY playcount DESC;'''
			cursor=sqlCommandWithReturn(sql)
			if cursor is not None:
				lst += [ (buildSonglistEntry(row),) for row in cursor ]
			self['headertext'].setText(_("With Plays  -> %d songs") %(l-1))
# search suggestion
	def keyOK(self): # from ['config_actions']
		self.searchvalueTimer.stop()
		self["config"].invalidateCurrent()
		self.switchListView2()
		logger.info('DatabaseBrowser]keyOK]suggestiontext->%s' %config.plugins.musiccenter.db_search.value)
		
	def artistSearchSuggstion(self):
		#self.setButtons(red=True)
		self['list'].setMode('artistSearchSuggstion')
		self.hlp['searchsuggestiontype']='ARTIST'
		self.switchListView2()
		self.searchvalueTimer.start(200)

	def songsSearchSuggstion(self):
		#self.setButtons(red=True)
		self['list'].setMode('songsSearchSuggstion')
		self.hlp['searchsuggestiontype']='TITLES'
		self.switchListView2()
		self.searchvalueTimer.start(200)

	def albumsSearchSuggstion(self):
		#self.setButtons(red=True)
		self['list'].setMode('albumsSearchSuggstion')
		self.hlp['searchsuggestiontype']='ALBUMS'
		self.switchListView2()
		self.searchvalueTimer.start(200)
		
	def switchListView2(self):
		splitListview=self.hlp.get('splitListview2', False)
		if RESOLUTIONx>1800:
			f=1.5
		else:
			f=1.0
		if not splitListview: # set configlist
			logger.info('DatabaseBrowser]switchListView2]->config activ')
			self.setButtons(red=True)
			list=self['list']

			list.resize(int(1180*f),int(530*f))
			list.move(int(50*f),int(170*f))
			list.selectionEnabled(0)
			sub0=self['config']
			sub0.instance.setZPosition(6)
			sub0.show()
			self["actions"].setEnabled(False)
			self["actions2"].setEnabled(False)
			self["config_actions"].setEnabled(True)
			current = self["config"].getCurrent()
			if current[1].help_window.instance is not None:
				current[1].help_window.instance.show()
			self.hlp['splitListview2']=True	
		else:
			logger.info('DatabaseBrowser]switchListView2]->reslut activ')
			self.setButtons(red=True, green='Set Filter')
			list=self['list']
			list.resize(int(1180*f),int(570*f))
			list.move(int(50*f),int(130*f))
			list.selectionEnabled(1)
			sub0=self['config']
			sub0.instance.setZPosition(-2)
			sub0.hide()
			self["actions"].setEnabled(True)
			self["actions2"].setEnabled(True)
			self["config_actions"].setEnabled(False)
			current = self["config"].getCurrent()
			if current[1].help_window.instance is not None:
				current[1].help_window.instance.hide()
			self.hlp['splitListview2']=False

	def searchvalueTimerAppend(self):
		l=len(config.plugins.musiccenter.db_search.value)
		#logger.info('DatabaseBrowser]searchvalueTimerAppend]suggestword->%s config.plugins.musiccenter.db_search.value->%s' %(self.suggestword, config.plugins.musiccenter.db_search.value))
		if config.plugins.musiccenter.db_search.value !=self.suggestword:# and l!=self.suggestlen:
			searchsuggestiontype=self.hlp.get('searchsuggestiontype')
			suggestionsThread.Start(searchword=config.plugins.musiccenter.db_search.value, searchsuggestiontype=searchsuggestiontype)
			self.suggestlen=l
			self.suggestword=config.plugins.musiccenter.db_search.value
			logger.info('DatabaseBrowser]searchvalueTimerAppend]suggestword->%s searchsuggestiontype->%s' %(self.suggestword, searchsuggestiontype))

	def suggestionsThreadgotThreadMsg(self, msg):
		msg=suggestionsThread.Message.pop()
		self.setListNow(msg[0])
		self['headertext'].setText(_(str(msg[1])))

	def openArtistSuggestSelectionMenu(self, navigator):
		logger.info('Database]openArtistSuggestSelectionMenu]')
		options=[]
		options.append((_("List Tracks from Selected Artist"), self.startBuildArtistOverviewList),)
		options.append((_("List Tracks from all Artists in List"), self.startBuildAllselectedArtistsSongsList),)
		text='Artistsuggestion Selectbox'
		self.session.openWithCallback(self.genrerallyCallback, ChoiceBox, title=_('Selections'), list=options, keys=MYKEYSORT, titlebartext=text)

	def genrerallyCallback(self, ret):
		if ret is not None:
			if len(ret) == 3:
				ret and ret[1](ret[2])
			else:
				ret and ret[1]()

	def startBuildArtistOverviewList(self):
		logger.info('Database]startBuildArtistOverviewList]')
		self.mode='buildArtistOverviewList'
		self.buildArtistOverviewList(False)

	def startBuildAllselectedArtistsSongsList(self):
		self.mode='buildAllselectedArtistsSongList'
		self.buildAllselectedArtistsSongList(False)
		
	def buildAllselectedArtistsSongList(self, navigator=False):
		logger.info('Database]buildAllselectedArtistsSongList]')
		self.setButtons(red=True, green=True, yellow=True, blue=True)
		if not navigator:
			listview=self['list'].getList()
			self.cacheList.append(CacheItem(mode=self['list'].getMode(), index=self['list'].getCurrentIndex(), listview=listview, headertext=self['headertext'].getText(), methodarguments=self.LastMethod))
			arguments={}
			arguments["navigator"]=navigator	
			self.LastMethod=MethodArguments(method=self.buildSongsSongList, arguments=arguments)
			lst=[(Item(text=_("[back]"), mode='buildSongsAlphabetList', navigator=True),)]
			self.setListNow(lst)
			togetting=()
			for entry in listview:
				a=entry[0].artist
				logger.info('Database]buildAllselectedArtistsSongList]-->%s' %a)
				if len(a):
					togetting+=(a,)
			logger.info('Database]buildAllselectedArtistsSongList]-->%s' %str(togetting))
			sql='''SELECT * FROM Songs WHERE artist in ? ORDER by artist, title;''' %str(togetting)
			logger.info('Database]buildAllselectedArtistsSongList]-->%s' %sql)
			cursor=sqlCommandWithReturn(sql)
			lst += [ (buildSonglistEntry(row),) for row in cursor ]
			l=len(lst)
			self.setListNow(lst, header="Songs for all listed Artists (%d)" %(l-1))
# jukebox
	def startJukebox(self):
		self.mode='JukeboxSongList'
		self['list'].setMode(self.mode)
		self.setListNow([], header='Jukebox, treffe Deine Auswahl', red='Main Men', green='Jahr Filter', yellow='Genre Filter', blue='Favoriten')

	def startJahrAusgewaehlt(self):
		self['headertext'].setText('Suche Jahre in Datenbank...')
		jukeboxselectedgenres=self.hlp.get('jukeboxselectedgenres',[])
		if jukeboxselectedgenres:
			sql='''SELECT date, count(*) FROM Songs WHERE genre IN %s GROUP BY date ORDER BY date;''' %self.makesqlitelist(jukeboxselectedgenres)
		else:
			sql='''SELECT date, count(*) FROM Songs GROUP BY date ORDER BY date'''
		result=self.execSQLCommandWithReturnCached(sql)	
		#cursor=execSQLCommandWithReturn(sql, con=self.con)
		jahrlistekopf=[(("Selektion loeschen"), 'clear')]
		jahrliste=[]
		jukeboxselectedjahre=self.hlp.get('jukeboxselectedjahre',[])
		for jahr, count in result:
			if jahr in jukeboxselectedjahre:	
				jahrlistekopf.append(('>>>%s (%s)<<<' %(jahr, count), jahr),)
			else:
				jahrliste.append((' %s (%s) ' %(jahr, count), jahr),)
		self.session.openWithCallback(self.jahrAusgewaehlt, ChoiceBox, title=_("Whle ein Jahr!"), list=jahrlistekopf+sorted(jahrliste,reverse=True), keys=MYKEYSORT, titlebartext=_("MusicCenter Jukebox"))
		
	def jahrAusgewaehlt(self, jahr):
		logger.info('DatabaseBrowser]jahrAusgewaehlt]jahr->%s' %str(jahr))
		if jahr is not None:
			jahr=jahr[1]
			jukeboxselectedgenres=self.hlp.get('jukeboxselectedgenres',[])
			if jahr=='fromyear':
				jukeboxselectedjahre=self.hlp.get('jukeboxselectedjahre',[])
			elif jahr=='clear':
				todelete=self.hlp.pop('jukeboxselectedjahre')
				logger.info('DatabaseBrowser]jahrAusgewaehlt]clear jukeboxselectedjahre->%s' %str(todelete))
				if jukeboxselectedgenres:
					self.genreAusgewaehlt(('','fromyear'))
				else:
					header='Jukebox, treffe Deine Auswahl!'
					self.setButtons(red='Main Men', green='Jahr Filter', yellow='Genre Filter', blue='Favorite Filter')
					self.setListNow([], header=header)
				return

			else:
				jukeboxselectedjahre=self.hlp.get('jukeboxselectedjahre',[])
				jukeboxselectedjahre.append(jahr)
				self.hlp['jukeboxselectedjahre']=jukeboxselectedjahre
				
			self.buildJukeboxSonglist(jukeboxselectedgenres, jukeboxselectedjahre)		
				
	def makesqlitelist(self,j):# dirty...
		c=0
		s='('
		for i in j:
			if c!=0:
				s+=','
			else:
				c=1
			s+='\''+i+'\''
		s+=')'
		return s

	def startGenreAusgeaehlt(self):
		logger.info('DatabaseBrowser]startGenreAusgeaehlt]')
		self['headertext'].setText('Suche Genre in Datenbank...')
		jukeboxselectedjahre=self.hlp.get('jukeboxselectedjahre',[])
		if jukeboxselectedjahre:
			sql='''SELECT genre, count(*) FROM Songs WHERE date IN %s GROUP BY genre ORDER BY genre;''' %self.makesqlitelist(jukeboxselectedjahre)
		else:
			sql='''SELECT genre, count(*) FROM Songs GROUP BY genre ORDER BY genre'''
		result=self.execSQLCommandWithReturnCached(sql)	
		#cursor=execSQLCommandWithReturn(sql, con=self.con)
		genrelistekopf=[(("Selektion loeschen"), 'clear')]
		genreliste=[]
		jukeboxselectedjahre=self.hlp.get('jukeboxselectedgenres',[])
		for genre, count in result:
			if genre in jukeboxselectedjahre:	
				genrelistekopf.append(('>>>%s (%s)<<<' %(genre, count), genre),)
			else:
				genreliste.append((' %s (%s) ' %(genre, count), genre),)
		self.session.openWithCallback(self.genreAusgewaehlt, ChoiceBox, title=_("Waehle ein Genre!"), list=genrelistekopf+genreliste, keys=MYKEYSORT, titlebartext=_("MusicCenter Jukebox"))
		
	def genreAusgewaehlt(self, genre=None): # angepasst
		logger.info('DatabaseBrowser]genreAusgewaehlt]genre->%s' %str(genre))
		if genre is not None:
			genre=genre[1]
			jukeboxselectedjahre=self.hlp.get('jukeboxselectedjahre',[])
			if genre=='fromyear':
				jukeboxselectedgenres=self.hlp.get('jukeboxselectedgenres',[])
			elif genre=='clear':
				todelete=self.hlp.pop('jukeboxselectedgenres')
				logger.info('DatabaseBrowser]genreAusgewaehlt]clear jukeboxselectedgenres->%s' %str(todelete))
				if jukeboxselectedjahre:
					self.jahrAusgewaehlt(('','fromyear'))
				else:
					header='Jukebox, treffe Deine Auswahl!'
					self.setListNow([], header=header, red='Main Men', green='Jahr Filter', yellow='Genre Filter', blue='Favorite Filter')
				return
			else:
				jukeboxselectedgenres=self.hlp.get('jukeboxselectedgenres',[])
				jukeboxselectedgenres.append(genre)
				self.hlp['jukeboxselectedgenres']=jukeboxselectedgenres
			
			self.buildJukeboxSonglist(jukeboxselectedgenres, jukeboxselectedjahre)		
			
	def buildJukeboxSonglist(self, jukeboxselectedgenres, jukeboxselectedjahre):
		logger.info('DatabaseBrowser]buildJukeboxSonglist]jukeboxselectedgenres->%s jukeboxselectedjahre->%s' %(str(jukeboxselectedgenres), str(jukeboxselectedjahre)))
		if jukeboxselectedjahre and not jukeboxselectedgenres:
			sql='''SELECT * FROM Songs WHERE date in %s ORDER by artist, title, filename;''' %self.makesqlitelist(jukeboxselectedjahre)
		elif not jukeboxselectedjahre and jukeboxselectedgenres:
			sql='''SELECT * FROM Songs WHERE genre in %s ORDER by artist, title, filename;''' %self.makesqlitelist(jukeboxselectedgenres)
		elif jukeboxselectedjahre and jukeboxselectedgenres:
			sql='''SELECT * FROM Songs WHERE genre in %s AND date in %s ORDER by artist, title, filename;''' %(self.makesqlitelist(jukeboxselectedgenres), self.makesqlitelist(jukeboxselectedjahre))
		else:
			header='Jukebox, treffe Deine Auswahl!'
			self.setListNow([], header=header, red='Main Men', green='Jahr Filter', yellow='Genre Filter', blue='Favorite Filter')
			return
			
		result=self.execSQLCommandWithReturnCached(sql)	
		songliste = [ (buildSonglistEntry(row),) for row in result ]
		
		if jukeboxselectedjahre and not jukeboxselectedgenres:
			header="Jukebox %s (%d) Songs" %(tuple(jukeboxselectedjahre), len(songliste))
		elif not jukeboxselectedjahre and jukeboxselectedgenres:
			header="Jukebox %s (%d) Songs" %(tuple(jukeboxselectedgenres), len(songliste))
		elif jukeboxselectedjahre and jukeboxselectedgenres:
			header="Jukebox %s %s (%d) Songs" %(tuple(jukeboxselectedgenres), tuple(jukeboxselectedjahre), len(songliste))
		self.setButtons(red='Main Men', green='Jahr Filter', yellow='Genre Filter', blue='Favorite Filter')
		self.setListNow(songliste, header=header, red='Main Men', green='Jahr Filter', yellow='Genre Filter', blue='Favorite Filter')
		
	def startgetJukeboxFavoriten(self):
		l=[]
		favorites=[[['Cudderstyle'], ['2015','2016']],[['Schlager'],['2015']]]
		pass
		#[['Balade','pop'], [],['jukeboxselectedgenres1'], [2015,2016]]
		#self.jukeboxfavoriten
		for favorit in favorites:
			l.append(('Genre:%s Jahr:%s' %(favorit[0], favorit[1]), favorit),)
		self.session.openWithCallback(self.favoritausgewaehlt, ChoiceBox, title=_("Whle einen Favoriten"), list=l, keys=MYKEYSORT, titlebartext=_("MusicCenter Jukebox"))
		
	def favoritausgewaehlt(self, ret):
		if ret:
			logger.info('DatabaseBrowser]favoritausgewaehlt]->%s' %str(ret))
			self.buildJukeboxSonglist(ret[1][0], ret[1][1])
# kuenstler
	def startKuenstlerBrowsen(self):
		self.mode='KuenstlerBrowsen'
		self['list'].setMode(self.mode)
		self.setListNow([], header='Künstler browsen', red='Main Menü', green='Browse', yellow='Suche', blue='Favoriten')

	def browseKuenstler(self):
		self['headertext']. setText('Browse Knster in Datenbank')
		sql='''SELECT UPPER(SUBSTR(artist_text, 1, 1)), COUNT(distinct artist_text) FROM Artists GROUP BY UPPER(SUBSTR(artist_text, 1, 1));'''
		alphabet=self.execSQLCommandWithReturnCached(sql)
		alphabetliste=[]
		for buchstabe, count in alphabet:
			alphabetliste.append(('%s [%s]' %(buchstabe, count),buchstabe),)
		self.session.openWithCallback(self.browseKuenstlerNachErstemBuchstaben, ChoiceBox, title=_("Wähle einen Buchstaben"), list=alphabetliste, keys=MYKEYSORT, titlebartext=_("MusicCenter Artist Browser"))	

	def browseKuenstlerNachErstemBuchstaben(self, ret):
		if ret:
			buchstabe=ret[1]
			logger.info('DatabaseBrowser]browseKuenstlerNachErstemBuchstaben]buchstabe->%s' %buchstabe)
			self['headertext']. setText('Liste Artisten mit %s' %buchstabe)
			sql='''SELECT artist_text FROM Artists WHERE artist_text LIKE ? GROUP BY artist_text ORDER BY UPPER(SUBSTR(artist_text, 1, 1))||substr(artist_text, 2) COLLATE NOCASE;'''
			args=('{0}%'.format(buchstabe),)
			artisten=self.execSQLCommandWithReturnCached(sql, args)
			artistliste=[]
			for artist in artisten:
				artistliste.append(('%s' %(artist[0]), artist[0]),)
			self.session.openWithCallback(self.artistAusgewaehlt, ChoiceBox, title=_("Wähle einen Artisten"), list=artistliste, keys=MYKEYSORT, titlebartext=_("MusicCenter Artist Browser"))	

	def artistAusgewaehlt(self, ret):
		if ret:
			selectedartist=ret[1]
			logger.info('DatabaseBrowser]artistAusgewaehlt]selectedartist->%s' %selectedartist)
			sql='''SELECT * FROM Songs WHERE artist=? ORDER by title, filename;'''
			args=(selectedartist,)			
			result=self.execSQLCommandWithReturnCached(sql, args)	
			songliste = [ (buildSonglistEntry(row),) for row in result ]
			header="Artist %s Songs" %selectedartist
			self.setListNow(songliste, header=header)	
# buttons
	def setListNow(self, list=[], index=0, header=None, stopBlinking=True, red=None, green=None, yellow=None, blue=None, aussortiert=0):
		logger.info('DatabaseBrowser]setListNow]')
		self['list'].setList(list)	
		self['list'].moveToIndex(index)
		if stopBlinking:
			self['headertext'].stopBlinking()
			self['headertext'].show()
		if header !=None:
			itemcount=self['list'].getItemCount()
			if aussortiert==0:
				self['headertext'].setText(_('%s(%d)' %(header, itemcount)))
			else:
				self['headertext'].setText(_('%s(%d) aussortiert(%d)' %(header, itemcount, aussortiert)))
		self.setButtons(red, green, yellow, blue)

	def setButtons(self, red=None, green=None, yellow=None, blue=None):
		if red!=None:
			self["key_red"].setText(red)
		if green!=None:	
			self["key_green"].setText(green)
		if yellow!=None:
			self["key_yellow"].setText(yellow)
		if blue!=None:
			self["key_blue"].setText(blue)

	def audioPressed(self):
		logger.info('DatabaseBrowser]audioPressed]')
		if self.player is not None and self.player.songList:
			self.session.execDialogger.info(self.player)

	def closePlayerNow(self):
		logger.info('DatabaseBrowser]closePlayerNow]')
		self.player.closePlayer()
		self.session.deleteDialogger.info(self.player) 
		self.player=None

	def redPressed(self):
		if self.keyslocked:
			return
		if self.mode=='buildMainMenuListDB':
			logger.info('DatabaseBrowser]redPressed]is buildMainMenuListDB, go jukebox')
			self.startJukebox()
		else:
			logger.info('DatabaseBrowser]redPressed]not buildMainMenuListDB, go Main!')
			self.setButtons()
			self.mode='buildMainMenuListDB'
			self['list'].setMode(self.mode)
			self.buildMainMenuListDB()

	def greenPressed(self):
		if self.keyslocked:
			return
		logger.info('DatabaseBrowser]greenPressed]mode is:%s'%self.mode)
		if self.mode=='buildMainMenuListDB':
			self.startKuenstlerBrowsen()	
		elif self.mode=='JukeboxSongList':
			self.startJahrAusgewaehlt()
		elif self.mode=='KuenstlerBrowsen':
			self.browseKuenstler()
		else:
			self.session.open(MessageBox, _("Noch nicht fertig...", type=MessageBox.TYPE_INFO, title="MusicCenter",timeout=5 ))

	def yellowPressed(self):
		if self.keyslocked:
			return
		logger.info('DatabaseBrowser]yellowPressed]')
		if  self.mode=='JukeboxSongList':
			self.startGenreAusgeaehlt()
		elif self.mode=='KuenstlerBrowsen':
			self.artistSearchSuggstion()
		else:
			self.session.open(MessageBox, _("Noch nicht fertig...", type=MessageBox.TYPE_INFO, title="MusicCenter",timeout=5 ))

	def bluePressed(self):
		if self.keyslocked:
			return
		logger.info('DatabaseBrowser]bluePressed]')
		if self.mode=='JukeboxSongList':
			self.startgetJukeboxFavoriten()

	def openConfig(self):
		self.session.openWithCallback(self.setupFinished, MusicCenterSetup)

	def setupFinished(self, result):
		if result:
			pass#self.redPressed()
# new buttons
	def arrowLeft(self):
		if self.keyslocked:
			return
		if self.headerpos>0:
			self.headerpos-=1
			self['key_arrow_left'].setText('<')
			self.setButtons(red=self.headertextlist[self.headerpos+0], green=self.headertextlist[self.headerpos+1], yellow=self.headertextlist[self.headerpos+2], blue=self.headertextlist[self.headerpos+3])
		else:
			self['key_left'].setText('')
		
	def arrowRight(self):
		if self.keyslocked:
			return
		if self.headerpos < len(self.headertextlist)-4:
			self.headerpos+=1
			self['key_arrow_right'].setText('>')
			self.setButtons(red=self.headertextlist[self.headerpos+0], green=self.headertextlist[self.headerpos+1], yellow=self.headertextlist[self.headerpos+2], blue=self.headertextlist[self.headerpos+3])
		else:
			self['key_arrow_right'].setText('')		

	def upBouquet(self):
		if self.keyslocked:
			return
		#l=self['list'].getList()
		pass

	def downBouquet(self):
		if self.keyslocked:
			return
		pass
		
	def up(self):
		if self.keyslocked:
			return
		self['list'].up()

	def down(self):
		if self.keyslocked:
			return
		if self.hlp.get('splitListview2', False):
			self.keyOK()
		else:
			self['list'].down()
		
	def left(self):
		if self.keyslocked:
			return
		self['list'].pageUp()

	def right(self):
		if self.keyslocked:
			return
		self['list'].pageDown()
# sql cache
	def execSQLCommandWithReturnCached(self, sql, args='', threaded=None):
		# cache sqlresults...
		cachekey=sql+str(args)
		logger.info('DatabaseBrowser]addToCachesql]cachekey->%s' %cachekey)
		cache=self.cacheSql.get(cachekey, None)
		if cache is not None:
			logger.info('DatabaseBrowser]addToCachesql]is in cache :-) ->%s' %str(cache[:100]))
			return cache
		if threaded is None:
			con=self.con
		else:
			con=OpenDatabase()
		cursor=execSQLCommandWithReturn(sql, args, con)
		res=cursor.fetchall()
		self.cacheSql[sql]=res
		cachesize=total_size(self.cacheSql)
		#cachesize=sys_getsizeof(self.cacheSql)
		logger.info('DatabaseBrowser]addToCachesql]->len cache->%d cachesize->%s bytes' %(len(self.cacheSql), cachesize))
		return res

	def clearCacheSql(self):
		cachesize=total_size(self.cacheSql)
		logger.info('DatabaseBrowser]clearCacheSql]->len cache->%d cachesize->%s bytes' %(len(self.cacheSql), cachesize))
		self.cacheSql={}
		
	def destroy(self):
		logger.info('DatabaseBrowser]destroy]...')

	def closing(self, navigator=True):
		logger.info('DatabaseBrowser]closing] self.mode->%s' % self.mode)
		self.clearCacheSql()
		'''
		if self.mode in ('JukeboxSongList',):
			logger.info('DatabaseBrowser]closing]do nothing, is jukebox!!!')	
		elif self.mode not in ('buildMainMenuListDB', 'closing'):
			self.keyNumberPressed(0)
		else:
		'''
		logger.info('DatabaseBrowser]closing]Start')
		self.close(self.player)

	def __onClose(self):
		logger.info('DatabaseBrowser]__onClose]...')


class DatabaseBrowserList(MenuList):

	def __init__(self, list, enableWrapAround = True):
		logger.info('DatabaseBrowserList]__init__]')
		MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
		if RESOLUTIONx==1920:
			self.rfactor=1.5
			self.l.setFont(0, gFont("SansReg", 39))
			self.l.setFont(1, gFont("SansReg", 30))
			self.l.setFont(2, gFont("SansReg", 25))
			self.thbsze=150
			self.picloader60_34 = PicLoaderScale(90, 51, transparent=False, name='CentralList_66_34')
		else:
			self.rfactor=1
			self.l.setFont(0, gFont("SansReg", 26))
			self.l.setFont(1, gFont("SansReg", 20))
			self.l.setFont(2, gFont("SansReg", 17))
			self.thbsze=100
			self.picloader60_34 = PicLoaderScale(60, 34, transparent=False, name='CentralList_66_34')
			
		self.picloader100 = PicLoaderScale(self.thbsze, self.thbsze, transparent=False, name='CentralList_100')
		self.itemHight=int(114*self.rfactor)
		self.l.setItemHeight(self.itemHight)
		self.l.setBuildFunc(self.buildEntryBig)
		self.onSelectionChanged = [ ]
		self.displaySongMode = True
		self.displayartistmode = False
		self.mode = 0
		self.list = list
		self.itemCount = 0

	def destroy(self):
		#logger.info('DatabaseBrowserList]destroy]')
		self.picloader100.destroy()
		self.picloader60_34.destroy()

	def buildEntryMini(self, item):
		width, height = self.getRes()
		if item.navigator or item.text in ("[back]", "[zurück]"):
			return [None, self.buildBackEntry(item, width, height)]
		else:
			res = [ None ]
			if fileExists(item.coverfn):
				ptr=self.picloader60_34.load(item.coverfn)
				res.append((eListboxPythonMultiContent.TYPE_PIXMAP, int(7*self.rfactor),  2, int(34*self.rfactor), int(34*self.rfactor), ptr))
			offset=int(34*self.rfactor+14*self.rfactor)
			res.append((eListboxPythonMultiContent.TYPE_TEXT, offset, int((height-28*self.rfactor)/2), int((width-offset)*self.rfactor) , int(28*self.rfactor), 0, RT_HALIGN_LEFT|RT_VALIGN_CENTER, "%s" % item.text))
			return res
	
	def buildEntryBig(self, item):
			f=self.rfactor
			res = [ None ]
			dir='/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/'
			width, height = self.getRes()
			if self.displaySongMode:
				if item.audio:
					color = parseColor("#C6C6C6").argb()#fast weiß
				else:
					color = parseColor("#636363").argb()#grau
				selcolor = parseColor("#ffffff").argb()# white			

				title = '%s - %s' %(item.artist, item.title)
				album = '%s [%s]' %(item.album, str(item.date))
				mypath=item.filename
				png=item.coverfn
				if not fileExists(png):
					png=drawImageJobWithLongMultilineText(text='no            cover', size=(200,200), fontsize=50)
				ptr = self.picloader100.load(png)
				res.append((eListboxPythonMultiContent.TYPE_PIXMAP,	10,  10, self.thbsze, self.thbsze, ptr))
				if item.album!=title:
					res.append((eListboxPythonMultiContent.TYPE_TEXT,       129*f,  4*f, (width-(150+129)*f), 28*f, 0, RT_HALIGN_LEFT|RT_VALIGN_CENTER, title, color, selcolor)) # artist + title
					res.append((eListboxPythonMultiContent.TYPE_TEXT, width-150*f,  4*f, 150*f, 28*f, 1, RT_HALIGN_CENTER|RT_VALIGN_CENTER, 'Track '+item.track, color, selcolor)) #track?? or tracknr
				res.append((eListboxPythonMultiContent.TYPE_TEXT, (width-150*f), 38*f, 150*f, 22*f, 1, RT_HALIGN_CENTER|RT_VALIGN_CENTER, JCconvertLength(item.length), color, selcolor)) # length
				res.append((eListboxPythonMultiContent.TYPE_TEXT,       129*f, 38*f, (width-(400+129)*f), 22*f, 1, RT_HALIGN_LEFT|RT_VALIGN_CENTER, album, color, selcolor)) #album
				res.append((eListboxPythonMultiContent.TYPE_TEXT, (width-400*f), 38*f, 230*f, 22*f, 1, RT_HALIGN_CENTER|RT_VALIGN_CENTER, item.genre, color, selcolor)) # genre

				if config.plugins.musiccenter.defaultfilebrowserpath.value in mypath:#root
					mypath = 'MyMusik/' + mypath[len(config.plugins.musiccenter.defaultfilebrowserpath.value):]# schneide defaultpath ab
				bitrate=JCconvertBitrate(item.bitrate)
				mypath=shortFoldername(mypath)
				res.append((eListboxPythonMultiContent.TYPE_TEXT,    129*f, ((68+2)*f), (width-(355+129)*f), 19*f, 2, RT_HALIGN_LEFT|RT_VALIGN_CENTER, mypath, color, selcolor)) #Pfad zum Song
				
				gradientlength=200*f
				ptr=LoadPixmap(cached=True, path=dir+'gradientmypathalpha%d_32.png' %gradientlength) # verlauf mypath am Ende
				res.append((eListboxPythonMultiContent.TYPE_PIXMAP_ALPHATEST, (width-(355+gradientlength/f)*f), ((68+2)*f), gradientlength, 20*f, ptr))
				res.append((eListboxPythonMultiContent.TYPE_TEXT, (width-150*f), 68*f, 150*f, 22*f, 1, RT_HALIGN_CENTER|RT_VALIGN_CENTER, bitrate, color, selcolor)) # bitrate
				res.append((eListboxPythonMultiContent.TYPE_TEXT, (width-235*f), 68*f, 80*f, 22*f, 1, RT_HALIGN_RIGHT|RT_VALIGN_CENTER, 'Plays %d' %item.playcount, color, selcolor)) # playcount
				res.append((eListboxPythonMultiContent.TYPE_PIXMAP_ALPHATEST, (width-355*f), 68*f, 120*f, 23*f, 	LoadPixmap(cached=True, path=dir+'rating'+str(calcRating(item.rating))+'.png'))) # rating

			elif self.displayartistmode:
				png=item.coverfn
				ptr = self.picloader60_34.load(png)
				res.append((eListboxPythonMultiContent.TYPE_PIXMAP, 7,  2*f, 70*f, 34*f, ptr))
				res.append((eListboxPythonMultiContent.TYPE_TEXT, (14+60*f), height/2-14*f, (width-14+60*f) , 28*f, 0, RT_HALIGN_LEFT|RT_VALIGN_CENTER, "%s" % item.text))
			return res


	def getRes(self):
		esize = self.l.getItemSize()
		return esize.width(), esize.height()

	def connectSelChanged(self, fnc):
		if not fnc in self.onSelectionChanged:
			self.onSelectionChanged.append(fnc)

	def disconnectSelChanged(self, fnc):
		if fnc in self.onSelectionChanged:
			self.onSelectionChanged.remove(fnc)

	def selectionChanged(self):
		for x in self.onSelectionChanged:
			x()

	def getCurrent(self):
		cur = self.l.getCurrentSelection()
		return cur and cur[0]

	def postWidgetCreate(self, instance):
		instance.setContent(self.l)
		self.selectionChanged_conn = instance.selectionChanged.connect(self.selectionChanged)
		if self.enableWrapAround:
			self.instance.setWrapAround(True)

	def moveToIndex(self, index):
		self.instance.moveSelectionTo(index)

	def getCurrentIndex(self):
		return self.instance.getCurrentIndex()

	currentIndex = property(getCurrentIndex, moveToIndex)
	currentSelection = property(getCurrent)

	def setList(self, mylist):
		self.list = mylist
		self.l.setList(mylist)

	def getItemCount(self):
		return len(self.list)

	def getList(self):
		return self.list

	def refreshList(self):
		self.l.setList(self.list)
		
	def removeItem(self, index):
		del self.list[index]
		self.l.entryRemoved(index)

	def setMode(self, mode):
		logger.info('DatabaseBrowserList]setMode]->%s' %mode)
		self.mode = mode
		if mode in ('SONGLIST', 'songsSearchSuggstion', 'buildPlaylistSongList') or isinstance( mode, str ) and mode.endswith('SongList'):
			self.displaySongMode = True
			self.itemHight=int(114*self.rfactor)
			self.displayartistmode = False
		elif mode in ('buildArtistCharList','artistSearchSuggstion'):
			self.displaySongMode = False
			self.itemHight=int(38*self.rfactor)
			self.displayartistmode = True
		else:
			self.displaySongMode = False
			self.displayartistmode = False
			self.l.setBuildFunc(self.buildEntryMini)
			self.itemHight=int(38*self.rfactor)
		self.l.setItemHeight(self.itemHight)
	
	def getMode(self):
		return self.mode

	def selectionEnabled(self, enabled):
		if self.instance is not None:
			self.instance.setSelectionEnable(enabled)
			#logger.info('DatabaseBrowserList]selectionEnabled]->%s'%str(enabled))
		
def total_size(o, handlers={}, verbose=False):
    """ Returns the approximate memory footprint an object and all of its contents.
    Automatically finds the contents of the following builtin containers and
    their subclasses:  tuple, list, deque, dict, set and frozenset.
    To search other containers, add handlers to iterate over their contents:
        handlers = {SomeContainerClass: iter,
                    OtherContainerClass: OtherContainerClass.get_elements}
    """
    dict_handler = lambda d: chain.from_iterable(d.items())
    all_handlers = {tuple: iter,
                    list: iter,
                    deque: iter,
                    dict: dict_handler,
                    set: iter,
                    frozenset: iter,
                   }
    all_handlers.update(handlers)     # user handlers take precedence
    seen = set()                      # track which object id's have already been seen
    default_size = getsizeof(0)       # estimate sizeof object without __sizeof__

    def sizeof(o):
        if id(o) in seen:       # do not double count the same object
            return 0
        seen.add(id(o))
        s = getsizeof(o, default_size)

        if verbose:
            print(s, type(o), repr(o), file=stderr)

        for typ, handler in all_handlers.items():
            if isinstance(o, typ):
                s += sum(map(sizeof, handler(o)))
                break
        return s

    return sizeof(o)
