# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

from ItemClasses import fitName
from myLogger import logger
from SQLConnector import execSQLCommand, execSQLCommandWithReturn
from Globals import *
from ArtistArtLoader import buildCoverpath, buildCoverfilename
from JobCenter import PicLoaderScale, ID3WriterJob
from tagger import myenCode, getID3raw
import GoogleImageSearch
import YoutubeSearch


class myConfigNumber(ConfigNumber):
			
	def __init__(self, default = 0):
		ConfigText.__init__(self, str(default), fixed_size = False)
		logger.info('myConfigNumber]__init__...')
		global NUMBERS
		NUMBERS='-1'
		
	def conform(self):
		pos = len(self.text) - self.marked_pos
		if self.text == "":
			self.text = "0"
		if pos > len(self.text):
			self.marked_pos = 0
		else:
			self.marked_pos = len(self.text) - pos
		logger.info('myConfigNumber]conform text->%s' %self.text)
		global NUMBERS
		NUMBERS=self.text


class EditId3(Screen, ConfigListScreen):


	if RESOLUTIONx>1800:
		skin='''
			<screen position="center,center" size="1920,1080" title="MusicCenter_Edit_ID3" >
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="20,20" size="1900,100" zPosition="1" /> 
				<widget name="filetype" position="25,25" zPosition="3" size="1870,30" font="SansReg;26" transparent="1"	backgroundColor="#00000000"/>
				<widget name="googleresult" position="25,55" zPosition="3" size="1870,30" font="SansReg;26" transparent="1"	backgroundColor="#00000000"/>
				<widget name="coverArt" position="20,700" size="250,250" zPosition="3"/>
			<!-- Buttons -->
				<eLabel position="20,135" size="1880,40" backgroundColor="#191919" zPosition="1" /> 
				<widget name="buttonred" font="SansReg;34" position="100,135" size="450,40" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget name="buttongreen" font="SansReg;34" position="510,135" size="450,40" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget name="buttonyellow" font="SansReg;34" position="960,135" size="450,40" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget name="buttonblue" font="SansReg;34" position="1410,135" size="450,40" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>	
			<!-- lists -->
				<widget name="config" position="15,190" size="1880,500" scrollbarMode="showOnDemand" />
			</screen>'''
	else:
		skin='''
			<screen position="center,center" size="1280,720" title="MusicCenter_Edit_ID3" >
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="13,13" size="1267,67" zPosition="1" /> 
				<widget name="filetype"     position="10,10"   size="900,20" zPosition="3" font="SansReg;18" transparent="1"	backgroundColor="#00000000"/>
				<widget name="googleresult" position="10,30" zPosition="3" size="900,20" font="SansReg;18" transparent="1"	backgroundColor="#00000000"/>
			<!-- Buttons -->
				<eLabel position="13,90" size="1267,34" backgroundColor="#191919" zPosition="1" /> 
				<widget name="buttonred" font="SansReg;20" position="67,96" size="300,24" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget name="buttongreen" font="SansReg;20" position="340,96" size="300,24" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget name="buttonyellow" font="SansReg;20" position="640,96" size="300,24" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget name="buttonblue" font="SansReg;20" position="940,96" size="300,24" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>	
			<!-- lists -->
				<widget name="config" position="10,127"  size="1220,400" scrollbarMode="showOnDemand" />
			</screen>'''


	def __init__(self, session, slentryID3, currentSonglistindex, player):
	
		self.session=session
		Screen.__init__(self, session)
		ConfigListScreen.__init__(self, [], session)
		self.onLayoutFinish.append(self._onLayoutFinishAppend) # dont start before gui is finished

		self.player = player
		self.slentryID3 = slentryID3
		self.currentSonglistindex = currentSonglistindex
		
		self.date = "0000"
		self.track = "0000"
		self.track_is_seted_on_init_from_file = False
		self.artist_is_changed = False
		self.titl_is_changed = False
		self.root, self.filename = os_path_split(os_path_realpath(slentryID3.filename))
		basefilename = self.filename.strip().rsplit('.',1)[0]

		# tracknr
		tracknr_from_filename = ''
		index = 0
		skip_digit = False
		
		for char in iter(basefilename):
		
			if char.isdigit():
				if not skip_digit:
					tracknr_from_filename += char
				index += 1
				
			elif char in ('_', ):
				skip_digit = True
				index += 1
				continue
				
			else:
				break
			
		# artist, title
		artistandtitle = [ i.strip() for i in basefilename[index:].strip().split('-') if len(i) ]
		logger.info('EditID3]init]artistandtitle after split:{}'.format(artistandtitle))
				
		self.artist = myenCode(re_sub('\A | \Z','',(artistandtitle[0])))
		if len(artistandtitle)>1:
			self.title = myenCode(re_sub('\A | \Z','',(artistandtitle[1])))
		else:
			self.title = self.artist
		logger.info('EditID3]init]names after split filename track:{} artist:{} title:{}'.format(tracknr_from_filename, self.artist, self.title))

		# getID3Tags now...
		self.genre = slentryID3.genre
		self.album = slentryID3.album
		self.albumartist = slentryID3.albumartist
		self.filetype = slentryID3.filetype
		self.playcount = slentryID3.playcount
		self.rating = slentryID3.rating
		self.wave = slentryID3.wave
		self.youtubeurl = slentryID3.youtubeurl
		self["coverArt"] = PicLoaderScale(transparent = False, name = 'EditID3cover')
		
		self["filetype"] = Label('Songfile is %s' % (self.filetype))
		self["googleresult"] = Label('')

		logger.info('EditID3]init]slentryID3 track:{} artist:{} title:{}'.format(slentryID3.track, slentryID3.artist, slentryID3.title))
		if slentryID3.tracknr and not slentryID3.tracknr == 'n/a':
			self.track = slentryID3.tracknr
		elif tracknr_from_filename:
			self.track_is_seted_on_init_from_file = tracknr_from_filename
			self.track = tracknr_from_filename
			
		if slentryID3.artist and not slentryID3.artist == "n/a":
			self.artist = myenCode(slentryID3.artist).title()
		else:
			self.artist_is_changed = True
		
		if slentryID3.title and not slentryID3.title == 'n/a' and slentryID3.title != self.filename:
			self.title = myenCode(slentryID3.title).title()
		else:
			self.titl_is_changed = True	
		logger.info('EditID3]init names after getId3 track->{} artist->{} title->{}'.format(self.track, self.artist, self.title))
		
		if self.album == "n/a":
			self.album = ''

		if self.albumartist == "n/a":
			self.albumartist = ''
			
		actualdate = datetime_date.today().year
		self.choicesdate = [ str(f) for f in range(actualdate-70, actualdate+1) ]
		logger.info('EditID3]init]slentryID3 date:{}'.format(slentryID3.date))
		
		if slentryID3.date != '-1' and len(slentryID3.date) > 0 :
			self.date=slentryID3.date
			self.choicesdate.append(self.date)# kein Datum und das von slentryID3 an
			
		# genre
		if self.genre == 'n/a' or not len(self.genre):
			self.genre='No genre'
		sql='''SELECT genre_text FROM Genres WHERE (SELECT 1 FROM Songs WHERE genre LIMIT 1) IS NOT Null AND genre_text IS NOT 'n/a' ORDER BY genre_text;'''
		genres=execSQLCommandWithReturn(sql).fetchall()
		self.genre_choices=[ entry[0] for entry in genres if entry[0] ] # fix crash ValueError: '' is not in list  and entry[0] not in genretop20
		#logger.info('EditID3]init]genre_choices:{}'.format(self.genre_choices))
		self.genreList = []
		
		self.youtubeurlslentry = ''

		#ConfigListScreen.__init__(self, [], session, on_change = self.refreshID3ListafterValueChanged)

		self["buttonred"] = Label(_("Zurück"))
		self["buttongreen"] = Label(_("Änderungen speichern"))
		self["buttonyellow"] = Label(_("Tausche Artit und Titel"))
		self["buttonblue"] = Label(_("Suche auf Google nach Tags"))

		self["setupActions"] = ActionMap(['ColorActions', 'SetupActions'],
		{
			"red": self.cancel,
			"green": self.save,
			"yellow": self.yellowPressed,
			"blue": self.bluePressed,
			"cancel": self.cancel,
			"ok": self.okPressed,
		}, -2)
		
		# backup old values...
		self.artist_on_init = self.artist
		self.title_on_init = self.title
		self.album_on_init = self.album
		self.albumartist_on_init = self.albumartist
		self.genre_on_init = self.genre
		self.date_on_init = self.date
		self.track_on_init = self.track
		self.playcount_on_init = self.playcount
		self.youtubeurl_on_init = self.youtubeurl

		
	def _onLayoutFinishAppend(self):
		self.buildConfigList()	
		self["coverArt"].doshow(self.slentryID3.coverfn)

		
	def buildConfigList(self):
	
		cpm = config.plugins.musiccenter
		
		cpm.newfilename = NoSave(ConfigText(default=self.filename , fixed_size=False))
		cpm.newartist = NoSave(ConfigText(default=self.artist , fixed_size=False))
		cpm.newtitle = NoSave(ConfigText(default=self.title , fixed_size=False))
		cpm.newalbum = NoSave(ConfigText(default=self.album , fixed_size=False))
		cpm.newalbumartist = NoSave(ConfigText(default=self.albumartist , fixed_size=False))
		cpm.genresindb=NoSave(ConfigText(default= self.genre, fixed_size=False))
		#cpm.newgenre = NoSave(ConfigText(default=self.genre , fixed_size=False))
		cpm.newdate=NoSave(ConfigSelection(default= self.date, choices=self.choicesdate))
		cpm.newtrack = NoSave(myConfigNumber(default=str(self.track)))
		cpm.newplaycount = NoSave(myConfigNumber(default=str(self.playcount)))
		cpm.newyoutubeurl = NoSave(ConfigText(default=self.youtubeurl , fixed_size=False))
		cpm.newcover = NoSave(ConfigText(default='' , fixed_size=False))
		
		self.refreshID3ListafterValueChanged()


	def refreshID3ListafterValueChanged(self):
	
		clist=[]
		cpm = config.plugins.musiccenter
		
		clist.append(getConfigListEntry(_("Filename:"), cpm.newfilename))
		clist.append(getConfigListEntry(_("Artist:"), cpm.newartist))
		clist.append(getConfigListEntry(_("Title:"), cpm.newtitle))
		clist.append(getConfigListEntry(_("Album:"), cpm.newalbum))
		clist.append(getConfigListEntry(_("Albumartist:"), cpm.newalbumartist))
		self.genreList=getConfigListEntry(_("Genre: press OK to Select genre from list"), cpm.genresindb)
		clist.append(self.genreList)
		clist.append(getConfigListEntry(_("Year:"), cpm.newdate))
		clist.append(getConfigListEntry(_("Tracknr:"), cpm.newtrack))
		clist.append(getConfigListEntry(_("Playcount:"), cpm.newplaycount))
		self.youtubeurlslentry=getConfigListEntry(_("Youtubeurl:  press OK to get new youtubeurl"), cpm.newyoutubeurl)
		clist.append(self.youtubeurlslentry)
		self.coverentryedit=getConfigListEntry(_("Cover:  press OK to update cover"), cpm.newcover)
		clist.append(self.coverentryedit)		

		self["config"].setList(clist)
	
	
	def bluePressed(self):
		searchword=quote('{} {}'.format(self.artist, self.title))
		url='https://www.google.de/search?q={}'.format(searchword)
		logger.debug('EditID3]bluePressed]url {}'.format(url))
		getPage(url, timeout=TWISTED_TIMEOUT, agent='Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.17 (KHTML, like Gecko) Chrome/24.0.1312.56 Safari/537.17').addCallback(self.googleAsked).addErrback(self.errorfetch)

		
	def googleAsked(self, res):
	
		#match='>Ungefähr.+?Ergebnisse<nobr> .+?Sekunden(.+?)">Feedback</a></div></div>'
		match='>Ungefähr.+?Ergebnisse<nobr> .+?Sekunden(.+?)">Feedback geben'#10.03.2019
		result = re_findall(match, res)
		
		if result:
			result = result[0]
			#logger.debug('EditID3]googleAsked]{}'.format(result))
			
			date_match = 'ffentlicht</a>: </span><span class="LrzXr kno-fv">(.+?)</span><'
			date = re_findall(date_match, result)
			if date:
				date = date[0]
			else:
				date = ''
			self.google_date = date
			
			#Kuenstler
			artist = ''
			artist_block = re_findall('K*nstle(.*?)Album', result)
			if artist_block:
				artist = ' feat '.join(re_findall('href=.*?>(.*?)<', artist_block[0]))
			# feat... 
			feat_match = '>Featured artist</a>: </span><span.*?href="/search?q=(.+?)&amp;stick='
			feat = re_findall(feat_match, result)
			
			#Album
			album_match = 'Album</a>.+? data-ved=".+?">(.+?)</a></span>'#10.03.2019
			album = ''.join(re_findall(album_match, result))

			# Genre
			genre_match = '>Genre</a>: </span><span class="LrzXr kno-fv">(.+?)</span><'
			genre = re_findall(genre_match, result)
			logger.debug('EditID3]googleAsked]genre:{}'.format(genre))
			if genre:
				genre = genre[0]
			else:
				genres_match = '>Genres</a>: </span><span class="LrzXr kno-fv">(.+?)</span>'
				genres = re_findall(genres_match, result)
				logger.debug('EditID3]googleAsked]genres:{}'.format(genres))
				genre = '-'.join(genres)
				logger.debug('EditID3]googleAsked]genres fitted:{}'.format(genre))
			self.google_genre = genre
			
			# youtube
			#youtube_match = 'padding-top:4px"><cite class=".+?">(.+?)</cite>'
			youtube_match = 'class="twQ0Be" style="height:312px"><a href="(.*?)" data-ved=' # new 16.09.2019
			youtubeurl = ''.join(re_findall(youtube_match, result))
			self.google_youtubeurl = youtubeurl
			m = 'Release:{} Artist:{} Featured:{} Album:{} Genres:{} Youtube:{}'.format(date, artist, feat, album, genre, youtubeurl)
			logger.debug('EditID3]googleAsked]'+m)
			self['googleresult'].setText(m)

			self.google_album = album
			
			cpm = config.plugins.musiccenter
			if album and album.lower() != cpm.newalbum.value.lower():
				self.session.openWithCallback(self.albumSelected, MessageBox, _("Album ersetzen?\n{} -> {}".format(cpm.newalbum.value, album)), MessageBox.TYPE_YESNO)
				
			elif genre and genre.lower() != cpm.genresindb.value.lower():
				self.session.openWithCallback(self.genreSelected, MessageBox, _("Genre ersetzen?\n{} -> {}".format(cpm.genresindb.value, genre)), MessageBox.TYPE_YESNO)
				
			elif date and date.lower() != cpm.newdate.value.lower():
				self.session.openWithCallback(self.dateSelected, MessageBox, _("Datum ersetzen?\n{} -> {}".format(cpm.newdate.value, date)), MessageBox.TYPE_YESNO)
				
			elif youtubeurl and youtubeurl != cpm.newyoutubeurl.value:
				self.session.openWithCallback(self.youtubeSelected, MessageBox, _("Youtubeurl ersetzen?\n{} -> {}".format(cpm.newyoutubeurl.value, youtubeurl)), MessageBox.TYPE_YESNO)

		else:
			result ='n/a'
			self['googleresult'].setText('No match for {} - {}'.format(self.artist, self.title))

		if config.plugins.musiccenter.setdebug.value == 'debug':
			fn = '/tmp/{}.txt'.format('googlesearch')
			with open(fn, 'wb') as f:
				f.write('{}\n\nsnipped result:{}'.format(res, result))

			
	def albumSelected(self, ret):
	
		cpm = config.plugins.musiccenter
		if ret:
			self.album=self.google_album
			cpm.newalbum.value = self.album
			
		if self.google_genre and self.google_genre.lower() != cpm.genresindb.value.lower():
			self.session.openWithCallback(self.genreSelected, MessageBox, _("Genre ersetzen?\n{} -> {}".format(cpm.genresindb.value, self.google_genre)), MessageBox.TYPE_YESNO)
			
		elif self.google_date and self.google_date.lower() != cpm.newdate.value.lower():
			self.session.openWithCallback(self.dateSelected, MessageBox, _("Datum ersetzen?\n{} -> {}".format(cpm.newdate.value, self.google_date)), MessageBox.TYPE_YESNO)
			
		elif self.google_youtubeurl and self.google_youtubeurl != cpm.newyoutubeurl.value:
			self.session.openWithCallback(self.youtubeSelected, MessageBox, _("Youtubeurl ersetzen?\n{} -> {}".format(cpm.newyoutubeurl.value, self.google_youtubeurl)), MessageBox.TYPE_YESNO)

		self.refreshID3ListafterValueChanged()

		
	def genreSelected(self, ret):
	
		cpm = config.plugins.musiccenter
		if ret:
			self.genre=self.google_genre
			cpm.genresindb.value = self.genre
			if self.genre not in self.genre_choices:
				self.genre_choices.append(self.genre)
				self.genre_choices.sort
				
		if self.google_date and self.google_date.lower() != cpm.newdate.value.lower():
			self.session.openWithCallback(self.dateSelected, MessageBox, _("Datum ersetzen?\n{}->{}".format(cpm.newdate.value, self.google_date)), MessageBox.TYPE_YESNO)
			
		elif self.google_youtubeurl and self.google_youtubeurl != cpm.newyoutubeurl.value:
			self.session.openWithCallback(self.youtubeSelected, MessageBox, _("Youtubeurl ersetzen?\n{} -> {}".format(cpm.newyoutubeurl.value, self.google_youtubeurl)), MessageBox.TYPE_YESNO)

		self.refreshID3ListafterValueChanged()

		
	def dateSelected(self, ret):
	
		cpm = config.plugins.musiccenter
		if ret:
			self.date=self.google_date
			cpm.newdate.value = self.date

		if self.google_youtubeurl and self.google_youtubeurl != cpm.newyoutubeurl.value:
			self.session.openWithCallback(self.youtubeSelected, MessageBox, _("Youtubeurl ersetzen?\n{} -> {}".format(cpm.newyoutubeurl.value, self.google_youtubeurl)), MessageBox.TYPE_YESNO)

		self.refreshID3ListafterValueChanged()

		
	def youtubeSelected(self, ret):
		if ret:
			self.youtubeurl=self.google_youtubeurl
			config.plugins.musiccenter.newyoutubeurl.value = self.youtubeurl
			
		self.refreshID3ListafterValueChanged()


	def errorfetch(self, error):
		logger.error('EditID3]errorfetch]%s' %error)
		self['googleresult'].setText('Error {}'.format(error))

		
	def saveChangedId3(self):
	
		id3dict={}
		cpm = config.plugins.musiccenter
		
		if self.artist_on_init != cpm.newartist.value or self.artist_is_changed:
			logger.info('EditID3]saveChangedId3]New Artist {}'.format(cpm.newartist.value))
			id3dict['artist']=cpm.newartist.value

		if self.title_on_init != cpm.newtitle.value or self.titl_is_changed:
			logger.info('EditID3]saveChangedId3]New Title {}'.format(cpm.newtitle.value))
			id3dict['title']=cpm.newtitle.value

		if self.album_on_init != cpm.newalbum.value:
			logger.info('EditID3]saveChangedId3]New Album {}'.format(cpm.newalbum.value))
			id3dict['album']=cpm.newalbum.value

		if self.albumartist_on_init != cpm.newalbumartist.value:
			logger.info('EditID3]saveChangedId3]New Albumartist {}'.format(cpm.newalbumartist.value))
			id3dict['albumartist']=cpm.newalbumartist.value

		if self.genre_on_init != cpm.genresindb.value:
			self.genre=cpm.genresindb.value
			logger.info('EditID3]saveChangedId3]New Genre from keyboard entry {}'.format(self.genre))
			id3dict['genre']=self.genre
		elif self.genre_on_init != self.genre:
			logger.info('EditID3]saveChangedId3]New Genre from choicelist {}'.format(self.genre))
			id3dict['genre']=self.genre
				
		if self.date_on_init != cpm.newdate.value:
			logger.info('EditID3]saveChangedId3]New Date {}'.format(cpm.newdate.value))
			id3dict['date']=str(cpm.newdate.value)

		logger.info('EditID3]saveChangedId3]tracknr cpm.newtrack.value {} NUMBERS {}'.format(cpm.newtrack.value, NUMBERS))
		tracknr=''
		if cpm.newtrack.value != '0000':

			if str(NUMBERS) != '-1': #changed
				tracknr=str(NUMBERS)
				logger.info('EditID3]saveChangedId3]new tracknr from NUMBER{}'.format(NUMBERS))
				id3dict['tracknr']=tracknr
			elif self.track_is_seted_on_init_from_file:
				tracknr=self.track_is_seted_on_init_from_file
				logger.info('EditID3]saveChangedId3]new tracknr {}'.format(self.track_is_seted_on_init_from_file))
				id3dict['tracknr']=tracknr

		if self.playcount_on_init != cpm.newplaycount.value:
			self.playcount=cpm.newplaycount.value
			logger.info('EditID3]saveChangedId3]New playcount from key entry:%s' % (cpm.newplaycount.value))
			id3dict['playcount']=self.playcount

		# youtube -> WXXX:youtube
		if self.youtubeurl_on_init != cpm.newyoutubeurl.value:
			logger.info('EditID3]saveChangedId3]New Youtubeurl:{}'.format(cpm.newyoutubeurl.value))
			id3dict['youtubeurl']=cpm.newyoutubeurl.value
		
		# filename
		if self.filename != cpm.newfilename.value:
			old_fullfn=os_path_join(self.root, self.filename)
			new_fullfn=os_path_join(self.root, cpm.newfilename.value)
			logger.info('EditID3]saveChangedId3]rename from:{} to:{}'.format(old_fullfn, new_fullfn))
			os_rename(old_fullfn, new_fullfn)
			self.filename=cpm.newfilename.value
			
			if new_fullfn.startswith(cpm.defaultfilebrowserpath.value):
				pathoffset=len(cpm.defaultfilebrowserpath.value)
				new_fullfnindb=new_fullfn[pathoffset:]
				old_fullfnindb=old_fullfn[pathoffset:]
				logger.info('EditID3]saveChangedId3]is in DB, update entry from:{} to:{}'.format(old_fullfnindb, new_fullfnindb))
				execSQLCommand('''UPDATE Songs SET filename=? WHERE filename=?;''', (old_fullfnindb, new_fullfnindb))
			else:
				logger.info('EditID3]saveChangedId3]is not in DB, skip update db')

				
		# ersetze songlistentrys und setze wieder n/a
		slentry_new=self.slentryID3
		
		if cpm.newtitle.value=='':
			slentry_new.title='n/a'
		else:
			slentry_new.title=cpm.newtitle.value
			
		if cpm.newartist.value=='':
			slentry_new.artist='n/a'
		else:
			slentry_new.artist=cpm.newartist.value
		
		if self.genre=='':
			slentry_new.genre='n/a'
		else:
			slentry_new.genre=self.genre
		
		if tracknr=='':
			slentry_new.track='n/a'
		else:
			slentry_new.track=tracknr
		
		if str(cpm.newdate.value)=='':
			slentry_new.date='n/a'
		else:
			slentry_new.date=str(cpm.newdate.value)

		if cpm.newalbum.value=='':
			slentry_new.album='n/a'
		else:
			slentry_new.album=cpm.newalbum.value
		
		if cpm.newalbumartist.value=='':
			slentry_new.albumartist='n/a'
		else:
			slentry_new.albumartist=cpm.newalbumartist.value
			
		slentry_new.filename=os_path_join(self.root, self.filename)
		slentry_new.playcount=self.playcount
		slentry_new.youtubeurl=self.youtubeurl
		
		return id3dict, slentry_new


	def okPressed(self):
		slentryID3=self.slentryID3
		cur = self["config"].getCurrent()
		if cur == self.genreList:
			index=0
			l=[]
			for i, entry in enumerate(self.genre_choices):
				l.append((entry,))
				if entry==self.genre:
					index=i
					
			config.plugins.musiccenter.genresindb.help_window.hide()

			self.session.openWithCallback(self.genreSelectResult, ChoiceBox, selection=index, title=_("Waehle ein Genre aus der Liste"), list=l, keys=MYKEYSORT, titlebartext=_("MusicCenter Edit ID3"))
			
		elif cur == self.youtubeurlslentry:
			searchword='{} {}'.format(fitName(self.artist), fitName(self.title))
			if JCcheckModuleIsUpdated('YoutubeSearch'):
				reload(YoutubeSearch)
			config.plugins.musiccenter.newyoutubeurl.help_window.hide()
			self.session.openWithCallback(self.youtubeSearchResult, YoutubeSearch.YoutubeSearchScreen, searchword, slentryID3)
			
		elif cur == self.coverentryedit:
			searchword='{} {}'.format(fitName(self.artist), fitName(self.title))
			if JCcheckModuleIsUpdated('YoutubeSearch'):
				reload(YoutubeSearch)
			config.plugins.musiccenter.newcover.help_window.hide()
			
			nameforcoverfile, fake=buildCoverfilename(slentryID3.artist,slentryID3.title,slentryID3.album,slentryID3.albumartist, cleannames=False)
			logger.debug('EditID3]okPressed]nameforcoverfile:{}'.format(nameforcoverfile))
			if nameforcoverfile != None:
				coverdownloaddir=os_path_join(config.plugins.musiccenter.downloadcache.value, "covers/" )
				picfilename=buildCoverpath(coverdownloaddir, nameforcoverfile)
				if JCcheckModuleIsUpdated('GoogleImageSearch'):
					reload(GoogleImageSearch)
				self.session.openWithCallback(self.googleCoverSearchCallback, GoogleImageSearch.GoogleImageSearchScreen, slentryID3, picfilename, nameforcoverfile,  sizeX=500, sizeY=500, face=False)


	def googleCoverSearchCallback(self, ret):
		slentry, picpath, error = ret
		if error is None:
			self["coverArt"].doshow(picpath)
			logger.debug('EditID3]googleCoverSearchCallback]new picpath is:{}'.format(picpath))
			if slentry.filename == self.player.currentplayingslentry.filename:
				logger.debug('EditID3]googleCoverSearchCallback]update player cover')
				self.player.showCover(isfilecover=False, picpath=picpath)
				
			if fileExists(slentry.coverfn):
				logger.debug('EditID3]googleCoverSearchCallback]old coverthumb found, remove')
				os_remove(slentry.coverfn)

			logger.debug('EditID3]googleCoverSearchCallback]create new coverthumb')
			coverfn = CoverLoader().loadfromImageFile(slentry.filename, picpath)
			self.player.songlist[self.player._currentplayingindex][0].cover = 1
			self.player.songlist[self.player._currentplayingindex][0].coverfn = coverfn			
			
			if config.plugins.musiccenter.addcoverautotosong.value:
				logger.debug('EditID3]googleCoverSearchCallback]add job for songID{}'.format(slentry.songID))
				musiccenterJobmanager.AddJob(ID3WriterJob(slentry, {'cover':coverfn}))		
		else:
			logger.error('EditID3]googleCoverSearchCallback]Error:{}'.format(error))

			
	def save(self):	
		id3dict, slentryID3=self.saveChangedId3()
		self.close([self.currentSonglistindex, os_path_join(self.root, self.filename), id3dict, slentryID3])

		
	def genreSelectResult(self, genre):
		config.plugins.musiccenter.genresindb.help_window.show()
		if genre:
			logger.info('EditID3]genreSelectResult]->{}'.format(genre[0]))
			self.genre = genre[0]
			config.plugins.musiccenter.genresindb.value = genre[0]
			self.refreshID3ListafterValueChanged()


	def youtubeSearchResult(self, youtubeurl, slentry):
		logger.info('EditID3]youtubeSearchResult]->{}'.format(youtubeurl))
		config.plugins.musiccenter.newyoutubeurl.help_window.hide()
		if youtubeurl:
			logger.info('EditID3]youtubeSearchResult]replace url to:{}'.format(youtubeurl))
			self.youtubeurl = youtubeurl#[0]
			config.plugins.musiccenter.newyoutubeurl.value = youtubeurl#[0]
			self.refreshID3ListafterValueChanged()
	

	def yellowPressed(self):
		cpm = config.plugins.musiccenter
		temp = cpm.newtitle.value
		cpm.newtitle.value = cpm.newartist.value
		cpm.newartist.value = temp


	def destroy(self):
		self["coverArt"].destroy()


	def cancel(self):
		for x in self["config"].list:
			x[1].cancel()
		self.close(None)
