#	-*-	coding:	utf-8	-*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

# global variables
from Components.AVSwitch import AVSwitch
from Components.ActionMap import ActionMap, NumberActionMap
from Components.config import config, ConfigSubsection, ConfigDirectory, ConfigYesNo, ConfigInteger, getConfigListEntry, ConfigLocations, configfile, ConfigText, ConfigSelection, NoSave, ConfigNumber, choicesList, ConfigElement
from Components.ConditionalWidget import BlinkingWidget
from Components.ConfigList import ConfigListScreen, ConfigList
from Components.CoverCollection import VideoDBPictureBox, CoverCollection
from Components.FileList import MultiFileSelectList as BaseMultiFileSelectList, FileList
from Components.GUIComponent import GUIComponent
from Components.Harddisk import harddiskmanager
from Components.HTMLComponent import HTMLComponent
from Components.Input import Input
from Components.Label import Label as BaseLabel, BlinkingLabel 
from Components.Label import BlinkingLabelConditional, MultiColorLabel
from Components.MenuList import MenuList
from Components.MerlinMusicPlayerWidget import MerlinMusicPlayerWidget, MerlinMusicPlayerRMS
from Components.Pixmap import Pixmap, MultiPixmap
from Components.ScrollLabel import ScrollLabel
from Components.ServicePosition import ServicePositionGauge as baseServicePositionGauge, ServicePosition
from Components.ServiceEventTracker import ServiceEventTracker, InfoBarBase
from Components.Sources.StaticText import StaticText
from Components.Sources.List import List
from Components.SystemInfo import SystemInfo
from Components.VariableText import VariableText
from Components.VideoWindow import VideoWindow

from merlin_musicplayer.emerlinmusicplayer import eMerlinMusicPlayer
import merlin_musicplayer._emerlinmusicplayer

from enigma import RT_VALIGN_CENTER, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, RT_VALIGN_TOP, RT_WRAP, getDesktop, gFont, eListbox, ePoint, eListboxPythonMultiContent, loadJPG, loadPNG, getBestPlayableServiceReference 
from enigma import eEPGCache, eServiceCenter, eServiceReference, eTimer, gPixmapPtr, ePythonMessagePump, eRect, gRGB, eSize
from enigma import iPlayableService, iServiceInformation, eConsoleAppContainer, eBackgroundFileEraser
from enigma import eWindowAnimationSet, eFloatAnimation, eLinearInterpolator, eWindowAnimationManager, ePixmap


from Screens.ChoiceBox import ChoiceBox
from Screens.EpgSelection import EPGSelection
from Screens.EventView import EventViewEPGSelect
from Screens.InfoBarGenerics import InfoBarSeek, InfoBarNotifications, NumberZap
from Screens.InputBox import InputBox
from Screens.MessageBox import MessageBox
from Screens.Screen import Screen
from Screens.VirtualKeyBoard import VirtualKeyBoard

from Screens.InfoBar import MoviePlayer


from Plugins.SystemPlugins.Toolkit.SimpleThread import SimpleThread

from ServiceReference import ServiceReference
from skin import parseColor # , parsePosition

from timer import TimerEntry

from Tools.BoundFunction import boundFunction
from Tools.Downloader import HTTPProgressDownloader, downloadWithProgress
from Tools.Directories import fileExists, pathExists, SCOPE_CONFIG, SCOPE_PLUGINS, SCOPE_HDD, SCOPE_CURRENT_SKIN, resolveFilename, createDir, removeDir
from Tools.LoadPixmap import LoadPixmap
from Tools.NumericalTextInput import NumericalTextInput
from Tools.HardwareInfo import HardwareInfo


from base64 import b64decode as base64_b64decode, standard_b64encode as base64_standard_b64encode, b64encode as base64_b64encode, decodestring as base64_decodestring

from copy import deepcopy as copy_deepcopy, copy as copy_copy
import cPickle as pickle
from cStringIO import StringIO

from datetime import timedelta as datetime_timedelta, datetime as datetime_datetime, date as datetime_date, time as datetime_time

from fcntl import ioctl as fcntl_ioctl
import fileinput

#import gc
from glob import glob as glob_glob

from httplib import HTTPConnection as httplib_HTTPConnection

from json import dumps as json_dumps, loads as json_loads, load as json_load, dump as json_dump

from operator import isCallable
from os import listdir as os_listdir, stat as os_stat, popen as os_popen, walk as os_walk, system as os_system, rename as os_rename, symlink as os_symlink, remove as os_remove, error as os_error
from os import access as os_access, W_OK as os_W_OK, utime as os_utime
from os.path import join as os_path_join, realpath as os_path_realpath, split as os_path_split, basename as os_path_basename, getsize as os_path_getsize, exists as os_path_exists
from os.path import isdir as os_path_isdir, getmtime as os_path_getmtime, isfile as os_path_isfile, islink as os_path_islink

from PIL import Image, ImageDraw, ImageFont, ImageStat

from random import shuffle, randrange, choice as random_choice, randint as random_randint

from re import sub as re_sub, compile as re_compile, IGNORECASE as re_IGNORECASE, DOTALL as re_DOTALL, findall as re_findall, S as re_S, escape as re_escape, split as re_split
from requests import get as requests_get, codes as requests_codes, session as requests_Session

from shutil import copy as sh_copy2, move as sh_move,  rmtree as sh_rmtree, copyfileobj as sh_copyfileobj, copytree as sh_copytree
import socket
import string
from struct import pack as struct_pack
from subprocess import call as sp_call, Popen as sp_Popen, check_output as sp_check_output, PIPE as sp_PIPE
from sys import getsizeof as sys_getsizeof 

from threading import Thread
from ThreadQueue import ThreadQueue

from time import time as time_time, strftime as time_strftime, localtime as time_localtime, sleep as time_sleep, gmtime as time_gmtime, ctime as time_ctime
from timer import TimerEntry

from twisted.internet import defer, reactor, ssl
from twisted.internet.threads import deferToThread
from twisted.web import client
from twisted.web.client import HTTPClientFactory, getPage, downloadPage, readBody, Agent, BrowserLikeRedirectAgent, HTTPConnectionPool
from twisted.python import failure
from twisted.internet._sslverify import ClientTLSOptions

from urllib import quote, urlencode, unquote
from urllib2 import URLError, Request, build_opener, HTTPError, urlopen

from urlparse import urlparse as urlparse_urlparse

from xml.etree.cElementTree import fromstring as ET_fromstring, parse as ET_parse
from xml.dom.minidom import parseString

from ItemClasses import buildCoverthumbFilename
from myLogger import logger


Numberhelper=False


PBKEY='9368280-566404fc1952dad60c6fc4729'
RESOLUTIONx = getDesktop(0).size().width()


#json save/load values...
def save_obj(obj, filename):
	with open(filename, 'w') as fn:
		json_dump(obj, fn)

def load_obj(filename):
	with open(filename, 'r') as fn:
		res=json_load(fn)
	return res



# build player version
v, r, t=load_obj('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/version').split('_')

MC_VERSION='v{} r{} {}'.format(v, r, datetime_datetime.fromtimestamp(float(t)).strftime('%Y-%m-%d %H:%M'))
#global MC_VERSION



# init reload modules
PP='/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/'
FILESIZES=dict([ (f.rsplit('.')[0], os_path_getsize(PP+f)) for f in os_listdir(PP) if f.lower().endswith('.py')])

def JCcheckModuleIsUpdated(module):

	# check if is reload module nessesarry...
	
	#p='/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/'
	#filesizes=dict([ (f.rsplit('.')[0], os_path_getsize(p+f)) for f in os_listdir(p) if f.lower().endswith('.py')])
	new_size=os_path_getsize('{}{}.py'.format(PP, module))
	
	if FILESIZES[module]!=new_size:
		FILESIZES[module]=new_size
		logger.info('JCcheckModuleIsUpdated]reload Module %s' %module)
		version, revision, timestamp=load_obj(PP+'version').split('_')
		currtime=time_time()
		if int(float(timestamp))+1800 < int(currtime):
			logger.info('JCcheckModuleIsUpdated]reload Module 0')
			revision=int(revision)+1
			save_obj(('_'.join((version, str(revision), str(currtime)))), PP+'version')
			logger.info('JCcheckModuleIsUpdated]reload Module 1')
			global MC_VERSION
			MC_VERSION='v{} r{} {}'.format(version, revision, datetime_datetime.fromtimestamp(float(currtime)).strftime('%Y-%m-%d %H:%M'))
			logger.info('JCcheckModuleIsUpdated]reload Module 2')
			
		return True
	else:
		return False


# internet helpers...
MCUSERAGNET = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36'#'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36'


def mcgetPage(url, *args, **kwargs):
	if 'agent' not in kwargs:
		kwargs['agent'] = MCUSERAGNET
	if 'timeout' not in kwargs:
		kwargs['timeout'] = 3
	if url.startswith('https://') and 'contextFactory' not in kwargs:
		kwargs['contextFactory'] = ssl.ClientContextFactory()
	return getPage(url, *args, **kwargs)


def mcdownloadPage(url, fn, *args, **kwargs): #ssl save!
	if 'agent' not in kwargs:
		kwargs['agent'] =MCUSERAGNET
	if 'timeout' not in kwargs:
		kwargs['timeout']=4
	if url.startswith('https://') and 'contextFactory' not in kwargs:
		kwargs['contextFactory']=ssl.ClientContextFactory()
	
	return downloadPage(url, fn, *args, **kwargs)

	
#radiobrowser
def rb_getPage(urlpart, *args, **kwargs):
	# getpage with RadioBrowser agent!
	url='http://www.radio-browser.info/webservice/{}'.format(urlpart)
	kwargs['agent']='enigma2 MusicCenter/RadioBrowser'
	kwargs['timeout']=5
	return getPage(url, *args, **kwargs)

def rb_post(url=None,payload={}):
	#url='http://www.radio-browser.info/webservice/json/stations/search', payload = {'name': 'Ostseewelle', 'country': 'Germany'}
	headers = {'User-Agent':'enigma2 MusicCenter/RadioBrowser'}
	if url is not None:
		result=requests_post(url, headers=headers, data=payload)
		return result.content
	return []

# lautfm
def lautfm_getPage(urlpart, *args, **kwargs):
	url='https://api.laut.fm/{}'.format(urlpart)
	kwargs['agent']='enigma2 MusicCenter'
	kwargs['timeout']=5
	kwargs['contextFactory']=ssl.ClientContextFactory()
	return getPage(url, *args, **kwargs)

def calcRating(rating, tobyte=False):
	#0-bomb.....254-10(5 stars)->280-11-<not set
	#[int(round(i/10.0*255)) for i in [0,  1,  2,  3,	4,	 5,	  6,   7,	8,	 9,	 10,  11]]
	#								  [0, 26, 51, 77, 102, 128, 153, 179, 204, 230, 255, 281]
	if not tobyte:
		newrating=int(round(rating*10.0/255))
	else:
		newrating=int(round(rating/10.0*255))
	#logger.debug('calcRating]rating->%d newrating->%d'%(rating, newrating))
	return newrating

	
def buildWaveFilename(songfilename):
	if songfilename.startswith(config.plugins.musiccenter.defaultfilebrowserpath.value):
		songfilenamelib='.' + songfilename[len(config.plugins.musiccenter.defaultfilebrowserpath.value):].rsplit('.',1)[0].replace('/','_._')
	else:
		songfilenamelib=songfilename.rsplit('.',1)[0][1:].replace('/','_._')
	return os_path_join(config.plugins.musiccenter.downloadcache.value, "waves/", ''.join((songfilenamelib, '.png')))


def joinDisplaytextStream(slentry):# SPlayer, LCDScreen
	stationname = 'Station: {}'.format(slentry.stationname)
	bitrateandcodec = '{} | {}'.format(slentry.bitrate, slentry.codec)
	stats = 'n/a'
	provider = 'n/a'
	
	if slentry.filetype == 'RADIOBROWSER':
		stats = 'Clicks {} | Votes {}'.format(slentry.playcount, slentry.votes)
		provider = 'www.radio-browser.info'
		
	elif slentry.filetype == 'RADIODE':
		stats = 'Rang {} | Rating {}'.format(slentry.playcount, slentry.votes)
		provider = 'www.Radio.de'
		
	elif slentry.filetype == 'LAUTFM':
		bitrateandcodec = ''
		stats = 'Listeners {} | Rang {}'.format(slentry.playcount, slentry.votes)
		provider = 'www.Laut.fm'
	return stationname, bitrateandcodec, stats, provider


def joinDisplaytextFiles(slentry):# Player, LCDScreen
	if slentry.album in ('n/a',''):
		if len(slentry.filename.rsplit('/',2)) > 1:
			showed_album=slentry.filename.rsplit('/',2)[1] #
		else:
			showed_album=slentry.album
	else:
		showed_album=slentry.album
	album_year_albumartist='{} [{}] {}'.format(showed_album, slentry.date, slentry.albumartist)
	playcount='Plays {}'.format(slentry.playcount)
	return album_year_albumartist, playcount


class vInputBox(InputBox):

	if RESOLUTIONx>1800:
		skin='''<screen name="vInputBox" position="center,center" size="1860,105" title="Input...">
				<widget name="text" position="6,6" size="1830,36" font="SansReg;30"/>
				<widget name="input" position="0,40" size="1830,39" font="SansReg;33"/>
			</screen>'''
	else:
		skin='''<screen name="vInputBox" position="center,center" size="1240,70" title="Input...">
				<widget name="text" position="4,4" size="1220,24" font="SansReg;20"/>
				<widget name="input" position="0,40" size="11220,26" font="SansReg;22"/>
			</screen>'''

	def __init__(self, session, title="MusikCenter", windowTitle=_("Input"), useableChars=None, **kwargs):
		self.session=session
		InputBox.__init__(self, session, title, windowTitle, useableChars, **kwargs)


	
#Jukebox playlists
from SQLConnector import execSQLCommandWithReturn, execSQLCommand, execSQLCommandMany

class PlaylistBase(object):

	def __init__(self):
		logger.info('PlaylistBase]__init__]...')
		self.__slentry = None
		self.__songlist = []


	def listPlaylists(self, callback):
		playlists = []
		#'''SELECT COUNT(1) FROM Playlist_Songs WHERE playlist_id=  SELECT playlist_id, playlist_text FROM Playlists order by playlist_text'''
		#Select * from people p, address a where  p.id = a.person_id and a.zip='97229';
		for playlist_id_text in execSQLCommandWithReturn('''SELECT playlist_id, playlist_text FROM Playlists order by playlist_text'''):
			counter = execSQLCommandWithReturn('''SELECT COUNT(1) FROM Playlist_Songs WHERE playlist_id={}'''.format(playlist_id_text[0])).fetchone()[0]
			playlists.append(('{} ({} Songs)'.format(playlist_id_text[1], counter), playlist_id_text[0]))

		self.session.openWithCallback(callback, ChoiceBox, title=_("Waehle eine Playliste"), list = playlists, keys=MYKEYSORT, titlebartext=_("MusicCenter"))


	def newPlaylist(self):
		self.session.openWithCallback(self.newPlaylistCB, vInputBox, title=_('Name der Playliste'), windowTitle=_("MusicCenter"), text="...")


	def newPlaylistCB(self, answer):
		if answer:
			execSQLCommand('''INSERT INTO Playlists (playlist_text) VALUES ("{}");'''.format(answer))


	def newPlaylistFromSonglist(self, songlist):
		self.__songlist = songlist
		self.session.openWithCallback(self.newPlaylistFromSonglistCB, vInputBox, title=_('Name der Playliste'), windowTitle=_("MusicCenter"), text="...")


	def newPlaylistFromSonglistCB(self, answer):
		if answer:
			execSQLCommand('''INSERT INTO Playlists (playlist_text) VALUES ("{}")'''.format(answer)) #SELECT * FROM Playlists
			
			playlist_id = execSQLCommandWithReturn('''SELECT playlist_id FROM Playlists WHERE playlist_text="{}"'''.format(answer)).fetchone()[0]
			values =[]
			
			for slentry in self.__songlist:
				entry = (playlist_id, slentry[0].songID , slentry[0].length)
				logger.debug('PlaylistBase]newPlaylistFromSonglistCB]append to values:{}'.format(str(entry)))		
				values.append(entry)
			
			execSQLCommandMany('''INSERT INTO Playlist_Songs (playlist_id, song_id, length) VALUES (?,?,?)''', values)


	def renamePlaylist(self):
		self.listPlaylists(self.renamePlaylistCB)

	
	def renamePlaylistCB(self, playlist_name_id):
		if playlist_name_id:
			self.__slentry = playlist_name_id
			self.session.openWithCallback(self.renamePlaylistCB2, vInputBox, title=_('Name der Playliste'), windowTitle=_("MusicCenter"), text="{}".format(playlist_name_id[0]))


	def renamePlaylistCB2(self, answer):
		playlist_name_id = self.__slentry	
		if answer != playlist_name_id[0]:
			execSQLCommand('''UPDATE Playlists SET playlist_text=? WHERE playlist_id=?''', (answer, playlist_name_id[1]))

			
	def addSongToPlaylist(self, slentry):
		self.__slentry = slentry
		self.listPlaylists(self.addSongToPlaylistCheckDublikate)

		
	def addSongToPlaylistCheckDublikate(self, playlist_name_id):
		if playlist_name_id and self.__slentry is not None:
			if not execSQLCommandWithReturn('''SELECT 1 FROM Playlist_Songs WHERE song_id={} AND playlist_id={}'''.format(self.__slentry.songID, playlist_name_id[1])).fetchone():
				self.addSongToPlaylistCB(playlist_name_id)
			else:
				self.session.open(MessageBox, _('Song {} ist schon in {} Abbruch!'.format(self.__slentry.filename, playlist_name_id[0])), type = MessageBox.TYPE_INFO, title = "MusicCenter",timeout = 6)

		
	def addSongToPlaylistCB(self, playlist_name_id):
		execSQLCommand('''INSERT INTO Playlist_Songs (playlist_id, song_id, length) VALUES ({}, {}, "{}")'''.format(playlist_name_id[1], self.__slentry.songID, self.__slentry.length))
		self.__slentry = None

		
	def deleteSongFromPlaylist(self, slentry):
		if slentry.playlistID >= 0:
			execSQLCommand('''DELETE FROM Playlist_Songs WHERE playlist_id={} AND song_id={}'''.format(slentry.playlistID, slentry.songID))
			

	def getPlaylistName(self, playlistID):
		cursor = execSQLCommandWithReturn('''SELECT playlist_text FROM Playlists WHERE playlist_id={}'''.format(playlistID)).fetchone()
		if cursor:
			return cursor[0]
		else:
			return 'n/a'


	def removePlaylist(self):
		self.listPlaylists(self.removePlaylistCB)


	def removePlaylistCB(self, playlist_name_id):
		if playlist_name_id:
			execSQLCommand('''DELETE FROM Playlists WHERE playlist_id={}'''.format(playlist_name_id[1]))
			execSQLCommand('''DELETE FROM Playlist_Songs WHERE playlist_id={}'''.format(playlist_name_id[1]))
	
	
	def globalCallback(self, ret):
		if ret is not None:
			if len(ret) == 2:
				ret and ret[1]()
			elif len(ret) == 3:
				ret and ret[1](ret[2])
			elif len(ret) == 4:
				ret and ret[1](ret[2], ret[3])


	
globalTimerInstances = []

class GlobalTimer:
	def __init__(self, delay, function, *params):
		logger.debug('GlobalTimer]__init__]delay:{} function:{}'.format(delay, function))		
		try:
			if isCallable(function):
				global globalTimerInstances
				globalTimerInstances.append(self)
				self.function = function
				self.params = params
				self.timer = None
				self.timer = eTimer()
				self.timer_conn = None
				self.timer_conn = self.timer.timeout.connect(self.timerTimeout)
				self.timer.start(delay, False)
				
		except:
			logger.exception('GlobalTimer]__init__]error...')		


	def timerTimeout(self):
		logger.debug('GlobalTimer]timerTimeout]call function:{}'.format(self.function))			
		try:
			global globalTimerInstances
			globalTimerInstances.remove(self)
			self.timer.stop()
			self.timer_conn = None
			self.timer = None
			self.function(*self.params)
			
		except:
			logger.exception('GlobalTimer]__init__]error...')		


class TLSSNIContextFactory(ssl.ClientContextFactory):
	def getContext(self, hostname=None, port=None):
		ctx = ssl.ClientContextFactory.getContext(self)
		ClientTLSOptions(hostname, ctx)
		return ctx

		
class Label(BaseLabel):
	
	#parse text to labels
	
	def __init__(self, text=""):
		BaseLabel.__init__(self, text=text)
			
	def setParsedText(self, text):#
		lentext = len(text)
		if lentext > 3:
			origtext = text
			self.setText(text)
			labelheigth = int(self.instance.size().height()*1.2)
			shorted = False
			while self.getSize()[1] > labelheigth*1.2:
				shorted = True
				text = self.getText()
				text = text[:-1]
				self.setText(text)
				
			if shorted:
				if len(text) == 0:
					logger.error('setParsedText]error shorting, set origtext->%s' %origtext)
					self.setText(origtext)
				else:
					text = self.getText()
					text = text[:-3]+'...'
					self.setText(text)			
				logger.debug('setParsedText]{} -> {} getSize:{} labelheigth:{}'.format(origtext, text, self.getSize()[1], int(self.instance.size().height()*1.2)))
		else:
			self.setText(text)


class BlinkingLabel(Label, BlinkingWidget):
	#parse text to labels..
	def __init__(self, text = ""):
		Label.__init__(self, text = text)
		BlinkingWidget.__init__(self)


## JobManager....
from Components.Task import Task, Job, JobManager
from Tools import Notifications

Notifications.notificationQueue.registerDomain("MusicCenterJobmanager", _("MusicCenter  Jobmanager"), Notifications.ICON_DEFAULT)


class MusicCenterJobmanager(JobManager):

	def __init__(self):
	
		JobManager.__init__(self, domain="MusicCenterJobmanager")


	def kick(self):
		if self.active_job is None:
			if len(self.active_jobs):
				self.active_jobs.sort(key=lambda a:a.name, reverse = False)
				self.active_job = self.active_jobs.pop(0)
				self.active_job.start(self.jobDone)


musiccenterJobmanager = MusicCenterJobmanager()
#musiccenterJobmanager.in_background = True


		
from mutagen.oggvorbis import OggVorbis
from mutagen.asf import ASF
from mutagen.flac import FLAC, Picture
from mutagen.mp3 import MP3
from mutagen.mp4 import MP4


class CoverLoader(object):

	def getCoverfilename(self, songfilename):
		return buildCoverthumbFilename(songfilename) 

	def isCreated(self, songfilename):
		coverfilenamewithendswith=self.getCoverfilename(songfilename)
		if os_path_exists(coverfilenamewithendswith):
			return True
		else:
			return False

	def loadfromImageFile(self, songfilename, imagefilename):
		coverfilenamewithendswith=self.getCoverfilename(songfilename)
		return self.createThumbFromFile(imagefilename, coverfilenamewithendswith)

	def load(self, songfilename):
		coverfilenamewithendswith=self.getCoverfilename(songfilename)
		if os_path_exists(coverfilenamewithendswith):
			return coverfilenamewithendswith
		else:
			return self.loadNow(songfilename, coverfilenamewithendswith)

	def loadNow(self, songfilename, coverfilenamewithendswith):
		logger.debug('CoverLoader]loadNow]songfilename {}'.format(songfilename))# coverfilenamewithendswith:{}'.format(songfilename, coverfilenamewithendswith))
		if songfilename.lower().endswith('mp3') and os_path_exists(songfilename):

			try:
				audio=MP3(songfilename)
			except:
				logger.exception('CoverLoader]loadNow]error...')
				audio={}

			frames=audio.get(u'APIC:Cover (front)', None)
			if frames is not None:
				coverframes=frames.data
				coverfilenamewithendswith=self.createThumbFromString(coverframes, coverfilenamewithendswith)
			else:
				frameslist=[audio[i] for i in audio.keys() if 'APIC:' in i]
				if len(frameslist):
					coverframes=frameslist[0].data
					coverfilenamewithendswith=self.createThumbFromString(coverframes, coverfilenamewithendswith)

		elif songfilename.lower().endswith('flac') and os_path_exists(songfilename):
			audio=FLAC(songfilename)
			if audio and audio.pictures:
				for pic in audio.pictures:
					if pic.type==3:
						coverframes=str(pic.data)
						if len(coverframes) > 0:
							coverfilenamewithendswith=self.createThumbFromString(coverframes, coverfilenamewithendswith)
						break

		elif songfilename.lower().endswith('ogg') and os_path_exists(songfilename):
			audio=OggVorbis(songfilename)
			meta=audio.get('METADATA_BLOCK_PICTURE')
			if meta and len(meta)==1:
				apicframes=Picture(base64_b64decode(meta[0])).data
				if apicframes:
					coverfilenamewithendswith=self.createThumbFromString(apicframes, coverfilenamewithendswith)
			elif meta:
				iscoverfront=False
				for cov in meta:
					covtype=Picture(base64_b64decode(cov)).type
					if covtype==3: # 3-Cover front
						apicframes=Picture(base64_b64decode(cov)).data
						if apicframes:
							coverfilenamewithendswith=self.createThumbFromString(apicframes, coverfilenamewithendswith)
							iscoverfront=True
							break
				if not iscoverfront:
					apicframes=Picture(base64_b64decode(meta[0])).data
					if apicframes:
						coverfilenamewithendswith=self.createThumbFromString(apicframes, coverfilenamewithendswith)

		elif songfilename.lower().endswith('m4a') and os_path_exists(songfilename):
			audio = MP4(songfilename)
			if audio.has_key('covr'):
				try:
					apicframes=audio['covr'][0].__str__()
					coverfilenamewithendswith=self.createThumbFromString(apicframes, coverfilenamewithendswith)
				except:
					logger.exception('CoverLoader]loadNow] m4a error fn {}'.format(coverfilenamewithendswith))
					
		return coverfilenamewithendswith

	def createThumbFromFile(self, imagefilename, coverfilenamewithendswith):
		try:
			im=Image.open(imagefilename)
			im.thumbnail((400,400),Image.ANTIALIAS)
			im=im.convert('RGB')
			im.save(coverfilenamewithendswith, quality=90)
			return coverfilenamewithendswith
		except:
			logger.exception('CoverLoader]createThumbFromFile]error coverfilenamewithendswith {}'.format(coverfilenamewithendswith))
			return coverfilenamewithendswith

	def createThumbFromString(self, coverframes, coverfilenamewithendswith):
		try:
			tempBuff = StringIO()
			tempBuff.write(coverframes)
			tempBuff.seek(0)
			im=Image.open(tempBuff)
			im.thumbnail((400,400),Image.ANTIALIAS)
			im=im.convert('RGB')
			im.save(coverfilenamewithendswith, quality=90)
			return coverfilenamewithendswith
		except:
			logger.exception('CoverLoader]createThumbFromString]error fn {}'.format(coverfilenamewithendswith))
			return coverfilenamewithendswith


PLAYABLEFORMATS=('mp3','ogg','flac','wav','wma', 'm4a')#,'mp4')



from skin import componentSizes, TemplatedListFonts
from Tools.Directories import SCOPE_CURRENT_SKIN, resolveFilename, fileExists


EXTENSIONS = {
		"m4a": "music",
		"mp2": "music",
		"mp3": "music",
		"wav": "music",
		"wma": "music",
		"ogg": "music",
		"flac": "music",
		"jpg": "picture",
		"jpeg": "picture",
		"png": "picture",
		"bmp": "picture",
		"ts": "movie",
		"avi": "movie",
		"divx": "movie",
		"m4v": "movie",
		"mpg": "movie",
		"mpeg": "movie",
		"mkv": "movie",
		"mp4": "movie",
		"mov": "movie",
		"m2ts": "movie",
		"flv": "movie",
		"wmv": "movie",
	}

def FileEntryComponent(name, absolute = None, isDir = False):
	sizes = componentSizes[componentSizes.FILE_LIST]
	tx = sizes.get("textX", 35)
	ty = sizes.get("textY", 0)
	tw = sizes.get("textWidth", 1000)
	th = sizes.get("textHeight", 25)
	pxw = sizes.get("pixmapWidth", 20)
	pxh = sizes.get("pixmapHeight", 20)

	res = [ (absolute, isDir) ]
	res.append((eListboxPythonMultiContent.TYPE_TEXT, tx, ty, tw, th, 0, RT_HALIGN_LEFT|RT_VALIGN_CENTER, name))
	if isDir:
		png = LoadPixmap(cached=True, path=resolveFilename(SCOPE_CURRENT_SKIN, "extensions/directory.png"))
	else:
		extension = name.split('.')
		extension = extension[-1].lower()
		if EXTENSIONS.has_key(extension):
			png = LoadPixmap(resolveFilename(SCOPE_CURRENT_SKIN, "extensions/" + EXTENSIONS[extension] + ".png"))
		else:
			png = None
	if png is not None:
		res.append((eListboxPythonMultiContent.TYPE_PIXMAP_ALPHABLEND, 10, (th-pxh)/2, pxw, pxh, png))

	return res

class MCFileList(MenuList):
	def __init__(self, directory, showDirectories = True, showFiles = True, showMountpoints = True, matchingPattern = None, useServiceRef = False, inhibitDirs = False, inhibitMounts = False, isTop = False, enableWrapAround = False, additionalExtensions = None):
		MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
		self.additional_extensions = additionalExtensions
		self.mountpoints = []
		self.current_directory = None
		self.current_mountpoint = None
		self.useServiceRef = useServiceRef
		self.showDirectories = showDirectories
		self.showMountpoints = showMountpoints
		self.showFiles = showFiles
		self.isTop = isTop
		# example: matching .nfi and .ts files: "^.*\.(nfi|ts)"
		self.matchingPattern = matchingPattern
		self.inhibitDirs = inhibitDirs or []
		self.inhibitMounts = inhibitMounts or []

		self.refreshMountpoints()
		self.changeDir(directory)

		tlf = TemplatedListFonts()
		self.l.setFont(0, gFont(tlf.face(tlf.MEDIUM), tlf.size(tlf.MEDIUM)))
		itemHeight = componentSizes.itemHeight(componentSizes.FILE_LIST, 25)
		self.l.setItemHeight(itemHeight)
		self.serviceHandler = eServiceCenter.getInstance()

	def refreshMountpoints(self):
		self.mountpoints = [os_path_join(p.mountpoint, "") for p in harddiskmanager.getMountedPartitions()]
		self.mountpoints.sort(reverse = True)

	def getMountpoint(self, file):
		file = os_path_join(os_path_realpath(file), "")
		for m in self.mountpoints:
			if file.startswith(m):
				return m
		return False

	def getMountpointLink(self, file):
		if os_path_realpath(file) == file:
			return self.getMountpoint(file)
		else:
			if file[-1] == "/":
				file = file[:-1]
			mp = self.getMountpoint(file)
			last = file
			file = os_path_dirname(file)
			while last != "/" and mp == self.getMountpoint(file):
				last = file
				file = os_path_dirname(file)
			return os_path_join(last, "")

	def getSelection(self):
		if self.l.getCurrentSelection() is None:
			return None
		return self.l.getCurrentSelection()[0]

	def getCurrentEvent(self):
		l = self.l.getCurrentSelection()
		if not l or l[0][1] == True:
			return None
		else:
			return self.serviceHandler.info(l[0][0]).getEvent(l[0][0])

	def getFileList(self):
		return self.list

	def inParentDirs(self, dir, parents):
		dir = os_path_realpath(dir)
		dir=dir.rsplit('/',1)[-1]# patch
		#logger.debug('MC_MultiFileSelectList]inParentDirs:{} parents:{}'.format(dir, parents))
		for p in parents:
			if dir.startswith(p):
				return True
		return False

	def changeDir(self, directory, select = None):
		self.list = []

		# if we are just entering from the list of mount points:
		if self.current_directory is None:
			if directory and self.showMountpoints:
				self.current_mountpoint = self.getMountpointLink(directory)
			else:
				self.current_mountpoint = None
		self.current_directory = directory
		directories = []
		files = []

		if directory is None and self.showMountpoints: # present available mountpoints
			for p in harddiskmanager.getMountedPartitions():
				path = os_path_join(p.mountpoint, "")
				if path not in self.inhibitMounts and not self.inParentDirs(path, self.inhibitDirs):
					self.list.append(FileEntryComponent(name = p.description, absolute = path, isDir = True))
			files = [ ]
			directories = [ ]
		elif directory is None:
			files = [ ]
			directories = [ ]
		elif self.useServiceRef:
			root = eServiceReference("2:0:1:0:0:0:0:0:0:0:" + directory)
			if self.additional_extensions:
				root.setName(self.additional_extensions)
			serviceHandler = eServiceCenter.getInstance()
			list = serviceHandler.list(root)

			while 1:
				s = list.getNext()
				if not s.valid():
					del list
					break
				if s.flags & s.mustDescent:
					directories.append(s.getPath())
				else:
					files.append(s)
			directories.sort()
			files.sort()
		else:
			if fileExists(directory):
				try:
					files = os_listdir(directory)
				except:
					files = []
				files.sort()
				tmpfiles = files[:]
				for x in tmpfiles:
					if os_path_isdir(directory + x):
						directories.append(directory + x + "/")
						files.remove(x)

		if directory is not None and self.showDirectories and not self.isTop:
			if directory == self.current_mountpoint and self.showMountpoints:
				self.list.append(FileEntryComponent(name = "<" +_("List of Storage Devices") + ">", absolute = None, isDir = True))
			elif (directory != "/") and not (self.inhibitMounts and self.getMountpoint(directory) in self.inhibitMounts):
				self.list.append(FileEntryComponent(name = "<" +_("Parent Directory") + ">", absolute = '/'.join(directory.split('/')[:-2]) + '/', isDir = True))

		if self.showDirectories:
			for x in directories:
				if not (self.inhibitMounts and self.getMountpoint(x) in self.inhibitMounts) and not self.inParentDirs(x, self.inhibitDirs):
					name = x.split('/')[-2]
					self.list.append(FileEntryComponent(name = name, absolute = x, isDir = True))

		if self.showFiles:
			for x in files:
				if self.useServiceRef:
					path = x.getPath()
					name = path.split('/')[-1]
				else:
					path = directory + x
					name = x

				if (self.matchingPattern is None) or re_compile(self.matchingPattern).search(path):
					self.list.append(FileEntryComponent(name = name, absolute = x , isDir = False))

		if self.showMountpoints and len(self.list) == 0:
			self.list.append(FileEntryComponent(name = _("nothing connected"), absolute = None, isDir = False))

		self.l.setList(self.list)

		if select is not None:
			i = 0
			self.moveToIndex(0)
			for x in self.list:
				p = x[0][0]

				if isinstance(p, eServiceReference):
					p = p.getPath()

				if p == select:
					self.moveToIndex(i)
				i += 1

	def getCurrentDirectory(self):
		return self.current_directory

	def canDescent(self):
		if self.getSelection() is None:
			return False
		return self.getSelection()[1]

	def descent(self):
		if self.getSelection() is None:
			return
		self.changeDir(self.getSelection()[0], select = self.current_directory)

	def getFilename(self):
		if self.getSelection() is None:
			return None
		x = self.getSelection()[0]
		if isinstance(x, eServiceReference):
			x = x.getPath()
		return x

	def getServiceRef(self):
		if self.getSelection() is None:
			return None
		x = self.getSelection()[0]
		if isinstance(x, eServiceReference):
			return x
		return None

	def execBegin(self):
		harddiskmanager.on_partition_list_change.append(self.partitionListChanged)

	def execEnd(self):
		harddiskmanager.on_partition_list_change.remove(self.partitionListChanged)

	def refresh(self):
		self.changeDir(self.current_directory, self.getFilename())

	def partitionListChanged(self, action, device):
		self.refreshMountpoints()
		if self.current_directory is None:
			self.refresh()

	def byNameFunc(self, a, b):
		return cmp(b[0][1], a[0][1]) or cmp(a[1][7], b[1][7])

	def sortName(self):
		self.list.sort(self.byNameFunc)
		#self.l.invalidate()
		self.l.setList(self.list)
		self.moveToIndex(0)

	def byDateFunc(self, a, b):
		try:
			stat1 = os_stat(self.current_directory + a[0][0])
			stat2 = os_stat(self.current_directory + b[0][0])
		except:
			return 0
		return cmp(b[0][1], a[0][1]) or cmp(stat2.st_ctime, stat1.st_ctime)

	def sortDate(self):
		self.list.sort(self.byDateFunc)
		#self.l.invalidate()
		self.l.setList(self.list)
		self.moveToIndex(0)


MYKEYSORT=["red", "green", "yellow", "blue", "0",  "1", "2", "3", "4", "5", "6", "7", "8", "9", "text"]


if HardwareInfo().get_device_name() in ("dm900", "dm920",):
	ARM=True
else:
	ARM=False



# last search streams
LAST_STREAM_SEARCH=''

SCSEARCHHIST=resolveFilename(SCOPE_CONFIG, 'mc_SoundcloudSearchhist')
	
TWISTED_TIMEOUT=5

MAINSCREEN=0
FILEBROWSERSCREEN=1
PLAYERSCREEN=2

#Playermodes
FILEMODE=0
SOUNDCLOUDMODE=2
DBMODE=3
RADIODE=5
RADIOBROWSER=6

#Soundcloudmodes
ROOT=500
SEARCH=501
MYLIKEDTRACKLIST=510
MYLIKEDPLAYLIST=515
USERLIKEDTRACKLIST=522
USERLIKEDPLAYLIST=523
USERPLAYLIST=524
USERFOLLOWINGSLIST=525
USERFOLLOWERLIST=526
MYSETS=540
MYLIKEDPLAYLISTTRACKLIST=516
MYFOLLOWINGSLIST=520
MYFOLLOWERSLIST=530
SEARCHHISTORY=550
FOLLOWINGUSERTRACKLIST=560
STARTPLAYER=599
SELECTUSERACTION=521
MYCOMMENTLIST=580
MYCOMMENTLISTAFTER=581
LEARNSC=582


