# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

from Globals import *

from myLogger import logger
from JobCenter import *
	

def googleentry(entry, picfilename, size, zoomfactor, nocoverptr):
	ix, iy, text, id, domain, imagetype, imageurl, tmburl = entry
	xptr,yptr=size
	
	res = [entry]

	ptr=None
	
	if fileExists(picfilename):
		ptr=LoadPixmap(cached=False, path = picfilename)
		if ptr is None:
			picload=ePicLoad()
			picload.setPara((xptr, yptr, 1, 1, False, 1, '#ff000000'))
			picload.startDecode(picfilename, False)
			logger.debug('RadioList]googleentry]LoadPixmap failed, try epicload:{}'.format(picfilename))
			ptr = picload.getData()
			
	if ptr is None:
		logger.debug('RadioList]googleentry]epicload also failed, show no cover')
		ptr = nocoverptr
		
	res.append((eListboxPythonMultiContent.TYPE_PIXMAP,  int(10*zoomfactor), 0, xptr, yptr, ptr))
	xoffset=int(xptr+20*zoomfactor)
	res.append((eListboxPythonMultiContent.TYPE_TEXT, xoffset,  int(5*zoomfactor), int((1250-xoffset)*zoomfactor), int(30*zoomfactor), 0, RT_HALIGN_LEFT|RT_VALIGN_CENTER, text)) # url
	res.append((eListboxPythonMultiContent.TYPE_TEXT, xoffset,  int(35*zoomfactor), int((1250-xoffset)*zoomfactor), int(30*zoomfactor), 1, RT_HALIGN_LEFT|RT_VALIGN_CENTER, '{}x{}  -  {}'.format(ix, iy, domain) ))
	res.append((eListboxPythonMultiContent.TYPE_TEXT, xoffset,  int(65*zoomfactor), int((1250-xoffset)*zoomfactor), int(30*zoomfactor), 2, RT_HALIGN_LEFT|RT_VALIGN_CENTER, imageurl)) # resolution
	return res


class GoogleImageSearchScreen(Screen):


	if RESOLUTIONx>1800:
		skin = """
			<screen name="GoogleImageSearchScreen"  position="0,0" size="1920,1080" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="20,20" size="1880,100" zPosition="1" /> 
				<widget name="headertext" position="140,39" size="1760,42" font="SansReg;35" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
				<ePixmap position="20,20" size="100,100" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/google_200x200.png" scale="1" zPosition="2"/>
			<!-- Buttons -->
				<eLabel position="20,135" size="1880,40" backgroundColor="#191919" zPosition="1" /> 
				<widget render="Label" font="SansReg;34" position="100,138" size="450,40" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;34" position="510,138" size="450,40" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;34" position="960,138" size="450,40" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;34" position="1410,138" size="450,40" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>	
			<!-- lists -->
				<widget name="imagelist" position="75,195" zPosition="1" size="1800,855" scrollbarMode="showOnDemand" backgroundColor="#00000000"/>
			</screen>"""
	else:
		skin = """
			<screen name="GoogleImageSearchScreen"  position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="13,13" size="1253,67" zPosition="1" /> 
				<widget name="headertext" position="96,26" size="1173,28" font="SansReg;25" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
				<ePixmap position="13,13" size="67,67" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/google_200x200.png" scale="1" zPosition="2"/>
			<!-- Buttons -->
				<eLabel position="13,90" size="1253,27" backgroundColor="#191919" zPosition="1" /> 
				<widget render="Label" font="SansReg;22" position="67,96" size="300,27" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;22" position="340,96" size="300,27" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;22" position="640,96" size="300,27" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;22" position="940,96" size="300,27" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>	
			<!-- lists -->
				<widget name="imagelist" position="50,130" zPosition="1" size="1200,570" scrollbarMode="showOnDemand" backgroundColor="#00000000"/>
			</screen>"""


	def __init__(self, session, slentry, picname='', searchterm='', sizeX=-1, sizeY=-1, face=False):

		logger.info('GoogleImageSearchScreen]__init__')
		self.session = session
		self.skin_path='/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images'
		Screen.__init__(self, session)

		self['headertext'] = Label()
		self["key_red"] = StaticText(_("Back"))
		self["key_green"] = StaticText(_("Add selected pic"))
		self["key_yellow"] = StaticText(_("Edit Serachstring"))
		self["key_blue"] = StaticText(_("Exclude Youtube results"))
		self["actions"]  = ActionMap(["OkCancelActions", "WizardActions", "ColorActions", "SetupActions", "MenuActions", "EPGSelectActions"], {
			"cancel": self.keyCancel,
			"red": self.keyCancel,
			"green" : self.greenPressed,
			"yellow" : self.yellowPressed,
			"blue" : self.bluePressed,
			}, -1)
		
		self.imagelist = []
		self['imagelist'] = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		if RESOLUTIONx>1800:
			zoomfactor=1.5
		else:
			zoomfactor=1
		self['imagelist'].l.setFont(0, gFont("SansReg", int(26*zoomfactor)))
		self['imagelist'].l.setFont(1, gFont("SansReg", int(22*zoomfactor)))
		self['imagelist'].l.setFont(2, gFont("SansReg", int(18*zoomfactor)))
		itemhigth=100*zoomfactor
		self['imagelist'].l.setItemHeight(int(itemhigth))
		self.zoomfactor=zoomfactor
		
		self.currenPlayingslentry = slentry
		self.picname=picname
		self.searchterm = searchterm
		self.sizeX=sizeX
		self.sizeY=sizeY
		self.face=face
		self.possibleimageurls=[]
		self.blockyt=False
		self.imagedlurls=[]
		self.dlcount=(0,0)
		factor=sizeX/sizeY
		yptr=itemhigth
		xptr=float(factor)*yptr
		self.size=xptr,yptr
		logger.debug('GoogleImageSearchScreen]__init__]xptr->{} yptr->{}'.format(xptr,yptr))
		
		self._cachingDeferred = None
		agent = Agent(reactor, contextFactory=TLSSNIContextFactory(), pool=HTTPConnectionPool(reactor))
		self._agent = BrowserLikeRedirectAgent(agent)
		
		self.onLayoutFinish.append(self._onLayoutFinishRun)


	def _onLayoutFinishRun(self):
		logger.debug('GoogleImageSearchScreen]_onLayoutFinishRun]searchterm->%s' %self.searchterm)			
		if self.searchterm !='':
			self.askGoogle(self.searchterm)
			self['headertext'].setText("Google search start->%s" %self.searchterm)
		else:
			self['headertext'].setText("Google image search no valid album,artist,title given, do nothing")
			logger.debug('GoogleImageSearchScreen]_onLayoutFinishRun]no valid album,artist,title given, do nothing')


	def yellowPressed(self):
		options=[]
		if not self.face:
			artist_title='{} - {}'.format(self.currenPlayingslentry.artist, self.currenPlayingslentry.title)
			options.append((_(artist_title), self.stringEditedCallback, artist_title),)
			artist_album='{} - {}'.format(self.currenPlayingslentry.artist, self.currenPlayingslentry.album)
			options.append((_(artist_album), self.stringEditedCallback, artist_album),)
		else:
			artist='{}'.format(self.currenPlayingslentry.artist)
			options.append((_(artist), self.stringEditedCallback, artist),)
			
			albumartist='{}'.format(self.currenPlayingslentry.albumartist)
			options.append((_(albumartist), self.stringEditedCallback, albumartist),)
			
		options.append((_('Edit Searchstring'), self.openStringEdit),)
		self.session.openWithCallback(self.yellowPressedCallback, ChoiceBox, title=_('Searchchoices'), list=options, keys=MYKEYSORT, titlebartext=_('MusicCenter'))


	def yellowPressedCallback(self, ret):
		if ret:
			if len(ret)==2:
				ret[1]()
			elif len(ret)==3:
				ret[1](ret[2])

				
	def openStringEdit(self):	
		self.session.openWithCallback(self.stringEditedCallback, vInputBox, title=_("old:  "+self.searchterm), windowTitle=_('MusicCenter Edit Searchstring'), text=self.searchterm)
		

	def stringEditedCallback(self, answer):
		logger.debug('GoogleImageSearchScreen]stringEditedCallback]->{}'.format(answer))
		if answer is not None:
			self['imagelist'].setList([])
			self.imagelist = []
			self.imagedlurls=[]
			self.searchterm=answer
			self._onLayoutFinishRun()

			
	def greenPressed(self):
		if os_path_isdir(self.picname):
			image_filename='{}.{}'.format(self['imagelist'].getCurrent()[0][3], self['imagelist'].getCurrent()[0][5])
			logger.debug('GoogleImageSearchScreen]greenPressed]rename image_filename from dir to file')
			destfilename=os_path_join(self.picname, os_path_basename(image_filename))
		else:
			destfilename=self.picname
		url=self['imagelist'].getCurrent()[0][6]			
		logger.debug('GoogleImageSearchScreen]greenPressed]download picfilename:{} to destfilename:{}'.format(url, destfilename))
		#dl=mcSSLdownloadPage(self['imagelist'].getCurrent()[0][6], destfilename)
		#dl.addCallback(self.downloadFinish, destfilename)
		#dl.addErrback(self.downloadError, destfilename)
		self._cachingDeferred = self._agent.request('GET', url)
		self._cachingDeferred.addCallbacks(self._downloadFinish, self._downloadError, callbackArgs=[destfilename,])


	def _downloadFinish(self, response, destfilename):
		self._cachingDeferred = readBody(response)
		self._cachingDeferred.addCallbacks(self._onDownloadPageBody, self._downloadError, callbackArgs=[destfilename,])


	def _onDownloadPageBody(self, body, destfilename):
		with open(destfilename, 'w') as f:
			f.write(body)
		self._cachingDeferred = None
		self.close([self.currenPlayingslentry, destfilename, None])


	def _downloadError(self, error, destfilename):
		self._cachingDeferred = None
		logger.error('GoogleImageSearchScreen]downloadError]->%s' %error)
		self.keyCancel()

		
	def keyCancel(self):
		self.close([None, None, 'No image found'])


	def __onClose(self):
		if self._cachingDeferred:
			logger.error('GoogleImageSearchScreen]__onClose]cancel pending downloads')
			self._cachingDeferred.cancel()
			
			
	def askGoogle(self, searchterm):
		
		searchterm = quote(searchterm.replace(' ', '+'))
		
		if self.blockyt:
			 searchterm = searchterm + '+-youtube'
			
		if self.sizeX == -1 and self.sizeY == -1:
			if self.face:
				url='https://www.google.de/search?q={}&tbs=isz:ex,itp:face&tbm=isch'.format(searchterm)
			else:
				url='https://www.google.de/search?q={}&tbs=isz:ex&tbm=isch'.format(searchterm)			
		else:
			if self.face:
				#https://www.google.de/search?q=Andrea+Berg&tbs=isz:ex,iszw:1920,iszh:1080,itp:face&tbm=isch&source=lnt
				url='https://www.google.de/search?q={}&tbs=isz:ex,iszw:{},iszh:{},itp:face&tbm=isch'.format(searchterm, self.sizeX, self.sizeY)
			else:
				url='https://www.google.de/search?q={}&tbs=isz:ex,iszw:{},iszh:{}&tbm=isch'.format(searchterm, self.sizeX, self.sizeY)
				
		logger.info('GoogleImageSearchScreen]askGoogle]url:{}'.format(url))
		getPage(url, timeout=TWISTED_TIMEOUT, agent='Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.17 (KHTML, like Gecko) Chrome/24.0.1312.56 Safari/537.17').addCallback(self.askGoogleCallback,).addErrback(self.getGoogleSearchErrback, 'getpageEntry')

		
	def askGoogleCallback(self, result):

		#with open('/tmp/mc/image_serach_result.txt', 'wb') as f:
		#	f.write(result)
		#	f.write(base64_b64decode(result))
		
		restring = '<!--m--><div jscontroller=.*?class="rg_ilmbg"> (.*?)&nbsp;&#215;&nbsp;(.*?)  </div></a><.*?nJGrxf">(.*?)</div><div class.*?"id":"(.*?):","isu":"(.*?)",".*?"ity":"(.*?)","oh":.*?,"ou":"(.*?)","ow".*?"tu":"(.*?)","tw":'
		# neu 2019.11.10
		#restring = '<!--m--><div jscontroller=.*?class="rg_ilmbg"> (.*?)&nbsp;&#215;&nbsp;(.*?)  </div></a><.*?nJGrxf">(.*?)</div><div class.*?"id":"(.*?):","isu":"(.*?)",".*?"ity":"(.*?)","oh":.*?,"ou":"(.*?)","ow".*?"tu":"(.*?)/\u0026s","tw":'
		self.googlematches=re_findall(restring, result)

		result = None
		
		if not self.googlematches:
			logger.warn('GoogleImageSearchScreen]askGoogleCallback]No images found..., show no cover')	
			self['headertext'].setText("No images found!")		
			return

		self.grabUrlsNow()

		
	def grabUrlsNow(self):
	
		class objectview(object):
			def __init__(self, d):
				self.__dict__ = d
	
		i = 0
		downloads = []
		ds = defer.DeferredSemaphore(tokens=5)
		
		for  entry in self.googlematches:
					
			if i == 24:
				break
		
			x, y, text, id, domain, imagetype, imageurl, tmburl = entry
			#logger.debug('GoogleImageSearchScreen]DownloadImages]x:{} y:{} text:{} id:{} imagetype:{} imageurl:{} tmburl:{}'.format(x, y, text, id, imagetype, imageurl, tmburl))
				
			if imageurl.lower().endswith('.gif'): # sort out gif
				logger.debug('GoogleImageSearchScreen]askGoogleCallback]is GIF, sort out:{}'.format(imageurl))
				pass
			else:
				i += 1
				if not imagetype:
					imagetype = 'unknown'
				local_filename = '/tmp/mc/{}.{}'.format(id, imagetype)
				imageentry=objectview({'entry':entry, 'filename':local_filename, 'imageurl':imageurl})
				self.imagedlurls.append(imageentry)
				if not fileExists(local_filename):
					tmburl = tmburl.replace('q\\u003dtbn', 'q=tbn')
					tmburl = tmburl.replace('\\u0026s', '&')# neu 2019.11.10
					logger.debug('GoogleImageSearchScreen]DownloadImages]add to downloads tmburl->%s local_filename->%s' %(tmburl, local_filename))
					downloads.append(ds.run(mcdownloadPage, tmburl, local_filename).addCallback(self.finishedPicDownload).addErrback(self.getGoogleSearchErrback, 'finishedPicDownloadError'))
		
		finished = defer.DeferredList(downloads).addCallback(self.finishedAllPicDownloads).addErrback(self.getGoogleSearchErrback, 'finishedAllPicDownloadsError')			
		self.dlcount=(0, len(downloads))

		
	def getGoogleSearchErrback(self, error, jobname):
		logger.error('GoogleImageSearchScreen]getGoogleSearchErrback]{} -> {}'.format(jobname, error))
		self['headertext'].setText('error->%s ->%s' %(jobname, error))


	def finishedPicDownload(self, result):
		#logger.debug('GoogleImageSearchScreen]finishedPicDownload]result%s' %(result))
		self.dlcount = (self.dlcount[0]+1, self.dlcount[1])
		self['headertext'].setText(_('Images found, downloaded images %d/%d' %(self.dlcount)))

		
	def finishedAllPicDownloads(self, result):
	
		nocoverptr=LoadPixmap(cached=False, path=drawImageJobWithLongMultilineText(text=_('No Stationicon'), size=(200,200), fontsize=30, round=20, out='/tmp/mc/radiobrowser_no_icon.png', force=True))

		for entry in self.imagedlurls:
		
			try:
				im=Image.open(entry.filename)
				if entry.filename.endswith('unknown'):
					logger.debug('GoogleImageSearchScreen]finishedAllPicDownloads]unknown image type:{}'.format(entry.filename))
					imagetype = im.format.lower()
					entry.filename = '{}.{}'.format(entry.filename.rsplit('.',1)[0], im.format.lower())
					logger.debug('GoogleImageSearchScreen]finishedAllPicDownloads]save as:{}'.format(entry.filename))
					im.save(entry.filename)
					
				self.imagelist.append(googleentry(entry.entry, entry.filename, self.size, self.zoomfactor, nocoverptr))
				
			except IOError:
				pass
				
		self['imagelist'].setList(self.imagelist)
		lenimagelist=len(self.imagelist)
		if lenimagelist:
			self['headertext'].setText("%d images->%s" %(lenimagelist, self.searchterm))
		else:
			self['headertext'].setText("No images found, press yellow key for edit search!")

			
	def errorAllPicDownloads(self, error):
		logger.error('GoogleImageSearchScreen]errorAllPicDownloads]error %s' %(error.getErrorMessage()))
		self['headertext'].setText("No images found for %s" %self.searchterm)

		
	def bluePressed(self):
		logger.debug('GoogleImageSearchScreen]bluePressed]reset image list')
		self.imagelist=[]
		self.imagedlurls=[]
		self.blockyt = not self.blockyt

		if self.blockyt:
			self["key_blue"].setText(_("Include Youtube results"))
		else:
			self["key_blue"].setText(_("Exclude Youtube results"))
			
		self.askGoogle(self.searchterm)

