# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

# from __future__ import unicode_literals -> crash enigma

from Globals import *
from radiodeApi import RadioDeApi
from SQLConnector import *
from myLogger import logger
from ItemClasses import *
from JobCenter2 import parsePictoCovercollection, drawImageJobWithLongMultilineText, calcPointerColors, createGradientPNG, drawImageJobWithLongText
from tagger import getID3Tags, myenCode, id3writerthreadinstance
from threading import Lock
from enigma import ePixmap, ePicLoad

from youtube_dl import YoutubeDL as youtube_dl_YoutubeDL


class MC_LCDText(Screen):


	skin="""
		<screen position="0,0" size="132,64" id="1">
			<widget name="text1" position="3,5" size="128,14" font="SansReg;12"/>
			<widget name="text2" position="3,21" size="128,14" font="SansReg;12"/>
			<widget name="text3" position="3,37" size="128,12" font="SansReg;10"/>
			<widget name="text4" position="3,51" size="128,10" font="SansReg;8"/>
		</screen>"""


	def __init__(self, session, parent):
		Screen.__init__(self, session)
		self["text1"]=Label()
		self["text2"]=Label()
		self["text3"]=Label()
		self["text4"]=Label()

	def setText(self, text, line):
		if line == 1:
			self["text1"].setText(text)
		elif line == 2:
			self["text2"].setText(text)
		elif line == 3:
			self["text3"].setText(text)
		elif line == 4:
			self["text4"].setText(text)


class PicLoaderScale(Pixmap):


	def __init__(self, width=None, height=None, transparent=False, name='n/a'):
		logger.info('PicLoaderScale]__init__]name:{}'.format(name))
		Pixmap.__init__(self)
		self.__picload=ePicLoad()
		self._name=name
		self.__forceshow=False
		self.currentpic='' #on Player get name,for set grey pic
		self.forceshow=False

		if transparent:
			bcolor="#ff000000"
		else:
			bcolor="#00000000"

		if width!=None and height!=None:
			self.__picload.setPara((width, height, width, height, False, 1, bcolor))
			self.__has_w_h=True
		else:
			self.__bcolor=bcolor
			self.__has_w_h=False

		self.__picload_conn = self.__picload.PictureData.connect(self._setPixmapNow)

	def doshow(self, filename, forceshow=False):
		self.forceshow=forceshow
		#logger.info('PicLoaderScale]doshow]{}->{}'.format(self._name, filename))
		if not self.__has_w_h:
			s = self.instance.size()
			#config.pic.resize = ConfigSelection(default="2", choices = [("0", _("simple")), ("1", _("better")), ("2", _("fast JPEG"))])
			#config.pic.resize.value = 2 # 2 = fast JPEG (non JPEG fallback to 1)
			#0=Width 1=Height 2=Aspect 3=use_cache 4=resize_type 5=Background(#AARRGGBB)
			#params=(self._scaleSize.width(), self._scaleSize.height(), sc[0], sc[1], config.pic.cache.value, int(config.pic.resize.value), "#00000000")
			self.__picload.setPara((s.width(), s.height(), s.width(), s.height(), False, 1, self.__bcolor)) # ((width, height, 1, 1, False, 1, self.__bcolor))
		self.__picload.startDecode(filename)#, True) # filename, async

	def _setPixmapNow(self, filename=''):
		filename=filename.split('\n')[0]
		self.currentpic=filename
		ptr = self.__picload.getData()
		if ptr != None:
			self.instance.setPixmap(ptr)
			ptr = None
			if self.forceshow: # if self.instance.isVisible() or self.forceshow:
				self.instance.show()
		else:
			logger.error('PicLoaderScale]_setPixmapNow]no ptr name:{}'.format(self._name))


	def dohide(self):
		self.instance.hide()



def mygetPage(*args, **kwargs):
	if 'agent' not in kwargs:
		kwargs['agent'] =MCUSERAGNET
	return getPage(*args, **kwargs)


def downloadFunction(item):
	#logger.info('JobCenter]downloadFunction]Starturl->%s fn->%s' %(item.url, item.filename))
	#return downloadPage(item.url, file(item.filename, 'wb'),  headers={'Content-Type':'application/x-www-form-urlencoded'})
	return downloadPage(item.url, item.filename,  headers={'Content-Type':'application/x-www-form-urlencoded'})


def cleanName(name):# fit all other name
	
	chars_to_remove = ['.', '!', '?', '_', '/', ':', '.', '*', '+', '-', '|', '!', '%', '&', '`', '=', '$', '','#', '\\','{','}','[',']','(',')','>']
	
	for ch in chars_to_remove:
		if ch in name:
			name = name.replace(ch,' ')
	return ' '.join(name.split())


def fitArtistname(name): #Fit artistname
	return name.lower().split('feat',1)[0].split(' ft',1)[0].replace('_','').replace('/','').replace("'",'').replace(' | ',' ').strip().title()


def getmyip():
	s= socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	try:
		return socket.inet_ntoa(fcntl_ioctl(s.fileno(),0x8915,struct_pack('256s', 'eth0'[:15]))[20:24])
	except:
		try:
			return socket.inet_ntoa(fcntl_ioctl(s.fileno(),0x8915,struct_pack('256s', 'wl0'[:15]))[20:24])
		except:
			return ([(s.connect(('8.8.8.8', 80)), s.getsockname()[0], s.close()) for s in [socket.socket(socket.AF_INET, socket.SOCK_DGRAM)]][0][1])


def getRealPath(fn):
	if os_path_islink(fn):
		realfn=os_path_realpath(fn)
		return realfn
	else:
		return fn


class McServicePositionGauge(baseServicePositionGauge):

	def __init__(self, navcore):
		GUIComponent.__init__(self)
		baseServicePositionGauge.__init__(self, navcore)
		self.onPollAppend=[ ]

	def pollAppend(self, data):
		for f in self.onPollAppend:
			f(data)

	def newService(self):
		if self.get() is None:
			self.disablePolling()
		else:
			self.enablePolling(interval=300) # old 200
			self.newCuesheet()

	def poll(self):
		data = self.get()
		if data is None:
			return

		if self.instance is not None:
			self.instance.setLength(data[0])
			self.instance.setPosition(data[1])
			self.pollAppend(data)

	def connectPollAppend(self, fnc):
		if not fnc in self.onPollAppend:
			self.onPollAppend.append(fnc)



def JCdeleteSongfileonThread(filename, songID=-3, connection=None):
	try:
		logger.info('JCdeleteSongfileonThread]filename {} songID {}'.format(filename, songID))
		if filename.startswith(config.plugins.musiccenter.defaultfilebrowserpath.value):# file is in musiclib
			fullfnindb=filename[len(config.plugins.musiccenter.defaultfilebrowserpath.value):]

			if songID<0:
				logger.info('JCdeleteSongfileonThread]songID is unknown, resolve fullfnindb {}'.format(fullfnindb))
				cursor=execSQLCommandWithReturn('''SELECT song_id FROM Songs  WHERE filename=?''', (fullfnindb,), connection).fetchone()
				if cursor is not None:
					logger.info('JCdeleteSongfileonThread]songID is {}'.format(songID))

			if songID!=None:
				execSQLCommand('''DELETE FROM Songs  WHERE filename=?''', (fullfnindb,), connection)
				execSQLCommand('''DELETE FROM playlist_songs WHERE song_id=?''', (songID,), connection)
			else:
				logger.info('JCdeleteSongfileonThread]file not found in database, abort!')

		wavefn=buildWaveFilename(filename)
		coverfn=CoverLoader().getCoverfilename(filename)
		for fn in [filename, wavefn, coverfn]:
			if fileExists(fn):
				logger.debug('JCdeleteSongfileonThread]delete {}'.format(fn))
				os_remove(fn)

	except:
		logger.exception('JCdeleteSongfileonThread]exception...')

	logger.debug('JCdeleteSongfileonThread]done')

	return 'deleted:'+filename



class downloadJob(Job): #soundcloud...

	def __init__(self, url, file, title, soundcloud=None):
		Job.__init__(self, title)
		# fit this the error crash?
		#self.state_changed = CList()

		downloadTask(self, url, file, soundcloud)

class downloadTask(Task):

	def __init__(self, job, url, file, soundcloud):
		Task.__init__(self, job, ("download task"))
		self.waitTimer=eTimer()
		self.waitTimer_mc_conn=self.waitTimer.timeout.connect(self.http_failed)
		self.end=100
		self.url=url
		self.local=file
		self.progress=0
		self.soundcloud=soundcloud

	def prepare(self):
		self.error=None

	def run(self, callback):
		self.callback=callback
		downloadPage(self.url, self.local, agent='Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.17 (KHTML, like Gecko) Chrome/24.0.1312.56 Safari/537.17').addCallback(self.http_finished).addErrback(self.http_failed)

	def http_finished(self, res):
		logger.info('downloadTask]dlPlayingSongFinish]res->%s' %res)
		if self.soundcloud:
			pass

		fileToDatabase.Start(self.local)
		self.progress=100
		Task.processFinished(self, 0)

	def http_failed(self, error='None'):
		logger.error('downloadTask]dlPlayingSongError]error->%s' %error)
		self.progress=100
		Task.processFinished(self, 1)


def buildSonglistEntry(row):
	# globale eintrge der songlisten
	#logger.info('buildSonglistEntry]row[cover]:{}'.format(row['cover']))
	fullfilename=config.plugins.musiccenter.defaultfilebrowserpath.value+row['filename']
	if row['cover']==1:
		CoverLoader().load(fullfilename)
	slentry=Item(mode='PLAY', songID=row['song_id'], text=os_path_split(row['filename'])[-1], filename=fullfilename, title=row['title'], artist=row['artist'], bitrate=row['bitrate'], length=row['length'], genre=row['genre'], track=row['track'], date=row['date'], album=row['album'], audio=True, albumartist=row['albumartist'], filetype=row['filetype'], playcount=row['playcount'], rating=row['rating'], wave=row['wave'], cover=row['cover'], join=True)
	return slentry

def constructArtistthumbfilename(artist):
	c=fitName(artist)
	thumb=''.join((config.plugins.musiccenter.downloadcache.value, "artistpics/", c[:1], '/', c, '/artist.tumb'))
	if not pathExists(thumb):
		thumb='/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/no_artist_125x125.png'
	return thumb


# new 2018
class ID3WriterJob(Job):

	def __init__(self, slentry, id3dict):

		jobtitle = 'Write ID3 Tags:{} on {}'.format(' '.join(id3dict.keys()), slentry.filename.rsplit('/',1)[1])
		logger.info('ID3WriterJob] __init__] {}'.format(jobtitle))

		Job.__init__(self, jobtitle)

		ID3WriterTask(self, slentry, id3dict)

		#self.saveJobvalues(slentry, id3dict)


	def saveJobvalues(self, slentry, id3dict):
		d={}
		d['slentry']=slentry
		d['id3dict']=id3dict
		with open('/tmp/openjobs' , 'a+') as f:
			f.write(json_dumps(d)+'\n')


class ID3WriterTask(Task):

	def __init__(self, job, slentry, id3dict):

		logger.info('ID3WriterTask] __init__]{}'.format(slentry.songID))
		Task.__init__(self, job, 'ID3WriterTask')

		self.slentry=slentry
		self.id3dict=id3dict
		self.progress=0

		self.waitTimer=eTimer()
		self.waitTimer_mc_conn=self.waitTimer.timeout.connect(self.checkfinish)

	def run(self, callback):
		logger.info('ID3WriterTask] run]{}'.format(self.slentry.songID))
		self.callback=callback
		id3writerthreadinstance.Start(self.slentry, self.id3dict)
		self.waitTimer.start(50,1)
		self.progress=10


	def checkfinish(self):
		if id3writerthreadinstance.isRunning:
			self.progress=id3writerthreadinstance.theProgress
			self.waitTimer.start(50,1)
		else:
			if self.waitTimer.isActive():
				self.waitTimer.stop()
			self.progress=100
			Task.processFinished(self, 0)


# Database
def OpenDB_Streaming(dbname=None, getpath=None):
	if dbname is None:
		return None
	dbpath=os_path_join(config.plugins.musiccenter.databasepath.value ,dbname)
	db_exists=False
	if os_path_exists(dbpath):
		db_exists=True
	try:
		connection=sqlite.connect(dbpath, timeout=10)
		if not os_access(dbpath, os_W_OK):
			logger.error("OpenDB_Streaming]Error: database file needs to be writable, can not open %s for writing..." % dbpath)
			connection.close()
			return None
	except Exception, e:
		logger.error("OpenDB_Streaming]unable to open database file: %s" %dbpath)
		logger.error("OpenDB_Streaming]unable to open database file:Exception %s" %e)
		return None
	if not db_exists :
		if dbname == 'musiccenter_stream_favorites.db':
			connection.execute('CREATE TABLE IF NOT EXISTS Stream_Favorites (station_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, stationname TEXT NOT NULL, genre TEXT, location TEXT, bitrate INTEGER, codec TEXT, streamtype TEXT, stationhp TEXT, streamurl TEXT, stationicon TEXT, streamID INTEGER, filetype TEXT, clicks INTEGER DEFAULT 0, votes INTEGER DEFAULT 0);')
			connection.execute('CREATE TABLE IF NOT EXISTS Stream_Recent (station_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, stationname TEXT NOT NULL, genre TEXT, location TEXT, bitrate INTEGER, codec TEXT, streamtype TEXT, stationhp TEXT, streamurl TEXT, stationicon TEXT, streamID INTEGER ,filetype TEXT, clicks INTEGER DEFAULT 0, votes INTEGER DEFAULT 0);')
	if getpath is None:
		return connection
	else:
		return connection, dbpath

def sqlCommand_Streaming_WithReturn(sql, args=None, dbname=None):
	logger.info('sqlCommand_Streaming_WithReturn]sql->%s args->%s' %(str(sql), str(args)))
	c=OpenDB_Streaming(dbname)
	if c is not None:
		with c:
			c.row_factory = sqlite3_Row
			c.text_factory=str
			csr=c.cursor()
			if args!=None:
				csr.execute(sql, args)
			else:
				csr.execute(sql)
		return csr
	else:
		csr=None
		return csr


def addStreamToFavoriteList(sel): # radiobrowser, radio.de ->streamtype is fromsearch
	picdir = os_path_join(config.plugins.musiccenter.downloadcache.value, 'favoritestationicons')
	if not pathExists(picdir):
		if not createDir(picdir):
			logger.error('addStreamToFavoriteList]error create picdir:{} use temporary:/tmp/mc/'.format(picdir))
			picdir="/tmp/mc/"
	stationicon = os_path_join(picdir, sel.stationicon.rsplit('/',1)[-1])
	bitrate = sel.bitrate.replace('kbit','')
	logger.info('addStreamToFavoriteList]add stream stationname:{} genre:{} location:{} bitrate:{} codec:{} streamurl:{} stationicon:{} streamID:{} filetype:{} clicks:{} votes:{}'.format(sel.stationname, sel.genre, sel.location, bitrate, sel.codec, sel.streamurl, stationicon, sel.streamID, sel.filetype, sel.playcount, sel.rating))

	sql='''INSERT INTO Stream_Favorites(stationname, genre, location, bitrate, codec, streamurl, stationicon, streamID, filetype, clicks, votes)
	VALUES(?,?,?,?,?,?,?,?,?,?,?);'''
	args=(sel.stationname, sel.genre, sel.location, bitrate, sel.codec, sel.streamurl, sel.stationicon, sel.streamID, sel.filetype, sel.playcount, sel.rating)
	cursor=sqlCommand_Streaming_WithReturn(sql, args, dbname='musiccenter_stream_favorites.db')
	logger.info('addStreamToFavoriteList]done:{}'.format(cursor))


def removeStreamFromFavoriteList(sel):
	logger.info('removeStreamFromFavoriteList]station_id->%s streamID->%s filetype->%s' %(sel.songID, sel.streamID, sel.filetype))
	sql='''DELETE FROM  Stream_Favorites WHERE station_id=?;'''
	args=(sel.songID,)
	cursor=sqlCommand_Streaming_WithReturn(sql, args, dbname='musiccenter_stream_favorites.db')
	logger.info('removeStreamFromFavoriteList]%s' %cursor)
	sql='''VACUUM'''
	cursor=sqlCommand_Streaming_WithReturn(sql, dbname='musiccenter_stream_favorites.db')
	logger.info('removeStreamFromFavoriteList] vacuum db-->%s' %cursor)




class ScanPath(Thread):
	'''
	scan files to generate songlist for playing
	'''

	def __init__(self):
		Thread.__init__(self)
		self.__running=False
		self.__cancel=False
		self.__fileList=[]
		self.__messages=ThreadQueue()
		self.__messagePump=ePythonMessagePump()

	def __getRunning(self):
		return self.__running

	def __getMessagePump(self):
		return self.__messagePump

	def __getMessageQueue(self):
		return self.__messages

	MessagePump=property(__getMessagePump)
	Message=property(__getMessageQueue)
	isRunning=property(__getRunning)

	def Start(self, fileList=[], update_event_after_run=True, playlistID = -1):
		if not self.__running:
			self.__fileList=fileList
			self.__update_event_after_run=update_event_after_run
			self.__playlistID = playlistID
			self.__running=True
			self.start()
		else:
			m='ScanPath]Start]old thread is running, abort!'
			logger.info(m)
			self.__messages.push(('THREAD_EXCEPTED', m, ''))
			self.__messagePump.send(0)

	def Cancel(self):
		self.__cancel=True

	def run(self):

		logger.info('ScanPath]run]start')
		mp=self.__messagePump
		ms=self.__messages
		__fileList=self.__fileList
		starttime=time_time()
		lensongList=len(__fileList)
		songlist=[]
		count=0
		coverfnlist=[]

		if lensongList:
			connection=OpenDatabase()
			coverLoader=CoverLoader()
			toinsertsongs=[]
			toupdatesongs=[]
			if connection!=None:
				with connection:
					connection.row_factory = sqlite3_Row
					connection.text_factory=str
					cursor=connection.cursor()
					logger.info('ScanPath]run]songlist has len...')
					musiclibbasepath=config.plugins.musiccenter.defaultfilebrowserpath.value
					pathoffset=len(musiclibbasepath)
					row=cursor.execute('''select seq from sqlite_sequence where name="Songs";''').fetchone()
					if row is not None:
						lastrowid=int(row['seq'])
					else:
						lastrowid=-1

					logger.info('ScanPath]run]lastrowid->%d' %lastrowid)
					for index, fullfn in enumerate(__fileList):

						if self.__cancel:
							break

						coverfn=coverLoader.getCoverfilename(fullfn)
						if not fileExists(coverfn):
							coverfnlist.append(fullfn)

						root, filename=os_path_split(fullfn)
						if not fullfn.startswith(musiclibbasepath): # path is NOT in musiclib
							ID3=getID3Tags(root, filename)
							slentry=Item(songID=index*-1, text=filename, filename=fullfn, title=ID3.title, artist=ID3.artist, bitrate=ID3.bitrate, length=ID3.length, genre=ID3.genre, track=ID3.track, date=ID3.date, album=ID3.album, audio=ID3.audio, tracknr=ID3.tracknr, albumartist=ID3.albumartist, filetype=ID3.filetype, playcount=ID3.playcount, rating=ID3.rating, wave=ID3.wave, cover=ID3.hasapicframes, coverfn=coverfn, youtubeurl=ID3.youtubeurl)
						else: # path is in musiclib
							fullfnindb=fullfn[pathoffset:]
							toupdsongID=-1
							songisindb=cursor.execute('''SELECT song_id, track, title, bitrate, length, filetype, playcount, rating, wave, file_m_time, file_size, artist, albumartist, album, genre, date, cover, shazam_id, youtubeurl, (SELECT shazam_id from Artists WHERE artist_text=Songs.artist) as shazam_artist_id from Songs WHERE filename=? LIMIT 1;''', (fullfnindb,)).fetchone()
							if songisindb: # schon in db, prfe auf Vernderung...
								#logger.info('ScanPath]run]songisindb->%s' %str(songisindb))
								if (os_path_getmtime(fullfn)) > songisindb['file_m_time'] or songisindb['file_size'] != (os_path_getsize(fullfn)):
									toupdsongID=songisindb['song_id']
									#logger.info('ScanPath]run]File time->%s or size->%s was changed ->update song_id->%s'%(os_path_isdir_getmtime(fullfn), songisindb['file_m_time'], toupdsongID))
									songisindb=None
								else:
									slentry=Item(songID=songisindb['song_id'], text=filename, filename=fullfn, title=songisindb['title'], artist=songisindb['artist'], bitrate=songisindb['bitrate'], length=songisindb['length'], genre=songisindb['genre'], track=songisindb['track'], date=songisindb['date'], album=songisindb['album'], audio=True, albumartist=songisindb['albumartist'], filetype=songisindb['filetype'], playcount=songisindb['playcount'], rating=songisindb['rating'], wave=songisindb['wave'], cover=songisindb['cover'], coverfn=coverfn, shazamtitleID=songisindb['shazam_id'], shazamartistID=songisindb['shazam_artist_id'], youtubeurl=songisindb['youtubeurl'], playlistID = self.__playlistID)
									#logger.info('ScanPath]run]File is unchanged, get db wave?->%s' %str(songisindb['wave'][:50]))
							else:
								logger.info('ScanPath]run]File not in db,scan now...')

							if not songisindb:
								ID3=getID3Tags(root, filename)
								#logger.info('ScanPath]run]getID3Tags finish')
								if ID3.filetype:
									try:
										file_m_time=(os_path_getmtime(fullfn))
										file_size=(os_path_getsize(fullfn))
										if toupdsongID == -1 :
											logger.info('ScanPath]run]Insert new song->%s'%fullfn)
											toinsertsongs.append((fullfnindb, ID3.title, ID3.artist, ID3.album, ID3.albumartist, ID3.genre, ID3.date, ID3.tracknr, ID3.bitrate, ID3.length, ID3.track, ID3.filetype, file_m_time, file_size, ID3.playcount, ID3.rating, ID3.wave, time_time(), ID3.hasapicframes, ID3.youtubeurl))
											lastrowid=lastrowid+1
											song_id=lastrowid
										else:
											logger.info('ScanPath]run]Update song->%s'%fullfn)
											toupdatesongs.append((fullfnindb, ID3.title, ID3.artist, ID3.album, ID3.albumartist, ID3.genre, ID3.date, ID3.tracknr, ID3.bitrate, ID3.length, ID3.track, ID3.filetype, file_m_time, file_size, ID3.playcount, ID3.rating, ID3.wave, ID3.hasapicframes, ID3.youtubeurl, toupdsongID))
											song_id=toupdsongID

										slentry=Item(songID=song_id, text=filename, filename=fullfn, title=ID3.title, artist=ID3.artist, bitrate=ID3.bitrate, length=ID3.length, genre=ID3.genre, track=ID3.track, date=ID3.date, album=ID3.album, audio=ID3.audio, tracknr=ID3.tracknr, albumartist=ID3.albumartist, filetype=ID3.filetype, playcount=ID3.playcount, rating=ID3.rating, wave=ID3.wave, cover=ID3.hasapicframes, coverfn=coverfn, youtubeurl=ID3.youtubeurl, playlistID = self.__playlistID)
									except Exception, e:
										logger.error('ScanPath]run]WRITE DB error->%s file->%s' %(e, fullfn))

								else:
									logger.error('ScanPath]run]Hmm! ! ! ! not good song {}'.format(fullfn))
									slentry=Item()

						count+=1
						#logger.debug('ScanPath]run]songid {}'.format(slentry.songID))
						songlist.append((slentry,))
						if index==0 and lensongList>1:
							starttime=time_time()
							m=('THREAD_WORKING', count, '')
							ms.push(m)
							mp.send(0)
						elif index<lensongList-1:
							ctime=time_time()-starttime
							#logger.info('ScanPath]run]scan count{}'.format(count))
							if ctime > 0.3:
								starttime=time_time()
								m=('THREAD_WORKING', count, '')
								ms.push(m)
								mp.send(0)
						else:
							m=('THREAD_SCAN_FINISHED', count, songlist)
							logger.info('ScanPath]run]push:{} count:{}'.format(m[0], count))
							ms.push(m)
							mp.send(0)


		else:
			logger.info('ScanPath]run]no songlist given...')

		logger.info('ScanPath]run]filescan done')
		if toupdatesongs or toinsertsongs:
			logger.info('ScanPath]run]execute now sql updates')
			if connection!=None:
				with connection:
					connection.text_factory=str
					cursor=connection.cursor()
					logger.info('ScanPath]DROP INDEX index_filename')
					connection.execute('''DROP INDEX IF EXISTS index_filename;''')
					if toupdatesongs:
						logger.info('ScanPath]run]update rows now...')
						cursor.executemany('''UPDATE Songs SET filename=?, title=?, artist=?, album=?, albumartist=?, genre=?, date=?, tracknumber=?, bitrate=?, length=?, track=?, filetype=?, file_m_time=?, file_size=?, playcount=?, rating=?, wave=?, cover=?, youtubeurl=? WHERE song_id=?;''' ,toupdatesongs)
					if toinsertsongs:
						logger.info('ScanPath]run]insert rows now...')
						cursor.executemany('''INSERT INTO Songs (filename, title, artist, album, albumartist, genre, date, tracknumber, bitrate, length, track, filetype, file_m_time, file_size, playcount, rating, wave, scantime, cover, youtubeurl) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);''' ,toinsertsongs)
					logger.info('ScanPath]Recreate INDEX index_filename on songs')
					cursor=connection.cursor()
					cursor.execute('''CREATE INDEX IF NOT EXISTS index_filename ON Songs(filename);''')
					logger.info('ScanPath]Recreate INDEX done')

		else:
			logger.info('ScanPath]run]no sql toupdatesongs wait 1 second')
			time_sleep(0.5)

		logger.info('ScanPath]run]extract now missing cover thumbs...')
		# update missing thumbs
		for coverfn in coverfnlist:
			if self.__cancel:
				break
			coverLoader.load(coverfn)

		logger.info('ScanPath]run]extract cover thumbs done THREAD_FINISHED!')
		ms.push(('THREAD_FINISHED', self.__update_event_after_run, ''))
		mp.send(0)

		songlist=[]
		count=0
		coverfnlist=[]

		Thread.__init__(self)
		self.__running=False
		self.__cancel=False
		self.__fileList=[]


scanPath=ScanPath()


class PathToDatabaseThreadQueue:
	def __init__(self):
		self.__list = [ ]
		self.__lock = Lock()

	def push(self, val):
		lock = self.__lock
		lock.acquire()
		self.__list.append(val)
		lock.release()

	def pop(self):
		lock = self.__lock
		lock.acquire()
		ret = self.__list.pop()
		lock.release()
		return ret


class PathToDatabase(Thread):

	def __init__(self):

		Thread.__init__(self)
		self.__running=False
		self.__cancelscandb=False
		self.__path=None

		self.__messages=PathToDatabaseThreadQueue()
		self.__messagePump=ePythonMessagePump()

	def __getMessagePump(self):
		return self.__messagePump

	def __getMessageQueue(self):
		return self.__messages

	def __getRunning(self):
		return self.__running

	def CancelScanDB(self):
		logger.info('PathToDatabase]CancelScanDB]')
		self.__cancelscandb=True

	MessagePump=property(__getMessagePump)
	Message=property(__getMessageQueue)
	isRunning=property(__getRunning)

	def Start(self, path):
		if not self.__running:
			self.__running=True
			logger.info('PathToDatabase]Start]not running, start run! with job:%s' %path)
			self.__path=path
			self.start()
		else:
			logger.info('PathToDatabase]Start]old job is running, abort!')
			return

	def run(self):

		logger.info('PathToDatabase]start!')
		musiclibbasepath=config.plugins.musiccenter.defaultfilebrowserpath.value
		path=self.__path
		coverLoader=CoverLoader()
		lasttime=starttime=time_time()

		if path is None:
			self.sendMessage(('THREAD_WORKING',"Cleanup Database Start!",), log=True)
			connection=OpenDatabase()
			deletecount=self.cleaningDatabase('Cleanup Database ', connection, starttime, lasttime)
			self.sendMessage(('THREAD_FINISHED',"Cleanup Database complete {} Songs deleted".format(deletecount),), log=True)

		elif not path.startswith(musiclibbasepath): # path is not in musiclib
			self.sendMessage(('THREAD_FINISHED', 'Scan aborted, path is not in Musiclibrary!\nMusiclibrary:{}\nPath to scan was:{}'.format(musiclibbasepath, path),), log=True)
		else:

			inserts, updates, skips, coverloads=0,0,0,0
			pathoffset=len(musiclibbasepath)
			connection=OpenDatabase()

			if connection is not None:

					#try:
					self.sendMessage(('THREAD_WORKING', "Start Scan Database now",), log=True)

					with connection: #DROP INDEX
						logger.info('PathToDatabase]DROP INDEX index_filename')
						connection.execute('''DROP INDEX IF EXISTS index_filename;''')

					with connection:# scan now...
						connection.row_factory = sqlite3_Row
						connection.text_factory=str
						cursor=connection.cursor()

						for root, subFolders, files in os_walk(path):

							if self.__cancelscandb:
								break

							subFolders.sort()
							files.sort()

							toupdatedentrys=[]
							for filename in files:#scan folder

								if self.__cancelscandb:
									break

								if filename.lower().endswith(PLAYABLEFORMATS):

									fullfn=os_path_join(root,filename)
									fullfnindb=fullfn[pathoffset:]
									toupdsongID=-1
									#logger.info('PathToDatabase]chech file is in db fullfnindb -->%s fullfn -->%s' %(fullfnindb,fullfn))
									songisindb=cursor.execute('''SELECT song_id, file_m_time, file_size, cover FROM Songs WHERE filename=? LIMIT 1;''', (fullfnindb,)).fetchone()

									if songisindb: # schon in db, prfe auf Vernderung...
										#logger.info('PathToDatabase]songisindb->%s' %str(songisindb))
										if (os_path_getmtime(fullfn)) > songisindb['file_m_time'] or songisindb['file_size'] != (os_path_getsize(fullfn)):
											toupdsongID=songisindb['song_id']
											#logger.info('PathToDatabase]File time->%s or size->%s was changed ->update song_id->%s'%(os_path_getmtime(fullfn), songisindb['file_m_time'], toupdsongID))
											songisindb=[]
										else:
											skips+=1
											#logger.info('PathToDatabase]File is unchanged, skip')
									#else:
										#logger.info('PathToDatabase]File not in db,scan now...')

									if not songisindb:
										ID3=getID3Tags(root, filename)
										if ID3.audio: # old audio, changed 30.08.15
											try:
												file_m_time=(os_path_getmtime(fullfn))
												file_size=(os_path_getsize(fullfn))
												if toupdsongID == -1 :
													#logger.info('PathToDatabase]Insert song->%s'%fullfn)
													cursor.execute('''INSERT INTO Songs (filename, title, artist, album, albumartist, genre, date, tracknumber, bitrate, length, track, filetype, file_m_time, file_size, playcount, rating, wave, scantime, cover, youtubeurl) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);''' , (fullfnindb, ID3.title, ID3.artist, ID3.album, ID3.albumartist, ID3.genre, ID3.date, ID3.tracknr, ID3.bitrate, ID3.length, ID3.track, ID3.filetype, file_m_time, file_size, ID3.playcount, ID3.rating, ID3.wave, time_time(), ID3.hasapicframes, ID3.youtubeurl))
													song_id=cursor.lastrowid
													inserts+=1
												else:
													toupdatedentrys.append((fullfnindb, ID3.title, ID3.artist, ID3.album, ID3.albumartist, ID3.genre, ID3.date, ID3.tracknr, ID3.bitrate, ID3.length, ID3.track, ID3.filetype, file_m_time, file_size, ID3.playcount, ID3.rating, ID3.hasapicframes, ID3.youtubeurl, toupdsongID))
													updates+=1
												if ID3.hasapicframes:
													coverLoader.load(fullfn)
													coverloads+=1
											except Exception, e:
												logger.error('PathToDatabase]WRITE DB error->%s file->%s' %(e, fullfn))
											#logger.info('PathToDatabase]add to DB done')

										else:
											logger.error('PathToDatabase]Hmm here to not good... song->%s'%fullfn)
								#else:
								#	logger.info('PathToDatabase]no Musikfile skip -->%s'%filename)
								if time_time() - 0.4 > lasttime:
									lasttime=time_time()
									self.sendMessage(('THREAD_WORKING', 'Scan folder:{}\n{} songs added\n{} songs updated\n{} songs skipped\n{} thumb created\n{} duration'.format(root, inserts, updates, skips, coverloads, self.getDuration(starttime)),))

							if toupdatedentrys:
								while toupdatedentrys:
									toupdatedentry=toupdatedentrys.pop()
									textbase='Scan folder:{}\n{} songs added\n{} songs updated\n{} songs skipped\n{} thumb created\n{} duration'.format(root, inserts, updates, skips, coverloads, self.getDuration(starttime))
									text=textbase+'\nupdate database now {} entrys'.format(len(toupdatedentrys))
									self.sendMessage(('THREAD_WORKING',text), log=True)
									cursor.execute('''UPDATE Songs SET filename=?, title=?, artist=?, album=?, albumartist=?, genre=?, date=?, tracknumber=?, bitrate=?, length=?, track=?, filetype=?, file_m_time=?, file_size=?, playcount=?, rating=?, cover=?, youtubeurl=? WHERE song_id=?;''' ,toupdatedentry)
								text=textbase+'\nupdate database done'
								self.sendMessage(('THREAD_WORKING',text), log=True)

					text='Scan Database complete\n{} songs added\n{} songs updated\n{} songs skipped\n{} thumb created'.format(inserts, updates, skips, coverloads)
					text=text+'\ncleanup database now...'
					self.sendMessage(('THREAD_WORKING',text), log=True)

					deletes=self.cleaningDatabase(text, connection, starttime, lasttime)

					self.sendMessage(('THREAD_WORKING',"Scan Database complete\n{} songs added\n{} songs updated\n{} songs skipped\n{} thumb created\n{} songs removed\ncleaned up database done\nscan duration{} create indexe now...".format(inserts, updates, skips, coverloads, deletes, self.getDuration(starttime)),), log=True)

					#except Exception, e:
					#logger.error('PathToDatabase]->%s' %e)

					#finally:
					logger.info('PathToDatabase]finally recreate indexes...')
					with connection:
						logger.info('PathToDatabase]create INDEX index_filename on songs')
						cursor=connection.cursor()
						cursor.execute('''CREATE INDEX IF NOT EXISTS index_filename ON Songs(filename);''')
						logger.info('PathToDatabase]create INDEX done')
					self.sendMessage(('THREAD_FINISHED', "Scan Database complete\n{} songs added\n{} songs updated\n{} songs skipped\n{} thumb created\n{} songs removed\nscan duration{}\ncleaned up database done, create index done".format(inserts, updates, skips, coverloads, deletes, self.getDuration(starttime)),), log=True)
					self.savestats(connection, inserts, updates, skips, coverloads, deletes, self.getDuration(starttime))

			else: # no connection !
				logger.error('PathToDatabase]no songs, abort...')
				self.sendMessage(('THREAD_EXCEPTED', "Scan Database aborted!\nError->databases not found!",), log=True)

			logger.info('PathToDatabase]done, Scanzeit:{}'.format(time_time()-starttime))

		Thread.__init__(self)
		self.__cancelscandb=False
		self.__running=False
		self.__path=None

	def sendMessage(self, message, log=False):
		self.__messages.push(message)
		self.__messagePump.send(0)
		if log:
			logger.debug('PathToDatabase]run]{}'.format(message[1].replace('\n',' ')))

	def getDuration(self, starttime):
		return str(datetime_timedelta(seconds=int(time_time()-starttime)))

	def cleaningDatabase(self, text, connection, starttime, lasttime):

		if connection is not None:
			logger.info('PathToDatabase]cleaningDatabase]Start')
			with connection:
				connection.text_factory=str
				connection.row_factory = sqlite3_Row
				cursor=connection.cursor()
				sql='''SELECT song_id, filename FROM Songs;'''
				cursor.execute(sql)

			count=0
			musiclibbasepath=config.plugins.musiccenter.defaultfilebrowserpath.value
			to_delete_song_ids=0
			for row in cursor:
				count +=1
				filename=os_path_join(musiclibbasepath, row["filename"])
				if not os_path_exists(filename):
					#logger.info('PathToDatabase]cleaningDatabase]Remove DB entry %s' %row["filename"])
					#to_delete_song_ids+=(row["song_id"],)
					JCdeleteSongfileonThread(filename, row["song_id"], connection)
					to_delete_song_ids+=1
				if time_time() - lasttime >= 0.4:
					self.sendMessage(('THREAD_WORKING', "{}\n{} songs checked {} songs deleted\nscan duration{}".format(text, count,to_delete_song_ids, self.getDuration(starttime)),), log=True)
					lasttime=time_time()

			'''
			if to_delete_song_ids:
				self.sendMessage(('THREAD_WORKING', "{}\ndelete now dropped {} songs...".format(text, len(to_delete_song_ids))), log=True)
				#logger.info('PathToDatabase]cleaningDatabase]delete now to_delete_song_ids->%s' %str(to_delete_song_ids))
				with connection:
					cursor=connection.cursor()
					c=0
					for id in to_delete_song_ids:
						c+=1
						if time_time() - lasttime >= 0.7:
							self.sendMessage(('THREAD_WORKING', "{}\ndelete now song {} from dropped {} songs".format(text, c, len(to_delete_song_ids))))
							lasttime=time_time()
						cursor.execute('DELETE FROM Songs WHERE song_id ={};'.format(id))

					#cursor.execute('DELETE FROM Songs WHERE song_id in %s;' %str(to_delete_song_ids))
				logger.info('PathToDatabase]cleaningDatabase]delete songs done.')
				self.sendMessage(('THREAD_WORKING', "{}\nall {} dropped songs deleted!".format(text, len(to_delete_song_ids))), log=True)
			return (len(to_delete_song_ids))
			'''
			return (to_delete_song_ids)

		else:

			return 0

	def savestats(self, connection, inserts, updates, skips, coverloads, deletes, scanduration):
		with connection:
			cursor=connection.cursor()
			playlists, artists, albums, genres, dates, songs, playcount, rating=cursor.execute('''SELECT * FROM table_entry_counts;''').fetchone()
		logger.info('PathToDatabase]setStats]playlists {}, artists {}, albums {}, genres {}, dates {}, songs {}, playcount {}, rating {}'.format(playlists, artists, albums, genres, dates, songs, playcount, rating))
		t='Scantime {}\nInserts {}\nUpdates {}\nSkips {}\nCoverloads {}\nDeletes {}\nScanduration {}\nPlaylists {}\nArtists {}\nAlbums {}\nGenres {}\nDates {}\nSongs {}\nPlaycount {}\nRating {}'.format(time_time(),inserts, updates, skips, coverloads, deletes, scanduration, playlists, artists, albums, genres, dates, songs, playcount, rating)
		#values={'playlists':playlists, 'artists':artists, 'albums':albums, 'genres':genres, 'dates':dates, 'songs':songs, 'playcount':playcount, 'rating':rating, 'inserts':inserts, 'updates':updates, 'skips':skips, 'coverloads':coverloads, 'deletes':deletes, 'scanduration':scanduration, 'timestamp':time_time()}
		with open('/etc/enigma2/mc_stat', 'wb') as o:
			o.write(t)


pathToDatabase=PathToDatabase()


class SuggestionsThread(Thread):

	def __init__(self):
		self.__running=False
		Thread.__init__(self)
		self.__searchlist=[]
		self.canceled=False
		self.__messages=ThreadQueue()
		self.__messagePump=ePythonMessagePump()


	def cancel(self):
		self.canceled=True


	def __getMessagePump(self):
		return self.__messagePump

	def __getMessageQueue(self):
		return self.__messages

	def __getRunning(self):
		return self.__running

	MessagePump=property(__getMessagePump)
	Message=property(__getMessageQueue)
	isRunning=property(__getRunning)

	def Start(self, searchword, searchsuggestiontype='Hits', getall=False):

		self.__searchlist=[(searchword, searchsuggestiontype, getall)]
		if 	not self.__running:
			self.__running=True
			self.start()
			logger.info('SuggestionsThread]Start]new thread__searchlist:{}'.format(self.__searchlist))
		else:
			logger.info('SuggestionsThread]Start]old thread is running __searchlist:{}'.format(self.__searchlist))


	def run(self):
		#logger.info('SuggestionsThread]run]start')
		while self.__searchlist:
			try:
				searchword, searchsuggestiontype, getall = self.__searchlist.pop(0)
				reslist = []
				headertext = 'Suche {}'.format(searchsuggestiontype)
				limit = 21
				sql = None

				if searchword != '' and not self.canceled:
					searchword = searchword.replace("'", "''") #quote '
					searchword2 = searchword.replace(' ','%')
					args = ('%%%s%%' %searchword, '%%%s%%' %searchword2)

					if searchsuggestiontype=='Artists':
						sql = '''SELECT * FROM Songs WHERE artist LIKE ? OR artist LIKE ? ORDER BY artist'''

					elif searchsuggestiontype=='Titles':
						sql = '''SELECT * FROM Songs WHERE title LIKE ? OR title LIKE ? ORDER BY title'''

					elif searchsuggestiontype=='Albums':
						sql = '''SELECT * FROM Songs WHERE album LIKE ? OR album LIKE ? ORDER BY album'''

					elif searchsuggestiontype=='Hits':
						sql = '''SELECT * FROM Songs WHERE title LIKE ? OR title LIKE ? OR artist LIKE ? OR artist LIKE ? OR album LIKE ? OR album LIKE ?'''
						args = ('%%%s%%' %searchword, '%%%s%%' %searchword2,'%%%s%%' %searchword, '%%%s%%' %searchword2,'%%%s%%' %searchword, '%%%s%%' %searchword2)

					if sql is not None:
						if getall:
							sql='{};'.format(sql)
						else:
							sql='{} LIMIT {};'.format(sql, limit)

						logger.debug('SuggestionsThread]run]sql:{} args:{}'.format(sql, args))
						for row in execSQLCommandWithReturn(sql, args):
							slentry = buildSonglistEntry(row)
							reslist.append((slentry,))

						if len(reslist)-1 >= 31:
							headertext = '>{} Songs Typ {} mit {}'.format(limit, searchsuggestiontype, searchword)
						else:
							if len(reslist)==1:
								song = 'Song'
							else:
								song = 'Songs'
							headertext = '{} {} Typ {} mit {}'.format(len(reslist)-1, song, searchsuggestiontype, searchword)

				self.__messages.push((reslist, headertext))
				self.__messagePump.send(0)

			except Exception, error:
				logger.error('SuggestionsThread]run]error->%s' %error)
				l = [(Item(text = _(error), mode = 'buildMainMenuListDB'),)]

				self.__messages.push((l,error))
				self.__messagePump.send(0)


		Thread.__init__(self)
		self.__running = False
		self.canceled = False
		logger.info('SuggestionsThread]run]done')


suggestionsThread = SuggestionsThread()


def getLautFMStats(self, event, listeners, position, stationname):
	try:
		if event == 'n/a':
			event = self.s.get('https://api.laut.fm/station/{}/current_song'.format(stationname)).json()
			event = str('{} - {} | {}'.format(event[u'artist'][u'name'], event[u'title'], event[u'started_at'].split(' ')[1]))
	except:
		logger.exception('getLautFMStats]exception for station:{}'.format(stationname))
		event = 'n/a'

	try:
		if listeners == 'n/a':
			listeners = str(self.s.get('https://api.laut.fm/station/{}/listeners'.format(stationname)).json())
	except:
		logger.exception('getLautFMStats]error:{}'.format(stationname))
		listeners = 'n/a'

	try:
		if position == 'n/a':
			position = self.s.get('https://api.laut.fm/station/{}'.format(stationname)).json()
			position = position[u'position']
	except:
		logger.exception('getLautFMStats]error:{}'.format(stationname))
		position = 'n/a'

	return event, listeners, position


def getRadioBrowserStats(self, clickcount, votes, streamID):
	try:
		url = 'http://www.radio-browser.info/webservice/json/stations/byid/{}'.format(streamID)
		clickcount = self.s.get(url).json()[0]
		clickcount, votes = clickcount[u'clickcount'], clickcount[u'votes']
	except:
		logger.exception('StationiconDownloader]getRadioBrowserStats]error:{}'.format(streamID))
		clickcount = 'n/a'
		votes = 'n/a'

	return clickcount, votes


class StationiconDownloader(Thread):


	def __init__(self, picdir, type=''):
		self.__running = False
		Thread.__init__(self)

		self.__picdir = picdir
		self.__stations = []
		self.canceled = False
		self.__jobname = ''
		self.s = requests_Session()
		self.s.headers.update({'User-Agent': MCUSERAGNET})
		self.__messages=ThreadQueue()
		self.__messagePump=ePythonMessagePump()


	def cancel(self):
		logger.info('StationiconDownloader]cancel]old thread')
		self.canceled = True


	def __getMessagePump(self):
		return self.__messagePump


	def __getMessageQueue(self):
		return self.__messages


	def __getRunning(self):
		return self.__running

	MessagePump=property(__getMessagePump)
	Message=property(__getMessageQueue)
	isRunning = property(__getRunning)

	def Start(self, jobname = 'station_icons', stations = []):

		self.__stations = stations
		self.__jobname = jobname
		
		if 	not self.__running:
			self.__running = True
			logger.info('StationiconDownloader]Start]new thread')
			self.start()
		else:
			logger.info('StationiconDownloader]Start]old thread is running update dllist')


	def run(self):

		logger.info('StationiconDownloader]run]start job:{} len stations:{}'.format(self.__jobname, len(self.__stations)))
		
		if self.__jobname == 'station_icons':		
			
			c = 0

			while self.__stations:

				if self.canceled:
					logger.debug('StationiconDownloader]run]canceled')
					break

				entry = self.__stations.pop(0)
				type, station = entry[0], entry[2]

				if str(c).endswith('0'):
					logger.info('StationiconDownloader]run]{} dlcounts check station:{}'.format(len(self.__stations), station['name'].encode()))

				c += 1
				is_stationicon_url = ''

				if type == 'RADIOBROWSER':
					is_stationicon_url = self.resolveStationiconRadiobrowser(station)

				elif type == 'RADIODE':
					is_stationicon_url = self.resolveStationiconRadioDe(station)

				elif type == 'LAUTFM':
					type, index, station, event, listeners, position = entry
					is_stationicon_url = self.resolveStationiconLautFM(index, station, event, listeners, position)

				if is_stationicon_url and not self.canceled:

					try:
						stationiconfilename, url = is_stationicon_url
						if url.startswith('www.'):
							url = 'http://{}'.format(url)

						response = self.s.get(url, timeout = (1, 2.5), verify = False)

						if response.status_code == 200:
							if stationiconfilename.lower().endswith(('.svg', 'ico')):
								with open(stationiconfilename, 'wb') as f:
									logger.info('StationiconDownloader]run]is svg save untouched...')
									f.write(response.content)

							else:
								im = Image.open(StringIO(response.content))
								if im.size[0]>200 or im.size[1]>200:
									logger.info('StationiconDownloader]downloadFinished]thumnail image x:{} to x:175 y:{} to y:175'.format(im.size[0], im.size[1]))
									im.thumbnail((200, 200), Image.ANTIALIAS)
								im.save(stationiconfilename, im.format)
								del im

						else:
							logger.error('StationiconDownloader]run]error:{}'.format(response.status_code))

					except:
						logger.exception('StationiconDownloader]run]error...')
						logger.info('StationiconDownloader]run]error on stationiconfilename:{} url:{}'.format(is_stationicon_url[0], is_stationicon_url[1]))

		elif self.__jobname == 'station_stats':

			logger.info('StationiconDownloader]run]start....')
			
			sql='''SELECT * FROM Stream_Favorites ORDER BY stationname;'''
			cursor = sqlCommand_Streaming_WithReturn(sql, dbname = 'musiccenter_stream_favorites.db')
			radiodeapiinstance = None			
			list = []
			index = -1
			
			for row in cursor:

				if self.canceled:
					logger.debug('StationiconDownloader]run]canceled')
					break
			
				codec = row['codec']
				if codec in ('UNKNOWN', ''):
					codec = 'n/a'
					
				event = listeners = votes = 'n/a'
				index +=1
				
				if row['filetype'] == 'LAUTFM':
					logger.info('StationiconDownloader]run]get LAUTFM event!')
					event, listeners, votes = getLautFMStats(self, event, listeners, votes, row['streamID'])
					# event, listeners, position
					
				elif row['filetype'] == 'RADIODE':
					if radiodeapiinstance == None:
						radiodeapiinstance = RadioDeApi()
						radiodeapiinstance.__init__('german')

					logger.info('StationiconDownloader]run]get RADIODE event!')
					st = radiodeapiinstance.get_station_by_station_id(row['streamID'])
					event = myenCode(st[u'currentTrack'])
					listeners = str(st[u'rank'])
					votes = str("{:.1f}".format(st[u'rating']))
					
				elif row['filetype'] == 'RADIOBROWSER':
					logger.info('StationiconDownloader]run]get RADIOBROWSER event!')
					listeners, votes = getRadioBrowserStats(self, listeners, votes, row['streamID'])
					#clickcount, votes
				else:
					continue
				
				if not self.canceled:
					logger.debug('StationiconDownloader]run]index:{} event:{} listeners:{} votes:{}'.format(index, event, listeners, votes))
					self.__messages.push((self.__jobname, index, event, listeners, votes))
					self.__messagePump.send(0)
					

			radiodeapiinstance = None
			logger.info('getStations]end')

		Thread.__init__(self)
		self.canceled = False
		self.__running = False
		logger.info('StationiconDownloader]run]done')


	def resolveStationiconRadioDe(self, station):
		stationname = myenCode(station[u'name']).replace('/','-')
		stationiconurl = myenCode(station[u'pictureBaseURL']+'t175.png')
		filename = ''.join((cleanName(stationname), '.png'))
		stationiconfilename = os_path_join(self.__picdir, filename)
		if stationiconurl!='':
			return stationiconfilename, stationiconurl
		else:
			return None


	def resolveStationiconRadiobrowser(self, station):
		stationname = station['name'].encode()
		stationiconurl = station['favicon'].encode()
		if stationiconurl.startswith('data:image/jpeg;base64'):
			filename = ''.join((cleanName(stationname), '.jpeg'))
			stationiconfilename = os_path_join(self.__picdir, filename)
			if not fileExists(stationiconfilename):
				base64_image_str = stationiconurl[stationiconurl.find(",")+1:]
				logger.debug('StationiconDownloader]resolveStationiconRadiobrowser]stationiconurl is jpeg, save stationname.{} to stationiconfilename'.format(stationname, stationiconfilename))
				with open(stationiconfilename, "wb") as f:
					f.write(base64_image_str.decode('base64'))
			return None

		elif stationiconurl.startswith('data:image/png;base64'):
			filename = ''.join((cleanName(stationname), '.png'))
			stationiconfilename = os_path_join(self.__picdir, filename)
			if not fileExists(stationiconfilename):
				base64_image_str = stationiconurl[stationiconurl.find(",")+1:]
				logger.debug('StationiconDownloader]resolveStationiconRadiobrowser]stationiconurl is png, save stationname.{} to stationiconfilename'.format(stationname, stationiconfilename))
				with open(stationiconfilename, "wb") as f:
					f.write(base64_image_str.decode('base64'))
			return None

		else:
			endswithbase = stationiconurl.rsplit('/',1)[-1].lower()
			endswith = None
			for e in ('.jpg', '.png', '.jpeg', '.bmp', '.gif', '.svg', 'ico'):
				if e in endswithbase:
					endswith = e
					break

			if endswith is not None:
				filename = ''.join((cleanName(stationname), endswith))
				stationiconfilename = os_path_join(self.__picdir, filename)
			else:
				filename = cleanName(stationname)
				stationiconfilename = os_path_join(self.__picdir, filename)
			return stationiconfilename, stationiconurl


	def resolveStationiconLautFM(self, index, station, event, listeners, position):

		stationname = station['name'].encode()
		stationiconurl = station['images']['station_120x120'].encode() # station_640x640
		filename = ''.join((stationname, '.jpg'))
		stationiconfilename = os_path_join(self.__picdir, filename)

		event, listeners, position = getLautFMStats(self, event, listeners, position, stationname)
		if not self.canceled:
			self.__messages.push((self.__jobname, index, event, listeners, position))
			self.__messagePump.send(0)

		if not os_path_exists(stationiconfilename) and stationiconurl != '':
			return stationiconfilename, stationiconurl
		else:
			return None


import Screens.Standby

class DatabaseScannerTimer():

	def __init__(self):
		m='DatabaseScannerTimer]__init__]....]'
		print m
		logger.debug(m)
		self.scantimer=eTimer()
		self.scantimer_mc_conn=self.scantimer.timeout.connect(self.afterScantimerTimeout)

	def start(self):
		self.startTimer(fromwhere='start')

	def stop(self):
		self.scantimer.stop()
		self.scantimer_mc_conn=None

	def startTimer(self, timespawn=3600, fromwhere='unknown'):
		logger.info('DatabaseScannerTimer]startTimer]from {} timespawn {}'.format(fromwhere, timespawn))
		self.scantimer.startLongTimer(timespawn)

	def afterScantimerTimeout(self):
		if config.plugins.musiccenter.autodatabasescan.value:
			now=datetime_datetime.now().hour
			if now<22 and now>5:
				self.startTimer(fromwhere='scanner is activ, time is < 22 hour')
			else:
				if not Screens.Standby.inStandby:
					self.startTimer(timespawn=1200, fromwhere='scanner is activ, time is > 22 hour, but stb is running')
				else:
					if pathToDatabase.isRunning:
						self.startTimer(timespawn=60, fromwhere='scanner is activ, time is > 22 hour, but pathToDatabase is running')
					else:
						if fileExists('/etc/enigma2/mc_stat'):
							with open('/etc/enigma2/mc_stat', 'rb') as fn:
								line = fn.readline()
								last = int(line.split(' ',1)[1].strip().split('.')[0])
							now = int(time_time())
							if now-last > 3600*6:#aelter 6 h
								self.startScanNow()
							else:
								self.startTimer(timespawn = 3600*14, fromwhere = 'scanner is activ, time is > 22 hour, but new scanstat file found, skip scan...')# 12 stunden
						else:
							self.startScanNow()

		else:
			self.startTimer(fromwhere='no scanner activ')

	def startScanNow(self):
		pathToDatabase.Start(config.plugins.musiccenter.defaultfilebrowserpath.value)
		logger.debug('DatabaseScannerTimer]startScanNow]scanner is activ, time is 22 hour, start databasescanner now...')
		self.startTimer(timespawn=3600*14, fromwhere='scanner is activ, time is 22 hour, start databasescanner now...')# 12 stunden


databaseScannerTimer=DatabaseScannerTimer()



class YoutubeDownloadJob(Job):

	def __init__(self, url, title):

		Job.__init__(self, title)
		#self.state_changed = CList() # fit this the error crash?
		YoutubeDownloadTask(self, url)


class YoutubeDownloadTask(Task):

	def __init__(self, job, url):

		Task.__init__(self, job, ("download task"))
		self.end = 100
		self.url = url
		self.progress = 0


	def prepare(self):
		self.error=None


	def run(self, callback):
		self.callback=callback
		self.progress = 10
		deferToThread(self.threadedDownload, self.url).addCallback(self.http_finished).addErrback(self.http_failed)


	def threadedDownload(self, url):

		ydl_opts = {
		'nocheckcertificate': True,
		'outtmpl': '{}%(id)s_._%(title)s_%(format)s.%(ext)s'.format(config.plugins.musiccenter.ytcachedir.value),
		'format':'bestvideo[ext=mp4]+bestaudio[ext=m4a]/best[ext=mp4]/best',
		'logger': logger,
		'progress_hooks': [self.my_hook],
		}

		logger.debug('YoutubeDownloadTask]threadedDownload]url:{} options:{}'.format(url, ydl_opts))

		with youtube_dl_YoutubeDL(ydl_opts) as ydl:
			ydl.download([url])
		logger.debug('YoutubeDownloadTask]threadedDownload]finish')


	def my_hook(self, d):
		if d['status'] == 'finished':
			logger.debug('YoutubeDownloadTask]threadedDownload]Done downloading {}'.format(d['filename']))
		elif d['status'] == 'downloading':
			logger.debug('YoutubeDownloadTask]threadedDownload]Progress downloading:{} {}/{}'.format(d['filename'], d['_percent_str'], d['_eta_str']))



	def http_finished(self, res):
		logger.info('YoutubeDownloadTask]http_finished]with:{}'.format(res))
		self.progress=100
		Task.processFinished(self, 0)


	def http_failed(self, error='None'):
		logger.error('YoutubeDownloadTask]http_failed]with error:{}'.format(error))
		self.progress=0
		Task.processFinished(self, 1)
