# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

'''
import sys
sys.path.append('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter')
import JobCenter2
'''

from random import randrange as random_randrange
from textwrap import wrap as textwrap_wrap
from PIL import ImageFont, ImageDraw, Image, ImageOps
from pydub import AudioSegment
from mutagen.id3 import ID3, WXXX
#from datetime import timedelta as datetime_timedelta
#from time import strptime as time_strptime

try:
	from myLogger import logger
	from Globals import *
	from tagger import getID3raw

except Exception, e: # not running in enigma2

	from time import time as time_time
	from os.path import join as os_path_join, realpath as os_path_realpath, split as os_path_split, basename as os_path_basename, getsize as os_path_getsize, exists as os_path_exists
	from os.path import isdir as os_path_isdir, getmtime as os_path_getmtime, isfile as os_path_isfile, islink as os_path_islink

	
	from subprocess import call as sp_call, Popen as sp_Popen, PIPE as sp_PIPE
	from time import sleep as time_sleep
	from threading import Thread
	from tagger import getID3raw
	import logging
	from logging.handlers import RotatingFileHandler

	logger = logging.getLogger(__name__)
	filename='/var/log/musiccenter.log'
	maxBytes=1024*1024
	backupCount=3
	# create a rotating file handler
	handler = RotatingFileHandler(filename, "a", maxBytes, backupCount)
	logger.setLevel(logging.INFO)
	formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')
	handler.setFormatter(formatter)
	logger.addHandler(handler)

	logger.error('JobCenter2]running not on enigma2... %s' %e)


colorlist=[(0, 0, 0), (0, 0, 139), (0, 0, 255), (0, 128, 0), (0, 139, 139), (0, 206, 209), (0, 255, 0), (0, 255, 255), (30, 144, 255), (34, 139, 34), (47, 79, 79),
(60, 179, 113), (65, 105, 225), (72, 61, 139), (75, 0, 130), (95, 158, 160), (102, 205, 170), (106, 90, 205), (112, 128, 144), (123, 104, 238), (127, 255, 0), (128, 0, 0), (128, 128, 0), (135, 206, 235),
(138, 43, 226), (139, 0, 139), (143, 188, 143), (147, 112, 219), (152, 251, 152), (154, 205, 50), (165, 42, 42), (173, 216, 230), (175, 238, 238), (176, 224, 230), (184, 134, 11), (188, 143, 143), (192, 192, 192), (205, 92, 92),
(210, 105, 30), (211, 211, 211), (218, 112, 214),(220, 20, 60), (224, 255, 255), (233, 150, 122), (240, 230, 140), (240, 255, 255), (245, 222, 179), (245, 245, 245), (250, 235, 215), (250, 250, 210), (255, 0, 0), (255, 20, 147), (255, 99, 71),
(255, 127, 80), (255, 160, 122), (255, 182, 193), (255, 215, 0), (255, 222, 173), (255, 228, 196), (255, 235, 205), (255, 240, 245), (255, 248, 220), (255, 250, 240), (255, 255, 0), (255, 255, 255)]


def drawImageJob( text='-', size=(200,200), out=None, backcolor=None, round=0):
	# zeichne pic mit text einzeilig
	# choose color
	text=text.replace('/','-')
	index=random_randrange(len(colorlist))
	if backcolor==None:
		backcolor=colorlist[index]

	if backcolor[0]+backcolor[1]+backcolor[2]<378:
		textcolor1=(255,255,255) # (255-backcolor[0], 255-backcolor[1], 255-backcolor[2])
	else:
		textcolor1=(0,0,0)

	if out==None:
		#out='/tmp/mc/%s_%d_%d_%d.png' %(text, backcolor[0], backcolor[1], backcolor[2])
		out='/tmp/mc/%s_%d.png' %(text, round)
	if not os_path_exists(out):
		im = Image.new('RGB',size, backcolor)
		draw = ImageDraw.Draw(im)
		text_size=size[1]/10*6
		font = ImageFont.truetype("/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf", text_size) #Light, Thin

		w, h = draw.textsize(text, font=font)
		draw.text(((size[0]-w)/2,(size[1]-h)/2), text, fill=textcolor1, font=font)
		del draw

		if round!=None:
			im = _add_corners(im, round)


		im.save(out, "PNG")

	return out

def drawTransparentImage( text='-', size=(200,200), out=None, textcolor='white', textsize=35):
	# zeichne pic mit text einzeilig
	# transparent
	text=text.replace('/','-')

	if out==None:
		out='/tmp/mc/%s_transparent.png' %(text)

	im = Image.new("RGBA", size, (0,0,0,0))
	draw = ImageDraw.Draw(im)
	font = ImageFont.truetype("/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf", textsize) #Light, Thin

	w, h = draw.textsize(text, font=font)
	draw.text(((size[0]-w)/2,(size[1]-h)/2), text, fill=textcolor, font=font)
	del draw

	im.save(out, "PNG")

	return out


def _add_corners(im, rad):
	circle = Image.new('L', (rad * 2, rad * 2), 0)
	draw = ImageDraw.Draw(circle)
	draw.ellipse((0, 0, rad * 2, rad * 2), fill=255)
	alpha = Image.new('L', im.size, 255)
	w, h = im.size
	alpha.paste(circle.crop((0, 0, rad, rad)), (0, 0))
	alpha.paste(circle.crop((0, rad, rad, rad * 2)), (0, h - rad))
	alpha.paste(circle.crop((rad, 0, rad * 2, rad)), (w - rad, 0))
	alpha.paste(circle.crop((rad, rad, rad * 2, rad * 2)), (w - rad, h - rad))
	im.putalpha(alpha)

	del draw

	return im


def drawImageJobWithLongText(text='-', size=(200,200), fontsize=None):
	#choose color
	text=text.replace('/','-')
	index=random_randrange(len(colorlist))
	backcolor=colorlist[index]
	if backcolor[0]+backcolor[1]+backcolor[2]<378:
		textcolor1=(255,255,255) # (255-backcolor[0], 255-backcolor[1], 255-backcolor[2])
	else:
		textcolor1=(0,0,0)
	out='/tmp/mc/%s_%d_%d_%d.png' %(text, backcolor[0], backcolor[1], backcolor[2])
	im = Image.new('RGB',size, backcolor)
	draw = ImageDraw.Draw(im)
	img_fraction = 0.9
	if fontsize==None:
		fontsize = 19  # starting font size
		font = ImageFont.truetype("/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf", fontsize)
		while font.getsize(text)[0] < img_fraction*im.size[0]:
			# iterate until the text size is just larger than the criteria
			fontsize += 1
			font = ImageFont.truetype("/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf", fontsize)
	else:
		font = ImageFont.truetype("/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf", fontsize)

	logger.info('drawImageJobWithLongText]final font size %d' %fontsize)
	w, h = draw.textsize(text, font=font)
	#if w > img_fraction+0.05*im.size[0]:
	#	while font.getsize(text)[0] > img_fraction*im.size[0]:
	#		# iterate until the text is just larger than the criteria
	#		text=text[:-1]
	#		#font = ImageFont.truetype("/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf", fontsize)
	#	w, h = draw.textsize(text, font=font)
	draw.text(((size[0]-w)/2,(size[1]-h)/2), text, fill=textcolor1, font=font)
	del draw
	im.save(out, "PNG")
	return out


def paintTextToImageJob(pic, text1,text2):

	try:
		#logger.info('paintText]pic-->%s text1-->%s text2-->%s' %(pic, text1,text2))
		path,fn=os_path_split(pic)
		fn=fn.replace('/','-')
		out=''.join(('/tmp/mc/wt_', fn))
		if os_path_exists(pic):

			if not out.lower().endswith(('.jpg','.jpeg','.png')):
				im1=Image.open(pic)
				out+='.%s' %im1.tile[0][0]

			if not os_path_exists(out):
				im1=Image.open(pic)
				if im1.mode not in('RGB', 'RGBA'):
					im1=im1.convert("RGB")
				x,y=im1.size
				z=y/300.0
				im2 = Image.new('RGBA',(x,int(z*75)),(0, 0, 0,130))
				im1.paste(im2,(0,y-int(z*75)), im2)
				draw = ImageDraw.Draw(im1)
				fontsize=int(24*z)
				#logger.info('paintText]fontsize-->%s ' %str(fontsize))
				font = ImageFont.truetype("/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf", fontsize)
				draw.text((5, y-int(z*66)), text1, fill=(255,255,255), font=font)
				#logger.info('paintText]text2-->%s' %text2)
				draw.text((5, y-int(z*35)), text2, fill=(255,255,255), font=font)
				im1.save(out)

		return out
	except Exception, e:
		logger.error('paintTextToImageJob]-->%s' %e)
		return pic

def paintTextToImageJobResize(filename, pic, title='', artist='', album='', length='', rating=None):
	'''
	create new image with embeded thumb or stationicon
	paste text on images...
	'''
	try:
		#logger.info('paintTextToImageJobResize]start filename-->%s pic-->%s title-->%s artist-->%s album-->%s	length-->%s rating-->%s' %(filename, pic, title, artist, album, length, str(rating)))
		directory, filename=os_path_split(pic)
		filename=filename.replace('/','-')
		if '.fl.' in pic:
			out=pic.replace('.fl.','.wt.')
		elif rating==-1: # islike
			out='/wt_islike_'.join((directory, filename))
		elif rating==-2: # nolike
			out='/wt_nolike_'.join((directory, filename))
		else:
			out='/wt_'.join((directory, filename))
		logger.info('paintTextToImageJobResize]out-->%s' %out)
		if os_path_exists(pic):

			if not out.lower().endswith(('.jpg','.jpeg','.png')):
				im1=Image.open(pic)
				out+='.%s' %im1.tile[0][0]
			else:
				im1=None
			if filename==None or not os_path_exists(filename) :
				filename_mtime=time_time()
			else:
				filename_mtime=os_path_isdir.getmtime(filename)

			if not os_path_exists(out) or os_path_getmtime(out) < os_path_getmtime(pic) or os_path_getmtime(out) < filename_mtime:
				if im1==None:
					im1=Image.open(pic)
				if im1.mode != "RGB":
					im1=im1.convert("RGB")

				im1_x, im1_y=im1.size
				x,y=300, 300

				y_all=450
				im2=Image.open('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/background_300x450.png')
				#im2 = Image.new('RGB',(x, y_all),(45,45,45)) #0, 0, 0

				if (im1_x or im1_y)>300:
					logger.info('Image is bigger as 300 resize to 300')
				else:
					logger.info('Image is tinny as 300 resize to 300')
				basewidth = 300
				wpercent = (basewidth/float(im1_x))
				hsize = int((float(im1_y)*float(wpercent)))
				im1 = im1.resize((basewidth,hsize), Image.NEAREST) # ANTIALIAS)
				im1_x, im1_y= x, y

				offset = ((300 - im1_x) / 2, (450 - im1_y) / 2)
				#logger.info('Image paste offset is %s' %str(offset))
				im2.paste(im1,offset,)
				draw = ImageDraw.Draw(im2)
				fontsize=22 # 24
				font = ImageFont.truetype("/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf", fontsize)

				x_start=int((x-draw.textsize(title.decode('utf-8'), font=font)[0])/2)
				if x_start<5:
					x_start=5
				draw.text((x_start, y_all-66), title.decode('utf-8'), fill=(255,255,255), font=font)

				x_start=int((x-draw.textsize(artist.decode('utf-8'), font=font)[0])/2)
				if x_start<5:
					x_start=5
				draw.text((x_start, y_all-33), artist.decode('utf-8'), fill=(255,255,255), font=font)

				x_start=int((x-draw.textsize(album.decode('utf-8'), font=font)[0])/2)
				if x_start<5:
					x_start=5
				draw.text((x_start, 35), album.decode('utf-8'), fill=(255,255,255), font=font)

				text_len=font.getsize(length)[0]
				draw.text(( x-5-text_len, 5), length, fill=(255,255,255), font=font)


				if rating!=None:#rating
					if rating==-1:# sc like
						im3=Image.open('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/heart32_orange.png')
						im2.paste(im3,(50,4),)
					elif rating>-1:
						im3=Image.open('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/rating%d.png'%calcRating(rating))
						im2.paste(im3,(5,7),)
				im2.save(out)
				del draw
			else:
				logger.info('paintText]file is ok not recreate is nessesarry...')
		else:
			out=pic
		return out

	except Exception, e:
		logger.error('paintTextToImageJobResize]-->%s' %e)
		return pic

def createGradientPNG(size, bgcolor):
	im=Image.new('RGB', size, bgcolor)
	if im.mode != 'RGBA':
		im = im.convert('RGBA')
	# create a vertical gradient...
	gradient = Image.new('L', (256,1))
	for y in range(256):
		if y<256:
			gradient.putpixel((0+y,0),y)
		else:
			gradient.putpixel((y,0),255)
	# resize the gradient to the size of im...
	alpha = gradient.resize(im.size)
	im.putalpha(alpha)
	return im

# -----------
def drawImageJobWithLongMultilineText(text='-', size=(200,200), fontsize=33, round=0, out=None, force=False): # size=(300,300), fontsize=40
	if out is None:
		out='/tmp/mc/%s_%d.png' %(text.replace('/','-'), round)
	logger.info('drawImageJobWithLongMultilineText]start->%s' %out)
	if not os_path_exists(out) or force :
		logger.info('drawImageJobWithLongMultilineText]paint image->%s' %out)

		#choose color
		index=random_randrange(len(colorlist))
		backcolor=colorlist[index]

		if backcolor[0]+backcolor[1]+backcolor[2]<378:
			textcolor1=(255,255,255) # (255-backcolor[0], 255-backcolor[1], 255-backcolor[2])
		else:
			textcolor1=(0,0,0)
		logger.info('drawImageJobWithLongMultilineText]paint image->%s' %str(size))
		im = Image.new('RGB',size, backcolor)
		draw = ImageDraw.Draw(im)
		font = ImageFont.truetype("/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf", fontsize)
		textlines, max_text_width, heigth =IntelliDraw(draw,text,font, int(size[0]*0.9))

		if max_text_width > int(size[0]*0.9):
			old_size_0=int(size[0]*0.9)
			size=(max_text_width/9*10, max_text_width/9*10)
			logger.info('drawImageJobWithLongMultilineText]max_text_width:{} > image width*0.9:{}, repaint image to size:{}'.format(max_text_width, old_size_0, (size[0],size[1])))
			im = Image.new('RGB',size, backcolor)
			draw = ImageDraw.Draw(im)
		linecount=len(textlines)

		#heigth = draw.textsize(text, font=font)[1]*1.3
		hsum=int(linecount*heigth)
		h_text=(size[1]-hsum)/2
		for text in textlines:
			text_line=' '.join(text).decode()# fix utf errors
			w=draw.textsize(text_line, font=font)[0]
			draw.text(((size[0]-w)/2, h_text), text_line, fill=textcolor1, font=font)
			h_text+=heigth
		del draw

		if round>0:
			im = _add_corners(im, round)

		im.save(out, "PNG")
	else:
		logger.info('drawImageJobWithLongMultilineText]image allready exists, abort!')
	return out

def IntelliDraw(drawer, text, font, max_text_len):
	# split text to words
	for character in('''"-/.&%`$!'([{?\\'''):
		if character in text:
			if character in ('([{'):
				#logger.info('IntelliDraw]replace:{}'.format(character))
				text=text.replace(character,' {}'.format(character))
			else:
				#logger.info('IntelliDraw]replace:{}'.format(character))
				text=text.replace(character,' ')
	words=text.split()
	#logger.info('IntelliDraw]splitted text to words:{}'.format(words))

	# now construct textlines parsed to pic width
	line_count = 0
	widths=[]
	text_in_lines=[]
	while words:
		newline = [words.pop(0)]
		innerFinished = False
		while not innerFinished:
			#logger.info('IntelliDraw]newline test:{}'.format(newline))
			curr_line_width, heigth=drawer.textsize(' '.join(newline), font)

			if curr_line_width < max_text_len and len(words)>0:
				newline.append(words[0])
				if drawer.textsize(' '.join(newline), font)[0] > max_text_len and len(newline)>1:
					newline.pop()
					text_in_lines.append(newline)
					widths.append(curr_line_width)
					innerFinished = True
					line_count+=1
				else:
					words.pop(0)
			else:
				text_in_lines.append(newline)
				widths.append(curr_line_width)
				innerFinished = True
				line_count+=1
	width=max(widths)
	#logger.info('IntelliDraw]text_in_lines:{} width:{} heigth:{}'.format(text_in_lines, width, heigth))
	return (text_in_lines, width, heigth)

def parsePictoCovercollection(pic,out):
	#logger.info('parsePictoCovercollection]start build pic...')
	im1=Image.open(pic)
	#if im1.mode not in("RGB", "RGBA"):
	#	im1=im1
	im1_x, im1_y=im1.size
	basewidth = 300
	im2=Image.open('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/transparent_300_450.png')
	wpercent = (basewidth/float(im1_x))
	hsize = int((float(im1_y)*float(wpercent)))
	#if (im1_x or im1_y)>300:
	#	#logger.info('parsePictoCovercollection]Image is bigger, resize to 300')
	#	im1.thumbnail((basewidth,hsize), Image.NEAREST) # ANTIALIAS)
	#else:
	#	#logger.info('parsePictoCovercollection]Image is tinny, resize to 300')
	#	im1=im1.resize((basewidth,hsize), Image.NEAREST) # ANTIALIAS)
	im1=im1.resize((basewidth,hsize),)
	#logger.info('parsePictoCovercollection]Image paste offset is %s' %str(offset))
	im2.paste(im1,(0,75),)
	im2.save(out)
	return out

def parseImageInBackgroundbase(pic, size=200, im=None):
	logger.info('parseImageInBackgroundbase]->%s'%pic)
	if im is None:
		im=Image.open(pic)
	#if im1.mode not in("RGB", "RGBA"):
	#	im1=im1
	im1_x, im1_y=im.size
	im2=Image.new("RGB", (size, size), "white")
	if (im1_x or im1_y)>size:
		logger.info('parseImageInBackgroundbase]Image is bigger, skip')
	else:
		logger.info('parseImageInBackgroundbase]Image is tinny, parse')
		im2.paste(im,(size/2-im1_x/2, size/2-im1_y/2),)
		im2.save(pic)



def paintWaveformPicture(songfilename, wavevalues):
	filename=buildWaveFilename(songfilename)
	logger.debug('paintWaveformPicture]{}'.format(filename, repr(wavevalues[:5])))
	pixel_x=1920
	pixel_y=120
	max_rms=max(wavevalues)
	scaled_loudness=[ int(float(loudness) / max_rms * pixel_y) for loudness in wavevalues]
	im=Image.new('RGBA',(pixel_x, pixel_y))
	for i in xrange(pixel_x):
		im.paste('black', (i, 0, i+1, pixel_y-scaled_loudness[i]))
	im.save(filename)
	logger.debug('paintWaveformPicture]done')



class CalcWaveValusThread(Thread):

	def __init__(self):

		Thread.__init__(self)

		self.__running=False
		self.__slentry=[]
		self.__index=0
		self.canceled=False

		self.__messages=ThreadQueue()
		self.__messagePump=ePythonMessagePump()

	def cancel(self, reason = 'no reason?'):
		self.canceled = reason

	def __getMessagePump(self):
		return self.__messagePump


	def __getMessageQueue(self):
		return self.__messages


	def __getRunning(self):
		return self.__running


	def Start(self, slentry, index, len_of_songlist):

		if not self.__running:
			self.__slentry=slentry
			self.__index=index
			self.__len_of_songlist = len_of_songlist
			logger.info('CalcWaveValusThread]Start]index {}'.format(self.__index))
			self.__running=slentry.songID
			self.start()
		else:
			logger.info('CalcWaveValusThread]Start]abort start old instance songid:{} is running!!!'.format(slentry.songID))


	MessagePump=property(__getMessagePump)
	Message=property(__getMessageQueue)
	isRunning=property(__getRunning)


	def run(self):
		#self.__running=self.__slentry.songID
		#logger.info('CalcWaveValusThread]run]start')
		tmpfn='/tmp/mc/wave.wav'
		error='unknown!'
		wavevalues = 'n/a'
		
		try:# bse bse... :-)
			if os_path_exists('/usr/bin/ffmpeg'):
			
				logger.info('CalcWaveValusThread]run]index {}'.format(self.__index))
				
				if self.canceled:
					error='CalcWaveValusThread]run]raise Thread reason {}'.format(self.canceled)
					pkillcmd=['pkill', 'ffmpeg']
					sp_call(pkillcmd)
					#raise Exception(error)

				pixel_x=1920 # Full HD wide
				songfn=self.__slentry.filename.replace("'","\\'").replace(" ","\ ").replace("(","\(").replace(")","\)").replace("&","\&").replace("$","\$").replace(";","\;")
				cmd="exec nice -n 19 ffmpeg -i %s -y  -v quiet -acodec pcm_u8 -ac 1 -ar 11025 %s" %(songfn, tmpfn)# nice to reduce load
				#logger.info('CalcWaveValusThread]run]convert song cmd->%s' %str(cmd))
				p=sp_Popen(cmd, shell=True)
				start=time_time()
				lasttime = start
				runtime = 0
				lasttempfilesize =- 100000
				currtempfilesize = 0
				errorcounter = 0
				decade = 0

				h, m, s = self.__slentry.length.split(':')

				while 1:
				
					currtime = time_time()
					timedelta = currtime-lasttime

					if timedelta > 1: # 1 sekunde vergangen

						runtime += 1
						lasttime = currtime
						
						if os_path_exists(tmpfn):
							currtempfilesize = os_path_getsize(tmpfn)
							
						sizedelta = currtempfilesize-lasttempfilesize
						if decade >= 10:
							logger.debug('CalcWaveValusThread]run]convert time {} secounds wavefilesize {} size delta {}'.format(runtime, currtempfilesize, sizedelta))
							decade=0

						if sizedelta < 60000:
							if errorcounter < 5:
								errorcounter += 1
								logger.info('CalcWaveValusThread]run]tempfile size change to small {}, set counter for kill {}'.format(sizedelta, errorcounter))
							else:
								error='CalcWaveValusThread]run]tempfile size change to small, {}, kill ffmpeg now'.format(sizedelta)
								raise Exception(error)

						lasttempfilesize=currtempfilesize


						if p.poll()==0:
							logger.info('CalcWaveValusThread]run]ffmpeg finished!')
							break

					time_sleep(0.1)

				#logger.info('CalcWaveValusThread]run]Time for wavebuild was:{}'.format(currtime-start))

				if self.canceled:
					error='CalcWaveValusThread]run]raise Thread after ffmpeg, reason {}'.format(self.canceled)
					logger.info(error)
					raise Exception(error)
					#self.canceled=False

				sound = AudioSegment.from_wav(tmpfn)
				chunk_length = len(sound) / pixel_x
				wavevalues = [ sound[ i*chunk_length : (i+1)*chunk_length ].rms for i in xrange(pixel_x)]
				sound=None

				paintWaveformPicture(self.__slentry.filename, wavevalues)
			
			else:#no ffmpeg
				wavevalues = 'caneled by: no ffmpeg found!'
					
			#logger.info('CalcWaveValusThread]run]done push songID {} index {} filename {}'.format(self.__slentry.songID, self.__index, self.__slentry.filename))
			self.__messages.push((self.__index, self.__slentry, wavevalues, self.__len_of_songlist))
			self.__messagePump.send(0)

		except:
			logger.exception('CalcWaveValusThread]run]except...')
			self.__messages.push((self.__index, self.__slentry, 'canceled, by:{}'.format(self.canceled), self.__len_of_songlist))
			self.__messagePump.send(0)

		finally:
			if os_path_exists(tmpfn):
				logger.debug('CalcWaveValusThread]run]finally, remove {}'.format(tmpfn))
				os_remove(tmpfn)

			Thread.__init__(self)
			self.__slentry=[]
			self.canceled=False
			self.__running=False


def calcPointerColors(coverfn):
	#logger.info('calcPointerColors]start')
	try:
		im=Image.open(coverfn)
		if im.mode!='RGB':
			#logger.info('calcPointerColors]no rgb, convert to RGB')
			im=im.convert('RGB')
	except:
		logger.exception('calcPointerColors]pic->%s  Error->%s' %(coverfn, e))
		return (189,156,24),(255,255,255)

	im900=im.resize((30,30),)
	pixellist=im900.getcolors(900)
	pixellist=sorted(pixellist, key=lambda a:a[0], reverse=True)[:300]
	bgcolor=pixellist.pop(0)
	bgcolor=bgcolor[1]
	if sum(list(bgcolor))<120:
		d=(120-sum(list(bgcolor)))/3
		r=bgcolor[0]+d
		g=bgcolor[1]+d
		b=bgcolor[2]+d
		bgcolor=(r,g,b)
		#logger.info('calcPointerColors]bgcolor fixed->%s' %str(bgcolor))

	match=False
	colordistance=90
	isblack=False
	for pixel in pixellist:
		possible_fg_color=pixel[1]
		if sum(list(possible_fg_color))<120:# to dark
			isblack=True
			continue
		if abs(possible_fg_color[0]-bgcolor[0])>colordistance and abs(possible_fg_color[1]-bgcolor[1])-colordistance and abs(possible_fg_color[2]-bgcolor[2])>colordistance:
			match=True
			break
	if not match:
		#logger.info('calcPointerColors]No matching color found pic->%s' %coverfn)
		if isblack:
			#logger.info('calcPointerColors]set to black')
			possible_fg_color=(255,255,255)
		else:
			#logger.info('calcPointerColors]set to white')
			possible_fg_color=(45,45,45)

	return bgcolor, possible_fg_color


def ImageZerren(wavefn, waveout, color=(0,0,0)):
	im=Image.open(wavefn)
	im_x, im_y=im.size
	# spiegeln
	mirror_img = ImageOps.flip(im)
	# halbieren y
	mirror_img=mirror_img.resize((im_x,im_y/3))
	w,h=mirror_img.size
	# neues Image
	wave_new = Image.new('RGBA', (im_x+h, im_y+h))
	wave_new.paste(im,(0,0))
	# neuer Pointer
	pointer_new = Image.new('RGBA', (im_x+h, im_y+h))
	pointer_new.paste(color,(0, 0, im_x, im_y))

	pixels = mirror_img.load()
	putpixel_x, putpixel_y=0,0
	offset=-1
	# einfgen
	for y in xrange(h):
		offset+=1
		pointer_new.paste(color,(0, im_y+offset,im_x+offset, im_y+offset+1))

		for x in xrange(w):
			pixel = pixels[x, y]
			putpixel_x=x+offset
			putpixel_y=im_y+y
			wave_new.putpixel((putpixel_x, putpixel_y),(pixel))
	wave_new.save(waveout)
	pointer_new.save('/tmp/pointer.png')
	return '/tmp/pointer.png'
