#	-*-	coding:	utf-8	-*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.


from Globals import *
# local plugin
#from EditID3 import EditId3
from JobCenter import *
from myLogger import logger
from ItemClasses import *

from SelectPath import SelectPath
import SPlayer
from ListClasses import RadioList, listeFavoriten, meineLetztGespielt

from Setup import MusicCenterSetup
import EditStreamFavorite
from JobCenter2 import *
from LogScreen import *
from tagger import myenCode


class LautFM(Screen):


	if RESOLUTIONx>1800:

		skin='''<screen name="LautFM" position="0,0" size="1920,1080" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="20,20" size="1900,100" zPosition="1" />
				<widget name="headertext" position="140,39" size="1760,42" font="SansReg;35" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
				<ePixmap position="20,20" size="100,100" pixmap="~/lautfm-logo.png" scale="1" zPosition="2"/>
			<!-- Buttons -->
				<eLabel position="20,135" size="1900,40" backgroundColor="#191919" zPosition="1" />
				<!-- arrow left -->
					<widget render="Label" font="SansReg;40" position="30,135" size="40,40" source="key_arrow_left" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<!-- red -->
					<widget render="Label" font="SansReg;34" position="100,135" size="450,40" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget name="line_red" position="105,170" size="440,6" zPosition="3" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/white450x3.png" />
				<!-- green -->
					<widget render="Label" font="SansReg;34" position="510,135" size="450,40" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget name="line_green" position="515,170" size="440,6" zPosition="3" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/white450x3.png" />
				<!-- yellow -->
					<widget render="Label" font="SansReg;34" position="960,135" size="450,40" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget name="line_yellow" position="965,170" size="440,6" zPosition="3" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/white450x3.png" />
				<!-- blue -->
					<widget render="Label" font="SansReg;34" position="1410,135" size="450,40" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget name="line_blue" position="1415,170" size="440,6" zPosition="3" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/white450x3.png" />
				<!-- arrow right -->
					<widget render="Label" font="SansReg;40" position="1870,135" size="40,40" source="key_arrow_right" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
			<widget name="list" position="35,190" zPosition="1" size="1850,855" scrollbarMode="showOnDemand" backgroundColor="#00000000"/>
		</screen>'''

	else:
		skin='''<screen name="LautFM" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="13,13" size="1266,66" zPosition="1" />
				<widget name="headertext" position="93,26" size="1173,28" font="SansReg;23" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
				<ePixmap position="13,13" size="66,66" pixmap="~/lautfm-logo.png" scale="1" zPosition="2"/>
			<!-- Buttons -->
				<eLabel position="13,90" size="1266,33" backgroundColor="#191919" zPosition="1" />
				<!-- arrow left -->
					<widget render="Label" font="SansReg;29" position="20,92" size="26,29" source="key_arrow_left" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<!-- red -->
					<widget render="Label" font="SansReg;25" position="66,92" size="300,28" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget name="line_red" position="70,120" size="293,2" zPosition="2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/white450x3.png" />
				<!-- green -->
					<widget render="Label" font="SansReg;25" position="340,92" size="300,28" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget name="line_green" position="343,120" size="293,2" zPosition="2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/white450x3.png" />
				<!-- yellow -->
					<widget render="Label" font="SansReg;25" position="640,93" size="300,28" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget name="line_yellow" position="643,120" size="293,2" zPosition="2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/white450x3.png" />
				<!-- blue -->
					<widget render="Label" font="SansReg;25" position="940,92" size="300,28" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget name="line_blue" position="943,120" size="293,2" zPosition="2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/white450x3.png" />
				<!-- arrow right -->
					<widget render="Label" font="SansReg;29" position="1246,92" size="26,29" source="key_arrow_right" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
			<widget name="list" position="23,130" zPosition="1" size="1233,570" scrollbarMode="showOnDemand" backgroundColor="#00000000"/>
		</screen>'''


	def __init__(self, session, player, currentservice, servicelist):

		logger.info('LautFM]init...')
		self.session=session
		self.currentservice=currentservice
		self.servicelist=servicelist
		self.skin_path='/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics'

		Screen.__init__(self, session)
		self['list']=RadioList([])

		self["actions"]=ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions", "InfobarAudioSelectionActions", "HelpActions"],
		{
			"input_date_time": self.menuPressed,
			"ok": self.okPressed,
			"back": self.closing,
			"red": self.redPressed,
			"green": self.greenPressed,
			"yellow": self.yellowPressed,
			"blue": self.bluePressed,
			"prevService": self.keyLeft,
			"nextService": self.keyRight,
			"audioSelection": self.audioPressed,
		}, -1)

		self.onLayoutFinish.append(self.__startRun)
		self.onClose.append(self.__onClose)

		self.player=player
		self["key_arrow_left"]=StaticText("")
		self["key_red"]=StaticText("")
		self["line_red"] = Pixmap()
		self["line_red"].hide()
		self["key_green"]=StaticText("")
		self["line_green"] = Pixmap()
		self["line_green"].hide()
		self["key_yellow"]=StaticText("")
		self["line_yellow"] = Pixmap()
		self["line_yellow"].hide()
		self["key_blue"]=StaticText("")
		self["line_blue"] = Pixmap()
		self["line_blue"].hide()
		self["key_arrow_right"]=StaticText(">")
		self.bottomlineindex=0

		self['headertext']=Label()
		self.toconvertlist=[]
		self.picdir=self.initPicDir()
		self.mode='showMainMenu'
		self.headerpos=0
		self.hl=[]

		self.stationiconandstatsdownloaderinstance = StationiconDownloader(self.picdir)
		self.sdl_conn = self.stationiconandstatsdownloaderinstance.MessagePump.recv_msg.connect(self.stationiconDownloaded)
		
		self.genreselected=''
		self.genrefavoritenliste=[]
		if fileExists(resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_genre_favoriten.json")):
			self.genrefavoritenliste=load_obj(resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_genre_favoriten.json"))
		self.landselected=''
		self.laenderfavoritenliste=[]
		if fileExists(resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_laender_favoriten.json")):
			self.laenderfavoritenliste=load_obj(resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_laender_favoriten.json"))
		self.spracheselected=''
		self.sprachenfavoritenliste=[]
		if fileExists(resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_sprachen_favoriten.json")):
			self.sprachenfavoritenliste=load_obj(resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_sprachen_favoriten.json"))


	def initPicDir(self):
		picdir=''.join((config.plugins.musiccenter.downloadcache.value, 'LautFM/'))
		if not pathExists(picdir):
			if not createDir(picdir, makeParents=True):
				picdir='/tmp/mc/'
		return picdir


	def __startRun(self):
		self['list'].onSelectionChanged.append(self.updateLCTText)
		self.showMainMenu()


	def showMainMenu(self):
		#self.listeFavoritenNow()
		self.hl = ['Meine Favoriten', 'Letzt Gespielte', 'Top 100 Hörer', 'Top 100 Stationen', 'Genres', 'Alphabet', 'Suche Stationname' , 'Suche Station nach Artist']
		header='Welcome on www.laut.fm'
		self.setListNow(list=[], header=header, red=self.hl[0], green=self.hl[1], yellow=self.hl[2], blue=self.hl[3])
		url='server_status'
		lautfm_getPage(url).addCallback(self.showMainMenuAppend).addErrback(self.getPageError, 'Top_Listener')


	def showMainMenuAppend(self, result):
		result = json_loads(result)
		if result.get('running'):
			self['headertext'].setText('{}, {}'.format(self['headertext'].getText(), myenCode(result.get('message')).title()))
		
	
	def getPageError(self, error, key):
		logger.error('LautFM]getPageError]{} -> {}'.format(key, error))


	def buildStationEntrys(self, stationen):
		'''{name: "radio-lamuka",
		display_name: null,
		spoken_name: null,
		page_url: "https://laut.fm/radio-lamuka",
		stream_url: "https://stream.laut.fm/radio-lamuka",
		api_urls: {},
		format: "RADIO TELE LAMUKA.",
		description: " Unser Radio ist ein Radioprogramm der kongolesischen Gemeinde in Deutschland. Der Sitz des Radios ist Duisburg. Jede Woche geben drei Debattierer ihren Standpunkt zu den Nachrichten des Tages an. Folgen Sie uns live auf www.radiotelelamuka.top.",
		djs: "Franck Sando Kanda",
		location: "Duisburg",
		lat: 51.435,
		lng: 6.75956,
		color: "",
		updated_at: "2019-03-08 19:48:50 +0000",
		genres: [ ],
		active: true,
		invocation_name: null,
		alexa_skill_name: null,
		tunein_id: null,
		website: null,
		facebook_page: null,
		twitter_name: null,
		rss_url: null,
		disqus_shortname: null,
		third_parties: {},
		images: {},
		current_playlist: {},
		next_playlist: {},
		top_artists: [],
		position: 4882
		},,....
		'''
		list=[]
		to_load_stations=[]
		index=0

		for station in stationen:
		
			if station.has_key('station'):
				station = station.get('station', '')
				
			stationname = station.get('name', '').encode()
			
			try:
				display_name = station['display_name'].encode()
			except:
				display_name = stationname.title()
				
			songID = index
			streamurl=station.get('stream_url', 'n/a').encode()
			genres = station.get('genres', [])
			genres = str(', '.join(genres))
			location = station.get('location', 'n/a').encode()
			if not location:
				location = 'n/a'
			position = str(station.get('position', 0))
			
			filename=''.join((stationname, '.jpg'))
			stationiconfilename=os_path_join(self.picdir, filename)
			
			filetype = 'LAUTFM'
			text = 'n/a'
			listeners = 'n/a'
			
			to_load_stations.append((filetype, index, station, text, listeners, position))
			
			list.append((Item(songID = songID, streamID = stationname, text = text, stationname = display_name, genre = genres, location = location, streamurl = streamurl, join = True, filetype = 'LAUTFM', audio = True, stationicon = stationiconfilename, votes = position, playcount = listeners),))
			
			index += 1
		
		stationen = None
		
		return list, to_load_stations


	def stationiconDownloaded(self, msg):
		msg = self.stationiconandstatsdownloaderinstance.Message.pop()
		type = msg[0]
		
		if type == 'station_icons':
			type, index, event, listeners, position = msg
			logger.debug('LautFM]stationiconDownloaded]index:{} event:{} listeners:{}'.format(index, event, listeners))
			if index < self['list'].getItemCount:
				self['list'].list[index][0].text = event
				self['list'].list[index][0].playcount = listeners
				self['list'].list[index][0].votes = position

		elif type == 'station_stats':
			type, index, event, listeners, votes = msg
			logger.debug('LautFM]stationiconDownloaded]index:{} event:{} listeners:{}'.format(index, event, listeners))
			if index < self['list'].getItemCount:
				self['list'].list[index][0].text = event
				self['list'].list[index][0].playcount = listeners
				self['list'].list[index][0].votes = votes			


	def setBottomline(self, key=-1):
		logger.debug('LautFM]setBottomline]key->%d' %key)
		if key>-1:
			self.bottomlineindex=key
		self["line_red"].hide()
		self["line_green"].hide()
		self["line_yellow"].hide()
		self["line_blue"].hide()
		if key in range(0,12,4):
			self["line_red"].show()
		elif key in  range(1,12,4):
			self["line_green"].show()
		elif key in  range(2,12,4):
			self["line_yellow"].show()
		elif key in  range(3,12,4):
			self["line_blue"].show()


	def redPressed(self):
		self.selectMode(0)


	def greenPressed(self):
		self.selectMode(1)


	def yellowPressed(self):
		self.selectMode(2)


	def bluePressed(self):
		self.selectMode(3)


	def selectMode(self, mode):
	
		if self.stationiconandstatsdownloaderinstance.isRunning:
			logger.debug('LautFM]selectMode]stationicondownloaderinstance.isRunning:{}, cancel now...'.format(self.stationiconandstatsdownloaderinstance.isRunning))
			self.stationiconandstatsdownloaderinstance.cancel()

		mode=self.headerpos+mode
		logger.debug('LautFM]selectMode:{}'.format(mode))
		self.setBottomline(mode)
		self.setListNow([], header='...') # 'Favoriten', 'Top 100 Hörer', 'Top 100 Stationen', 'Genres', 'Alphabet', 'Suche Stationname' , 'Suche Station nach Artist'

		c = 0
		if mode == c: # Favoriten
			self.listeFavoritenNow()
			self.mode='listeFavoritenNow'
			
		c+=1
		if mode == c:# Top 100 Hörer
			self.meineLetztGespieltNow()
			self.mode='meineLetztGespieltNow'
		
		c+=1
		if mode == c:# Top 100 Hörer
			self.Top_Listener()
			self.mode='Top_Listener'
			
		c+=1
		if mode == c:# Top 100
			self.Top_100()
			self.mode='Top_100'
						
		c+=1
		if mode == c:# genres
			self.GernesListe()
			self.mode='GernesListe'
			
		c+=1
		if mode == c:# alphabet
			self.AlbhabetListe()
			self.mode='AlbhabetListe'
			
		c+=1
		if mode == c: # SucheStation
			self.startSucheStation()
			self.mode='startSucheStation'
			
		c+=1
		if mode == c: # SucheArtist
			self.startSucheArtist()
			self.mode='startSucheArtist'
			
		logger.debug('LautFM]selectMode {} c:{}'.format(self.mode, c))

# favoriten
	def listeFavoritenNow(self, index=0):
		self.setListNow(list = [], header = 'Lade Favoriten...')
		list , len_of_list = listeFavoriten(self, full = False)
		self.setListNow(list = list, index = index, header = '{} Favoriten'.format(len_of_list))
		self.stationiconandstatsdownloaderinstance.Start(jobname = 'station_stats')
		
		
	def listeFavoritenUpdateInfo(self, result):
		#logger.debug('LautFM]isteFavoritenUpdateInfo]status:' + status)
		list, len_of_list = result
		self['list'].list = list
		logger.debug('LautFM]isteFavoritenUpdateInfo]result:{}'.format(list[0][0].text))
		'''
		msg = self.srinstance.Message.pop()
		index, event, listeners, position = msg
		logger.debug('LautFM]stationiconDownloaded]index:{} event:{} listeners:{}'.format(index, event, listeners))
		if index < self['list'].getItemCount:
			self['list'].list[index][0].text = event
			self['list'].list[index][0].playcount = listeners
			self['list'].list[index][0].votes = position
		'''	

			
	def listeFavoritenUpdateInfoError(self, error):
		logger.error('LautFM]listeFavoritenUpdateInfoError]{}'.format(error))


	def updateStationlist(self, list , len_of_list):
		logger.debug('LautFM]updateStationlist]now...')
		self['list'].list = list


	def meineLetztGespieltNow(self):
		self.setListNow(list = [], header = 'Lade gespielte Stationen...')
		list , len_of_list = meineLetztGespielt(self, full = True)
		self.setListNow(list = list, index = 0, header = '{} letzt gespielte Stationen'.format(len_of_list))


	def Top_Listener(self):
		url = 'listeners'
		lautfm_getPage(url).addCallback(self.Top_ListenerAppend).addErrback(self.getPageError, 'Top_Listener')

		
	def Top_ListenerAppend(self, result):
		logger.debug('LautFM]Top_ListenerAppend]')
		# {42: 1,67: 7,100: 0,411: 0,495: 2,2000: 1,.....}
		stationen = []
		for stationname, listeners in json_loads(result).iteritems():
			if listeners > 0:
				stationen.append((stationname, listeners,))
			
		result = None
		stationen.sort(key = lambda a:a[1], reverse = True)
		
		stationen = [ station[0] for station in stationen ]
		url = 'stations/{}'.format(','.join(stationen[:100]))
		logger.debug('LautFM]Top_ListenerAppend]url:{}'.format(url))
		lautfm_getPage(url).addCallback(self.Top_ListenerStationenAppend).addErrback(self.getPageError, 'Top_ListenerAppend')


	def Top_ListenerStationenAppend(self, stationen):
		logger.debug('LautFM]Top_ListenerStationenAppend]')
		stationen = json_loads(stationen)
		list, to_load_stations = self.buildStationEntrys(stationen)
		if to_load_stations:
			self.stationiconandstatsdownloaderinstance.Start(jobname = 'station_icons', stations = to_load_stations)
		header = 'Top Hörer {} Stationen'.format(len(list))	
		self.setListNow(list = list, header = header)


	def Top_100(self):
		url = 'stations?limit=100'
		lautfm_getPage(url).addCallback(self.Top_100Append).addErrback(self.getPageError, 'Top_100')


	def Top_100Append(self, stationen, ):
		logger.debug('LautFM]Top_100Append]')
		stationen = json_loads(stationen)
		list, to_load_stations = self.buildStationEntrys(stationen)
		if to_load_stations:
			self.stationiconandstatsdownloaderinstance.Start(jobname = 'station_icons', stations = to_load_stations)
		header = 'Top 100 {} Stationen'.format(len(list))
		self.setListNow(list = list, header = header)

#suche Station
	def startSucheStation(self):
		self.session.openWithCallback(self.sucheStationJetzt, vInputBox, title = _('Name der Station eingeben!'), windowTitle = _("LautFM Suche"), text = LAST_STREAM_SEARCH)


	def sucheStationJetzt(self, suchname):
		logger.info('LautFM]sucheStationJetzt]suchname:{}'.format(suchname))
		if suchname is not None:
			global LAST_STREAM_SEARCH
			LAST_STREAM_SEARCH = suchname
			#/search/stations?query=name:Sunshine&limit=20 
			url = 'search/stations?query=name:{}&limit=3'.format(suchname)
			logger.debug('LautFM]sucheStationJetzt]url:{}'.format(url))
			lautfm_getPage(url).addCallback(self.getSucheAppend, suchname).addErrback(self.getPageError, 'sucheStationJetzt')
		else:
			self.setListNow(list = [], header = 'kein Suchwort!')


	def getSucheAppend(self, stationen, suchname):
		stationen = json_loads(stationen)
		logger.debug('LautFM]getSucheAppend]suchname:{} stationen:{}'.format(suchname, stationen))
		if stationen['results']:
			list, to_load_stations = self.buildStationEntrys(stationen['results'][0]['items'])
		else:
			list = []
		if to_load_stations:
			self.stationiconandstatsdownloaderinstance.Start(jobname = 'station_icons', stations = to_load_stations)
			
		self.setListNow(list = list, header = 'Ergebnis der Suche nach {} {} Stationen'.format(suchname, len(list)))


#suche current artist
	def startSucheArtist(self):
		self.session.openWithCallback(self.sucheArtistJetzt, vInputBox, title = _('Name des Artists eingeben!'), windowTitle = _("LautFM Suche"), text = LAST_STREAM_SEARCH)


	def sucheArtistJetzt(self, suchname):
		logger.info('LautFM]sucheArtistJetzt]suchname:{}'.format(suchname))
		if suchname is not None:
			global LAST_STREAM_SEARCH 
			LAST_STREAM_SEARCH = suchname
			url = 'search/stations?query=artists:{}&limit=30'.format(suchname) # artists -> Expandiert zu current_artist,next_artists,all_artists.
			logger.debug('LautFM]sucheArtistJetzt]url:{}'.format(url))
			lautfm_getPage(url).addCallback(self.sucheArtistAppend, suchname).addErrback(self.getPageError, 'sucheArtistJetzt')
		else:
			self.setListNow(list = [], header = 'kein Suchwort!')


	def sucheArtistAppend(self, stationen, suchname):
		stationen = json_loads(stationen)
		logger.debug('LautFM]sucheArtistAppend]suchname:{} stationen:{}'.format(suchname, stationen.keys()))
		if stationen['results']:
			tmpstations = stationen['results']
			stationen = []
			for stations in tmpstations:
				stationen += stations['items']
		
			logger.debug('LautFM]sucheArtistAppend]stationen:{}'.format(len(stationen)))

			list, to_load_stations = self.buildSucheArtistEntrys(stationen)
		else:
			list = []

		if to_load_stations:
			self.stationiconandstatsdownloaderinstance.Start(jobname = 'station_icons', stations = to_load_stations)
			
		self.setListNow(list = list, header = 'Ergebnis der Suche nach {} {} Stationen'.format(suchname, len(list)))
		

	def buildSucheArtistEntrys(self, stationen):

		list = []
		to_load_stations = []
		index = 0

		for stationentry in stationen:
		
			station = stationentry.get('station', '')
				
			stationname = station.get('name', '').encode()
			
			try:
				display_name = station['display_name'].encode()
			except:
				display_name = stationname.title()
				
			songID = index
			streamurl=station.get('stream_url', 'n/a').encode()
			genres = station.get('genres', [])
			genres = str('|'.join(genres))
			location = station.get('location', 'n/a').encode()
			if not location:
				location = 'n/a'
			position = str(station.get('position', 0))
			
			filename=''.join((stationname, '.jpg'))
			stationiconfilename=os_path_join(self.picdir, filename)
			
			text = 'n/a'
			listeners = 'n/a'
			
			if stationentry.get('current_song'):
				current_song = stationentry.get('current_song')
				title = current_song.get('title', 'n/a').encode()
				artist = current_song['artist'].get('name', 'n/a').encode()
				started_at = current_song.get('started_at', 'n/a').encode()
				album = current_song.get('album', 'n/a')
				if album is not None:
					album = album.encode()
				text ='Playing:{} - {}({})|{}'.format(artist, title, album, started_at.split(' ')[1])
			
			elif stationentry.get('next_artists'):
				next_artists = stationentry.get('next_artists')
				text ='Next:{}'.format(next_artists)
				
			else:
				logger.debug('LautFM]sucheArtistAppend]skip station:{}'.format(stationentry.keys()))######################################################################

				continue
				
			to_load_stations.append((index, station, text, listeners))
				
			list.append((Item(songID=songID, streamID=stationname, text=text, stationname=display_name, genre=genres, location=location, streamurl=streamurl, join=True, filetype='LAUTFM', audio=True, stationicon=stationiconfilename, votes=position, playcount = listeners),))
			
			index += 1
		
		stationen = None
		
		return list, to_load_stations


	def GernesListe(self):
		logger.info('LautFM]GernesListe]')
		url='genres'
		lautfm_getPage(url).addCallback(self.GernesListeAppend).addErrback(self.getPageError, 'GernesListe')


	def GernesListeAppend(self, tagsliste):
		#{name: "Rock",score: 1188,related: ["Pop","Alternative","Oldies","Metal","Blues", "Schlager","Punk","Classic Rock","Dance & Electronic","Hard Rock"]},...
		entrylist=[]
		tagsliste = json_loads(tagsliste)
		for entry in tagsliste:
			name = entry['name'].encode()
			score = entry['score']
			entrylist.append((_("{} (Score:{})".format(name.title(), score)), name, score),)
			
		entrylist.sort(key=lambda a:a[1], reverse=False)
		
		self.session.openWithCallback(self.selectedGenre, ChoiceBox, title=_('Bitte Genre auswählen'), list=entrylist, keys=MYKEYSORT, titlebartext=_('MusicCenter Genreliste'))


	def selectedGenre(self, genre):
		if genre is not None:
			genre=genre[1]
			logger.debug('LautFM]selectedGenre]->%s' %genre)
			url='stations/genre/{}?limit=100'.format(quote(genre))
			logger.info('LautFM]selectedGenre]url->%s' %url)
			lautfm_getPage(url).addCallback(self.selectedGenreAppend, genre).addErrback(self.getPageError, 'selectedGenreAppend')


	def selectedGenreAppend(self, stationen, genre):
		self.genreselected=genre
		stationen=json_loads(stationen)
		list, to_load_stations=self.buildStationEntrys(stationen)
		if to_load_stations:
			self.stationiconandstatsdownloaderinstance.Start(jobname = 'station_icons', stations = to_load_stations)
		self.setListNow(list=list, header='Genre %s %s Stationen' %(genre.title(), len(list)))


	def AlbhabetListe(self):
		logger.info('LautFM]AlbhabetListe]')
		url='letters'
		lautfm_getPage(url).addCallback(self.AlbhabetListeAppend).addErrback(self.getPageError, 'AlbhabetListe')


	def AlbhabetListeAppend(self, alphabet):
		#{name: "Rock",score: 1188,related: ["Pop","Alternative","Oldies","Metal","Blues", "Schlager","Punk","Classic Rock","Dance & Electronic","Hard Rock"]},...
		entrylist=[]
		alphabet = json_loads(alphabet)
		for entry in alphabet:
			name =entry.encode()
			entrylist.append((_("Stations {}".format(name.title(),)), name,),)
			
		#entrylist.sort(key=lambda a:a[1], reverse=False)
		
		self.session.openWithCallback(self.selectedBuchstabe, ChoiceBox, title=_('Bitte Buchstabe auswählen'), list=entrylist, keys=MYKEYSORT, titlebartext=_('MusicCenter AlbhabetListe'))


	def selectedBuchstabe(self, buchstabe):
		if buchstabe is not None:
			buchstabe=buchstabe[1]
			url='stations/letter/{}'.format(quote(buchstabe)) #?limit=100
			logger.info('LautFM]selectedBuchstabe]url->%s' %url)
			lautfm_getPage(url).addCallback(self.selectedBuchstabeAppend, buchstabe).addErrback(self.getPageError, 'selectedBuchstabeAppend')


	def selectedBuchstabeAppend(self, stationen, buchstabe):
		self.buchstabeselected=buchstabe
		stationen=json_loads(stationen)
		list, to_load_stations=self.buildStationEntrys(stationen)
		if to_load_stations:
			self.stationiconandstatsdownloaderinstance.Start(jobname = 'station_icons', stations = to_load_stations)
		self.setListNow(list=list, header='Buchstabe %s %s Stationen' %(buchstabe.title(), len(list)))


	def okPressed(self):
		logger.info('LautFM]ok]start')
		if self.player is not None:
			if self.player.seekstate!=self.player.SEEK_STATE_STOP: # currentindex!=-2: #-2 is stopPlay
				self.player.stopPlay()
			logger.debug('LautFM]scanFinished]is player instance, delete now...')
			self.session.deleteDialog(self.player)
			self.player=None
		try:
			if JCcheckModuleIsUpdated('SPlayer'):
				reload(SPlayer)
		except Exception, e:
			self.session.open(MessageBox, _("Error reload SPlayer\n%s" %e), type=MessageBox.TYPE_ERROR, timeout=10 )

		logger.debug('LautFM]scanFinished]instantiate new player dialog')
		self.player=self.session.instantiateDialog(SPlayer.SPlayer, songlist=self['list'].getList(), index=self['list'].getSelectedIndex(), currentservice=self.currentservice, servicelist=self.servicelist)
		self.player.setShowHideAnimation("quick_fade")
		self.session.execDialog(self.player)


	def setListNow(self, list=[], index=0, header='', red=None, green=None, yellow=None, blue=None):
		logger.info('LautFM]setListNow]')
		self['list'].setList(list)
		self['list'].moveToIndex(index)
		self['headertext'].setText(_(header))
		self.setButtons(red, green, yellow, blue)


	def setButtons(self, red=None, green=None, yellow=None, blue=None):
		if red!=None:
			self["key_red"].setText(red)
		if green!=None:
			self["key_green"].setText(green)
		if yellow!=None:
			self["key_yellow"].setText(yellow)
		if blue!=None:
			self["key_blue"].setText(blue)


	def menuPressed(self):
		options=[]
		options.append((_("Globale Konfiguration"), self.startConfig),)
		if self.mode!='listeFavoritenNow':
			options.append((_("Füge ausgewählten Stream zu Favoriten hinzu"), self.startAddStreamToFavoriteList),)
		#	options.append((_("Füge ausgewähltes Suchwort den Favoriten hinzu"), self.startAddStreamToFavoriteList),)
		if self.mode == 'GernesListe':
			if self.genreselected in self.genrefavoritenliste:
				options.append((_("Entferne ausgewählten Tag von den Favoriten der Länderliste"), self.entferneTagAusFavoritenliste),)
			else:
				options.append((_("Füge ausgewählten Tag zu den Favoriten der Tagliste hinzu"), self.fuegeTagZurFavoritenliste),)
		elif self.mode == 'LaenderListe':
			if self.landselected in self.laenderfavoritenliste:
				options.append((_("Entferne ausgewähltes Land von den Favoriten der Länderliste"), self.entferneLandAusFavoritenliste),)
			else:
				options.append((_("Füge ausgewähltes Land zu den Favoriten der Länderliste hinzu"), self.fuegeLandZurFavoritenliste),)
		elif self.mode == 'SprachenListe':
			if self.spracheselected in self.sprachenfavoritenliste:
				options.append((_("Entferne ausgewählte Sprache von den Favoriten der Sprachenliste"), self.entferneSpracheAusFavoritenliste),)
			else:
				options.append((_("Füge ausgewählte Sprache zu den Favoriten der Sprachnliste hinzu"), self.fuegeSpracheZurFavoritenliste),)
		else:
			options.append((_("Editiere ausgewählten FavoritenStream"), self.startEditiereSelektieretenStream),)
			options.append((_("Lösche ausgewählten FavoritenStream"), self.startLoescheSelektieretenStream),)
		options.append((_("öffne Logfile"), self.startLog ),)
		self.session.openWithCallback(self.menuCallback, ChoiceBox, title=_("Mainscreen Options"), list=options, keys=MYKEYSORT, titlebartext=_("MusicCenter"))

	def menuCallback(self, ret):
		if ret is not None:
			if len(ret) == 3:
				ret and ret[1](ret[2])
			else:
				ret and ret[1]()

	def startAddStreamToFavoriteList(self):
		sel=self.getCurrentSelection()
		if sel is not None:
			addStreamToFavoriteList(sel)
# genre
	def fuegeTagZurFavoritenliste(self):
		self.genrefavoritenliste.append(self.genreselected)
		save_obj(self.genrefavoritenliste, resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_genre_favoriten.json"))

	def entferneTagAusFavoritenliste(self):
		if self.genreselected in self.genrefavoritenliste:
			self.genrefavoritenliste.remove(self.genreselected)
			save_obj(self.genrefavoritenliste, resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_genre_favoriten.json"))
# laender
	def fuegeLandZurFavoritenliste(self):
		self.laenderfavoritenliste.append(self.landselected)
		save_obj(self.laenderfavoritenliste, resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_laender_favoriten.json"))

	def entferneLandAusFavoritenliste(self):
		if self.landselected in self.laenderfavoritenliste:
			self.laenderfavoritenliste.remove(self.landselected)
			save_obj(self.laenderfavoritenliste, resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_laender_favoriten.json"))
# sprache
	def fuegeSpracheZurFavoritenliste(self):
		self.sprachenfavoritenliste.append(self.spracheselected)
		save_obj(self.sprachenfavoritenliste, resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_sprachen_favoriten.json"))

	def entferneSpracheAusFavoritenliste(self):
		if self.spracheselected in self.sprachenfavoritenliste:
			self.sprachenfavoritenliste.remove(self.spracheselected)
			save_obj(self.sprachenfavoritenliste, resolveFilename(SCOPE_CONFIG ,"mc_radiobrowser_sprachen_favoriten.json"))

	def startEditiereSelektieretenStream(self):
		sel=self.getCurrentSelection()
		if sel is not None:
			if JCcheckModuleIsUpdated:
				reload(EditStreamFavorite)
			self.session.openWithCallback(self.afterEditdSelectedStream, EditStreamFavorite.EditFavoriteStreamDB, sel.stationname)

	def afterEditdSelectedStream(self, res):
		logger.info('LautFM]afterEditdSelectedStream]update Favoritelist, is chnaged->%s' %str(res))
		if res!=None:# stationname
			index=self['list'].getSelectedIndex()
			logger.info('LautFM]afterEditdSelectedStream]update Favoritelist now index->%d' %index)
			self.listeFavoritenNow(index=index)

	def startLoescheSelektieretenStream(self, sel=None):#also called from player
		if sel is None:
			sel=self.getCurrentSelection()
		if sel is not None:
			removeStreamFromFavoriteList(sel)
			logger.info('LautFM]startLoescheSelektieretenStream]remove station->%s' %sel.stationname)
			i=self['list'].getCurrentIndex()
			self['list'].removeItem(i)
			self['list'].refreshList()

	def startConfig(self):
		self.session.open(MusicCenterSetup)

	def startLog(self):
		self.session.open(LogScreen)

	def keyLeft(self):
		if self.headerpos>0:
			self.headerpos-=4
			self['key_arrow_left'].setText('<')
			self.setButtons(red=self.hl[self.headerpos+0], green=self.hl[self.headerpos+1], yellow=self.hl[self.headerpos+2], blue=self.hl[self.headerpos+3])
			if not self.headerpos>0:
				self['key_arrow_left'].setText('')

		if self.headerpos>0:
			self['key_arrow_right'].setText('>')
		self.updateBottomline()

	def keyRight(self):
		if self.headerpos < len(self.hl)-4:
			self.headerpos+=4
			self['key_arrow_right'].setText('>')
			self.setButtons(red=self.hl[self.headerpos+0], green=self.hl[self.headerpos+1], yellow=self.hl[self.headerpos+2], blue=self.hl[self.headerpos+3])
			if not self.headerpos < len(self.hl)-4:
				self['key_arrow_right'].setText('')

		if self.headerpos>0:
			self['key_arrow_left'].setText('<')
		self.updateBottomline()

	def updateBottomline(self):
		if self.bottomlineindex not in range(self.headerpos, self.headerpos+4):
			self.setBottomline(-1)
		else:
			self.setBottomline(self.bottomlineindex)

	def audioPressed(self):
		logger.info('LautFM]audioPressed]')
		if self.player is not None and self.player.songlist:
			self.session.execDialog(self.player)

	def getCurrentSelection(self):
		try: sel=self['list'].l.getCurrentSelection()[0]
		except: sel=None
		return sel

	def updateLCTText(self):
		entry=self['list'].getCurrent()
		if entry is not None:
			self.summaries.setText(entry.artist, 1)
			self.summaries.setText(entry.title, 2)
			self.summaries.setText(entry.stationname, 3)
		index=self['list'].getSelectedIndex()
		self._onSelectedIndexChanged(index)
		

	def _onSelectedIndexChanged(self, index):
		self["list"].selectionEnabled(index >= 0)
		self["list"].moveToIndex(index)

	def createSummary(self):
		return RadioBrowserLCD

	def closePlayerNow(self):
		logger.info('LautFM]closePlayerNow]')
		self.player.closePlayer()
		self.session.deleteDialog(self.player)
		self.player=None

	def closing(self):
		logger.info('LautFM]closing]')
		if self.stationiconandstatsdownloaderinstance.isRunning:
			self.stationiconandstatsdownloaderinstance.cancel()
		self.close(self.player)

	def __onClose(self):
		logger.info('LautFM]__onClose]...')
		self.stationiconandstatsdownloaderinstance = None
		self.sdl_conn = None


class RadioBrowserLCD(Screen):

	skin="""
		<screen position="0,0" size="132,64">
			<widget name="screenname" position="2,2" size="128,14" font="SansReg;12"/>
			<widget name="text1" position="2,17" size="128,14" font="SansReg;12"/>
			<widget name="text2" position="2,32" size="128,14" font="SansReg;12"/>
			<widget name="text3" position="2,47" size="128,14" font="SansReg;12"/>
		</screen>"""

	def __init__(self, session, parent):
		Screen.__init__(self, session)
		self["screenname"] = Label(_('MusicCenter LautFM'))
		self["text1"]=Label()
		self["text2"]=Label()
		self["text3"]=Label()

	def setText(self, text, line):
		if line == 1:
			self["text1"].setText(text)
		elif line == 2:
			self["text2"].setText(text)
		elif line == 3:
			self["text3"].setText(text)
		else:
			pass



'''
{
GET /doc: {
description: "List all routes and their doc text."
},
GET /server_status: {
description: "The current server status and a message to be displayed to the users.",
example: "https://api.laut.fm/server_status",
parameters: { }
},
GET /time: {
description: "The server time",
example: "https://api.laut.fm/time",
parameters: { }
},
GET /letters: {
description: "All available starting-letters of the stations.",
example: "https://api.laut.fm/letters",
parameters: { }
},
GET /genres: {
description: "All available genres",
example: "https://api.laut.fm/genres",
parameters: { }
},
GET /station_names: {
description: "The names of all stations.",
order: "Alphabetically ascending",
example: "https://api.laut.fm/station_names",
parameters: { }
},
GET /listeners: {
description: "The listeners of all stations.",
order: "By number of listener descending",
example: "https://api.laut.fm/listeners",
parameters: { }
},
GET /teaser: {
description: "The image sizes are 240x100, 220x220 and 720x300 pixels",
example: "https://api.laut.fm/teaser",
parameters: { }
},
GET /stations/live: {
description: "A list of all stations sending live at the moment.",
order: "Alphabetically",
example: "https://api.laut.fm/stations/live",
parameters: { }
},
GET /song_change.stream.json: {
description: "All occuring song changes as continous stream of linebreak separated json documents.",
example: "https://api.laut.fm/song_change.stream.json"
},
GET /song_change.ws.json: {
description: "All occuring song changes as continous websocket stream of json documents.",
example1: "ws://api.laut.fm/song_change.ws.json",
examplei2: "var connection = new WebSocket("ws://api.laut.fm/song_change.ws.json");"
},
GET /song_change.chunk.json: {
description: "The last ~50 song changes as linebreak separated json documents.",
example: "https://api.laut.fm/song_change.chunk.json"
},
GET /stations: {
description: "All stations.",
order: "By position ascending or by distance to given geolocation parameters.",
pagination: "Supports {limit} and {offset} parameters. Pagination metadata is only returned if {offset} is given. In that case, the actual result is in the "items" key of the json result.",
geolocation: "Supports {lat} and {lng} parameters (both must be given). If geolocation parameters are given the result is sorted by distance to the given location.",
example1: "https://api.laut.fm/stations",
example2: "https://api.laut.fm/stations?limit=10",
example3: "https://api.laut.fm/stations?limit=10&offset=5",
example4: "https://api.laut.fm/stations?limit=10&lat=47.6779&lng=9.17324",
parameters: { },
optional_parameters: {
limit: "\d+",
offset: "\d+",
lat: "[\.\d]+",
lng: "[\.\d]+"
}
},
GET /stations/letter/{letter}: {
description: "All stations beginning with the certain letter.",
order: "Alphabetically ascending or by distance to given geolocation parameters.",
pagination: "Supports {limit} and {offset} parameters. Pagination metadata is only returned if {offset} is given. In that case, the actual result is in the "items" key of the json result.",
geolocation: "Supports {lat} and {lng} parameters (both must be given). If geolocation parameters are given the result is sorted by distance to the given location.",
example1: "https://api.laut.fm/stations/letter/e",
example2: "https://api.laut.fm/stations/letter/e?limit=10",
example3: "https://api.laut.fm/stations/letter/e?limit=10&offset=5",
example4: "https://api.laut.fm/stations/letter/e?limit=10&lat=47.6779&lng=9.17324",
available_letters: "https://api.laut.fm/letters",
parameters: {
letter: "[a-z]"
},
optional_parameters: {
limit: "\d+",
offset: "\d+",
lat: "[\.\d]+",
lng: "[\.\d]+"
}
},
GET /stations/numbers: {
description: "All stations beginning with a number.",
order: "By number ascending or by distance to given geolocation parameters.",
pagination: "Supports {limit} and {offset} parameters. Pagination metadata is only returned if {offset} is given. In that case, the actual result is in the "items" key of the json result.",
geolocation: "Supports {lat} and {lng} parameters (both must be given). If geolocation parameters are given the result is sorted by distance to the given location.",
example1: "https://api.laut.fm/stations/numbers",
example2: "https://api.laut.fm/stations/numbers?limit=10",
example3: "https://api.laut.fm/stations/numbers?limit=10&offset=5",
example4: "https://api.laut.fm/stations/numbers?limit=10&lat=47.6779&lng=9.17324",
parameters: { },
optional_parameters: {
limit: "\d+",
offset: "\d+",
lat: "[\.\d]+",
lng: "[\.\d]+"
}
},
GET /stations/genre/{genre}: {
description: "All stations of a certain genre.",
order: "By genre-number weighted position ascending or by distance to given geolocation parameters.",
pagination: "Supports {limit} and {offset} parameters. Pagination metadata is only returned if {offset} is given. In that case, the actual result is in the "items" key of the json result.",
geolocation: "Supports {lat} and {lng} parameters (both must be given). If geolocation parameters are given the result is sorted by distance to the given location.",
example1: "https://api.laut.fm/stations/genre/Rock",
example2: "https://api.laut.fm/stations/genre/Rock?limit=10",
example3: "https://api.laut.fm/stations/genre/Rock?limit=10&offset=5",
example4: "https://api.laut.fm/stations/genre/Rock?limit=10&lat=47.6779&lng=9.17324",
available_genres: "https://api.laut.fm/genres",
parameters: {
genre: "[\w\d\- &]+"
},
optional_parameters: {
limit: "\d+",
offset: "\d+",
lat: "[\.\d]+",
lng: "[\.\d]+"
}
},
GET /stations/{comma_separated_station_names}: {
description: "Details about the given stations. Inactive stations are excluded.",
order: "As given or by distance to given geolocation parameters.",
geolocation: "Supports {lat} and {lng} parameters (both must be given). If geolocation parameters are given the result is sorted by distance to the given location.",
example1: "https://api.laut.fm/stations/eins,ende,best_of_80s",
example2: "https://api.laut.fm/stations/eins,ende,best_of_80s&lat=47.6779&lng=9.17324",
parameters: { },
optional_parameters: {
lat: "[\.\d]+",
lng: "[\.\d]+"
}
},
GET /station/{station_name}: {
description: "The basic info about a single station.",
example: "https://api.laut.fm/station/ende",
parameters: {
station_name: "[\w\d_\-]+"
}
},
GET /station/{station_name}/current_song: {
description: "The currently playing song of a single station.",
example: "https://api.laut.fm/station/eins/current_song",
parameters: {
station_name: "[\w\d_\-]+"
}
},
GET /station/{station_name}/last_songs: {
description: "The 10 last songs of a single station.",
example: "https://api.laut.fm/station/eins/last_songs",
parameters: {
station_name: "[\w\d_\-]+"
}
},
GET /station/{station_name}/schedule: {
description: "The schedule of a single station.",
example: "https://api.laut.fm/station/ende/schedule",
parameters: {
station_name: "[\w\d_\-]+"
}
},
GET /station/{station_name}/playlists: {
description: "The schedule of a single station grouped by playlists.",
example: "https://api.laut.fm/station/ende/playlists",
parameters: {
station_name: "[\w\d_\-]+"
}
},
GET /station/{station_name}/listeners: {
description: "The listener count of a single station.",
example: "https://api.laut.fm/station/eins/listeners",
parameters: {
station_name: "[\w\d_\-]+"
}
},
GET /station/{station_name}/next_artists: {
description: "Next artists of a single station. Information may be inacurate or plainly wrong right before a playlist or schedule change.",
example: "https://api.laut.fm/station/eins/next_artists",
parameters: {
station_name: "[\w\d_\-]+"
}
},
GET (?-mix:\/station\/([\w\d_\-]+)\/images\/([\w\d_\-]+)): {
description: "The images of a single station as redirects to the right asset. For convinience.",
example: "https://api.laut.fm/station/ende/images/:type",
parameters: {
station_name: "[\w\d_\-]+",
type: "[\w\d_\-]+"
}
}
}
'''