# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

from Globals import *
from myLogger import logger
from Components.ScrollLabel import ScrollLabel


class LogScreen(Screen):


	if RESOLUTIONx>1800:
		skin="""
			<screen name="LogScreen" position="0,0" size="1920,1080" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0" title="Music Center Log">
				<widget name="log_text" position="10,130" zPosition="1" size="1820,930" scrollbarMode="showOnDemand" backgroundColor="#00000000"/>
				<!-- Buttons -->
					<widget render="Label" font="SansReg;27" transparent="1" position="60,90" size="450,30" source="key_red" foregroundColor="#ff0000" halign="center" valign="center" zPosition="1"/>
					<widget render="Label" font="SansReg;27" transparent="1" position="510,90" size="450,30" source="key_green" foregroundColor="#00ff21" halign="center" valign="center" zPosition="1"/>
					<widget render="Label" font="SansReg;27" transparent="1" position="960,90" size="450,30" source="key_yellow" foregroundColor="#FFD800" halign="center" valign="center" zPosition="1"/>
					<widget render="Label" font="SansReg;27" transparent="1" position="1410,90" size="3450,30" source="key_blue" foregroundColor="#3D8DFF" halign="center" valign="center" zPosition="1"/>			
			
				<widget name="headertext" position="50,10" size="1820,56" font="SansReg;30" foregroundColor="#04931c" backgroundColor="#00000000" halign="center" valign="center" zPosition="1" />
				<!-- line -->
					<eLabel backgroundColor="#04931c" position="0,125" size="1920,1" zPosition="1" />
			</screen>"""

	else:
		skin="""
			<screen name="LogScreen" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0" title="Music Center Log">
				<widget name="log_text" position="7,86" zPosition="1" size="1213,620" scrollbarMode="showOnDemand" backgroundColor="#00000000"/>
				<!-- Buttons -->
					<widget render="Label" font="SansReg;18" transparent="1" position= "40,85" size="300,30" source="key_red" foregroundColor="#ff0000" halign="center" valign="center" zPosition="1"/>
					<widget render="Label" font="SansReg;18" transparent="1" position="340,85" size="300,30" source="key_green" foregroundColor="#00ff21" halign="center" valign="center" zPosition="1"/>
					<widget render="Label" font="SansReg;18" transparent="1" position="640,85" size="300,30" source="key_yellow" foregroundColor="#FFD800" halign="center" valign="center" zPosition="1"/>
					<widget render="Label" font="SansReg;18" transparent="1" position="940,85" size="300,30" source="key_blue" foregroundColor="#3D8DFF" halign="center" valign="center" zPosition="1"/>			
			
				<widget name="headertext" position="110,4" size="1000,73" font="SansReg;20" foregroundColor="#04931c" backgroundColor="#00000000" halign="center" valign="center" zPosition="1" />
				<!-- line -->
					<eLabel backgroundColor="#04931c" position="0,80" size="1280,1" zPosition="1" />
			</screen>"""


	def __init__(self, session, filename=None, title=''):
		logger.info('LogScreen]init...')
		self.session=session
		self.skin_path='/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images'
		Screen.__init__(self, session)

		self["actions"] = ActionMap(["WizardActions", "ColorActions"],
		{
			"back": self.close,
			"red": self.keyRed,
			"green" : self.keyGreen,
			"yellow" : self.keyYellow,
		}, -1)

		self["key_red"]=StaticText("Zeige letzte Sitzung")
		self["key_green"]=StaticText("Zeige alle Logzeilen")
		self["key_yellow"]=StaticText("Filter Log nach Gruppe")
		self["key_blue"]=StaticText("")
		self["headertext"]=Label()
		
		self.filename=filename
		self.title=title
		self.text = []
		self["log_text"] = MenuList([])
		self.sections = ['Entferne Filter',]
		self.onLayoutFinish.append(self.startRun)


	def startRun(self):
		logger.debug('LogScreen]startRun')
		if self.filename is None:
			try:
				headertext = ' '
				logfile = '/var/log/musiccenter.1.log'
				if fileExists(logfile):
					headertext += logfile
					with open(logfile,'r') as f:
						for line in f:
							self.text.append(line)
							
				logfile = '/var/log/musiccenter.log'
				with open(logfile,'r') as f:
					for line in f:
						self.text.append(line)
			
				self["headertext"].setText(logfile + headertext)
				
				self.keyRed()
				
			except Exception, e:
				logger.error('LogScreen]Error:%s'%e)
				
				self["headertext"].setText('No Logfile found! %s'%e)
			

		else:
			try:
				with open(self.filename,'r') as f:
					for line in f:
						self.text.append(line)
				self["headertext"].setText(self.title)
			except Exception, e:
				logger.error('LogScreen]Error:%s'%e)
				self["headertext"].setText('No Logfile found! %s'%e)
				
		self["log_text"].setList(self.text)

				
	def keyRed(self):
		logger.debug('LogScreen]keyRed')
		self["key_green"]=StaticText("Show All")
		text = []
		for line in self.text:
			if 'MusicCenter]plugin.py]reload MusicCenter...' in line:
				text=[]
			text.append(line)
			
		self["log_text"].setList(text)


	def keyGreen(self):
		logger.debug('LogScreen]keyGreen')
		self["key_red"]=StaticText("Show last session")
		text = []
		for line in self.text:
			text.append(line)
			
		self["log_text"].setList(text)


	def keyYellow(self):
		
		sections =[]
		t = []
		for line in self.text:
			temp = re_findall(' - .+? - (.*?)]', line)
			if temp and temp[0] not in t:
				t.append(temp[0])
				sections.append((temp[0], temp[0]),)
		t = []
		self.session.openWithCallback(self.sectionSelected, ChoiceBox, title=_("Waehle eine Section"), list = sections, keys=MYKEYSORT, titlebartext=_("MusicCenter Logger"))


	def sectionSelected(self, selectedsection):	
		logger.debug('LogScreen]sectionSelected]selectedsection:{}'.format(selectedsection))
		if selectedsection is not None:
			if selectedsection[0] == 'Entferne Filter':
				self.startRun()
				
			else:
				text = []
				for line in self.text:
					if ' - ' + selectedsection[0] + ']' in line :
						text.append(line)
						
				self['log_text'].setList(text)
				
				self["headertext"].setText('Log gefiltert nach {}'.format(selectedsection[0]))
			
	
	
	def __onClose(self):
		logger.debug('LogScreen]__onClose] Start destroying...')
		self.text=''
		self.giventext=''