# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.
#from __future__ import unicode_literals


from Globals import *
from JobCenter import PicLoaderScale
from JobCenter2 import  drawImageJobWithLongMultilineText
from myLogger import logger
from timer import TimerEntry
from LCDScreens import LCDPlayer
from Setup import MusicCenterSetup



class Pixabay(Screen):#################################################################

	if RESOLUTIONx>1800:
		skin="""
			<screen backgroundColor="#00000000" flags="wfNoBorder" position="0,0" size="1920,1080" title="Pixabay">
			<!-- headerfield  -->
				<widget name="infobarbg" position="20,20" size="1880,132" zPosition="2" foregroundColor="#ffffff" backgroundColor="#191919" cornerRadius="12"/>
				<widget name="wall_paper" position="0,0" size="1920,1080" zPosition="2" scale="fill full"/>
				<widget name="coverArt" position="20,20" size="132,132" zPosition="301"  scale="fill full"/>
				<widget name="coverArtround" position="21,21" size="130,130"  zPosition="301" mode="visRoundCover" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/no_cover.png" />
				<!-- 1 zeile  -->
					<widget name="artist" position="160,27" size="1340,39" font="SansReg;33" halign="left" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="genre" position="1300,27" size="300,39" font="SansReg;33" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="track" position="1750,27" size="130,39" font="SansReg;33" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
				<!-- 2 zeile  --> 
					<widget name="title" position="160,70" size="1340,39" font="SansReg;33" halign="left" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="plays" position="1300,70" size="300,39" font="SansReg;33" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="length" position="1750,70" size="130,39" font="SansReg;33" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
				<!-- 3 zeile  -->
					<widget name="album_year_albumartist" position="160,117" size="1340,33" font="SansReg;27" halign="left" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="rating" position="1300,117" size="300,33" alphatest="on" transparent="1" zPosition="4"  pixmaps="~/rating0.png,~/rating1.png,~/rating2.png,~/rating3.png,~/rating4.png,~/rating5.png,~/rating6.png,~/rating7.png,~/rating8.png,~/rating9.png,~/rating10.png,~/rating11.png"/>
					<widget name="bitrate" position="1750,117" size="130,33" font="SansReg;27" halign="center" valign="center" foregroundColor="#ffffff" transparent="1" zPosition="4"/>
				<!-- imageinfo  -->
					<widget name="userImage" position="10,970" size="90,90" zPosition="302" scale="fill full"/>
					<widget name="infofield" position="110,987" size="1800,56" font="SansReg;26" halign="left" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" zPosition="302" cornerRadius="12"/>
			</screen>"""
	else:
		skin="""
			<screen backgroundColor="transparent" flags="wfNoBorder" position="0,0" size="1280,720" title="Pixabay">
			<!-- headerfield  -->
				<widget name="infobarbg" position="12,12" size="1256,88" zPosition="300" />
				<widget name="wall_paper" position="0,0" size="1280,720" zPosition="2" scale="fill full"/>
				<widget name="coverArt" position="21,21" size="87,87" zPosition="301"  scale="fill full"/>
				<widget name="coverArtround" position="15,15" size="88,88"  zPosition="301" mode="visRoundCover" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/no_cover.png" />
				<!-- 1 zeile  -->
					<widget name="artistandtitlewithminicov" position="190,26" size="1480,30" font="SansReg;26" halign="left" valign="center" foregroundColor="#ffffff" backgroundColor="#191919" transparent="1" zPosition="301"/>
					<widget name="track" position="1675,26" size="225,30" font="SansReg;26" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="1" zPosition="301"/>
				<!-- 2 zeile  -->
					<widget name="album_year_albumartistwithminicov" position="190,76" size="1185,24" font="SansReg;22" halign="left" valign="center" foregroundColor="#ffffff" backgroundColor="#191919" transparent="1" zPosition="301"/>
					<widget name="genre" position="1375,76" size="300,24" font="SansReg;22" halign="left" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="1" zPosition="301"/>
					<widget name="length" position="1675,76" size="225,24" font="SansReg;22" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="1" zPosition="301"/>
				<!-- 3 zeile  -->
					<widget name="filenamewithminicov" position="190,117" size="985,20" font="SansReg;18" halign="left" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="1" zPosition="301"/>
					<widget name="rating" position="1175,116" size="300,32" alphatest="on" zPosition="301" scale="0" pixmaps="~/rating0.png,~/rating1.png,~/rating2.png,~/rating3.png,~/rating4.png,~/rating5.png,~/rating6.png,~/rating7.png,~/rating8.png,~/rating9.png,~/rating10.png,~/rating11.png"/>
					<widget name="plays" position="1475,117" size="200,20" font="SansReg;18" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="1" zPosition="301"/>
					<widget name="bitrate" position="1675,117" size="225,20" font="SansReg;18" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="1" zPosition="301"/>
				<!-- imageinfo  -->
					<widget name="userImage" position="6,650" size="60,60" zPosition="302" scale="fill full"/>
					<widget name="infofield" position="70,660" size="1200,40" font="SansReg;18" halign="left" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" zPosition="302"/>
			</screen>"""


	#ANIMATION_KEY_FADE_SLOW = "wallpaper_slow_fade_slow"
	#ANIMATION_KEY_FADE_FAST = "wallpaper_slow_fade_fast"
	
	
	def __init__(self, session, player):
		logger.info('Pixabay]__init__...')
		self.skin_path = '/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images'
		self.session = session
		Screen.__init__(self, session)

		self['actions'] = ActionMap(["OkCancelActions", 'EPGSelectActions'],
		{
			"back": self.closePicshow,
			"cancel": self.closePicshow,
			"ok": self.showHide,
			"input_date_time": self.menuPressed,
		}, -1)

		self.onFirstExecBegin.append(self._setupAnimation)
		self.onLayoutFinish.append(self._startRun)
		self.onShown.append(self.updateMusicInformationPlayer)
		self.onClose.append(self.__onClose)

		self['wall_paper'] = PicLoaderScale(transparent = False, name = 'Pixabay')
		self.screensaverfilename_new = ''
		
		self.maxmoves = 20
		self.movecounter = -1
		self.screensaverfilename = ''
		self.player = player

		self['infobarbg'] = Label()
		
		self['artist'] = Label()
		self['title'] = Label()
		self['album_year_albumartist'] = Label()
		self['genre'] = Label()
		self['plays'] = Label()
		self['track'] = Label()
		self['bitrate'] = Label()
		self['length'] = Label()
		self['rating'] = MultiPixmap()
		self['coverArt'] = PicLoaderScale(transparent=False, name='PixabaycoverArt')
		self['coverArtround'] = MerlinMusicPlayerWidget()

		self['infofield'] = Label()
		self['userImage'] = PicLoaderScale(transparent=False, name='PixabayuserImage')

		self.cachedir = ''
		self.userfilecachedir = os_path_join(config.plugins.musiccenter.downloadcache.value, "screensaver/user")
		createDir(self.userfilecachedir)
		self.apihits = []
		self.entry_dict = {}
		self.movetype = None
		self.conncounter = 0

		self.persistentskinelements=["artist", "title", "album_year_albumartist","genre","plays","track",'bitrate',"length", 'infobarbg', 'rating']
		self.userskinelements = ['userImage', 'infofield']
		if config.plugins.musiccenter.visualization.roundcover.value:
			self.persistentskinelements.append('coverArtround')
		else:
			self.persistentskinelements.append('coverArt')
		self.showHideTimer = eTimer()
		self.showHideTimer_conn = self.showHideTimer.timeout.connect(self.showHideTimerTimeout)
		self.changetimer = eTimer()
		self.changetimer_conn = self.changetimer.timeout.connect(self.onChangetimerTimeout)

		self.infobarshowtime = 8*1000
		self.s = requests_Session()
		self.s.headers.update({'User-Agent': MCUSERAGNET})
		self.infobarisshown = True
		self.userinfoisshown = False
		self.session.nav.SleepTimer.on_state_change.append(self.sleepTimerEntryOnStateChange)
		#config.plugins.musiccenter.pixabay.fadetime.addNotifier(self._setupAnimation, initial_call = False)


	def _setupAnimation(self, *args):
		animset = eWindowAnimationSet.create()
		
		animset.setKey('wallpaper_slow_fade_slow_{}'.format(config.plugins.musiccenter.pixabay.fadetime.value)) #Pixabay.ANIMATION_KEY_FADE_SLOW)
		animset.setName('Slow wallpaper fade_{}'.format(config.plugins.musiccenter.pixabay.fadetime.value))
		animset.setInternal(True)
		interpolator = eLinearInterpolator.create()
		duration = int(config.plugins.musiccenter.pixabay.fadetime.value) * 1000
		logger.info('Pixabay]_setupAnimation]fadetime duration:{}'.format(duration))
		animset.setAlpha(eFloatAnimation.create(duration, 0.0, 1.0, False, interpolator))
		eWindowAnimationManager.setAnimationSet(animset)
		
		self['wall_paper'].instance.setShowHideAnimation('wallpaper_slow_fade_slow_{}'.format(config.plugins.musiccenter.pixabay.fadetime.value))
		self['wall_paper'].instance.setScale(ePixmap.SCALE_TYPE_WIDTH)
		
		animset = eWindowAnimationSet.create()
		animset.setKey("wallpaper_slow_fade_fast") #Pixabay.ANIMATION_KEY_FADE_FAST)
		animset.setName("Fast fade")
		animset.setInternal(True)
		#interpolator = eLinearInterpolator.create()
		duration = 1 * 1500
		animset.setAlpha(eFloatAnimation.create(duration, 0.0, 1.0, False, interpolator))
		eWindowAnimationManager.setAnimationSet(animset)

		for element in self.persistentskinelements + self.userskinelements:	
			self[element].instance.setShowHideAnimation("wallpaper_slow_fade_fast")


	def _startRun(self):
		if config.plugins.musiccenter.visualization.roundcover.value:
			self['coverArt'].dohide()
		else:
			self['coverArtround'].hide()

		self.startPixabaySearch()


	def updateMusicInformationPlayer(self):
		logger.info('Pixabay]updateMusicInformationPlayer]...')
		slentry = self.player.currentplayingslentry
		self.updateCover(slentry.coverfn)
		self.showHideTimer.start(self.infobarshowtime)
		album_year_albumartist, playcount = joinDisplaytextFiles(slentry)
		track = '{}/{}'.format(self.player._currentplayingindex+1,len(self.player.songlist))
		self.updateDisplayText(slentry.artist, slentry.title, album_year_albumartist, track, slentry.genre, playcount, slentry.bitrate, slentry.length, slentry.rating)
		self.updateLCD(slentry)


	def sleepTimerEntryOnStateChange(self, timer):
		if timer.state == TimerEntry.StateEnded:
			self.close()


	def showHide(self):
		if self.infobarisshown:
			if self.showHideTimer.isActive():
				self.showHideTimer.stop()
			for element in self.persistentskinelements:
				self[element].hide()
		else:
			for element in self.persistentskinelements:
				self[element].show()
			self.showHideTimer.start(self.infobarshowtime)
		self.infobarisshown = not self.infobarisshown


	def showHideTimerTimeout(self):
		self.showHide()


	def hideUserinfo(self):
		if self.userinfoisshown:
			for element in self.userskinelements:
				self[element].hide()
			self.userinfoisshown = False


	def updateDisplayText(self, artist, title, album_year_albumartist, track, genre, playcount, bitrate, length, rating):
		#logger.debug('Pixabay]updateDisplayText]artistandtitle:{} album_year_albumartist:{} filename:{} track:{} genre:{} playcount:{} bitrate:{} length:{} ratingnum:{}'.format(artist, title, album_year_albumartist, track, genre, playcount, bitrate, length, ratingnum))
		if self.showHideTimer.isActive():
			self.showHideTimer.stop()
			
		self['artist'].setText(artist)
		self['title'].setText(title)
		self['album_year_albumartist'].setText(album_year_albumartist)
		self['track'].setText(track)
		self['genre'].setText(genre)
		self['plays'].setText(playcount)
		self['bitrate'].setText(bitrate)
		self['length'].setText(length)
		self['rating'].setPixmapNum(calcRating(rating))

		self.infobarisshown = False
		self.showHide()


	def updateLCD(self, slentry):
		self.summaries.updateSlentry(slentry)
		self.summaries.updateCover(slentry.coverfn)


	def updateCover(self, picpath):
		if config.plugins.musiccenter.visualization.roundcover.value:
			self['coverArtround'].setCover(picpath)
		else:
			self['coverArt'].doshow(picpath)


	def startPixabaySearch(self):
		deferToThread(self.getPixabaySearch).addCallback(self.getPixabaySearchCallback).addErrback(self.getPixabaySearchError)
	
	
	def getPixabaySearch(self):
		serachwords = ['musik', 'natur', 'strand', 'landschaft', 'wasser', 'strand']
		now = datetime_datetime.now().hour
		if now >= 22 and now < 5:
			serachwords = ['liebe', 'erotik', 'sexy', 'nackt', 'fitness']
		serachword = random_choice(serachwords)
		self.cachedir = os_path_join(config.plugins.musiccenter.downloadcache.value, "screensaver/", serachword)
		createDir(self.cachedir)
		#page = 2 # more results
		url = '''https://pixabay.com/api/?key=9368280-566404fc1952dad60c6fc4729&q={}&per_page=200&lang=de&orientation=horizontal&page={}'''.format(serachword, randrange(1,4))
		logger.info('Pixabay]getPixabaySearch]{}'.format(url))
		result = self.s.get(url)
		logger.debug('Pixabay]getPixabaySearch]status_code:{}'.format(result.status_code))
		if result.status_code == 200:
			return result.json()
		else:	
			return None
		

	def getPixabaySearchCallback(self, result):
		if result is not None:
			self.extractPixabaySearchResult(result)
		else:
			self.getPixabaySearchError('error getPixabaySearch!!!')


	def extractPixabaySearchResult(self, res):
		matches_count = res.get('totalHits')
		self.apihits = [ (e, True) for e in res.get('hits',[]) ]
		logger.debug('Pixabay]extractPixabaySearchResult]totalHits {} chunklength {}, shuffle hits now'.format(matches_count, len(self.apihits)))
		#likes: 17,imageURL: "",views: 459,comments: 2,type: "photo",tags: "bouquet, field, on the nature",downloads: 263,user: "Victoria_Borodinova",favorites: 13,userImageURL: ""
		if self.apihits:
			shuffle(self.apihits)
			self.downloadImageNow()
		else:
			logger.error('Pixabay]extractPixabaySearchResult]No images found, show no image screensaver')
			self.getPixabaySearchError('No images found on api call!!! show no image screensaver')


	def getPixabaySearchError(self, error = 'n/a'):
		logger.error("Pixabay]getPixabaySearchError]{}".format(error))
		self['infofield'].setText('{}'.format('{} ({})'.format(error, self.conncounter)))
		self.apihits = self.getLocalPictures()
		self.downloadImageNow()


	def getLocalPictures(self):
		logger.debug('Pixabay]getLocalPictures]start...')
		apihits = [ (load_obj(os_path_join(self.cachedir, e)), False) for e in os_listdir(self.cachedir) if e.lower().endswith('.json') ]
		shuffle(apihits)
		logger.info('Pixabay]getLocalPictures]found {} local pictures'.format(len(apihits)))	
		return apihits


	def downloadImageNow(self):
		if self.apihits:
			entry_dict, isweb = self.apihits.pop(0)
			logger.info('Pixabay]downloadImageNow]start for isweb:{} entry_dict:{}'.format(isweb, entry_dict))
			image_filename, json_filename=self.getImageAndJsonFilename(entry_dict)
			self.getUserImage(entry_dict)
			self.entry_dict=entry_dict
			if isweb:
				save_obj(entry_dict, json_filename)

			if not fileExists(image_filename):
				image_url=entry_dict.get('fullHDURL', '').encode()
				logger.info('Pixabay]downloadImageNow]{} urls load image_url:{} to image_filename:{}'.format(len(self.apihits), image_url, image_filename))
				deferToThread(self.downloadImageonThread, image_url, image_filename).addCallback(self.downloadImageFinished,).addErrback(self.downloadImageError,)
			else:
				logger.info('Pixabay]downloadImageNow]found local image_filename:{}'.format(image_filename))
				self.downloadImageFinished(image_filename)
		else:
			self.showNoScreensaver()

	
	def downloadImageonThread(self, url, filename):	
		logger.info('Pixabay]downloadImageonThread]{}'.format(url, filename))	
		result = self.s.get(url, stream=True)	
		if result.status_code == requests_codes.ok:
						
			with open(filename, 'wb') as fd:
				for chunk in result.iter_content(chunk_size=128):
					fd.write(chunk)
					
		return filename
			

	def getUserImage(self, entry_dict):
		user_url=entry_dict.get('userImageURL', '').encode()
		if user_url:
			userimagefilename=self.getUserfilename(entry_dict)
			if not fileExists(userimagefilename):
				logger.info('Pixabay]getUserImage]user_url {} to userimagefilename:{}'.format(user_url, userimagefilename))
				deferToThread(self.downloadImageonThread, user_url, userimagefilename).addCallback(self.getUserImageFinished,).addErrback(self.getUserImageError,)
		else:
			logger.info('Pixabay]getUserImage]no user image given...')


	def getImageAndJsonFilename(self, entry_dict):
		image_url=entry_dict.get('fullHDURL', '').encode()
		image_id=entry_dict.get('id', '')
		endswith=image_url.rsplit('.',1)[-1]
		image_fn='{}.{}'.format(image_id, endswith)
		image_filename=os_path_join(self.cachedir, image_fn)

		json_fn='{}.json'.format(image_id)
		json_filename=os_path_join(self.cachedir, json_fn)

		logger.debug('Pixabay]getImageAndJsonFilename]{}|{}'.format(image_filename, json_filename))
		return image_filename, json_filename


	def getUserfilename(self, entry_dict):
		user_url=entry_dict.get('userImageURL', '').encode()
		logger.debug('Pixabay]getUserfilename]user_url {}'.format(user_url))
		endswith=user_url.rsplit('.',1)[-1].encode()
		userid=entry_dict.get('user_id', '')
		fn= '{}.{}'.format(userid, endswith)
		p=os_path_join(self.userfilecachedir, fn)
		logger.debug('Pixabay]getUserfilename]{}'.format(p))
		return p


	def getUserImageFinished(self, userimagefilename):
		try: # check, is a valid image...
			im=Image.open(userimagefilename)
			logger.debug('Pixabay]getUserImageFinished]image is valid...')
		except:
			logger.exception('Pixabay]getUserImageFinished]no valid Image {}'.format(userimagefilename))
			os_remove(userimagefilename)


	def getUserImageError(self, error = 'n/a'):
		logger.error("Pixabay]getUserImageError]{}".format(error))


	def downloadImageError(self, error = 'n/a'):
		logger.error("Pixabay]downloadImageError]{}".format(error))
		self.downloadImageNow()
		logger.debug("Pixabay]downloadImageError]no cover downloaded, show now no cover")
		self.showNoScreensaver()


	def showNoScreensaver(self):
		picpath=drawImageJobWithLongMultilineText(text='NO PICTURES FOUND', size=(1920,1080), fontsize=120, round=0, out=None, force=True)
		logger.error('Pixabay]showNoScreensaver]...')


	def downloadImageFinished(self, screensaverfilename):
		logger.debug('Pixabay]downloadImageFinished]{}'.format(screensaverfilename))
		try: # check, is a valid image...
			im=Image.open(screensaverfilename)
			self.screensaverfilename_new = screensaverfilename
			if self.movecounter == -1: # init screenSaver
				logger.debug('Pixabay]downloadImageFinished]is init screenSaver, start first Screensaver Show now')
				self.movecounter = self.maxmoves - 1
				self.onChangetimerTimeout()
			
		except:
			logger.exception('Pixabay]downloadImageFinished]no valid Image, start download next Image Now, remove:{}'.format(screensaverfilename))
			os_remove(screensaverfilename)
			self.downloadImageNow()


	def onChangetimerTimeout(self):

		self.movecounter+=1

		if self.movecounter == self.maxmoves:

			self.movecounter=0
			self.setNewUserImage()
			self.screensaverfilename = self.screensaverfilename_new
			#self['wall_paper'].doshow(self.screensaverfilename, True)
			movetypes=['zoom_from_left_upper', 'zoom_full_center', 'zoom_from_right_upper', 'move_from_left_to_right']
			shuffle(movetypes)
			self.movetype=movetypes[0]
			logger.debug('Pixabay]onChangetimerTimeout]show new image now, set movtype:{}'.format(self.movetype))
			
		elif self.movecounter==1:
			logger.debug('Pixabay]onChangetimerTimeout]load next image now...')
			self.downloadImageNow()

		#info = self['infofield'].getText().split(' - ', 1)[0]
		#self['infofield'].setText('{} - {} move'.format(info, self.movecounter))

		deferToThread(self.cropeImage, self.screensaverfilename).addCallback(self.finishImageCrope,).addErrback(self.errorImageCrope,)

		#logger.debug('Pixabay]onChangetimerTimeout]activate now changetimer')
		self.changetimer.start(int(config.plugins.musiccenter.pixabay.movetime.value) * 1000, 1)


	def cropeImage(self, imagesource):
		a,b = imagesource.rsplit('.', 1)
		tempfn = '{}_.{}'.format(a,b)
		im = Image.open(imagesource)
		x,y = im.size
		#logger.debug('Pixabay]cropeImage]original {}|{} imagesource:{}'.format(x, y, imagesource))
		f = self.movecounter
		
		if x*1.0/y > 1920.0/1080:
			x = int(y*1.0/9*16)
		elif x*1.0/y <= 1920.0/1080:
			y = int(x*1.0/16*9)
		#logger.debug('Pixabay]cropeImage]fitted {}|{}'.format(x, y))
		
		if self.movetype == 'zoom_from_left_upper':
			xdelta = f*8
			ydelta = int(f*4.5)
			a,b,c,d = 0,0, x-xdelta, y-ydelta

		elif self.movetype == 'zoom_full_center':
			xdelta = f*4
			ydelta = int(f*2.25)
			a,b,c,d  = 0+xdelta,0+ydelta, x-xdelta, y-ydelta

		elif self.movetype == 'zoom_from_right_upper':
			xdelta = f*8
			ydelta = int(f*4.5)
			a,b,c,d = 0+xdelta, 0, x, y-ydelta

		elif self.movetype == 'move_from_left_to_right':
			maxmovepixel=self.maxmoves*8
			x_size_part=x-maxmovepixel
			y_size_part=y*x_size_part/x
			xdelta = f*8
			y_start = (y-y_size_part)/2
			a,b,c,d=xdelta, y_start, xdelta + x_size_part, y_start + y_size_part

		#logger.debug('Pixabay]cropeImage]movetype:{} {}|{}|{}|{}'.format( self.movetype, a, b, c, d))
		nim = im.crop((a,b,c,d))
		
		xnew, ynew = nim.size
		#logger.debug('Pixabay]cropeImage]crope from {}|{} to {}|{} movetype:{}'.format(x, y, xnew, ynew, self.movetype))

		nim.save(tempfn)
		
		del nim, im

		return tempfn


	def finishImageCrope(self, tempfn):
		#logger.debug('Pixabay]finishImageCrope]show now tempfn:{}'.format(tempfn))
		self['wall_paper'].doshow(tempfn, True)
	
	
	def errorImageCrope(self, error):
		logger.debug('Pixabay]errorImageCrope]error:{}'.format(error))

		
	def setNewUserImage(self):
		pbentry = self.entry_dict
		info = '{} Views {} Downloads {} Favs {}\nTags {}'.format(pbentry.get('user'), pbentry.get('views'), pbentry.get('favorites'), pbentry.get('downloads'), pbentry.get('tags'))
		logger.debug('Pixabay]setNewPicture]info:{}'.format(info))
		for element in self.userskinelements:
			self[element].show()
		self.userinfoisshown = True
		
		GlobalTimer(15*1000, self.hideUserinfo)
		self['infofield'].setText(info)
		self['userImage'].doshow(self.getUserfilename(pbentry))


	def menuPressed(self):
		self.session.open(MusicCenterSetup, 'pixabay')

		
	def closePicshow(self):
		logger.info('Pixabay]closePicshow]call now closePixabayScreen')
		self.close()
		self.player.closePixabayScreen()
	
	
	def __onClose(self):
		logger.info('Pixabay]__onClose]...')
		self.session.nav.SleepTimer.on_state_change.remove(self.sleepTimerEntryOnStateChange)
		#del self['coverArt'], self['wall_paper'], self['coverArtround'], self['userImage']
		if self.showHideTimer.isActive():
			self.showHideTimer.stop()
		self.showHideTimer = None


	def createSummary(self):
		return LCDPlayer
