# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.
#from __future__ import unicode_literals


from Globals import *
import EditID3
import LCDScreens
from ItemClasses import Item
from JobCenter import *
from JobCenter2 import *
from ListClasses import CentralList
from myLogger import logger
import GoogleImageSearch
from LogScreen import *
from tagger import getID3raw, getYoutubeurl, getWavevalues
import SimplePicbrowser
import SelectPath
from Setup import MusicCenterSetup
from StreamRipper import streamripperinstance
import TaskViewScreen
import Pixabay

from timer import TimerEntry
from enigma import eServiceCenter, getBestPlayableServiceReference, eServiceReference
from ServiceReference import ServiceReference
import YoutubeSearch

from ArtistArtLoader import CoverArtLoader, ArtistArtLoader, ShazamResolver

#from youtube_dl import YoutubeDL as youtube_dl_YoutubeDL

#ENIGMA_MERLINPLAYER_ID = 4097 # standard
ENIGMA_MERLINPLAYER_ID = 0x1019 # merlin

config.plugins.musiccenter.gapplessplayback = ConfigYesNo(default = False)
config.plugins.musiccenter.detectsilence = ConfigYesNo(default = False)


from . import _

#  select * from songs where artist='Rita Ora' and title='your song' COLLATE NOCASE;

#- added some options for ePixmap.setScale(...) and scale= in skins, fix code-bugs related to setScale, too (it's no immediate, some broken things have been removed)
#-- ePixmap.SCALE_TYPE_NONE: "off" / "none" in skins
#-- ePixmap.SCALE_TYPE_ASPECT: "on" / "aspect" in skins
#-- ePixmap.SCALE_TYPE_CENTER: "center" in skins
#-- ePixmap.SCALE_TYPE_WIDTH: "width" in skins
#-- ePixmap.SCALE_TYPE_HEIGHT: "height" in skins
#-- ePixmap.SCALE_TYPE_StRETCH: "stretch" in skins

# artist (shazam)--------------	genre------	Track
# title (shazam)--------------- plays------	length
# Album(date)Alnumartist-------	rating-----	bitrate


class Player(Screen, InfoBarBase, InfoBarSeek, InfoBarNotifications, PlaylistBase):

	if RESOLUTIONx>1800:
		skin="""
			<screen name="MusicCenterPlayer" position="0,0" size="1920,1080" flags="wfNoBorder" backgroundColor="transparent" title="MC Player" zPosition="0">
			<widget name="background" position="0,0" size="1920,1080" zPosition="1" backgroundColor="#000000"/>
			<!-- headerfield  -->
				<widget name="infobarbg" position="20,20" size="1880,132" zPosition="2" foregroundColor="#ffffff" backgroundColor="#191919" cornerRadius="12"/>
				<!-- 1 zeile  -->
					<widget name="artist" position="40,27" size="1260,39" font="SansReg;33" halign="left" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="genre" position="1300,27" size="450,39" font="SansReg;33" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="track" position="1750,27" size="130,39" font="SansReg;33" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
				<!-- 2 zeile  -->
					<widget name="title" position="40,70" size="1260,39" font="SansReg;33" halign="left" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="plays" position="1300,70" size="450,39" font="SansReg;33" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="length" position="1750,70" size="130,39" font="SansReg;33" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
				<!-- 3 zeile  -->
					<widget name="album_year_albumartist" position="40,117" size="1260,33" font="SansReg;27" halign="left" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="rating" position="1300,117" size="450,33" alphatest="on" transparent="1" zPosition="4"  pixmaps="~/rating0.png,~/rating1.png,~/rating2.png,~/rating3.png,~/rating4.png,~/rating5.png,~/rating6.png,~/rating7.png,~/rating8.png,~/rating9.png,~/rating10.png,~/rating11.png"/>
					<widget name="bitrate" position="1750,117" size="130,33" font="SansReg;27" halign="center" valign="center" foregroundColor="#ffffff" transparent="1" zPosition="4"/>
			<!-- Buttons  -->
				<widget render="Label" font="SansReg;33" transparent="1" position="60,167" size="450,40" source="key_red" foregroundColor="#ff0000" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;33" transparent="1" position="510,167" size="450,40" source="key_green" foregroundColor="#00ff21" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;33" transparent="1" position="960,167" size="450,40" source="key_yellow" foregroundColor="#FFD800" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;33" transparent="1" position="1410,167" size="450,40" source="key_blue" foregroundColor="#3D8DFF" halign="center" valign="center" zPosition="3"/>
			<!-- artistart  -->
				<widget name="youtube" position="590,220" size="100,40" zPosition="4"/>
				<widget name="artistArt" position="590,220" size="1227,690" zPosition="3" scale="width"/>
				<widget name="Video" position="590,220" size="1227,690" zPosition="2" backgroundColor="transparent" />
			<!-- wave  -->
				<widget name="wave" position="30,935" size="1860,120" zPosition="5" scale="stretch"/>
				<widget name="PositionGauge" position="30,935" size="1860,120" zPosition="4" pointer="~/SC_progressbar.png:1920,120" backgroundColor="#ff000000"/>
			<!-- playstate  -->
				<widget name="playstate" position="-12,1054" size="84,24" zPosition="6" transparent="0" font="SansReg;23" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#000000"/>
			<!-- coverart  -->
				<widget name="coverArt" position="50,340" size="450,450" zPosition="2" scale="width"/>
				<widget name="coverArtround" position="50,340" size="450,450" mode="visRoundCover" zPosition="2" transparent="1" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/no_cover.png"/>
			<!-- visualisationen  -->
				<widget name="visufilemode" position="50,190" size="450,100" transparent="1" zPosition="11" pixmap1="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/bar_88_226.png" distance1="20" threshold1="24" mode="visUp" internalSize="1" blendColor="#fcc000" smoothing="0.4" />
				<widget name="rms0" channel="0" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/rms_bar_rgb_450x20.png" zPosition="13" position="50,230" size="450,20" transparent="0" borderWidth="1" mode="standardEnigmaSlider" distance="15" maxValue="130" fadeOutTime="500" smoothing="0.5" />
				<widget name="rms1" channel="1" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/rms_bar_rgb_450x20.png" zPosition="13" position="50,260" size="450,20" transparent="0" borderWidth="1" mode="standardEnigmaSlider" distance="15" maxValue="130" fadeOutTime="500" smoothing="0.5" />
			<!-- textfields  -->
				<widget name="shuffle" position="50,800" size="110,27" font="SansReg;25" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#000000" zPosition="2"/>
				<widget name="gapplesstext" position="160,800" size="230,27" font="SansReg;25" halign="center" valign="center"  foregroundColor="#FF0000" backgroundColor="#000000" zPosition="2"/>
				<widget name="repeat" position="380,800" size="110,27" font="SansReg;25" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#000000" zPosition="2"/>
			<!-- embeded songlist  -->
				<widget name="embededSonglistSimplelist" position="0,220" size="1920,690" zPosition="4" scrollbarMode="showOnDemand" backgroundColor="#000000"/>
				<widget name="embededSonglist2DFlow" position="0,220" size="1920,690" transparent="0" backgroundColor="#000000" zPosition="4" coverSize="220,220" selectedCoverScale="1.4" unselectedCoverDimm="0.7"  coverflowCurrentPosition="960,345" coverflowCurrentXDistance="20" coverflowCurrentCenterDistance="20" style="1" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/no-cover.png" />
				<widget name="embededSonglistCoverwall" position="0,220" size="1920,690" transparent="0" backgroundColor="#000000" zPosition="4" coverSize="220,220" selectedCoverScale="1.4" unselectedCoverDimm="0.7"  coverBeginPosition="135,200" coverDistance="15,15" style="0" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/no-cover.png" />
				<widget name="slpage" font="SansReg;27" transparent="0" position="860,220" size="200,33" zPosition="5" halign="center" foregroundColor="#ffffff" backgroundColor="#000000"/>
			</screen>"""
	else:
		skin="""
			<screen name="MusicCenterPlayer" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="transparent" title="MC Player" zPosition="0">
			<widget name="background" position="0,0" size="1280,720" zPosition="1" backgroundColor="#000000"/>
			<!-- headerfield  -->
				<widget name="infobarbg" position="13,13" size="1253,89" zPosition="2" foregroundColor="#ffffff" backgroundColor="#191919" cornerRadius="8"/>
				<!-- 1 zeile  -->
					<widget name="artist" position="27,18" size="840,26" font="SansReg;22" halign="left" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="genre" position="867,18" size="300,26" font="SansReg;22" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="track" position="1167,18" size="87,26" font="SansReg;22" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
				<!-- 2 zeile  -->
					<widget name="title" position="27,47" size="840,26" font="SansReg;22" halign="left" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="plays" position="867,47" size="300,26" font="SansReg;22" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="length" position="1167,47" size="87,26" font="SansReg;22" halign="center" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
				<!-- 3 zeile  -->
					<widget name="album_year_albumartist" position="27,79" size="840,22" font="SansReg;18" halign="left" valign="center"  foregroundColor="#ffffff" transparent="1" zPosition="4"/>
					<widget name="rating" position="867,79" size="300,22" alphatest="on" transparent="1" zPosition="4"  pixmaps="~/rating0.png,~/rating1.png,~/rating2.png,~/rating3.png,~/rating4.png,~/rating5.png,~/rating6.png,~/rating7.png,~/rating8.png,~/rating9.png,~/rating10.png,~/rating11.png"/>
					<widget name="bitrate" position="1167,79" size="87,22" font="SansReg;18" halign="center" valign="center" foregroundColor="#ffffff" transparent="1" zPosition="4"/>
			<!-- Buttons  -->
				<widget render="Label" font="SansReg;22" transparent="1" position="40,112" size="300,27" source="key_red" foregroundColor="#ff0000" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;22" transparent="1" position="340,112" size="300,27" source="key_green" foregroundColor="#00ff21" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;22" transparent="1" position="640,112" size="300,27" source="key_yellow" foregroundColor="#FFD800" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;22" transparent="1" position="944,112" size="300,27" source="key_blue" foregroundColor="#3D8DFF" halign="center" valign="center" zPosition="3"/>
			<!-- artistart  -->
				<widget name="youtube" position="393,146" size="67,27" zPosition="4"/>
				<widget name="artistArt" position="393,146" size="822,460" zPosition="3" scale="width"/>
				<widget name="Video" position="393,146" size="822,460" zPosition="2" backgroundColor="transparent" />
			<!-- wave  -->
				<widget name="wave" position="20,626" size="1246,80" zPosition="5" scale="stretch"/>
				<widget name="PositionGauge" position="20,626" size="1246,80" zPosition="4" pointer="~/SC_progressbar.png:1280,80" backgroundColor="#ff000000"/>
			<!-- playstate  -->
				<widget name="playstate" position="-8,706" size="56,16" zPosition="6" transparent="0" font="SansReg;16" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#000000"/>
			<!-- coverart  -->
				<widget name="coverArt" position="34,226" size="300,300" zPosition="2" scale="width"/>
				<widget name="coverArtround" position="34,226" size="300,300" mode="visRoundCover" zPosition="2" transparent="1" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/no_cover.png"/>
			<!-- visualisationen  -->
				<widget name="visufilemode" position="34,126" size="300,67" transparent="1" zPosition="11" pixmap1="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/bar_88_226.png" distance1="13" threshold1="24" mode="visUp" internalSize="1" blendColor="#fcc000" smoothing="0.4" />
				<widget name="rms0" channel="0" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/rms_bar_rgb_450x20.png" zPosition="13" position="33,154" size="300,13" transparent="0" borderWidth="1" mode="standardEnigmaSlider" distance="10" maxValue="87" fadeOutTime="500" smoothing="0.5" />
				<widget name="rms1" channel="1" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/rms_bar_rgb_450x20.png" zPosition="13" position="33,174" size="300,13" transparent="0" borderWidth="1" mode="standardEnigmaSlider" distance="10" maxValue="87" fadeOutTime="500" smoothing="0.5" />
			<!-- textfields  -->
				<widget name="shuffle" position="33,536" size="74,18" font="SansReg;16" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#000000" zPosition="2"/>
				<widget name="gapplesstext" position="107,536" size="154,18" font="SansReg;16" halign="center" valign="center"  foregroundColor="#FF0000" backgroundColor="#000000" zPosition="2"/>
				<widget name="repeat" position="258,536" size="74,18" font="SansReg;16" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#000000" zPosition="2"/>
			<!-- embeded songlist  -->
				<widget name="embededSonglistSimplelist" position="0,146" size="1280,460" zPosition="4" scrollbarMode="showOnDemand" backgroundColor="#000000"/>
				<widget name="embededSonglist2DFlow" position="0,146" size="1280,460" transparent="0" backgroundColor="#000000" zPosition="4" coverSize="146,146" selectedCoverScale="1.4" unselectedCoverDimm="0.7"  coverflowCurrentPosition="640,230" coverflowCurrentXDistance="13" coverflowCurrentCenterDistance="13" style="1" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/no-cover.png" />
				<widget name="embededSonglistCoverwall" position="0,146" size="1280,460" transparent="0" backgroundColor="#000000" zPosition="4" coverSize="146,146" selectedCoverScale="1.4" unselectedCoverDimm="0.7"  coverBeginPosition="90,133" coverDistance="10,10" style="0" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/no-cover.png" />
				<widget name="slpage" font="SansReg;18" transparent="0" position="576,146" size="133,22" zPosition="5" halign="center" foregroundColor="#ffffff" backgroundColor="#000000"/>
			</screen>"""

	def __init__(self, session, songlist=[], index=0, playermode=FILEMODE, currentservice = None, servicelist = None, jukeboxinstance = None):

		logger.info('Player]__init__ ]...')

		self.skin_path='/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images'

		self.playermode=playermode
		self.session = session
		self.currentplayingslentry = None
		self._currentplayingindex = index
		self.currentservice = currentservice
		self.servicelist = servicelist
		self.jukeboxinstance = jukeboxinstance
		self.songlist = songlist
		self.songlistorig = []
		
		Screen.__init__(self, session)
		InfoBarNotifications.__init__(self)
		InfoBarBase.__init__(self)
		PlaylistBase.__init__(self)

		self['actions']=ActionMap(["HelpActions", "ColorActions", "WizardActions", "EPGSelectActions", "MediaPlayerActions", "InfobarAudioSelectionActions", "InfobarActions", 'InfobarInstantRecord', 'NumberActions'],
		{
			"input_date_time": self.menuPressed,
			"back": self.closePlayer,
			"pause": self.pauseEntry,
			"stop": self.stopPlay,
			"right": self.rightPressed,
			"left": self.leftPressed,
			"up": self.showSongListUp,
			"down" : self.showSongListDown,
			"prevBouquet": self.shuffleList,
			"nextBouquet": self.repeatSong,
			"info" : self.infoPressed,
			"red": self.redPressed,
			"green": self.greenPressed,
			"yellow": self.yellowPressed,
			"blue": self.bluePressed,
			"ok": self.okPressed,
			"audioSelection": self.audioPressed,
			"showMovies": self.pvrPressed,
			"previous": self.ratingDown,
			"next": self.ratingUp,
			"displayHelp": self.audioPressed,
		}, -1)

		self.onLayoutFinish.append(self._onLayoutFinishRun)
		self.onFirstExecBegin.append(self._setupAnimation)
		self.onShown.append(self.onShownAppend)
		self.onClose.append(self.__onClose)

		self['background']=Label()
		self['infobarbg']=Label()

		self.repeat = False
		self['repeat'] = Label(_('Repeat'))
		self['repeat'].hide()
		self.shuffle = False
		self['shuffle'] = Label(_('Shuffle'))
		self['shuffle'].hide()
		self['gapplesstext'] = Label('')

		#youtube
		self.isplayyoutube = False
		self.isplayyoutubethissong = False
		self.videomax = False
		self.hiddedelements = []
		self['youtube'] = Pixmap()
		desktopSize = getDesktop(0).size()
		self["Video"] = VideoWindow(decoder = 0, fb_width = desktopSize.width(), fb_height = desktopSize.height())

		self['rating'] = MultiPixmap()
		self['artist'] = Label()
		self['title'] = Label()
		self['genre'] = Label()
		self['album_year_albumartist'] = Label()
		self['plays'] = Label()
		self['track'] = Label()
		self['bitrate'] = Label()
		self['length'] = Label()

		self.__event_tracker = ServiceEventTracker(screen = self, eventmap = 
			{
				iPlayableService.evUpdatedInfo: self.__evUpdatedInfo,
				iPlayableService.evUser+10: self.__evAudioDecodeError,
				iPlayableService.evUser+12: self.__evPluginError,
				iPlayableService.evStart: self.__serviceStarted,
			})

		InfoBarSeek.__init__(self, actionmap = "MediaPlayerSeekActions")

		self.msgbox = None
		self.PixabayScreen = None

		self.hlp = {}

		# Timer
		self.screenSaverTimer = eTimer()
		self.screenSaverTimer_mc_conn = self.screenSaverTimer.timeout.connect(self.onScreenSaverTimerTimeout)
		self.updateLocationInfotimer = eTimer()
		self.musicinfoupdatetimer_mc_conn = self.updateLocationInfotimer.timeout.connect(self.updateLocationtimerAppend)

		# wave
		self['PositionGauge'] = McServicePositionGauge(self.session.nav)
		self['wave'] = Pixmap()
		self['playstate'] = Label('0:00:00')
		self.calcWaveValusThreadInstance = CalcWaveValusThread()
		self.wg_conn = self.calcWaveValusThreadInstance.MessagePump.recv_msg.connect(self.waveformGeneratorCallBack)
		self.wavelen = 0
		self.playstate = [-1, 0]
		self.endoffset_seek = 0
		
		# shazam
		self.shazamresolverinstance = ShazamResolver()
		self.sr_conn = self.shazamresolverinstance.MessagePump.recv_msg.connect(self.shazamResolverCallBack)
		
		self.stateposoffset = 0,0
		self.enigma_player_ID = 4097
		self.setGapplessPlayback()


		# coverart
		self.coverartloaderinstance = CoverArtLoader()
		self.ca_conn = self.coverartloaderinstance.MessagePump.recv_msg.connect(self.coverArtLoaderCallBack)
		self['coverArt'] = PicLoaderScale(transparent = False, name = 'Player-cover')
		self.no_cover_fn = drawImageJobWithLongMultilineText(text = 'NO COVER'.encode('utf-8'), size = (800,800), fontsize = 150, round = 30, out = '/tmp/mc/no_cover.png', force = True)

		# artistart
		self.current_artist_directory = ''
		self.current_artist_directory_name = ''
		self.artistartloaderinstance = ArtistArtLoader()
		self.aa_conn = self.artistartloaderinstance.MessagePump.recv_msg.connect(self.artistArtLoaderCallBack)
		self['artistArt'] = PicLoaderScale(transparent = False, name = 'Player-artist')
		self.no_artist_fn = drawImageJobWithLongMultilineText(text = 'NO ARTIST'.encode('utf-8'), size = (1920,1080), fontsize = 250, out = '/tmp/mc/no_artist.png', force = True)
		
		# songlist
		self.currembededlist = None
		self.embededsonglistisshown = False
		self.values_for_cover_on_song = None
		self.dublicate_search = []
		self['embededSonglistSimplelist'] = CentralList([])
		self['embededSonglistSimplelist'].hide()
		self['embededSonglist2DFlow'] = CoverCollection()
		self['embededSonglist2DFlow'].hide()
		self['embededSonglistCoverwall'] = CoverCollection()
		self['embededSonglistCoverwall'].hide()


		self['key_red'] = StaticText('')
		self['key_green'] = StaticText('')
		self['key_yellow'] = StaticText('')
		self['key_blue'] = StaticText('')

		self['slpage'] = Label()
		self['slpage'].hide()

		eMerlinMusicPlayer.getInstance().setFunc(self.getNextSong)
		eMerlinMusicPlayer.getInstance().enableAlsa(False)# fix unsync rms slider?
		self['coverArtround'] = MerlinMusicPlayerWidget()
		self['visufilemode'] = MerlinMusicPlayerWidget()
		self['rms0'] = MerlinMusicPlayerRMS()
		self['rms1'] = MerlinMusicPlayerRMS()

		self.__evupdateid = ''


	def _onLayoutFinishRun(self):
		logger.debug('Player]_onLayoutFinishRun]...')
		self.hlp['videosize'] = (self['Video'].getSize().width(), self['Video'].getSize().height(), self['Video'].getPosition())
		#x, y, position  =  self.hlp.get('videosize')
		#logger.debug('Player]_onLayoutFinishRun]size:{},{} position{}'.format(x, y, position))
		self['rating'].setPixmapNum(11)
		self['youtube'].setPixmap(LoadPixmap('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/yt_logo.png', cached = False))
		self['youtube'].hide()
		self['embededSonglistSimplelist'].connectSelChanged(self.updateLocationInfo)
		self['embededSonglist2DFlow'].connectSelChanged(self.updateLocationInfo)
		self['embededSonglistCoverwall'].connectSelChanged(self.updateLocationInfo)

		self.setVisualisation()
		self.stateposoffset = self['playstate'].getPosition()
		self.wavelen = self['wave'].getSize().width()
		self.waveheigth = self['wave'].getSize().height()
		self['PositionGauge'].connectPollAppend(self.setPosStateFilemode)
		self['PositionGauge'].hide()
		self['wave'].hide()
		self.setButtons('Visualisations','Playmodes', 'Shazam', '')
		self.resetScreenSaverTimer(restart = True)
		#GlobalTimer(30000, self.introTimerTimeout)
		self.playSong(self._currentplayingindex)


	def _setupAnimation(self, *args):
		animation_cover = "mc_coverart_fade"
		animset = eWindowAnimationSet.create()
		animset.setKey(animation_cover)
		animset.setName("Slow coverart fade")
		animset.setInternal(True)
		animset.setAlpha(eFloatAnimation.create(650, 0.0, 1.0, False, eLinearInterpolator.create())) # duration, 0.0, 1.0, False, interpolator)
		eWindowAnimationManager.setAnimationSet(animset)	
		self['coverArt'].instance.setShowHideAnimation(animation_cover)
		
		animation_artist = "mc_artistart_fade"
		animset = eWindowAnimationSet.create()
		animset.setKey(animation_artist)
		animset.setName("Slow artist fade")
		animset.setInternal(True)
		animset.setAlpha(eFloatAnimation.create(1000, 0.0, 1.0, False, eLinearInterpolator.create())) # duration, 0.0, 1.0, False, interpolator)
		eWindowAnimationManager.setAnimationSet(animset)	
		self['artistArt'].instance.setShowHideAnimation(animation_artist)

	
	def introTimerTimeout(self):
		self.setButtons()

		
	def getNextSong(self, arg):

		filename = ''

		if not config.plugins.musiccenter.gapplessplayback.value:
			logger.info('Player]getNextSong]abort, is not gapplessplayback set')

		#elif self.endoffset_seek>0:
		#	logger.debug('Player]getNextSong]abort, is endoffset_seek...')

		elif self.repeat:
			logger.debug('Player]getNextSong]abort, is repeat')

		else:
			self.updateRatingPlaycounterWaveCover()
			index = self.getNextSonglistIndex(self._currentplayingindex)
			self._currentplayingindex = index
			slentry = self.getSonglistEntry()
			filename = slentry.filename
			self.currentplayingslentry = slentry # new song

		return filename


	def setPosStateFilemode(self, data = (1,1)):

		length, state = data[0], data[1]
		try:wavepos = self.wavelen*state/length
		except:wavepos = 0

		if self.endoffset_seek > 0 and state >= self.endoffset_seek:
			logger.info('Player]setPosStateFilemode]is silent now, playNext Song...')
			#self.endoffset_seek = 0
			self.playNext()

		state = str(datetime_timedelta(seconds = state/90000))
		if self.playstate[0] != state:
			self['playstate'].setText(state)
			self.playstate[0] = state
		# pos
		if self.playstate[1] != wavepos:
			pos_x_base, pos_y_base = self.stateposoffset
			posx = pos_x_base+wavepos
			self['playstate'].move(posx, pos_y_base)
			self.playstate[1] = wavepos


	def ratingUp(self):
		ratingnum = calcRating(self.songlist[self._currentplayingindex][0].rating)
		if ratingnum == 11:
			ratingnum = -1
		if ratingnum<10:
			ratingnum+=1
		self.updateRating(ratingnum)


	def ratingDown(self):
		ratingnum = calcRating(self.getSonglistEntry().rating)
		if ratingnum == 11:
			ratingnum=-1
		if ratingnum>-1:
			ratingnum-=1
		self.updateRating(ratingnum)


	def updateRating(self, ratingnum):
		self.songlist[self._currentplayingindex][0].rating = calcRating(ratingnum, tobyte = True)
		self['rating'].setPixmapNum(ratingnum)
		self.hlp['rating_changed'] = True


	def resetScreenSaverTimer(self, restart = True, ):
		logger.debug('Player]resetScreenSaverTimer]is with restart:{}'.format(restart))
		if self.screenSaverTimer.isActive():
			logger.debug('Player]resetScreenSaverTimer]stop running timer')
			self.screenSaverTimer.stop()
		if restart:
			if config.plugins.musiccenter.pixabay.starttime.value > 0:
				logger.debug('Player]resetScreenSaverTimer]restart with {} minutes'.format(config.plugins.musiccenter.pixabay.starttime.value))
				self.screenSaverTimer.start(60000 * int(config.plugins.musiccenter.pixabay.starttime.value), 1)


	def onShownAppend(self):
		logger.debug('Player]onShownAppend]...')
		slentry = self.getSonglistEntry()
		album_year_albumartist, playcount = joinDisplaytextFiles(slentry)
		self.summaries.updateSlentry(slentry)
		self.summaries.updateCover(slentry.coverfn)


	def pvrPressed(self):
		self.resetScreenSaverTimer(restart = True)
		options = []
		options.append((_('Browse current Artistpic directory'), self.brosweArtistPics),)
		options.append((_('Search for current Artist on google'), self.openArtistGoogleSearch),)
		self.session.openWithCallback(self.globalCallback, ChoiceBox, title = _('Artistpicoptions'), list = options, keys = MYKEYSORT, titlebartext = _('MusicCenter'))


	def openArtistGoogleSearch(self):
		self.resetScreenSaverTimer(restart = True)
		if JCcheckModuleIsUpdated('GoogleImageSearch'):
			reload(GoogleImageSearch)
			
		logger.debug('Player]openArtistGoogleSearch]:current_artist_directory:{} current_artist_directory_name:{} artistforart:{}'.format(self.current_artist_directory, self.current_artist_directory_name, self.currentplayingslentry.artist))
		if self.current_artist_directory_name:
			current_artist_directory = self.current_artist_directory_name
		else:
			current_artist_directory = self.current_artist_directory
		self.session.openWithCallback(self.closedArtistGoogleSearch, GoogleImageSearch.GoogleImageSearchScreen, self.currentplayingslentry, current_artist_directory, self.currentplayingslentry.artist, sizeX = 1920, sizeY = 1080, face = True)


	def closedArtistGoogleSearch(self, result):
	
		slentry, picname, error = result
		if picname is not None and slentry.songID == self.currentplayingslentry.songID:
			logger.debug('Player]closedArtistGoogleSearch]show new artistpic:{}'.format(picname))
			self.showArtist(picpath = picname, startwave = False)
		else:
			logger.debug('Player]closedArtistGoogleSearch]no artistpic given,or sonfile changed')
		self.resetScreenSaverTimer(restart = True)


	def audioPressed(self):
		self.resetScreenSaverTimer(restart = True)
		options = []
		if not self.embededsonglistisshown:

			options.append((_('Search youtube video for song'), self.startYoutubeSearch),)
			if self.isplayyoutube or self.isplayyoutubethissong:
				if not self.videoInCache(self.songlist[self._currentplayingindex][0].youtubeurl):
					options.append((_('Cache playing Video'), self.downloadPlayingVideo),)
			options.append((_('Add showing Cover to all songs in songlist'), self.startEmbedShowingCoverToAllFilesInSonglist),)
			options.append((_('Update wave from playing songf'), self.startUpdateWave),)
			if self.hlp.get('searchCoversandWavesFromPlaylist', False):
				options.append((_('Cancel Search Covers and build Waveforms from Playlist'), self.cancelSearchCoversandWavesFromPlaylist),)
			else:
				options.append((_('Start search Covers and build Waveforms from Playlist'), self.searchCoversandWavesFromPlaylist),)
		self.session.openWithCallback(self.globalCallback, ChoiceBox, title = _('Audiofileoptions'), list = options, keys = MYKEYSORT, titlebartext = _('MusicCenter'))


	def startYoutubeSearch(self):
		slentry = self.getSonglistEntry()		
		searchword = '{} {}'.format(fitName(slentry.artist), fitName(slentry.title))
		if JCcheckModuleIsUpdated('YoutubeSearch'):
			reload(YoutubeSearch)
		self.session.openWithCallback(self.youtubeSearchResult, YoutubeSearch.YoutubeSearchScreen, searchword, slentry)


	def youtubeSearchResult(self, youtubeurl, slentry):
		logger.debug('Player]youtubeSearchResult]{}'.format(youtubeurl))
		if youtubeurl:
			#logger.info('Player]youtubeSearchResult]->{}'.format(youtubeurl))
			if self.songlist[self._currentplayingindex][0].songID == slentry.songID:
				self.songlist[self._currentplayingindex][0].youtubeurl = youtubeurl
				slentry.youtubeurl = youtubeurl
				id3dict = {'youtubeurl':youtubeurl}
				musiccenterJobmanager.AddJob(ID3WriterJob(slentry, id3dict))
				if youtubeurl != 'disable':
					self.isplayyoutubethissong = True
					self.playYoutube(slentry)
					
	
	def downloadPlayingVideo(self):
		slentry = self.getSonglistEntry()
		musiccenterJobmanager.AddJob(YoutubeDownloadJob(slentry.youtubeurl, 'Download video {} - {}'.format(slentry.artist,slentry.title)))

		
	def videoInCache(self, youtubeurl):
		found_video_id = False
		new_id = youtubeurl.rsplit('watch?v=',1)[-1]
		for video_id in os_listdir(config.plugins.musiccenter.ytcachedir.value):
			if not video_id.lower().endswith(('.cuts', '.ap',)):
				if new_id == video_id.split('_._',1)[0]:
					found_video_id = video_id
					break
					
		logger.debug('Player]videoInCache]found_video_id:{}'.format(found_video_id))		
		return found_video_id
		
		
	def changeGapplessPlayback(self):
		config.plugins.musiccenter.gapplessplayback.value = not config.plugins.musiccenter.gapplessplayback.value
		config.plugins.musiccenter.gapplessplayback.save()
		configfile.save()
		self.setGapplessPlayback()


	def setGapplessPlayback(self):
		if config.plugins.musiccenter.gapplessplayback.value:
			self.enigma_player_ID = 0x1019 # merlin
			self['gapplesstext'].setText('Gappless playback')
		else:
			self['gapplesstext'].setText('Normal playback')
			if not config.plugins.musiccenter.visualization.rms.value and not config.plugins.musiccenter.visualization.roundcover.value and not config.plugins.musiccenter.visualization.spectrum_small.value:
				self.enigma_player_ID = 4097
			else:
				self.enigma_player_ID = 0x1019# merlin
		logger.info('Player]setGapplessPlayback]set enigma_player_ID {}'.format(self.enigma_player_ID))


	def setVisualisation(self):
		if config.plugins.musiccenter.visualization.rms.value:
			self['rms0'].show()
			self['rms1'].show()
		else:
			self['rms0'].hide()
			self['rms1'].hide()

		if config.plugins.musiccenter.visualization.roundcover.value:
			self['coverArt'].hide()
			self['coverArtround'].show()
			self['coverArtround'].setCover(self['coverArt'].currentpic)
		else:
			self['coverArtround'].hide()
			self['coverArt'].show()
			self['coverArt'].doshow(self['coverArtround'].filename)

		if config.plugins.musiccenter.visualization.spectrum_small.value:
			self['visufilemode'].show()
		else:
			self['visufilemode'].hide()


	def startUpdateWave(self):
		logger.debug('Player]startUpdateWave]clear old wave, restart wavebuild')
		slentry = self.getSonglistEntry(self._currentplayingindex)
		self.songlist[self._currentplayingindex][0].wave = 0
		wavefn = '{}wave_{}.png'.format(os_path_join(config.plugins.musiccenter.downloadcache.value, 'waves/' ), slentry.songID)
		if fileExists(wavefn):
			os_remove(wavefn)
		self.showWave(False)
		self.checkWave()


	def searchCoversandWavesFromPlaylist(self):
		logger.info('Player]searchCoversandWavesFromPlaylist]')
		self['gapplesstext'].setText('cover + wavescan')
		self.hlp['searchCoversandWavesFromPlaylist'] = self._currentplayingindex
		self.searchCoversandWavesFromPlaylistTimer = eTimer()
		self.searchCoversandWavesFromPlaylistTimer_mc_conn = self.searchCoversandWavesFromPlaylistTimer.timeout.connect(self.rightPressed)
		self.rightPressed()


	def cancelSearchCoversandWavesFromPlaylist(self):
		logger.info('Player]cancelSearchCoversandWavesFromPlaylist]')
		if self.hlp.get('searchCoversandWavesFromPlaylist'):
			self.searchCoversandWavesFromPlaylistTimer.stop()
		self.hlp['searchCoversandWavesFromPlaylist'] = None
		if self.searchCoversandWavesFromPlaylistTimer_mc_conn:
			self.searchCoversandWavesFromPlaylistTimer_mc_conn = None
		self.setGapplessPlayback() # set playermode back


	def brosweArtistPics(self):
		self.resetScreenSaverTimer(restart = False)
		if JCcheckModuleIsUpdated('SimplePicbrowser'):
			reload(SimplePicbrowser)
		self.session.openWithCallback(self.brosweArtistPicsCB, SimplePicbrowser.Picbrowser, self.current_artist_directory) 


	def brosweArtistPicsCB(self):
		self.resetScreenSaverTimer(restart = True)


	def	startEmbedShowingCoverToAllFilesInSonglist(self):
		#logger.debug('Player]startEmbedShowingCoverToAllFilesInSonglist]start')
		if len(self.songlist):
			#logger.debug('Player]startEmbedShowingCoverToAllFilesInSonglist]is songlist')
			cntmp='/tmp/coverartforcoveradd'
			if self.values_for_cover_on_song is not None:
				sh_copy2(self.values_for_cover_on_song['coverfn'], cntmp)
				self.values_for_cover_on_song = None
				#logger.debug('Player]startEmbedShowingCoverToAllFilesInSonglist]cover from file')
			elif fileExists('/tmp/.id3coverart'):
				sh_copy2('/tmp/.id3coverart', cntmp)
				#logger.debug('Player]startEmbedShowingCoverToAllFilesInSonglist]cover from tag')
			else:
				self.session.open(MessageBox, _('Error embed cover!\nNo cover found for embeding.'), type=MessageBox.TYPE_ERROR, title='MusicCenter',timeout=20)
				return
			#logger.debug('Player]startEmbedShowingCoverToAllFilesInSonglist]all nessesary parts found, embed songlist with  %s songs!' %len(self.songlist))
			for item in self.songlist:
				slentry=item[0]
				id3dict={'cover':cntmp}
				musiccenterJobmanager.AddJob(ID3WriterJob(slentry, id3dict))
		self.resetScreenSaverTimer(restart = True)


	def editId3Closed(self, res):
	
		self.resetScreenSaverTimer(restart = True)
		
		if res is not None: # [0] currentplayingindex  [1] filename [2]id3 [3]slentry
			index, filename, id3dict, slentry=res
			logger.debug('Player]editId3Closed]update Songlist index:{} for filename:{} id3dict:{} editid3filename:{}'.format(index, filename, id3dict.keys(), slentry.filename))

			if id3dict.keys():
				musiccenterJobmanager.AddJob(ID3WriterJob(slentry, id3dict))
				if id3dict.has_key('artist') or id3dict.has_key('title'):
					self.shazamresolverinstance.removeShazamIdFromSongsTable(slentry)
				if self.currentplayingslentry.songID == slentry.songID: # song not changed!
					logger.debug('Player]editId3Closed]song is unchanged, set id3')
					self.songlist[index]=(slentry,)
					self.updateMusicInformation(text = None, slentry=slentry)
					self.startShazamResolving(slentry)
					if id3dict.has_key('youtubeurl') and self.isplayyoutube:
						self.playSong(self._currentplayingindex)
			else:
				logger.error('Player]editId3Closed]no changed id3 given')
		else:
			logger.debug('Player]editId3Closed]nothing changed on EditID3 Screen')

		self.resetScreenSaverTimer(restart = True)


	def menuPressed(self):
		self.resetScreenSaverTimer(restart = True)	
		options=[]
		options.append((_('Global Configuration'), self.openConfig),)
		if self.embededsonglistisshown:
			if not self.dublicate_search:
				options.append((_('Remove selected Song from songlist'), self.removeSongFromList),)
			options.append((_('Remove selected song from songlist, Database and Disc'), self.removeSongFromListAndDisc),)
		else:
			self.hlp['slentry_and_index_for_delete']=(self.getSonglistEntry(), self._currentplayingindex)
			options.append((_('Delete current playing song'), self.deleteSelectedSong),)
		options.append((_('Current running jobs'), self.jobView),)
		options.append((_('Logfile'), self.startLog),)
		options.append((_('Update youtube_dl'), self.updateYoutubedl),)
		self.session.openWithCallback(self.globalCallback, ChoiceBox, title=_('Mainscreen Options'), list=options, keys=MYKEYSORT, titlebartext=_('MusicCenter'))


	def openConfig(self):
		self.resetScreenSaverTimer(restart = False)	
		self.session.openWithCallback(self.setupFinished, MusicCenterSetup)


	def setupFinished(self, result):
		self.resetScreenSaverTimer(restart = True)
		if result:
			pass
		logger.debug('Player]setupFinished]...')

		
	def help(self):
		pass # self.session.open(MCHelp, PLAYERSCREEN)


	def startLog(self):
		if JCcheckModuleIsUpdated('LogScreen'):
			reload(LogScreen)
		self.session.open(LogScreen)


	def updateYoutubedl(self):
		from Screens.Console import Console
		self.session.open(Console, title='MusicCenter update', cmdlist = ['pip install --upgrade youtube-dl']) #self.updateFinished, 
 

	def jobView(self):
	
		try:
			if JCcheckModuleIsUpdated('TaskViewScreen'):
				reload(TaskViewScreen)
			self.session.open(TaskViewScreen.MusicCenterTasksScreen)
			
		except Exception, e:
			logger.error('Play]jobView]error relaod Module:{}'.format(e))
			self.session.open(MessageBox, _('Error:{}'.format(e)), type=MessageBox.TYPE_ERROR, title='MusicCenter',timeout=5 )


	def deleteSelectedSong(self):
		slentry, index=self.hlp.get('slentry_and_index_for_delete')
		l=len(self.songlist)
		self.values_for_cover_on_song = None
		fn=os_path_realpath(slentry.filename)
		logger.debug('Player]deleteSelectedSong]index:{} len songlist:{} filename:{}'.format(index, l, fn))
		if l > 1:
			del self.songlist[index]
			self.hlp['rating_changed'] = False
			if index+1<l: #deleteSelectedSong]index:87 len songlist:88
				self.playSong(index)
			else:
				self.playSong(0)
		elif l == 1:
			del self.songlist[index]
			self.hlp['rating_changed'] = False
			self.stopPlay()
		else:
			logger.error('Player]deleteSelectedSong]wrong here!!!')

		deferToThread(JCdeleteSongfileonThread, fn, slentry.songID).addCallback(self.finishedJCdeleteSongfileonThread,).addErrback(self.errorJCdeleteSongfileonThread,)


	def finishedJCdeleteSongfileonThread(self, result):
		logger.debug('Player]finishedJCdeleteSongfileonThread]'+result)


	def errorJCdeleteSongfileonThread(self, error):
		logger.error('Player]errorJCdeleteSongfileonThread]'+error)


	def okPressed(self):
		if self.embededsonglistisshown:
		
			self.showhideEmbededSonglist()
			
			if self.dublicate_search:
				logger.debug('Player]okPressed]index:{}'.format(self.currembededlist.getCurrentIndex()))
				self.dublicate_search = []		
			else:
				self.updateRatingPlaycounterWaveCover()
				self.playSong(self.currembededlist.getCurrentIndex())
			self.setButtons('Visualisations','Playmodes', 'Shazam', '')
			#GlobalTimer(15000, self.introTimerTimeout)			
			self.resetScreenSaverTimer(restart = True)
			
		else:
			listentrys = []
			if self.isplayyoutube or self.isplayyoutubethissong:
				if self.videomax:
					self.minVideo()
				else:
					self.maxVideo()
			else:
				listentrys.append((_('Start Picture Screensaver'), self.onScreenSaverTimerTimeout),)
	
			if listentrys:
				self.session.openWithCallback(self.globalCallback, ChoiceBox, title=_('Mainscreen Options'), list = listentrys, keys = MYKEYSORT, titlebartext = _('MusicCenter'))


	def toggleVideoScreen(self):
		if self.videomax:
			self.minVideo()
		else:
			self.maxVideo()


	def infoPressed(self):
		listentrys = []
		listentrys.append((_('ID3 Editor'), self.openEditID3),)
		if not self.embededsonglistisshown:
			listentrys.append((_('Add selected song to a Playlist'), self.addSongToPlaylist, self.currentplayingslentry),)
			if self.currentplayingslentry.playlistID >- 1:
				playlistname = self.getPlaylistName(self.currentplayingslentry.playlistID)
				listentrys.append((_('Delete selected song from Playlist {}'.format(playlistname)), self.deleteSongFromPlaylist, self.currentplayingslentry),)
				listentrys.append((_('Rename Playlist {}'.format(playlistname)), self.renamePlaylistCB, (playlistname, self.currentplayingslentry.playlistID)),)
			else:
				listentrys.append((_('Rename Playlist'), self.renamePlaylist),)
				
			listentrys.append((_('Create new Playlist'), self.newPlaylist),)
			listentrys.append((_('Create new Playlist from playing Songlist'), self.newPlaylistFromSonglist, self.songlist),)
			listentrys.append((_('Remove Playlist'), self.removePlaylist),)
		
		if listentrys:
			self.session.openWithCallback(self.globalCallback, ChoiceBox, title=_('Mainscreen Options'), list = listentrys, keys = MYKEYSORT, titlebartext = _('MusicCenter'))
	
	
	def openEditID3(self):
		logger.debug('Player]infoPressed]....')
		self.resetScreenSaverTimer(restart = False)

		if JCcheckModuleIsUpdated('EditID3'):
			reload(EditID3)
			
		if self.embededsonglistisshown:
			index = self.currembededlist.getCurrentIndex()
			slentry = self.songlist[index][0]
		else:
			index = self._currentplayingindex
			slentry=self.getSonglistEntry()

		self.session.openWithCallback(self.editId3Closed, EditID3.EditId3, slentry, index, self)


	def playYoutube(self, slentry):
		youtubeurl = slentry.youtubeurl
		logger.debug('Player]playYoutube]youtubeurl:{}'.format(youtubeurl))
		cache = self.videoInCache(youtubeurl)
		if cache:
			fn = os_path_join(config.plugins.musiccenter.ytcachedir.value, cache)
			logger.debug('Player]playYoutube]play cached file:{}'.format(fn))
			ref=eServiceReference(4097, 0, fn)
			self.session.nav.playService(ref)			
			self.showhideartistvisuElements('hide')
			#self['youtube'].show()
			
		else:
			id = youtubeurl.rsplit('watch?v=',1)[-1]
			logger.debug('Player]playYoutube]no cached file found resolve id:{}'.format(id))
				
			if not id.startswith('https://'):
			
				self.session.nav.stopService()
				
				if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/MediaPortal/plugin.py') and  config.plugins.musiccenter.ytresolver.value == 'mediaportal':
					url = 'mp_yt://{}'.format(id)
				elif config.plugins.musiccenter.ytresolver.value == 'intern':
					url = 'yt://{}'.format(id)
					
				logger.debug('Player]playYoutube]url:{} use resolver:{}'.format(url, config.plugins.musiccenter.ytresolver.value))
				ref=eServiceReference(8193, 0, url)
				self.session.nav.playService(ref)
				self.showhideartistvisuElements('hide')
				#self['youtube'].show()
				
			else:
				self.session.open(MessageBox, _('Error play:\n{}'.format(youtubeurl)), type=MessageBox.TYPE_ERROR, title='MusicCenter Player', timeout=5)

		deferToThread(self.getYoutubeStats, youtubeurl,).addCallback(self.getYoutubeStatsAppend,).addErrback(self.getYoutubeStatsError, slentry)


	def getYoutubeStats(self, youtubeurl):
		ydl_opts = {'nocheckcertificate': True,'logger': logger,}
		with youtube_dl_YoutubeDL(ydl_opts) as ydl:
			meta = ydl.extract_info(youtubeurl, download = False)
		return meta
	

	def getYoutubeStatsAppend(self, meta):
		#logger.debug('Player]getYoutubeStatsAppend]meta:{}'.format(meta))
		title = meta[ u'title']
		view_count =  '{:,}'.format(int(meta.get(u'view_count', -1))).replace(',', '.')
		t = meta[ u'upload_date']
		upload_date = '{}-{}-{}'.format(t[:4],t[4:6], t[6:8])
		dislike_count = int(meta.get(u'dislike_count', -1))
		if dislike_count == None:
			dislike_count = 0
		dislike_count = '{:,}'.format(dislike_count).replace(',', '.')
		like_count = int(meta.get(u'like_count', -1))
		if like_count == None:
			like_count = 0
		like_count = '{:,}'.format(like_count).replace(',', '.')
		uploader = meta[ u'uploader']
		#urls = meta[ u'requested_formats']
		#video_url = urls[0][u'url']
		#audio_url = urls[1][u'url']	
		message = '{}({}) +{} -{} {} ({})'.format(title, view_count, like_count, dislike_count, upload_date, uploader)
		
		self['album_year_albumartist'].setParsedText(message)		


	def getYoutubeStatsError(self, error = 'n/a', slentry = Item()):
		error = str(error)
		logger.error('Player]getYoutubeStatsError]error:{}'.format(error))
		with open('/tmp/error.yt', 'wb') as f:
			f.write(slentry.youtubeurl + '->' + error)
		
		if 'This video is unavailable' in error:
			self.playFile(slentry)
		else:
			maske = '>:(.*?)\n'
			errorclean = re_findall(maske, error)
			if errorclean:
				error = errorclean
			self.session.open(MessageBox, _('Error extract Video:\n\n*** Try to update youtube_dl on Config ***\n\n{}'.format(error)), type=MessageBox.TYPE_ERROR, title='MusicCenter Player', timeout=10)
			self['album_year_albumartist'].setParsedText('{}'.format(error))


	def showhideartistvisuElements(self, what=''):
		if what == 'hide':
			self['artistArt'].hide()
			if config.plugins.musiccenter.visualization.rms.value:
				self['rms0'].hide()
				self['rms1'].hide()
			if config.plugins.musiccenter.visualization.spectrum_small.value:
				self['visufilemode'].hide()

			
		elif what == 'show':
			self['artistArt'].show()
			if config.plugins.musiccenter.visualization.rms.value:
				self['rms0'].show()
				self['rms1'].show()
			if config.plugins.musiccenter.visualization.spectrum_small.value:
				self['visufilemode'].show()
			self.minVideo()


	def minVideo(self):
		logger.debug('Player]minVideo]...')		
		self.videomax = False
		x, y, position = self.hlp.get('videosize')
		self['Video'].resize(x,y)
		self['Video'].move(position[0], position[1])
		self['Video'].setZPosition(2)# how to read zpos from skin?
		for e in ("wave", "PositionGauge", "playstate"):
			self[e].show()

		
	def maxVideo(self):
		logger.debug('Player]maxVideo]...')
		for e in ("wave", "PositionGauge", "playstate"):
			self[e].hide()
		self['Video'].move(0,0)
		self['Video'].resize(1920, 1080)
		self['Video'].setZPosition(20)
		self.videomax = True


	def findYoutubeUrl(self, slentry):
		searchword=quote('{} {}'.format(fitName(slentry.artist), fitName(slentry.title)))
		url='https://www.google.de/search?q={}&num=5&source=lnms&tbm=vid&tbs=hq:h,srcf:H4sIAAAAAAAAACWKQQrAIAzAftPLwD-12lHRUnHtxn4_1cacQkuO18CBO2RQesQt1dC5bqfZOhvM3qT5wYlmrwImZyazton4vpmjwASf_1sYtOAAAA'.format(searchword)
		#url='https://www.google.de/search?q={}&num=5&source=lnms&tbm=vid'.format(searchword)
		logger.debug('Player]findYoutubeUrl]{}'.format(url))
		getPage(url, timeout=TWISTED_TIMEOUT, agent='Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.17 (KHTML, like Gecko) Chrome/24.0.1312.56 Safari/537.17').addCallback(self.findYoutubeUrlCallback, slentry).addErrback(self.findYoutubeUrlErrback, slentry)


	def findYoutubeUrlCallback(self, html, slentry):
		urls=re_findall('''r"><a href="(.*?)" ping=''', html)
		#str='''r"><a href="(.*?) ping=.*?"LC20lb">(.*?)</h3><br><div style=".*?style="height:(.*?)px;width:(.*?)px"><a.*?px"><img id="(.*?)" src=".*?><div class="slp f">(.*?)</div><span class="st">(.*?)</span></div><div'''
		#matches=re_findall(str, html) #url, title, ix,iy, iname, uploaddate, descripion
		#if matches:
		#	url, title, ix,iy, iname, uploaddate, descripion=matches[0]
		#image=re_findall('''\(function\(\)\{var _image_src=\'(.*?)\';var _image_ids=\['vidthumb1''', html)
		#with open('/tmp/result.txt', 'wb') as f:
		#	f.write(html)
		html = None
		logger.debug('Player]findYoutubeUrlCallback]{}'.format(urls))
		if urls:
			youtubeurls=[ url for url in urls if url.startswith('https://www.youtube.com/watch')]
			if youtubeurls:
				if self.songlist[self._currentplayingindex][0].songID == slentry.songID:
					youtubeurl=youtubeurls[0]
					self.songlist[self._currentplayingindex][0].youtubeurl=youtubeurl
					slentry.youtubeurl=youtubeurl
					id3dict={'youtubeurl':youtubeurl}
					musiccenterJobmanager.AddJob(ID3WriterJob(slentry, id3dict))
					self.playYoutube(slentry)
					return

		self.session.toastManager.showToast(_('No video found, play file', 5))
		self.playFile(slentry)


	def findYoutubeUrlErrback(self, error, slentry):
		logger.error('Player]findYoutubeUrlErrback]{}'.format(error))
		self.session.toastManager.showToast(_('Error resolve video, please report to developer!\n{}'.format(error), 5))
		self.playFile(slentry)


	def playSong(self, index):
		logger.info('Player]playSong]index:{} playyoutube:{}'.format(index, self.isplayyoutube))
		if self.videomax:
			self.minVideo()
			self.screenSaverTimer.start(1000 * 10, 1)

		self.session.nav.stopService()
		slentry=self.getSonglistEntry(index)
		self.updateMusicInformation(text = None, slentry=slentry)
		self.currentplayingslentry=slentry # new song
		self._currentplayingindex=index
		
		if slentry.audio:
			if self.isplayyoutube and slentry.youtubeurl != 'disable':
				if slentry.youtubeurl:
					self.playYoutube(slentry)
				else:
					self.findYoutubeUrl(slentry)
			else:
				self.playFile(slentry)
		else:
			logger.error('Player]playSong]file is not audio:{}'.format(slentry.filename))
			slentry.artist='File or Stream not found!'
			self.updateMusicInformation(text = None, slentry=slentry)
			self.playNext()
			

	def playFile(self, slentry):
		logger.info('Player]playSong]songID:{} filename:{}'.format(slentry.songID, slentry.filename))
		self.showhideartistvisuElements('show')
		logger.debug('Player]playFile]songID:{}'.format(slentry.songID))
		ref = eServiceReference(self.enigma_player_ID, 0, slentry.filename)
		self.session.nav.playService(ref)


	def findSilentParts(self, slentry, wavevalues=[]):

		self.endoffset_seek=0

		if config.plugins.musiccenter.detectsilence.value and not self.isplayyoutube and not self.isplayyoutubethissong:

			if config.plugins.musiccenter.gapplessplayback.value:
				eMerlinMusicPlayer.getInstance().enableGapless(False)

			if not wavevalues:
				wavevalues=self.getID3SpecialFromFile(slentry.filename)

			#start_siro_levels=0
			end_siro_levels=0

			if wavevalues:
				threshold=int(max(wavevalues)/100*1.11)# dynamic range

				wavevalues.reverse()

				for v in wavevalues:
					if v<threshold:
						end_siro_levels+=1
					else:
						break

				wavevalues.reverse()
				logger.debug('Player]findSilentParts]end_siro_levels {} threshold:{} 20 last wavevalues:{}'.format(end_siro_levels, threshold, str(wavevalues[-20:])))
				wavevalues = None

				h, m, s = slentry.length.split(':')
				length=(int(h)*3600+int(m)*60+int(s))*90000
				chunk=length/1920

				if end_siro_levels:
					endoffset=chunk*end_siro_levels
					offset=60000
					if endoffset>offset:
						logger.info('Player]findSilentParts]endoffset {} is > {}, skip faster to next song'.format(endoffset, offset))
						if config.plugins.musiccenter.gapplessplayback.value:
							eMerlinMusicPlayer.getInstance().enableGapless(False)
						self.endoffset_seek=chunk*(1920-end_siro_levels)
					else:
						logger.info('Player]findSilentParts]endoffset {} is < {}, do not skip faster'.format(endoffset, offset))
			else:
				logger.debug('Player]findSilentParts]no wavevalues found')


	def __evUpdatedInfo(self):
		slentry=self.currentplayingslentry
		if slentry.songID == self.__evupdateid:
			#logger.info('Player]__evUpdatedInfo]unchanged event:{}'.format(slentry.songID))
			return

		self.__evupdateid=slentry.songID
		logger.info('Player]__evUpdatedInfo]New event:{}'.format(slentry.songID))
		
		self.updateMusicInformation(text = None, slentry=slentry)
		self.showWaveFormNow(slentry)
		
		if slentry.cover:# show embeded cover
			if not fileExists(slentry.coverfn):
				CoverLoader().load(slentry.filename)
			self.showCover(isfilecover = False, picpath=slentry.coverfn)
		else:
			self.showNoCover('No embeded Cover, start search...')
			
		self.startShazamResolving(slentry)
		#self.startArtistart(slentry)
		self.findSilentParts(slentry)


	def __serviceStarted(self):
		logger.debug('Player]__serviceStarted]...')
		if not self.embededsonglistisshown and (self.isplayyoutube or self.isplayyoutubethissong) and self.currentplayingslentry.youtubeurl != 'disable':
			self['youtube'].show()
		else:
			self['youtube'].hide()			


	def updateMusicInformation(self, text = None, slentry=Item()):
		if int(slentry.shazamartistcounts) == -1:
			self['artist'].setText('{}'.format(slentry.artist))
		else:
			self['artist'].setText('{} ({:,} Shazams)'.format(slentry.artist, int(slentry.shazamartistcounts)).replace(',','.'))

		if text is None:
			if int(slentry.shazamtitlecounts) == -1:
				self['title'].setText('{}'.format(slentry.title))
			else:
				self['title'].setText('{} ({:,} Shazams)'.format(slentry.title, int(slentry.shazamtitlecounts)).replace(',','.'))
				#self['title'].setText('{} ({} Shazams)'.format(slentry.title, int(slentry.shazamtitlecounts)).replace(',','.'))
		else:
			self['title'].setText(text)

		album_year_albumartist, playcount = joinDisplaytextFiles(slentry)
		self['album_year_albumartist'].setText(album_year_albumartist)
		track = '{}/{}'.format(self._currentplayingindex+1,len(self.songlist))
		self['track'].setText(track)
		self['genre'].setText(slentry.genre)
		self['plays'].setText(playcount)
		self['bitrate'].setText(slentry.bitrate)
		self['length'].setText(slentry.length)
		self['rating'].setPixmapNum(calcRating(slentry.rating)) # self.songlist[self._currentplayingindex][0].rating))
		#lcd
		self.summaries.updateSlentry(slentry)

		if self.PixabayScreen:#artist, title, album_year_albumartist, track, genre, playcount, bitrate, length, ratingnum
			self.PixabayScreen.updateDisplayText(slentry.artist, slentry.title, album_year_albumartist, track, slentry.genre, playcount, slentry.bitrate, slentry.length, calcRating(slentry.rating))
			self.PixabayScreen.updateLCD(slentry)


	def startShazamResolving(self, slentry):
			
		h, m, s = slentry.length.split(':')
		songlength = int(h) * 60 + int(m)
		#logger.debug('Player]startShazamResolving]songlength:{}'.format(songlength))
		
		if songlength < 8: # song kürzer x min
			logger.info('Player]startShazamResolving]shazamartistcounts->{} shazamartistID->{}'.format(slentry.shazamartistcounts, slentry.shazamartistID))
			if slentry.shazamartistcounts == -1:
				if str(slentry.shazamartistID) != '-1':
					self.getShazamArtistcount(slentry.shazamartistID, slentry)

	 		if slentry.shazamtitlecounts == -1:
				if str(slentry.shazamtitleID) != '-1':
					self.getShazamTitlecount(slentry.shazamtitleID, slentry)
				else:
					if slentry == self.currentplayingslentry:
						logger.debug('Player]startShazamResolving]start startShazamThread')
						self.startShazamThread(slentry, 'title')
						return
		else:
			logger.info('Player]startShazamResolving]song is to long, skip shazam...')

		logger.debug('Player]startShazamResolving]no shazamsearch, start loadCover and artistArt')
		self.loadCover(slentry, '') # no shazamimage
		self.startArtistart(slentry, '')
		
	
	def shazamResolverCallBack(self, result):
		res = self.shazamresolverinstance.Message.pop()
		status_ok = res[0]
		slentry = res[1]
		type = res[2]
		shazam_title_image = ''
		shazam_artist_image = ''
		
		if status_ok:
		
			ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image = res[3:]

			if slentry.songID == self.currentplayingslentry.songID:
				if type == 'title' and str(ratio).startswith('alternative'):
					self.session.openWithCallback(self.callbackDifferentTagsAfterShazam, MessageBox, _('Different Artist or Title found\n want you replace Artist or title to\n{} - {}?'.format(shazam_artist_text, shazam_title_text)), type = MessageBox.TYPE_YESNO, timeout = 10, close_on_any_key = True, default = False, enable_input = True, msgBoxID = None, windowTitle = 'Musiccenter', additionalActionMap = None, title = _("Question:"))

				else:
					if shazam_artist_ID:
						self.getShazamArtistcount(shazam_artist_ID, slentry)
					if shazam_title_ID:
						self.getShazamTitlecount(shazam_title_ID, slentry)
			else:
				logger.info('Player]shazamResolverCallBack]song is leaved, abort')

		if slentry.songID == self.currentplayingslentry.songID and type == 'title':				
			self.loadCover(slentry, shazam_title_image)
			self.startArtistart(slentry, shazam_artist_image)

		
	def callbackDifferentTagsAfterShazam(self, answer):
		logger.info('Player]callbackDifferentTagsAfterShazam]answer:{}'.format(answer))
		if answer:
			pass
			
			
	def getShazamArtistcount(self, shazam_artist_ID, slentry):
		url='''https://www.shazam.com/shazam/v1/de/DE/web/-/publisher/{}/followers/count'''.format(shazam_artist_ID)
		logger.debug('Player]getShazamArtistcount]{}'.format(url))
		mygetPage(url, timeout=TWISTED_TIMEOUT).addCallback(self.getShazamArtistcountCallback, slentry).addErrback(self.getShazamArtistcountError, slentry)

		
	def getShazamArtistcountCallback(self, counts, slentry):
		counts=json_loads(counts)
		if slentry.songID == self.currentplayingslentry.songID:
			self.songlist[self._currentplayingindex][0].shazamartistcounts=counts[u'count']
			if not self.embededsonglistisshown:
				self['artist'].setText('{} ({:,} Shazams)'.format(slentry.artist, int(counts[u'count'])).replace(',','.'))

				
	def getShazamArtistcountError(self, error, slentry):
		logger.debug('Player]getShazamArtistcountError]{}'.format(error))
		self.getShazamArtistcountCallback('{"count": "0"}', slentry)

		
	def getShazamTitlecount(self, shazam_title_ID, slentry):
		url='''https://www.shazam.com/shazam/v1/de/DE/web/-/tagcounts/track/{}'''.format(shazam_title_ID)
		logger.debug('Player]getShazamTitlecount]{}'.format(url))
		mygetPage(url, timeout=TWISTED_TIMEOUT).addCallback(self.getShazamTitlecountCallback, slentry).addErrback(self.getShazamTitlecountError, slentry)

		
	def getShazamTitlecountCallback(self, result, slentry):
		counts = json_loads(result)
		if slentry.songID == self.currentplayingslentry.songID:
			self.songlist[self._currentplayingindex][0].shazamtitlecounts = counts[u'total']
			if not self.embededsonglistisshown:
				self['title'].setText('{} ({:,} Shazams)'.format(slentry.title, int(counts['total'])).replace(',','.'))

				
	def getShazamTitlecountError(self, error, slentry):
		logger.debug('Player]getShazamTitlecountError]{}'.format(error))
		self.getShazamTitlecountCallback('0', slentry)

		
	def startShazamThread(self, slentry, type, reload = False):
		self.hlp['shazam_slentry'] = slentry, type, reload
		self.shazamWaitTimerTimeout()


	def shazamWaitTimerTimeout(self):
		if self.shazamresolverinstance.isRunning:
			logger.debug('Player]shazamWaitTimerTimeout]old thread, start new waittimer')
			GlobalTimer(100, self.shazamWaitTimerTimeout)
		else:
			slentry, type, reload = self.hlp.get('shazam_slentry')
			self.shazamresolverinstance.Start(slentry, type, reload = reload)

	
	def startShazamTrackResearch(self, slentry):
		self.shazamresolverinstance.removeShazamIdFromSongsTable(slentry)
		self.startShazamThread(slentry, 'title', reload = True)	
		

	def startShazamArtistResearch(self, slentry):
		self.shazamresolverinstance.removeShazamIdFromArtistTable(slentry)
		self.startShazamThread(slentry, 'artist', reload = True)	

			
	def loadCover(self, slentry, shazamimage=''):
		if not slentry.cover:
			self.hlp['coverartloaderinstanceparameter'] = (slentry, shazamimage)
			self.onCoverArtIsFinishedWaitTimerTimeout()			


	def onCoverArtIsFinishedWaitTimerTimeout(self):
		if self.coverartloaderinstance.isRunning:
			logger.info('Player]onCoverArtIsFinishedWaitTimerTimeout]start new timer')
			GlobalTimer(100, self.onCoverArtIsFinishedWaitTimerTimeout)
		else:
			res = self.hlp.get('coverartloaderinstanceparameter')
			if res is not None:
				slentry, shazamimage = res
				self.coverartloaderinstance.Start(slentry, shazamimage)
			else:
				logger.error('Player]onCoverArtIsFinishedWaitTimerTimeout] !!!!')


	def coverArtLoaderCallBack(self, msg):
		isrunned, slentry, pic_path, message = self.coverartloaderinstance.Message.pop()
		logger.debug('Player]coverArtLoaderCallBack]isrunned:{} pic_path{} message:{}'.format(isrunned, pic_path, message))

		if slentry.songID == self.currentplayingslentry.songID:
			if isrunned:
				self.showCover(isfilecover = True, picpath = pic_path)
			else:
				self.showNoCover()
				
			if message is not None:
				self.session.toastManager.showToast(_(message), 3)
		else:	
			logger.info('Player]coverArtLoaderCallBack]song changed, abort')
			
	
	def showCover(self, isfilecover = False, picpath=''):

		self.values_for_cover_on_song = None

		if fileExists(picpath):
			logger.debug('Player]showCover]picpath:{}'.format(picpath))
			if not config.plugins.musiccenter.visualization.roundcover.value:
				self['coverArt'].doshow(picpath)
			else:
				self['coverArtround'].setCover(picpath)
			self.summaries.updateCover(picpath) #LCD
			if self.PixabayScreen:
				self.PixabayScreen.updateCover(picpath)

			slentry=self.getSonglistEntry() # Poster

			if isfilecover:

				filename=self.currentplayingslentry.filename

				if config.plugins.musiccenter.addcoverautotosong.value:
					self.values_for_cover_on_song=dict(coverfn=picpath, slentry=slentry)

				if fileExists(slentry.coverfn):
					logger.debug('Player]showCover]old coverthumb found, remove')
					os_remove(slentry.coverfn)

				logger.debug('Player]showCover]create new coverthumb')
				coverfn=CoverLoader().loadfromImageFile(filename, picpath)
				self.songlist[self._currentplayingindex][0].cover=1
				self.songlist[self._currentplayingindex][0].coverfn=coverfn

		else:
			error = 'Error show cover'
			logger.error('Player]showCover]error:{} picpath:{}'.format(error, picpath))
			self.showNoCover(error)
		#dublikates
		deferToThread(self.searchForDublicates,).addCallback(self.checkForDublicateShowResult,).addErrback(self.checkForDublicateError,)

				
	def showNoCover(self, message = ''):
		self.showCover(isfilecover = False, picpath=self.no_cover_fn)
		if message:
			self.session.toastManager.showToast(_(message), 3)


	def startArtistart(self, slentry, shazam_artist_image):
		self.hlp['slentry_for_artistart'] = (slentry, shazam_artist_image)
		self.onArtistArtWaitTimerTimeout()


	def onArtistArtWaitTimerTimeout(self):
		if self.artistartloaderinstance.isRunning:
			logger.info('Player]onArtistArtWaitTimerTimeout]start new timer')
			GlobalTimer(150, self.onArtistArtWaitTimerTimeout)
		else:
			logger.info('Player]onArtistArtWaitTimerTimeout]check song is leaved..')
			slentry, shazam_artist_image = self.hlp.get('slentry_for_artistart')
			if self.currentplayingslentry.songID == slentry.songID:
				self.artistartloaderinstance.Start(slentry.artist, slentry.songID, shazam_artist_image)


	def artistArtLoaderCallBack(self, msg):
		isrunned, id, pic_path, current_artist_directory, current_artist_directory_name, message, showtime = self.artistartloaderinstance.Message.pop()
		logger.debug('Player]artistArtLoaderCallBack]isrunned:{} id:{} pic_path{} current_artist_directory:{} current_artist_directory_name:{} message:{}'.format(isrunned, id, pic_path, current_artist_directory, current_artist_directory_name, message))
		if isrunned and id == self.currentplayingslentry.songID:
				self.current_artist_directory = current_artist_directory
				self.current_artist_directory_name = current_artist_directory_name
				self.showArtist(pic_path)

				if message is not None:
					self.session.toastManager.showToast(_(message), showtime)


	def showArtist(self, picpath='', startwave = True):
		if picpath!=self['artistArt'].currentpic:
			self['artistArt'].doshow(picpath)
		if startwave:
			self.checkWave()


	def showWaveFormNow(self, slentry):
		# called after song change, wave generate start after artistart is shown
		if slentry.wave == 1:
			wavefn=buildWaveFilename(slentry.filename)
			if not fileExists(wavefn):
				self.showWave(False)
				logger.debug('Player]showWaveFormNow]file has wave, hide wave, extract now')
			deferToThread(self.paintWaveformPNGNowonThread, slentry.filename, slentry.coverfn).addCallback(self.showWave,).addErrback(self.showWaveError)
		else:
			self.showWave(False)
			logger.debug('Player]showWaveFormNow]file has no wave, wave generate start after artistart is shown')


	def getID3SpecialFromFile(self, fn, what='wave'):
		logger.debug('Player]getID3SpecialFromFile]what:{}'.format(what))
		id3, filetype=getID3raw(fn)
		if what == 'wave':
			if id3:
				return getWavevalues(id3, filetype)
			else:
				return []
		elif what == 'youtube':
			if id3:
				return getYoutubeurl(id3, filetype)
			else:
				return ''


	def checkWave(self):

		slentry=self.getSonglistEntry()
		index=self._currentplayingindex
		len_of_songlist = len(self.songlist)
		
		if slentry.wave == 1:
			logger.debug('Player]checkWave]current song have wave, check next song')
			self.checkNextWave()
		else:
			if not self.calcWaveValusThreadInstance.isRunning:
				logger.debug('Player]checkWave]no wave thread is running start thread for new songID {}'.format(slentry.songID))
				self.calcWaveValusThreadInstance.Start(slentry, index, len_of_songlist)

			elif self.calcWaveValusThreadInstance.isRunning == slentry.songID:
				logger.debug('Player]checkWave]old wave thread is running for songID {} = new songID {}, let run...'.format(self.calcWaveValusThreadInstance.isRunning, slentry.songID))
			else:
				message='old wave thread is running for songID {} new songID {}, cancel old Thread now'.format(self.calcWaveValusThreadInstance.isRunning, slentry.songID)
				logger.debug('Player]checkWave]'+message)
				self.cancelCalcWaveThread(slentry, index, len_of_songlist, message)


	def cancelCalcWaveThread(self, slentry, index, len_of_songlist, message=''):
		logger.info('Player]cancelCalcWaveThread]old thread is running, cancel old threadinstance')
		self.calcWaveValusThreadInstance.cancel(message)
		logger.info('Player]cancelCalcWaveThread]wait now 100ms...')
		self.hlp['calcwavethreadvalues'] = (slentry, index, len_of_songlist)
		GlobalTimer(100, self.checkIsThreadCanceled)


	def checkIsThreadCanceled(self):
		if self.calcWaveValusThreadInstance.isRunning:
			logger.info('Player]checkIsThreadCanceled]old thread is running, restart new 100ms wait timer')
			GlobalTimer(100, self.checkIsThreadCanceled)
		else:
			logger.info('Player]checkIsThreadCanceledis ]ok, start new thread now')
			slentry, index, len_of_songlist = self.hlp.get('calcwavethreadvalues')
			self.calcWaveValusThreadInstance.Start(slentry, index, len_of_songlist)


	def waveformGeneratorCallBack(self, msg):
		index, slentry, wavevalues, len_of_songlist = self.calcWaveValusThreadInstance.Message.pop()
		logger.info('Player]waveformGeneratorCallBack]filename:{} wavevalues:{}'.format(slentry.filename, str(wavevalues)[:20]))

		if not isinstance(wavevalues, list): # error
			logger.error('Player]waveformGeneratorCallBack]canceled or error:{} for:{}'.format(wavevalues, slentry.filename))
			return

		id3dict={'wavevalues':wavevalues}
		musiccenterJobmanager.AddJob(ID3WriterJob(slentry, id3dict))

		if self.seekstate == self.SEEK_STATE_STOP:
			logger.debug('Player]waveformGeneratorCallBack]is stopPlay. Cancel')
			return

		if len_of_songlist ==  len(self.songlist):
			logger.debug('Player]waveformGeneratorCallBack]songlist is unchanged, find now id songID:{} wavesongfFilename:{}'.format(slentry.songID, slentry.filename))
		
			if slentry.songID == self.currentplayingslentry.songID:# is current song
				self.songlist[index][0].wave=1
				logger.debug('Player]waveformGeneratorCallBack]song is unchanged, show wave now and update songlist')
				self.findSilentParts(slentry, wavevalues)
				deferToThread(self.paintWaveformPNGNowonThread, slentry.filename, slentry.coverfn).addCallback(self.showWave,).addErrback(self.showWaveError)
				self.checkNextWave()
				return

			nextindex = self.getNextSonglistIndex(index)
			nextslentry = self.getSonglistEntry(nextindex)
			
			if slentry.songID == nextslentry.songID:# is next song
				logger.debug('Player]waveformGeneratorCallBack]update next song in songlist songID:{} nextindex:{} filename:{}'.format(slentry.songID, nextindex, nextslentry.filename))
				self.songlist[nextindex][0].wave=1
				deferToThread(self.paintWaveformPNGNowonThread, nextslentry.filename, nextslentry.coverfn)
				return
	
		logger.debug('Player]waveformGeneratorCallBack]songlist changed, find now songID:{} wavesongfFilename:{}'.format(slentry.songID, slentry.filename))
		deferToThread(self.replaceSonglistentryOnThread, self.songlist, slentry.songID).addErrback(self.replaceSonglistentryOnThreadErrback)


	def replaceSonglistentryOnThread(self, songlist, songID):
		logger.debug('Player]replaceSonglistentryOnThread]start')
		index=-1
		for i, v in enumerate(songlist):
			if v[0].songID == songID:
				index=i
				logger.debug('Player]replaceSonglistentryOnThread]found index:{}'.format(index))
				songlist=[]
				self.songlist[index][0].wave=1
				break


	def replaceSonglistentryOnThreadErrback(self, error):
		logger.error('Player]replaceSonglistentryOnThreadErrback]:{}'.format(error))


	def checkNextWave(self):

		index = self.getNextSonglistIndex(self._currentplayingindex)
		nextslentry = self.songlist[index][0]
		len_of_songlist = len(self.songlist)

		if nextslentry.wave:
			wavefn=buildWaveFilename(nextslentry.filename)
			if not fileExists(wavefn):
				logger.debug('Player]checkNextWave]file has wave, paint wave now')
				deferToThread(self.paintWaveformPNGNowonThread, nextslentry.filename, nextslentry.coverfn).addErrback(self.showWaveError)
			else:
				logger.debug('Player]checkNextWave]wavefile exist done...')

		else:
			logger.debug('Player]checkNextWave]next wave missing, start new calcthread')
			if not self.calcWaveValusThreadInstance.isRunning:
				logger.debug('Player]checkWave]no wave thread is running start thread for new songID {}'.format(nextslentry.songID))
				self.calcWaveValusThreadInstance.Start(nextslentry, index, len_of_songlist)

			elif self.calcWaveValusThreadInstance.isRunning == nextslentry.songID:
				logger.debug('Player]checkNextWave]old wave thread is running for songID {} = new songID {}, let run...'.format(self.calcWaveValusThreadInstance.isRunning, nextslentry.songID))
			else:
				message='old wave thread is running for songID {} new songID {}, cancel old Thread now'.format(self.calcWaveValusThreadInstance.isRunning, nextslentry.songID)
				logger.debug('Player]checkNextWave]'+message)
				self.cancelCalcWaveThread(nextslentry, index, len_of_songlist, message)


	def showWave(self, returnvalue):
		if isinstance(returnvalue, tuple):
			iswave, wavefn, pointerfn, bgcolor=returnvalue
			logger.debug('Player]showWave]iswave:{}, wavefn:{} pointerfn:{} bgcolor:{}'.format(iswave, wavefn, pointerfn, bgcolor))

			self['wave'].instance.setPixmap(LoadPixmap(wavefn))
			self['wave'].show()

			ptr=LoadPixmap(pointerfn)
			bghtml='#%02x%02x%02x' % bgcolor[:3] # no alphablend
			self['PositionGauge'].instance.setBackgroundColor(parseColor(bghtml))
			#				ePositionGauge.setPointer(which, None, center) is deprecated please use
			#				ePositionGauge.setPointer(which, enigma.gPixmapPtr(), center)
			if ptr is not None:
				self['PositionGauge'].instance.setPointer(0, ptr,ePoint(self.wavelen, self.waveheigth/2)) #pointer=0, seek_pointer=1 und progress_pointer=2
			else:
				logger.error('Player]showWave]no ptr for pointerfn:{}?'.format(pointerfn))
			self['PositionGauge'].show()

			if self.hlp.get('searchCoversandWavesFromPlaylist'):
				if self._currentplayingindex!=self.hlp.get('searchCoversandWavesFromPlaylist'):
					logger.debug('Player]is searchCoversandWavesFromPlaylist]wait 5000, then start next song')
					self.searchCoversandWavesFromPlaylistTimer.start(5000, 1)
				else:
					logger.debug('Player]is searchCoversandWavesFromPlaylist]index match, cancel searchCoversandWavesFromPlaylist')
					self.cancelSearchCoversandWavesFromPlaylist()
		else:
			self['PositionGauge'].hide()
			self['wave'].hide()

		self.getNextJukeboxEntries()


	def getNextJukeboxEntries(self):
		if self.playermode in (DBMODE,) and not self.shuffle:
			if self._currentplayingindex+5 >= len(self.songlist):
				if self.jukeboxinstance is not None:
					logger.debug('Player]showWave]jukeboxinstance.getNextEntries...')
					self.jukeboxinstance.getNextEntries(False)


	def showWaveError(self, error):
		logger.error('Player]showWaveError]:{}'.format(error))


	def paintWaveformPNGNowonThread(self, filename='', coverfn=''):
		logger.debug('Player]paintWaveformPNGNowonThread]filename:{} coverfilename:{}'.format(filename, coverfn))
		if fileExists(coverfn):
			fgcolor, bgcolor=calcPointerColors(coverfn)
		else:
			fgcolor, bgcolor=(189,156,24),(255,255,255)

		wavefn=buildWaveFilename(filename)
		if not fileExists(wavefn):
			wavevalues=self.getID3SpecialFromFile(filename)
			paintWaveformPicture(filename, wavevalues)

		wavecolor='_'.join([str(i) for i in fgcolor])
		pointerfn = os_path_join(config.plugins.musiccenter.downloadcache.value, "waves/", ''.join(('.{}.png'.format(wavecolor))))
		
		if not fileExists(pointerfn):
			logger.debug('Player]paintWaveformPNGNowonThread]create pointer picture:'+pointerfn)
			im=Image.new('RGB',(self.wavelen, self.waveheigth*2), fgcolor)
			im.save(pointerfn)

		return (True, wavefn, pointerfn, bgcolor)

		
	def buildPointerFilename(self, color): #old unused
		color='_'.join([str(i) for i in color])
		return os_path_join(config.plugins.musiccenter.downloadcache.value, "waves/", ''.join(('.{}.png'.format(color))))


	def __evAudioDecodeError(self, isTrue = True):
		currPlay=self.session.nav.getCurrentService()
		sAudioType=currPlay.info().getInfoString(iServiceInformation.sUser+10)
		logger.error("Player]__evAudioDecodeError]audio-codec %s can't be decoded by hardware" % (sAudioType))
		self['youtube'].hide()			
		if not isTrue:
			self.session.open(MessageBox, _("This Dreambox can't decode %s streams!") % sAudioType, type=MessageBox.TYPE_INFO, title='MusicCenter',timeout=10 )


	def __evPluginError(self):
		currPlay=self.session.nav.getCurrentService()
		message=currPlay.info().getInfoString(iServiceInformation.sUser+12)
		self['youtube'].hide()			
		logger.error('Player]__evPluginError]Error: %s' %message)
		self.session.open(MessageBox, message, type=MessageBox.TYPE_ERROR, title='MusicCenter',timeout=20 )


	def doEofInternal(self, playing):
		logger.debug('Player]doEofInternal]Start, playNext:{}'.format(playing))
		if playing:
			self.playNext()


	def checkSkipShowHideLock(self): # InfoBarSeek n�tig???
		pass


	def doSeekRelative(self, pts): # InfoBarSeek n�tig???
		skiptime=pts+self.hlp.get('skiptime',0)
		self.hlp['skiptime']=skiptime
		#logger.debug('Player]doSeekRelative]skiptime->%s' %skiptime)
		seekable=self.getSeek()
		if seekable is None:
			return
		prevstate=self.seekstate
		if self.seekstate == self.SEEK_STATE_EOF:
			if prevstate == self.SEEK_STATE_PAUSE:
				self.setSeekState(self.SEEK_STATE_PAUSE)
			else:
				self.setSeekState(self.SEEK_STATE_PLAY)
		seekable.seekRelative(pts<0 and -1 or 1, abs(pts))
		if abs(pts) > 100 and config.usage.show_infobar_on_skip.value:
			self.showAfterSeek()


	def pauseEntry(self):			
		logger.debug('Player]pauseEntry]seekstate:{} SEEK_STATE_PAUSE:{} SEEK_STATE_PLAY:{}'.format(self.seekstate, self.SEEK_STATE_PAUSE, self.SEEK_STATE_PLAY))		
		if self.seekstate == self.SEEK_STATE_PLAY:
			self.setPause()
		elif self.seekstate == self.SEEK_STATE_PAUSE:
			self.setUnpause()


	def setPause(self):
		self.pauseService()
		logger.debug('Player]pauseEntry]seekstate:{} SEEK_STATE_PAUSE:{} SEEK_STATE_PLAY:{}'.format(self.seekstate, self.SEEK_STATE_PAUSE, self.SEEK_STATE_PLAY))
		if config.plugins.musiccenter.visualization.rms.value:
			self['rms0'].hide()
			self['rms1'].hide()
			
		for art in ('coverArt', 'artistArt'):
			picpath=self[art].currentpic
			self.hlp[art]=picpath
			if picpath:
				im=Image.open(picpath).convert('RGB')
				stat=ImageStat.Stat(im)
				if sum(stat.sum)/3 == stat.sum[0]:
					im=im.point(lambda p: p > 160 and 255)
				else:
					r, g, b=im.split()
					im=Image.merge('RGB', (g,g,g))
				tmp='/tmp/mc/merged_{}.jpg'.format(art)
				im.save(tmp)
				self[art].doshow(tmp)


	def setUnpause(self):
		self.unPauseService()
		logger.debug('Player]pauseEntry]seekstate:{} SEEK_STATE_PAUSE:{} SEEK_STATE_PLAY:{}'.format(self.seekstate, self.SEEK_STATE_PAUSE, self.SEEK_STATE_PLAY))

		if config.plugins.musiccenter.visualization.rms.value:
			self['rms0'].show()
			self['rms1'].show()

		for art in ('coverArt', 'artistArt'):
			picpath=self.hlp.get(art)
			if picpath:
				logger.debug('Player]setUnpause]picpath:{}'.format(picpath))
				self[art].doshow(picpath)


	def play(self):
		logger.debug('Player]play]play the current song from beginning again')
		self.playSong(self._currentplayingindex)


	def stopPlay(self):
		logger.info('Player]stopPlay]start')

		try: # empty list
			if self.songlist:
				slentry=self.getSonglistEntry()
				self.updateRatingPlaycounterWaveCover(slentry, True)
		except:
			logger.exception('Player]stopPlay]exception...')
		ret=self.setSeekState(self.SEEK_STATE_STOP, onlyGUI = True)
		logger.debug('Player]stopPlay]stopService set SEEK_STATE_STOP {} self.seekstate {}'.format(ret, self.seekstate))
		self.session.nav.stopService()
		logger.debug('Player]stopPlay]clear songlist now...')
		self.songlistorig=[]
		self.songlist=[]
		self.repeat = False
		self['repeat'].hide()
		self.shuffle = False
		self['shuffle'].hide()
		self.close()


	def rightPressed(self):
		if self.embededsonglistisshown == 'list':
			self.currembededlist.pageDown()
		elif self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.MoveRight()
		else:
			self.playNext()


	def playNext(self):
		self.updateRatingPlaycounterWaveCover()
		if not self.repeat:
			self._currentplayingindex=self.getNextSonglistIndex(self._currentplayingindex)
		logger.debug('Player]playNext]index:{}'.format(self._currentplayingindex))
		self.playSong(self._currentplayingindex)


	def leftPressed(self):
		if self.embededsonglistisshown is False:
			self.playLast()
		elif self.embededsonglistisshown == 'list':
			self.currembededlist.pageUp()
		elif self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.MoveLeft()


	def playLast(self):
		self.updateRatingPlaycounterWaveCover()
		if not self.repeat:
			if self._currentplayingindex-1 < 0:
				self._currentplayingindex=len(self.songlist) - 1
			else:
				self._currentplayingindex-= 1
		self.playSong(self._currentplayingindex)


	def shuffleList(self):
		if self.embededsonglistisshown:
			if self.embededsonglistisshown in('2dlist', 'coverwall'):
				self.currembededlist.NextPage()		
		else:
			self.shuffle = not self.shuffle
			if self.shuffle:
				self['shuffle'].show()
				if not self.hlp.get('filtered', False):
					self.songlistorig=self.songlist[:]
				shuffle(self.songlist)
			else:
				self.songlist=self.songlistorig[:]
				if not self.hlp.get('filtered', False):
					self.songlistorig=[]
				self['shuffle'].hide()
			index=0
			for x in self.songlist:
				if x[0].songID == self.currentplayingslentry.songID:
					self._currentplayingindex=index
					break
				index += 1


	def repeatSong(self):
		if self.embededsonglistisshown:
			if self.embededsonglistisshown in('2dlist', 'coverwall'):
				self.currembededlist.PreviousPage()		
		else:	
			self.repeat = not self.repeat
			if self.repeat:
				self['repeat'].show()
			else:
				self['repeat'].hide()


	def updateLocationInfo(self, index=0):
		if self.updateLocationInfotimer.isActive():
			self.updateLocationInfotimer.stop()
		self.updateLocationInfotimer.start(450, 1)
		self.selindex=index


	def updateLocationtimerAppend(self):
		if self.embededsonglistisshown == 'list':
			self.songlistSimpleSelChanged()
		else:
			self.songlist2DSelChanged(self.selindex)
		self.resetScreenSaverTimer(restart = True)


	def showSongListUp(self):
		if self.embededsonglistisshown == 'list':
			self.currembededlist.up()
		elif self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.MoveUp()
		else:				
			if self.videomax:
				self.minVideo()
			self.showhideEmbededSonglist()


	def showSongListDown(self):
		if self.embededsonglistisshown == 'list':
			self.currembededlist.down()
		elif self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.MoveDown()
		else:
			if self.videomax:
				self.minVideo()

			self.showhideEmbededSonglist()


	def showhideEmbededSonglist(self):
		#("list", _("list")), ("2dlist", _("2D Coverflow")), ("coverwall", _("Coverwall"))
		if self.embededsonglistisshown:
			self.setButtons()
			if self.isplayyoutube or self.isplayyoutubethissong:
				self.showhideartistvisuElements('hide')
				self['youtube'].show()
			else:
				self.showhideartistvisuElements('show')

			self['coverArt'].show()

			if self['slpage'].getVisible():
				self['slpage'].hide()
			self.currembededlist.hide()
			self.embededsonglistisshown = False

		else: #-> show now songlist
			self.setButtons('', 'Reveret sort order', 'Sort list', 'Select Liststyle')
			
			for element in ('visufilemode', 'rms0', 'rms1', 'coverArtround', 'coverArt', 'artistArt'):
				if self[element].getVisible():
					self[element].hide()				
			self['youtube'].hide()

			if self.dublicate_search or config.plugins.musiccenter.songliststyle.value == 'list':
				self['slpage'].hide()
				self.embededsonglistisshown='list'
				self['embededSonglistSimplelist'].show()
				if self.dublicate_search:
					self['embededSonglistSimplelist'].setList(self.dublicate_search)
					self['embededSonglistSimplelist'].moveToIndex(0)
				else:
					self['embededSonglistSimplelist'].setList(self.songlist)
					self['embededSonglistSimplelist'].moveToIndex(self._currentplayingindex)				
				self.currembededlist=self['embededSonglistSimplelist']

			elif config.plugins.musiccenter.songliststyle.value == '2dlist':
				self['slpage'].hide()
				self.embededsonglistisshown='2dlist'
				self.buildAndShowCoverFlowlist(self._currentplayingindex)

			elif config.plugins.musiccenter.songliststyle.value == 'coverwall':
				self['slpage'].show()
				self.embededsonglistisshown='coverwall'
				self.buildAndShowCoverFlowlist(self._currentplayingindex)

			else:
				logger.error('Player]showhideEmbededSonglist]why here?')


	def errorCoverLoader(self, error):
		logger.error('Player]errorCoverLoader]->%s' %error)


	def buildAndShowCoverFlowlist(self, selectedindex):
		#logger.debug('Player]buildAndShowCoverFlowlist]embededsonglistisshown {}'.format(self.embededsonglistisshown))
		list=[]
		covers=[]
		for fake, slentry in enumerate(self.songlist):
			cover=slentry[0].coverfn
			covers.append(cover)
		logger.debug('Player]buildAndShowCoverFlowlist]set collection')
		if self.embededsonglistisshown == '2dlist':
			logger.debug('Player]buildAndShowCoverFlowlist]set collection-> 2dlist')
			self.currembededlist=self['embededSonglist2DFlow']
		elif self.embededsonglistisshown == 'coverwall':
			logger.debug('Player]buildAndShowCoverFlowlist]set collection-> coverwall')
			self.currembededlist=self['embededSonglistCoverwall']
		else:
			logger.error('Player]buildAndShowCoverFlowlist]uihh, what is wrong?')
			return
		self.currembededlist.setList(list, covers, selectedindex)
		self.currembededlist.show()


	def songlist2DSelChanged(self, index):
		slentry=self.songlist[index][0]
		self.updateMusicInformation(slentry=slentry)
		self.summaries.updateCover(slentry.coverfn)
		self['slpage'].setText(_('Page {} | {}'.format(self.currembededlist.getCurrentPage(), self.currembededlist.getTotalPages())))


	def songlistSimpleSelChanged(self):
		slentry = self['embededSonglistSimplelist'].getCurrent()
		if slentry is not None:
			slalbum_year_albumartist, slplaycount = joinDisplaytextFiles(slentry)
			#lcd
			self.summaries.updateSlentry(slentry)
			self.summaries.updateCover(slentry.coverfn)


	def removeSongFromList(self, index = None):
		if index is None:
			index = self.currembededlist.getCurrentIndex()

		if self.dublicate_search:
			del self.dublicate_search[index]
			self.currembededlist.setList(self.dublicate_search)
			if index < len(self.dublicate_search):
				self.currembededlist.moveToIndex(index)
			else:
				if len(self.dublicate_search)> 1:
					self.currembededlist.moveToIndex(index-1)
				else:
					self.currembededlist.moveToIndex(0)
				
		else:
			del self.songlist[index]
			self.showhideEmbededSonglist()
			self.showhideEmbededSonglist()


	def removeSongFromListAndDisc(self):
	
		index = self.currembededlist.getCurrentIndex()
		if self.dublicate_search:
			l = len(self.songlist)
			slentry = self.currembededlist.getCurrent()
			fn = os_path_realpath(slentry.filename)
		else:
			l = self.currembededlist.getItemCount()
			fn = os_path_realpath(self.songlist[index][0].filename)
		
		logger.debug('Player]removeSongFromListAndDisc]index:{} len:{} songfilename:{}'.format(index, l, fn)) 
		
		if l > 1:
			logger.debug('Player]removeSongFromListAndDisc]%s' %fn)
			songID = self.songlist[index][0].songID
			deferToThread(JCdeleteSongfileonThread, fn, songID).addCallback(self.finishedremoveSongFromListAndDisc,).addErrback(self.errorremoveSongFromListAndDisc,)
			self.removeSongFromList(index)
			
		elif l == 1 and not self.dublicate_search:
			self.hlp['slentry_and_index_for_delete']=(self.getSonglistEntry(), index)
			self.deleteSelectedSong()


	def finishedremoveSongFromListAndDisc(self, result):
		logger.debug('Player]removeSongFromListAndDisc]result:{}'.format(result))


	def errorremoveSongFromListAndDisc(self, error):
		logger.error('Player]errorremoveSongFromListAndDisc]{}'.format(error))


	def bluePressed(self):
		self.resetScreenSaverTimer(restart = True)
		logger.debug('Player]bluePressed]...')
		options=[]
		if self.embededsonglistisshown:
			logger.debug('Player]bluePressed]is embededsonglistisshown, show selections')
			if config.plugins.musiccenter.songliststyle.value!='list':
				options.append((_('Style: Listbox High'), 'list'),)
			if config.plugins.musiccenter.songliststyle.value!='2dlist':
				options.append((_('Style: 2D Coverflow'), '2dlist'),)
			if config.plugins.musiccenter.songliststyle.value!='coverwall':
				options.append((_('Style: Coverwall'), 'coverwall'),)
				
			self.session.openWithCallback(self.bluePressedCallback, ChoiceBox, title=_('Select style...'), list=options,keys=MYKEYSORT, titlebartext=_('MusicCenter'))
		else:
			self.showDublicatesNow()


	def bluePressedCallback(self, ret):
		if ret:
			logger.debug('Player]bluePressedCallback]{}'.format(ret))
			config.plugins.musiccenter.songliststyle.value=ret[1]
			config.plugins.musiccenter.songliststyle.save()
			configfile.save()
			if self.embededsonglistisshown!=config.plugins.musiccenter.songliststyle.value:
				logger.debug('Player]bluePressedCallback]liststyle changed, update list')
				self.showhideEmbededSonglist()
				self.showhideEmbededSonglist()


	def searchForDublicates(self,):
		def fitit(string):
			return string.lower().split('feat',1)[0].split(' ft',1)[0].rsplit('(',1)[0].strip().replace("'", "''").replace(" ", "%")
			
		sql = '''SELECT * FROM Songs WHERE artist LIKE '%%{}%%' AND title LIKE '%%{}%%';'''.format(fitit(self.currentplayingslentry.artist), fitit(self.currentplayingslentry.title))
		logger.debug('Player]searchForDublicates]sql:{}'.format(sql))
		#  COLLATE NOCASE
		dublicates = []
		for row in execSQLCommandWithReturn(sql):
			slentry = buildSonglistEntry(row)
			dublicates.append((slentry,))
	
		return dublicates


	def checkForDublicateShowResult(self, dublicates):
		logger.debug('Player]checkForDublicateShowResult]dublicates:{}'.format(dublicates))
		if dublicates and len(dublicates) >1:
			self['key_blue'].setText('{} Dublicates'.format(len(dublicates)-1))
		else:
			self['key_blue'].setText('No Dublicates')
		#GlobalTimer(15000, self.introTimerTimeout)


	def checkForDublicateError(self, error):
		logger.error('Player]checkForDublicateError]{}'.format(error))
		
	
	def showDublicatesNow(self):
		self.dublicate_search = self.searchForDublicates()
		logger.debug('Player]showDublicatesNow]{}'.format(self.dublicate_search))
			
		if self.dublicate_search and len(self.dublicate_search) > 1:
			self.showhideEmbededSonglist()
		else:
			self.session.open(MessageBox, _('No dublicate found'), type=MessageBox.TYPE_INFO, title='MusicCenter',timeout=5)
			self.dublicate_search = []
			

	def redPressed(self):
		self.resetScreenSaverTimer(restart = True)
		if not self.embededsonglistisshown:
			options=[]

			if not config.plugins.musiccenter.visualization.rms.value:
				options.append((_('Show RMS Meter'), self.changeRMSMeter),)
			else:
				options.append((_('Hide RMS Meter'), self.changeRMSMeter),)

			if not config.plugins.musiccenter.visualization.spectrum_small.value:
				options.append((_('Show Spectrumanalyser small'), self.changeSpectrumSmall),)
			else:
				options.append((_('Hide Spectrumanalyser small'), self.changeSpectrumSmall),)

			if not config.plugins.musiccenter.visualization.roundcover.value:
				options.append((_('Show Round Cover animated'), self.changeRoundCover),)
			else:
				options.append((_('Show square Cover'), self.changeRoundCover),)

			if options:
				self.session.openWithCallback(self.globalCallback, ChoiceBox, title=_('Animation Options'), list=options, keys=MYKEYSORT, titlebartext=_('MusicCenter'))


	def changeRMSMeter(self):
		config.plugins.musiccenter.visualization.rms.value = not config.plugins.musiccenter.visualization.rms.value
		config.plugins.musiccenter.visualization.roundcover.value = False
		config.plugins.musiccenter.visualization.spectrum_small.value = False
		self.saveNewConfig()


	def changeRoundCover(self):
		config.plugins.musiccenter.visualization.rms.value = False
		config.plugins.musiccenter.visualization.roundcover.value = not config.plugins.musiccenter.visualization.roundcover.value
		config.plugins.musiccenter.visualization.spectrum_small.value = False
		self.saveNewConfig()


	def changeSpectrumSmall(self):
		config.plugins.musiccenter.visualization.rms.value = False
		config.plugins.musiccenter.visualization.roundcover.value = False
		config.plugins.musiccenter.visualization.spectrum_small.value = not config.plugins.musiccenter.visualization.spectrum_small.value
		self.saveNewConfig()


	def saveNewConfig(self):
		config.plugins.musiccenter.save()
		configfile.save()
		self.setVisualisation()


	def greenPressed(self):
		self.resetScreenSaverTimer(restart = True)
		if self.embededsonglistisshown:
			self.songlist.reverse()
			currsongID=self.getSonglistEntry().songID
			logger.debug('Player]sortSonglistByTrack]get currsongID:{}'.format(currsongID))
			self.updateEmbededSonglist(currsongID)
		else:
			options=[]
			
			if not self.isplayyoutube:
				options.append((_('Set youtube playermode'), self.changePlayermode),)
			else:
				options.append((_('Set standard playermode'), self.changePlayermode),)
			if not config.plugins.musiccenter.gapplessplayback.value:
				options.append((_('Set Gappless Playback'), self.changeGapplessPlayback),)
			else:
				options.append((_('Set normal Playback'), self.changeGapplessPlayback),)
			if not config.plugins.musiccenter.detectsilence.value:
				options.append((_('Skip on silent end of songs'), self.changeDetectSilence),)
			else:
				options.append((_('Don`t skip on silence on end of songs'), self.changeDetectSilence),)
				
			if options:
				self.session.openWithCallback(self.globalCallback, ChoiceBox, title=_('Playbackoptions'), list=options, keys=MYKEYSORT, titlebartext=_('MusicCenter'))


	def changePlayermode(self):
 		self.isplayyoutube = not self.isplayyoutube
		self.saveNewConfig()
		ref = eServiceReference(0x1013, 0, '/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/music')
		self.session.nav.playService(ref)
		self.playSong(self._currentplayingindex)


	def changeDetectSilence(self):
		config.plugins.musiccenter.detectsilence.value = not config.plugins.musiccenter.detectsilence.value
		config.plugins.musiccenter.detectsilence.save()
		configfile.save()


	def yellowPressed(self):
		self.resetScreenSaverTimer(restart = True)

		options=[]
		
		if self.embededsonglistisshown:
			options.append((_('Sort Songlist by Tracknr'), self.sortSonglistByTrack),)
			options.append((_('Sort Songlist by Title'), self.sortSonglistByTitle),)
			options.append((_('Sort Songlist by Artist'), self.sortSonglistByArtist),)
			options.append((_('Sort Songlist by Album'), self.sortSonglistByAlbum),)
			options.append((_('Sort Songlist by Date'), self.sortSonglistByDate),)
			options.append((_('Sort Songlist by Genre'), self.sortSonglistByGenre),)
			options.append((_('Sort Songlist by Favorite'), self.sortSonglistByFavorite),)
			self.session.openWithCallback(self.globalCallback, ChoiceBox, title=_('Sort Songlist'), list=options,keys=MYKEYSORT, titlebartext=_('MusicCenter'))
			
		else:
			slentry=self.getSonglistEntry()
			options.append((_('New Shazam song search'), self.startShazamTrackResearch, slentry),)
			options.append((_('New Shazam artist search'), self.startShazamArtistResearch, slentry),)
			
		self.session.openWithCallback(self.globalCallback, ChoiceBox, title=_('Shazam'), list=options, keys=MYKEYSORT, titlebartext=_('MusicCenter'))
	

	def sortSonglistByTrack(self):
		currsongID=self.getSonglistEntry().songID
		logger.debug('Player]sortSonglistByTrack]get currsongID:{}'.format(currsongID))
		self.songlist.sort(key=lambda a:a[0].track)
		self.updateEmbededSonglist(currsongID)


	def sortSonglistByArtist(self):
		currsongID=self.getSonglistEntry().songID
		logger.debug('Player]sortSonglistByArtist]get currsongID:{}'.format(currsongID))
		self.songlist.sort(key=lambda a:a[0].artist)
		self.updateEmbededSonglist(currsongID)


	def sortSonglistByTitle(self):
		currsongID=self.getSonglistEntry().songID
		logger.debug('Player]sortSonglistByTitle]get currsongID:{}'.format(currsongID))
		self.songlist.sort(key=lambda a:a[0].title)
		self.updateEmbededSonglist(currsongID)


	def sortSonglistByAlbum(self):
		currsongID=self.getSonglistEntry().songID
		logger.debug('Player]sortSonglistByAlbum]get currsongID:{}'.format(currsongID))
		self.songlist.sort(key=lambda a:a[0].album)
		self.updateEmbededSonglist(currsongID)


	def sortSonglistByDate(self):
		currsongID=self.getSonglistEntry().songID
		logger.debug('Player]sortSonglistByDate]get currsongID:{}'.format(currsongID))
		self.songlist.sort(key=lambda a:a[0].date)
		self.updateEmbededSonglist(currsongID)


	def sortSonglistByGenre(self):
		currsongID=self.getSonglistEntry().songID
		logger.debug('Player]sortSonglistByGenre]get currsongID:{}'.format(currsongID))
		self.songlist.sort(key=lambda a:a[0].genre)
		self.updateEmbededSonglist(currsongID)


	def sortSonglistByFavorite(self):
		currsongID=self.getSonglistEntry().songID
		logger.debug('Player]sortSonglistByFavorite]get currsongID:{}'.format(currsongID))
		self.songlist.sort(key=lambda a:a[0].rating)
		self.updateEmbededSonglist(currsongID)


	def updateEmbededSonglist(self, currsongID):
		new_songList_Index=[ song[0].songID for song in self.songlist].index(currsongID)
		logger.debug('Player]updateEmbededSonglist]set list and move to new_songList_Index:{}'.format(new_songList_Index))
		if self.embededsonglistisshown == 'list':
			self.currembededlist.setList(self.songlist)
			self.currembededlist.moveToIndex(new_songList_Index)
		elif self.embededsonglistisshown in ('2dlist', 'coverwall'):
			self.buildAndShowCoverFlowlist(new_songList_Index)
		self._currentplayingindex=new_songList_Index


	def startPicshow(self):
		self.resetScreenSaverTimer(restart = True)
		from Plugins.Extensions.PicturePlayer.plugin import picshow
		self.session.open(picshow)


	def startPicshow2(self):
		self.resetScreenSaverTimer(restart = True)
		from Plugins.Extensions.PicturePlayer2 import pictureplayer2
		self.session.open(pictureplayer2.picshow2)


	def updateRatingPlaycounterWaveCover(self, slentry = None, iscloseplayer = False):

		index = self._currentplayingindex
		logger.debug('Player]updateRatingPlaycounterWaveCover]index:{} start...'.format(index))
		self.isplayyoutubethissong = False

		if  not self.hlp.get('reload',False):

			if slentry is None:
				slentry=self.getSonglistEntry()

			playcountertriggerprozent=int(config.plugins.musiccenter.playcountertriggerprozent.value)
			playcountertriggertime=int(config.plugins.musiccenter.playcountertriggertime.value)
			length, playstate=self['PositionGauge'].get()
			rating_changed=self.hlp.pop('rating_changed',False)
			skiptime=self.hlp.get('skiptime')
			values_for_cover_on_song=self.values_for_cover_on_song
			self.values_for_cover_on_song = None

			t = deferToThread(self.updateRatingPlaycounterWaveCoverOnThread, slentry, playcountertriggerprozent, playcountertriggertime, length, playstate, rating_changed, skiptime, values_for_cover_on_song, index)
			if not iscloseplayer:
				t.addCallback(self.updateRatingPlaycounterWaveCoverOnThreadCB)
			t.addErrback(self.updateRatingPlaycounterWaveCoverOnThreadErrorCB)
			

	def updateRatingPlaycounterWaveCoverOnThread(self, slentry, playcountertriggerprozent, playcountertriggertime, length, playstate, rating_changed, skiptime, values_for_cover_on_song, index):
		if values_for_cover_on_song:
			vfcos = True
		else:
			vfcos = False
		logger.info('Player]updateRatingPlaycounterWaveCoverOnThread]songID{} rating_changed:{} length:{} playstate:{} values_for_cover_on_song:{}'.format(slentry.songID, rating_changed, length, playstate, vfcos))

		id3dict={}

		if slentry.filetype in ('MP3','FLAC', 'OGG', 'M4A'):

			id3_for_action, filetype=getID3raw(slentry.filename, will_write = True)

			if playcountertriggerprozent!=0 or playcountertriggertime!=0 :
				logger.debug('Player]updateRatingPlaycounterWaveCoverOnThread]playstate:{} length:{} skiptime:{}'.format(playstate, length, skiptime))
				if skiptime is not None:
					playstate-=skiptime
				if playstate>0 and length>0 and playstate*100/length > playcountertriggerprozent or  playstate/90000/60.0 > playcountertriggertime:
					id3dict['playcount']=slentry.playcount+1

			if rating_changed:
				logger.debug('Player]updateRatingPlaycounterWaveCoverOnThread]rating is changed:{}'.format(slentry.rating))
				id3dict['rating']=slentry.rating

			if values_for_cover_on_song:
				logger.debug('Player]updateRatingPlaycounterWaveCoverOnThread]values_for_cover_on_song ID3tags found')
				id3dict['cover']=values_for_cover_on_song['coverfn']

			if id3dict.keys():
				return id3dict, slentry, index

		else:
			logger.error('Player]updateRatingPlaycounterWaveCoverOnThread]not supported filetype, break:{}'.format(slentry.filename))

		return None


	def updateRatingPlaycounterWaveCoverOnThreadCB(self, result):
		if result is not None:
			id3dict, slentry, index = result
			logger.debug('Player]updateRatingPlaycounterWaveCoverOnThreadCB]add job for songID{}'.format(slentry.songID))
			musiccenterJobmanager.AddJob(ID3WriterJob(slentry, id3dict))
			if id3dict.get('playcount'):
				logger.debug('Player]updateRatingPlaycounterWaveCoverOnThreadCB]set new playcount:{}'.format(id3dict.get('playcount')))
				self.songlist[index][0].playcount = id3dict.get('playcount')
				


	def updateRatingPlaycounterWaveCoverOnThreadErrorCB(self, error):
		logger.error('Player]updateRatingPlaycounterWaveCoverOnThreadErrorCB]{}'.format(error))


	def getNextSonglistIndex(self, index):
		if index +1 > len(self.songlist) -1:
			return 0
		else:
			return index+1


	def getSonglistEntry(self, index = None):
		try:
			if index is None:
				return self.songlist[self._currentplayingindex][0]
			else:
				return self.songlist[index][0]
		except:
			logger.exception('Player]getSonglistEntry]no Songlist? len {} index {} self._currentplayingindex {}! Return default Item!'.format(len(self.songlist), index, self._currentplayingindex))
			return Item()


	def onScreenSaverTimerTimeout(self):
		if not self.isplayyoutube and not self.isplayyoutubethissong:
			self.resetScreenSaverTimer(restart = False)
			logger.debug('Player]onScreenSaverTimerTimeout]start Pixabay')
			if self.PixabayScreen:
				logger.debug('Player]onScreenSaverTimerTimeout]delete old dialog')
				self.session.deleteDialog(self.PixabayScreen)
				self.PixabayScreen = None

			if JCcheckModuleIsUpdated('Pixabay'):
				reload(Pixabay)
			self.PixabayScreen=self.session.instantiateDialog(Pixabay.Pixabay, self)
			self.session.execDialog(self.PixabayScreen)
			
		else:
			self.maxVideo()

	
	def closePixabayScreen(self):
		logger.debug('Player]closePixabayScreen]...')
		self.tmptimer = eTimer()
		self.tt_conn = self.tmptimer.timeout.connect(self.onClosePixabayScreenTimeout)
		self.tmptimer.start(500, 1)
		
		
	def onClosePixabayScreenTimeout(self):
		if self.PixabayScreen:
			logger.debug('Player]closePixabayScreen]now...')
			self.session.deleteDialog(self.PixabayScreen)
			self.PixabayScreen = None
		self.tt_conn = None
		self.tmptimer = None
		
				
	def setButtons(self, red='', green='', yellow='', blue=''):
		self['key_red'].setText(red)
		self['key_green'].setText(green)
		self['key_yellow'].setText(yellow)
		if blue != '':
			self['key_blue'].setText(blue)


	def closePlayer(self):# called on exit and player running continius...
		self.resetScreenSaverTimer(restart = False)
		if self.embededsonglistisshown:
			logger.debug('Player]closePlayer]embededsonglist is shown, hideEmbededSonglist now')
			self.showhideEmbededSonglist()
			self.updateMusicInformation(slentry = self.currentplayingslentry)
			self.setButtons('Visualisations','Playmodes', 'Shazam', '')
			#GlobalTimer(15000, self.introTimerTimeout)
			self.dublicate_search = []
			deferToThread(self.searchForDublicates,).addCallback(self.checkForDublicateShowResult,).addErrback(self.checkForDublicateError,)
		else:
			if self.videomax:
				self.minVideo()
				return
			self.close()


	def __onClose(self):
		logger.info('Player]__onClose]...')
		self.closePixabayScreen()

		self.screenSaverTimer_mc_conn = None
		eMerlinMusicPlayer.getInstance().setFunc(None)
		self.musicinfoupdatetimer_mc_conn = None
		self.wg_conn = None
		self.coverartloaderinstance = None
		self.shazamresolverinstance = None
		self.sr_conn = None
		self.artistartloaderinstance = None
		self.ca_conn = None
		self.ca_t_conn = None

		if self.calcWaveValusThreadInstance.isRunning:
			logger.info('Player]__onClose]calcWaveValusThreadInstance is running, cancel!')
			self.calcWaveValusThreadInstance.cancel('Player]__onClose]calcWaveValusThreadInstance is running, cancel!')
		self.calcWaveValusThreadInstance = None
		
		logger.debug('Player]__onClose]del ePixmaps...')
		del self['coverArt'], self['artistArt'], self['coverArtround']


	def createSummary(self):
		if JCcheckModuleIsUpdated('LCDScreens'):
			reload(LCDScreens)
		return LCDScreens.LCDPlayer
