# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.
#from __future__ import unicode_literals



from Globals import *
import EditID3
from ItemClasses import Item
import LCDScreens
import Pixabay

from JobCenter import *
from JobCenter2 import *
from ListClasses import CentralList
from myLogger import logger
import GoogleImageSearch
import LogScreen
from ListClasses import RadioList
from tagger import getID3raw, getYoutubeurl, getWavevalues
import SimplePicbrowser
import SelectPath
from Setup import *
from StreamRipper import streamripperinstance
import TaskViewScreen

# merlin mp3 player
from merlin_musicplayer.emerlinmusicplayer import eMerlinMusicPlayer
import merlin_musicplayer._emerlinmusicplayer

from ArtistArtLoader import ShazamResolver, ArtistArtLoader, CoverArtLoader

#ENIGMA_MERLINPLAYER_ID = 4097 # standard
ENIGMA_MERLINPLAYER_ID = 0x1019 # merlin

from . import _

# artist-title--------------------------genre----
# Station----------------------------bitratecodec
# Location-radiotype--------------------stats----


class SPlayer(Screen, InfoBarBase, InfoBarSeek, InfoBarNotifications):

	
	if RESOLUTIONx>1800:
		skin="""
			<screen name="MusicCenterPlayer" position="0,0" size="1920,1080" flags="wfNoBorder" backgroundColor="transparent" title="MC SPlayer" zPosition="0">
			<widget name="background" position="0,0" size="1920,1080" zPosition="1" backgroundColor="#000000"/>
			<!-- headerfield  -->
				<widget name="infobarbg" position="20,20" size="1880,132" zPosition="2" foregroundColor="#ffffff" backgroundColor="#191919" cornerRadius="12"/>
				<!-- 1 zeile  -->
					<widget name="artist" position="40,26" size="1320,40" font="SansReg;33" halign="left" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
					<widget name="genre" position="1370,26" size="510,40" font="SansReg;30" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
				<!-- 2 zeile  -->
					<widget name="title" position="40,66" size="1320,40" font="SansReg;33" halign="left" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
					<widget name="bitrateandcodec" position="1370,66" size="510,40" font="SansReg;30" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
				<!-- 3 zeile  -->
					<widget name="stationnameornextevent" position="40,106" size="1320,40" font="SansReg;33" halign="left" valign="center" foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
					<widget name="stats" position="1370,106" size="510,40" font="SansReg;30" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
			<!-- Buttons  -->
				<widget name="console" position="20,167" zPosition="4" size="1880,40" font="SansReg;20" foregroundColor="#ffffff" backgroundColor="#00000000" cornerRadius="12"/>
				<widget render="Label" font="SansReg;34" transparent="0" position="30,167" size="450,40" source="key_red" foregroundColor="#ff0000" backgroundColor="#000000" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;34" transparent="0" position="500,167" size="450,40" source="key_green" foregroundColor="#00ff21" backgroundColor="#000000" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;34" transparent="0" position="970,167" size="450,40" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#000000" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;34" transparent="0" position="1440,167" size="450,40" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#000000" halign="center" valign="center" zPosition="3"/>
			<!-- artistart  -->
				<widget name="artistArt" position="590,220" size="1227,690" zPosition="3" scale="width"/>
			<!-- coverart  -->
				<widget name="coverArt" position="50,340" size="450,450" zPosition="2" scale="width"/>
				<widget name="coverArtround" position="50,340" size="450,450" mode="visRoundCover" zPosition="2" transparent="1" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/no_cover.png"/>
			<!-- visualisationen  -->
				<widget name="visuradio" position="590,870" size="1227,220" backgroundColor="#000000" transparent="0" zPosition="2" pixmap1="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/bar_88_226.png" distance1="12" threshold1="24" mode="visUp" internalSize="1" blendColor="#fcc000" smoothing="0.4" />
				<widget name="rms0" channel="0" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/rms_bar_rgb_450x20.png" zPosition="13" position="50,230" size="450,20" transparent="0" borderWidth="0" mode="standardEnigmaSlider" maxValue="130" fadeOutTime="600" smoothing="0.3" />
				<widget name="rms1" channel="1" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/rms_bar_rgb_450x20.png" zPosition="13" position="50,260" size="450,20" transparent="0" borderWidth="0" mode="standardEnigmaSlider" maxValue="130" fadeOutTime="600" smoothing="0.3" />
			<!-- unten links  -->
				<widget name="stationicon" position="40,910" size="150,150" zPosition="3"/>
				<widget name="location" position="200,916" size="350,38" font="SansReg;30" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#000000" transparent="0" zPosition="4"/>
				<widget name="provider" position="200,966" size="350,38" font="SansReg;30" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#000000" transparent="0" zPosition="4"/>
				<widget name="playstate" position="200,1016" size="350,33" zPosition="4" transparent="0" font="SansReg;27" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#191919"/>
				<widget name="track" position="200,25" size="110,38" font="SansReg;27" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
				<!-- <widget name="playlength" position="430,1010" size="120,38" zPosition="8" transparent="0" font="SansReg;27" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#000000"/>  -->
			<!-- embeded songlist  -->
				<widget name="embededSonglistSimplelist" position="0,220" size="1920,690" zPosition="4" scrollbarMode="showOnDemand" backgroundColor="#000000"/>
				<widget name="embededSonglist2DFlow" position="0,220" size="1920,690" transparent="0" backgroundColor="#000000" zPosition="4" coverSize="220,220" selectedCoverScale="1.4" unselectedCoverDimm="0.7"  coverflowCurrentPosition="960,345" coverflowCurrentXDistance="20" coverflowCurrentCenterDistance="20" style="1" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/no-cover.png" />
				<widget name="embededSonglistCoverwall" position="0,220" size="1920,690" transparent="0" backgroundColor="#000000" zPosition="4" coverSize="220,220" selectedCoverScale="1.4" unselectedCoverDimm="0.7"  coverBeginPosition="135,200" coverDistance="15,15" style="0" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/no-cover.png" />
				<widget name="slpage" font="SansReg;27" transparent="0" position="860,220" size="200,33" zPosition="5" halign="center" foregroundColor="#ffffff" backgroundColor="#000000"/>
			</screen>"""

	else:
		skin="""
			<screen name="MusicCenterPlayer" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="transparent" title="MC SPlayer" zPosition="0">
			<widget name="background" position="0,0" size="1280,720" zPosition="1" backgroundColor="#000000"/>
			<!-- headerfield  -->
				<widget name="infobarbg" position="13,13" size="1253,88" zPosition="2" foregroundColor="#ffffff" backgroundColor="#191919" cornerRadius="8"/>
				<!-- 1 zeile  -->
					<widget name="artist" position="27,18" size="880,26" font="SansReg;22" halign="left" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
					<widget name="genre" position="913,18" size="340,26" font="SansReg;20" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
				<!-- 2 zeile  -->
					<widget name="title" position="26,44" size="880,26" font="SansReg;22" halign="left" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
					<widget name="bitrateandcodec" position="913,44" size="340,26" font="SansReg;20" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
				<!-- 3 zeile  -->
					<widget name="stationnameornextevent" position="26,71" size="880,26" font="SansReg;22" halign="left" valign="center" foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
					<widget name="stats" position="609,71" size="340,26" font="SansReg;20" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
			<!-- Buttons  -->
				<widget name="console" position="13,111" zPosition="4" size="1253,26" font="SansReg;14" foregroundColor="#ffffff" backgroundColor="#00000000" cornerRadius="8"/>
				<widget render="Label" font="SansReg;22" transparent="0" position="20,111" size="300,26" source="key_red" foregroundColor="#ff0000" backgroundColor="#000000" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;22" transparent="0" position="333,111" size="300,26" source="key_green" foregroundColor="#00ff21" backgroundColor="#000000" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;22" transparent="0" position="647,111" size="300,26" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#000000" halign="center" valign="center" zPosition="3"/>
				<widget render="Label" font="SansReg;22" transparent="0" position="960,111" size="300,26" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#000000" halign="center" valign="center" zPosition="3"/>
			<!-- artistart  -->
				<widget name="artistArt" position="393,146" size="818,460" zPosition="3" scale="width"/>
			<!-- coverart -->
				<widget name="coverArt" position="34,226" size="300,300" zPosition="2" scale="width"/>
				<widget name="coverArtround" position="34,226" size="300,300" mode="visRoundCover" zPosition="2" transparent="1" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/no_cover.png"/>
			<!-- visualisationen  -->
				<widget name="visuradio" position="393,590" size="818,147" backgroundColor="#000000" transparent="0" zPosition="2" pixmap1="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/bar_88_226.png" distance1="12" threshold1="24" mode="visUp" internalSize="1" blendColor="#fcc000" smoothing="0.4" />
				<widget name="rms0" channel="0" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/rms_bar_rgb_450x20.png" zPosition="13" position="33,153" size="300,14" transparent="0" borderWidth="0" mode="standardEnigmaSlider" maxValue="130" fadeOutTime="600" smoothing="0.3" />
				<widget name="rms1" channel="1" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/rms_bar_rgb_450x20.png" zPosition="13" position="33,173" size="300,14" transparent="0" borderWidth="0" mode="standardEnigmaSlider" maxValue="130" fadeOutTime="600" smoothing="0.3" />
			<!-- unten links  -->
				<widget name="stationicon" position="26,607" size="100,100" zPosition="3"/>
				<widget name="location" position="133,611" size="233,26" font="SansReg;20" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#000000" transparent="0" zPosition="4"/>
				<widget name="provider" position="133,644" size="233,26" font="SansReg;20" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#000000" transparent="0" zPosition="4"/>
				<widget name="playstate" position="133,677" size="233,22" zPosition="4" transparent="0" font="SansReg;18" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#191919"/>
				<widget name="track" position="133,16" size="73,26" font="SansReg;18" halign="center" valign="center"  foregroundColor="#ffffff" backgroundColor="#191919" transparent="0" zPosition="4"/>
				<!-- <widget name="playlength" position="287,673" size="80,26" zPosition="8" transparent="0" font="SansReg;27" halign="center" valign="center" foregroundColor="#ffffff" backgroundColor="#000000"/>  -->
			<!-- embeded songlist  -->
				<widget name="embededSonglistSimplelist" position="0,147" size="1280,460" zPosition="4" scrollbarMode="showOnDemand" backgroundColor="#000000"/>
				<widget name="embededSonglist2DFlow" position="0,147" size="1280,460" transparent="0" backgroundColor="#000000" zPosition="4" coverSize="147,147" selectedCoverScale="1.4" unselectedCoverDimm="0.7"  coverflowCurrentPosition="640,230" coverflowCurrentXDistance="13" coverflowCurrentCenterDistance="13" style="1" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/no-cover.png" />
				<widget name="embededSonglistCoverwall" position="0,147" size="1280,460" transparent="0" backgroundColor="#000000" zPosition="4" coverSize="147,147" selectedCoverScale="1.4" unselectedCoverDimm="0.7"  coverBeginPosition="90,133" coverDistance="10,10" style="0" noCoverAvailablePic="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/no-cover.png" />
				<widget name="slpage" font="SansReg;18" transparent="0" position="573,147" size="133,22" zPosition="5" halign="center" foregroundColor="#ffffff" backgroundColor="#000000"/>
			</screen>"""


	def __init__(self, session, songlist=[], index=0, radiode_api = None, currentservice = None, servicelist = None, radiodeinstance = None, radiobrowserinstance = None):

		logger.info('SPlayer]__init__ ]...')

		self.skin_path = '/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images'

		self.session = session
		self.songlist = songlist
		self.currentplayingslentry = None
		self._currentplayingindex = index
		self.radiode_api = radiode_api
		self.currentservice = currentservice
		self.servicelist = servicelist
		self.radiodeinstance = radiodeinstance
		self.radiobrowserinstance = radiobrowserinstance

		Screen.__init__(self, session)
		InfoBarNotifications.__init__(self)
		InfoBarBase.__init__(self)

		self['actions'] = ActionMap(["ColorActions", "WizardActions", "EPGSelectActions", "MediaPlayerActions", "InfobarAudioSelectionActions", "InfobarActions", 'InfobarInstantRecord'],
		{
			"input_date_time": self.menuPressed,
			"back": self.closePlayer,
			"stop": self.stopPlay,
			"right": self.rightPressed,
			"left": self.leftPressed,
			"up": self.showSongListUp,
			"down" : self.showSongListDown,
			"prevBouquet": self.shuffleList,
			"nextBouquet": self.repeatSong,
			"info" : self.infoPressed,
			"red": self.redPressed,
			"green": self.greenPressed,
			"yellow": self.yellowPressed,
			"blue": self.bluePressed,
			"ok": self.okPressed,
			"audioSelection": self.audioPressed,
			"showMovies": self.pvrPressed,
			'instantRecord': self.recordPressed,
		}, -1)

		self.onShown.append(self.onShownAppend)
		self.onLayoutFinish.append(self.__startRun)
		self.onClose.append(self.__onClose)

		self['background'] = Label()
		self['infobarbg'] = Label()

		self['artist'] = Label()
		self['title'] = Label()
		self['genre'] = Label()
		self['stationnameornextevent'] = Label()
		self['provider'] = Label()
	
		self['stats'] = Label()
		self['track'] = Label()
		self['location'] = Label()
		self['bitrateandcodec'] = Label()
		self['console'] = Label()

		self.__event_tracker = ServiceEventTracker(screen = self, eventmap = 
			{
				iPlayableService.evUpdatedInfo: self.__evUpdatedInfo,
				iPlayableService.evUser+10: self.__evAudioDecodeError,
				iPlayableService.evUser+12: self.__evPluginError,
				iPlayableService.evBuffering: self.__buffering,
			})
		#		iPlayableService.evStart: self.__serviceStarted,

		InfoBarSeek.__init__(self, actionmap = "MediaPlayerSeekActions")

		self.PixabayScreen = None
		self.hlp = {}

		# shazam
		self.shazamresolverinstance = ShazamResolver()
		self.sr_conn = self.shazamresolverinstance.MessagePump.recv_msg.connect(self.shazamResolverCallBack)
		self.shazamwaittimer = eTimer()
		self.shazamWaitTimer_mc_conn = self.shazamwaittimer.timeout.connect(self.shazamWaitTimerTimeout)
		
		self.stateposoffset = 0,0
		self.enigma_player_ID = 4097

		# coverart
		self.coverartloaderinstance = CoverArtLoader()
		self.ca_conn = self.coverartloaderinstance.MessagePump.recv_msg.connect(self.coverArtLoaderCallBack)
		self.coverartwaittimer = eTimer()
		self.ca_t_conn = self.coverartwaittimer.timeout.connect(self.onCoverArtIsFinishedWaitTimerTimeout)		
		self['coverArt'] = PicLoaderScale(transparent = False, name = 'Player-cover')
		self.no_cover_fn = drawImageJobWithLongMultilineText(text = 'NO COVER'.encode('utf-8'), size = (800,800), fontsize = 150, round = 30, out = '/tmp/mc/no_cover.png', force = True)

		# artistart
		self.current_artist_directory = ''
		self.artistartloaderinstance = ArtistArtLoader()
		self.aa_conn = self.artistartloaderinstance.MessagePump.recv_msg.connect(self.artistArtLoaderCallBack)
		self.artistartwaittimer = eTimer()
		self.aa_t_conn = self.artistartwaittimer.timeout.connect(self.onArtistArtWaitTimerTimeout)
		self['artistArt'] = PicLoaderScale(transparent = False, name = 'Player-artist')
		self.no_artist_fn = drawImageJobWithLongMultilineText(text = 'NO ARTIST'.encode('utf-8'), size = (1920,1080), fontsize = 250, out = '/tmp/mc/no_artist.png', force = True)

		
		# Timer
		self.screensavertimer = eTimer()
		self.screensavertimer_mc_conn = self.screensavertimer.timeout.connect(self.onScreenSaverTimerTimeout)
		self.updatelocationinfotimer = eTimer()
		self.musicinfoupdatetimer_mc_conn = self.updatelocationinfotimer.timeout.connect(self.updateLocationtimerAppend)

		self.radiopolltimer = eTimer()
		self.radioPollTimer_mc_conn = self.radiopolltimer.timeout.connect(self.updatePlaytimeRadiomode)
		
		self.nextEventtimer = eTimer()#laut.fm
		self.net_conn = self.nextEventtimer.timeout.connect(self.onNextEventTimerTimeout)
		
		self.playtime_station = 0
		self.playtime_song = 0
		self.eventcounter = 0
		self.badevents = []

		self['playstate'] = Label("0:00:00")
		#self['playlength'] = Label("0:00:00")

		# songlist
		self.currembededlist = None
		self.embededsonglistisshown = False
		self['embededSonglistSimplelist'] = RadioList([])
		self['embededSonglistSimplelist'].hide()

		self['embededSonglist2DFlow'] = CoverCollection()
		self['embededSonglist2DFlow'].hide()
		self['embededSonglistCoverwall'] = CoverCollection()
		self['embededSonglistCoverwall'].hide()


		self['key_red'] = StaticText("")
		self['key_green'] = StaticText("")
		self['key_yellow'] = StaticText("")
		self['key_blue'] = StaticText("")

		self['slpage'] = Label()
		self['slpage'].hide()

		self.streamripper_conn = streamripperinstance.MessagePump.recv_msg.connect(self.streamripperDataAvail)

		self['coverArt'] = PicLoaderScale(transparent = False, name = 'SPlayer-cover')
		self['stationicon'] = PicLoaderScale(transparent = False, name = 'SPlayer-station')

		#eMerlinMusicPlayer.getInstance().setFunc(self.getNextSong)
		self['coverArtround'] = MerlinMusicPlayerWidget()
		self["visuradio"] = MerlinMusicPlayerWidget()
		self["rms0"] = MerlinMusicPlayerRMS()
		self["rms1"] = MerlinMusicPlayerRMS()
		self.currentcoverfilename = ''
		self.no_cover_fn = drawImageJobWithLongMultilineText(text = 'NO COVER'.encode('utf-8'), size = (800,800), fontsize = 150, round = 30, out = '/tmp/mc/no_cover.png', force = True)
		self.evsongid = ''


	def __startRun(self):
		logger.debug('SPlayer]__startRun]...')
		self['embededSonglistSimplelist'].connectSelChanged(self.updateLocationInfo)
		self['embededSonglist2DFlow'].connectSelChanged(self.updateLocationInfo)
		self['embededSonglistCoverwall'].connectSelChanged(self.updateLocationInfo)

		self.setVisualisation()
		if os_path_exists(resolveFilename(SCOPE_CONFIG ,"mc_badevents")):
			self.badevents = load_obj(resolveFilename(SCOPE_CONFIG ,'mc_badevents'))

		self.resetScreenSaverTimer(restart = True)
		self.playStation(self._currentplayingindex)


	def updatePlaytimeRadiomode(self):
		self.playtime_station+=1
		m, s = divmod(self.playtime_station, 60)
		h, m = divmod(m, 60)
		stationstate= "%d:%02d:%02d" %(h, m, s)
		self.playtime_song+=1
		m, s = divmod(self.playtime_song, 60)
		h, m = divmod(m, 60)
		songstate= "%d:%02d:%02d" %(h, m, s)
		self['playstate'].setText('{}|{}'.format(songstate, stationstate))
		#self['playlength'].setText('{}'.format(stationstate))


	def onShownAppend(self):
		logger.debug('SPlayer]onShownAppend]...')


	def pvrPressed(self):
		pass


	def pvrCallback(self, ret):
		ret and ret[1]()


	def audioPressed(self):
		options=[]
		if not self.embededsonglistisshown:
			options.append((_("Update stationicon from current station"), self.updateStationicon),)
		self.session.openWithCallback(self.audioCallback, ChoiceBox, title=_(" Audiofileoptions"), list=options, keys=MYKEYSORT, titlebartext=_("MusicCenter"))


	def audioCallback(self, ret):
		ret and ret[1]()


	def setVisualisation(self):
	
		cpm = config.plugins.musiccenter

		if cpm.visualization.rms.value:
			self["rms0"].show()
			self["rms1"].show()
		else:
			self["rms0"].hide()
			self["rms1"].hide()

		if cpm.visualization.roundcover.value:
			self['coverArt'].hide()
			self['coverArtround'].show()
			self['coverArtround'].setCover(self['coverArt'].currentpic)
		else:
			self['coverArtround'].hide()
			self['coverArt'].show()
			self['coverArt'].doshow(self['coverArtround'].filename)

		if cpm.visualization.spectrum_small.value:
			self["visuradio"].show()
		else:
			self["visuradio"].hide()


	def updateStationicon(self):
		logger.debug('SPlayer]updateStationicon]start')
		slentry=self.getSonglistEntry()
		logger.debug('SPlayer]updateStationicon]id:{} streamID:{} stationname:{}'.format(slentry.id, slentry.streamID, slentry.stationname))
		if JCcheckModuleIsUpdated('GoogleImageSearch'):
			reload(GoogleImageSearch)
		self.session.openWithCallback(self.stationiconUpdated, GoogleImageSearch.GoogleImageSearchScreen, slentry, slentry.stationicon, slentry.stationname,  sizeX = -1, sizeY = -1, face = False)


	def stationiconUpdated(self, res):
	
		slentry, stationicon, error = res
		
		if error is None:
		
			try:
				picdir = os_path_join(config.plugins.musiccenter.downloadcache.value, 'favoritestationicons')
				if not pathExists(picdir):
					if not createDir(picdir):
						logger.error('SPlayer]stationiconUpdated]error create picdir:{} use temporary:/tmp/mc/'.format(picdir))
						picdir="/tmp/mc/"
				name = '{}.png'.format(cleanName(slentry.stationname))
				stationicon_new = os_path_join(picdir, name)
		
				logger.debug('SPlayer]stationiconUpdated]loaded stationicon:{}, rename now to:{}'.format(stationicon, stationicon_new))
				im = Image.open(stationicon)
				endswith = 'png'#im.format.lower()
				if im.size[0] > 200 or im.size[1] > 200:
					logger.info('SPlayer]stationiconUpdated]thumnail image x:{} to x:175 y:{} to y:175'.format(im.size[0], im.size[1]))
					im.thumbnail((175, 175), Image.ANTIALIAS)
					
				#if im.mode != "P":
				#	im = im.convert('RGB').convert('P',)
				
				im.save(stationicon_new, 'png')
				del im
				
				logger.debug('SPlayer]stationiconUpdated]stationicon renamed to:{}, show now...'.format(stationicon_new))
				self['stationicon'].doshow(stationicon_new)
				
				self.songlist[self._currentplayingindex][0].stationicon = stationicon_new
				logger.debug('SPlayer]stationiconUpdated]id:{} streamID:{} stationname:{}'.format(slentry.id, slentry.streamID, slentry.stationname))
				sql = '''UPDATE Stream_Favorites SET stationicon="{}" WHERE station_id="{}";'''.format(stationicon_new, slentry.id)
				logger.debug('SPlayer]stationiconUpdated]exec sql:{}'.format(sql))
				cursor = sqlCommand_Streaming_WithReturn(sql, dbname = 'musiccenter_stream_favorites.db')
				
			except:
				logger.exception('SPlayer]stationiconUpdated]stationicon imagetype getter or rename failed')

		else:
			logger.error('SPlayer]stationiconUpdated]error:{}'.format(error))


	def resetScreenSaverTimer(self, restart = True, ):
		logger.debug('SPlayer]resetScreenSaverTimer]is with restart:{}'.format(restart))
		if self.screensavertimer.isActive():
			logger.debug('SPlayer]resetScreenSaverTimer]stop running timer')
			self.screensavertimer.stop()
		if restart:
			if config.plugins.musiccenter.pixabay.starttime.value > 0:
				logger.debug('SPlayer]resetScreenSaverTimer]restart with {} minutes'.format(config.plugins.musiccenter.pixabay.starttime.value))
				self.screensavertimer.start(60000 * int(config.plugins.musiccenter.pixabay.starttime.value), 1)


	def menuPressed(self):
		self.resetScreenSaverTimer(restart = True)
		options=[]
		options.append((_("Global Configuration"), self.openConfig),)
		if self.getSonglistEntry().rating==10: # is favorite station!
			options.append((_("Remove current stream from favorite list"), self.removeStreamFromFavoriteList),)
		else:
			options.append((_("Add current stream to favorite list"), self.addCurrentStreamToFavorite),)
		options.append((_('Logfile'), self.startLog),)
		self.session.openWithCallback(self.menuCallback, ChoiceBox, title=_("Mainscreen Options"), list=options, keys=MYKEYSORT, titlebartext=_("MusicCenter"))


	def menuCallback(self, ret):
		ret and ret[1]()


	def openConfig(self):
		self.session.openWithCallback(self.setupFinished, MusicCenterSetup, self)


	def startLog(self):
		if JCcheckModuleIsUpdated('LogScreen'):
			reload(LogScreen)
		self.session.open(LogScreen.LogScreen)

		
	def okPressed(self):
		self.resetScreenSaverTimer(restart = True)
		if self.embededsonglistisshown:
			self.showhideEmbededSonglist()
			self.playStation(self.currembededlist.getCurrentIndex())
		else:
			options=[]
			options.append((_("Start Screensaver"), self.onScreenSaverTimerTimeout),)
			logger.debug('SPlayer]okPressed]evsongID {}'.format(self.evsongid))
			if self.evsongid not in self.badevents:
				self.hlp['bad event'] = self.evsongid
				options.append(("Add {} to bad events?".format(self.evsongid), self.addEventToBadEvents),)
			self.session.openWithCallback(self.menuCallback, ChoiceBox, title=_("Mainscreen Options"), list=options, keys=MYKEYSORT, titlebartext=_("MusicCenter"))


	def addEventToBadEvents(self):
		badevent = self.hlp.pop('bad event')
		logger.debug('SPlayer]addEventToBadEvents]add {}'.format(badevent))
		self.badevents.append(badevent)
		save_obj(self.badevents, resolveFilename(SCOPE_CONFIG, 'mc_badevents'))
		self.eventcounter -= 1
		logger.debug('SPlayer]addEventToBadEvents]reset old evsongid:{} and decrease eventcounter to:{}'.format(self.evsongid, self.eventcounter))
		self.evsongid = '-'
		self. __evUpdatedInfo()


	def recordPressed(self):
		if not self.embededsonglistisshown:
			options=[]
			if streamripperinstance.isRunning:
				options.append((_("Stop record stream"), self.stopStreamRipper),)
			else:
				options.append((_("Start record current stream"), self.startStreamRipperDialog),)
			if options:
				self.session.openWithCallback(self.menuCallback, ChoiceBox, title=_("Mainscreen Options"), list=options, keys=MYKEYSORT, titlebartext=_("MusicCenter"))

				
	def infoPressed(self):
		logger.debug('SPlayer]infoPressed]....')
		pass

		
	def voteStation(self):
		slentry=self.songlist[self._currentplayingindex][0]
		logger.debug('SPlayer]voteStation]->%s'%slentry.stationname)
		url='json/vote/%s' %slentry.streamID
		rb_getPage(url).addCallback(self.afterVote, 'vote ok', slentry.stationname).addErrback(self.afterVote, 'vote error', slentry.stationname)


	def afterVote(self, result, text, stationname):
		#{"ok":"true","message":"voted for station successfully"}
		result=json_loads(result)
		message=result['message'].encode()
		logger.debug('SPlayer]afterVote]text->%s result->%s'%(text, str(result)))
		self.session.open(MessageBox, _("{} {}".format(stationname, message)), type=MessageBox.TYPE_INFO, title="MusicCenter SPlayer",timeout=5)


	def setupFinished(self, result):
		if result:
			pass
		else:
			logger.debug('SPlayer]setupFinished]setup is not changed...')


	def playStation(self, currentindex):
		self.session.nav.stopService()
		self._currentplayingindex = currentindex
		slentry = self.getSonglistEntry()
		self.currentplayingslentry = slentry # new song
		logger.info('SPlayer]playStation]songID:{} index:{} filename:{}'.format(slentry.songID, currentindex, slentry.filename))
		stationname = 'Connect Station: {}'.format(slentry.stationname)
		slentry.tracknr = self.eventcounter
		self.updateMusicInformation(stationname, slentry)

		self.hlp['urlpool'] = []
		self.hlp['slentry'] = None
		self.resetPlayState()
		self.radiopolltimer.stop()
		logger.debug('SPlayer]playStation]songID:{} streamurl:{}'.format(slentry.songID, slentry.streamurl))

		self.showNoCover('No metadata')
		
		if self.nextEventtimer.isActive():
			logger.debug('SPlayer]playStation]stop nextEventtimer')
			self.nextEventtimer.stop()

		if slentry.filename.lower().startswith(("http",)):
			logger.debug('SPlayer]playStation]play pur url from songlist:{}'.format(slentry.filename))
			self.playServiceStream(slentry.streamurl, slentry, currentindex)

		elif slentry.streamurl.lower().startswith(("http",)) and not slentry.streamurl.lower().endswith((".pls",".m3u",".asx")) or ('func/dynampls.asp?' in slentry.streamurl):
			logger.debug('SPlayer]playStation]play pur url streamurl...')
			self.playServiceStream(slentry.streamurl, slentry, currentindex)
			
		elif slentry.filetype == 'RADIOBROWSER':
			url = 'v2/json/url/{}'.format(slentry.streamID)
			logger.debug('SPlayer]playStation]RADIOBROWSER click and resolve->%s' %url)
			rb_getPage(url).addCallback(self.playRadioBrowserAppend, slentry, currentindex).addErrback(self.playRadioBrowserError)

		elif slentry.filetype == 'RADIODE':
			if self.radiode_api == None:
				self.radiode_api = self.initRadioDEApi()
			logger.debug('SPlayer]playStation]connect streamID:{}'.format(slentry.streamID))
			res = self.radiode_api.resolve_playlist(slentry.streamID)
			logger.debug('SPlayer]playStation]get stationdata:{}'.format(res))
			urlpool = []
			
			if type(res) is list:
				try:
					for e in res:
						url = e.get( u'stream')
						if  url is not None:
							urlpool.append(url.encode())
					self.hlp['urlpool'] = urlpool
					self.hlp['slentry'] = (slentry, currentindex)
					#url = res[0].get(u'stream').encode()
					if len(urlpool):
						slentry.filename = urlpool[0]
						self.playServiceStream(urlpool[0], slentry, currentindex)
					else:
						url = ''
						self.updateMusicInformation('File or Stream not found!', slentry)
				except:
					logger.exception('SPlayer]playStation]res:{}'.format(res))
					url = ''
					self.updateMusicInformation('File or Stream not found!', slentry)
				
			else:
				url = ''
				self.updateMusicInformation('File or Stream not found!', slentry)

		elif slentry.streamurl.lower().endswith((".pls",".m3u",".asx")) or ('func/dynampls.asp?' in slentry.streamurl):
			logger.debug('SPlayer]playStation]resolve url from pls, m3u or asx...')
			mygetPage(slentry.streamurl, TWISTED_TIMEOUT).addCallback(self.callbackPlayList, slentry, currentindex).addErrback(self.callbackStationListError)

		else:
			logger.error('SPlayer]playStation]wrong here....')
		self.showStationicon(slentry)


	def showStationicon(self, slentry):
		logger.debug('SPlayer]showStationicon]')
		if slentry.stationicon!= None and pathExists(slentry.stationicon):
			self['stationicon'].doshow(slentry.stationicon)
		else:
			self['stationicon'].doshow(drawImageJobWithLongMultilineText(text = slentry.stationname, size = (200,200), fontsize = 30, round = 20, out = '/tmp/mc/stationicon.png', force = True))


	def initRadioDEApi(self):
		logger.debug('SPlayer]initRadioDEApi]No radiode_api Instance, create Instance')
		from radiodeApi import RadioDeApi
		radiode_api = RadioDeApi()
		radiode_api.__init__('german')
		return radiode_api


	def playRadioBrowserAppend(self, result, slentry, index):
		#{"ok":"true","message":"retrieved station url successfully","id":"78167","name":"Antenne Bayern - Chillout","url":"http://mp3channels.webradio.antenne.de/chillout"}
		res = json_loads(result)
		logger.debug('SPlayer]playRadioBrowserAppend]->%s' %str(res))
		if res['ok'].encode() == 'true':
			streamurl = res['url'].encode()
			self.playServiceStream(streamurl, slentry, index)
			self.updateClickVotesCounter(res['id'].encode())


	def updateClickVotesCounter(self, id):
		url = 'json/stations/byid/%s' %id
		logger.debug('SPlayer]updateClickVotesCounter]')
		rb_getPage(url).addCallback(self.updateClickVotesCounterAppend, id).addErrback(self.playRadioBrowserError)


	def updateClickVotesCounterAppend(self, result, id):
		deferToThread(self.updateClickVotesCounterDefered, result, id).addErrback(self.updateClickVotesCounterDeferedError)


	def updateClickVotesCounterDefered(self, result, id):
		#[{"id":"76079","name":"100 FM","url":"http://213.8.143.168/100fmAudio","homepage":"http://100fm.co.il/","favicon":"http://www.100fm.co.il/images/logo.png","tags":"","country":"Israel","state":"Tel Aviv","language":"Hebrew","votes":"6","negativevotes":"0","codec":"MP3","bitrate":"64","lastcheckok":"1","lastchecktime":"2017-01-02 20:50:06","lastcheckoktime":"2017-01-02 20:50:06","clicktimestamp":"2017-01-03 17:10:22","clickcount":"0","clicktrend":"0","lastchangetime":"2016-05-15 20:24:31"}]
		res = json_loads(result)
		logger.debug('SPlayer]updateClickVotesCounterDefered]->%s' %str(res))
		res = res[0]
		sql = '''UPDATE Stream_Favorites SET clicks=?, votes=? WHERE streamID=?;'''
		args = (res['clickcount'].encode(), res['votes'].encode(), id)
		cursor = sqlCommand_Streaming_WithReturn(sql, args, dbname = 'musiccenter_stream_favorites.db')
		logger.debug('SPlayer]updateClickVotesCounterAppend]%s' %cursor)


	def updateClickVotesCounterDeferedError(self, error):
		logger.error('SPlayer]updateClickVotesCounterDeferedError]error:{}'.format(error))


	def playRadioBrowserError(self, error):
		logger.error('SPlayer]playRadioBrowserError]error->%s' %error)


	def addCurrentStreamToFavorite(self):
		logger.debug('SPlayer]addCurrentStreamToFavorite]start')
		sel = self.getSonglistEntry()
		if sel:
			addStreamToFavoriteList(sel)


	def removeStreamFromFavoriteList(self):
		sel = self.getSonglistEntry()
		if sel is not None:
			removeStreamFromFavoriteList(sel)
			#if self.radiodeinstance is not None:
			#	self.radiodeinstance.removeStreamFromFavoriteList(sel)
			#elif self.radiobrowserinstance is not None:
			#	self.radiobrowserinstance.startLoescheSelektieretenStream(sel)
			#else:
			#	logger.error('SPlayer]removeStreamFromFavoriteList]no valid instance...')
			#	return
			self.playNext()


	def addStreamToLastPlayedStationList(self, sel):
		'''
		time = self['playstate'].getText()
		h,m,s = time.rsplit('|',1)[-1].split(':')
		tnew = timedelta(hours = int(h), minutes = int(m), seconds = int(s))
		told = timedelta(hours = int(h), minutes = int(15), seconds = int(45))
		str(told+tnew)
		logger.debug('SPlayer]addStreamToLastPlayedStationList]->%s'%time)
		'''
		logger.debug('SPlayer]addStreamToLastPlayedStationList]{}'.format(sel.stationname))
		connection = OpenDB_Streaming('musiccenter_stream_favorites.db')
		if connection is not None:
			with connection:
				connection.text_factory = str
				cursor = connection.cursor()
				cursor.execute('''DELETE FROM Stream_Recent WHERE stationname="%s";''' %sel.stationname)
				cursor.execute('''INSERT INTO Stream_Recent(stationname, genre, location, bitrate, codec, streamurl, stationicon, streamID, filetype) VALUES(?,?,?,?,?,?,?,?,?);''' , (sel.stationname, sel.genre, sel.location, sel.bitrate, sel.codec, sel.streamurl, sel.stationicon, sel.streamID, sel.filetype))
				cursor.execute('''DELETE FROM Stream_Recent where rowid NOT IN (Select rowid FROM Stream_Recent ORDER BY station_id DESC LIMIT 100);''')


	def callbackPlayList(self, result, slentry, index):
	
		logger.debug('SPlayer]callbackPlayList]result-> %s'%result[:500])
		found = False
		parts = result.split("\n")
		logger.debug('SPlayer]callbackPlayList]parts-> %s'%str(parts))
		
		if parts[0].lower().startswith("http://") or parts[0].lower().startswith("mms://"):
			url = parts[0].rstrip().strip()
			found = True
			self.playServiceStream(url, slentry, index)
			
		elif "[playlist]" in parts[0].lower():
			for line in parts:
				if line.lower().find("file1=") != -1:
					url = line.lower().split("file1=")[-1].rstrip().strip()
					found = True
					logger.debug('SPlayer]callbackPlayList]playlist found url:{}'.format(url))
					self.playServiceStream(url, slentry, index)
					break
					
		elif parts[0].lower().find("#extm3u") != -1:
			for lines in parts:
				if lines.startswith("http://"):
					found = True
					self.playServiceStream(lines.rstrip().strip(), slentry, index)
					break
	
		elif parts[0].lower().find("asx version") != -1:
			stationList = []
			try:
				root = ET_fromstring(result.lower())
			except:
				logger.exception('SPlayer]callbackPlayList]...?')
				root = None
			if root:
				for childs in root.findall("entry"):
					for childs2 in childs.findall("ref"):
						url = childs2.get("href")
						if len(url):
							found = True
							self.playServiceStream(url.rstrip().strip(), slentry, index)
							break
					if found:
						break
		elif parts[0].lower().find("reference") != -1:
			for lines in parts:
				if lines.lower().find('http://') != -1:
					url = 'mms' + lines[lines.lower().find('http://')+4:]
					#url = lines[lines.lower().find('http://'):]
					found = True
					self.playServiceStream(url.rstrip().strip(), slentry, index)
					break
					
		if not found:
			logger.debug('SPlayer]callbackPlayList]no match found!!!!')
			title = _("No streaming data found...")
			self['title'].setText(title)
			self.hlp['updateMusicInformation_slentry'].title = title


	def callbackStationListError(self, error = None):
		if error is not None:
			try:
				e = str(error.getErrorMessage())
				title = _("{}...".format(e))
				self['title'].setText(title)
				self.hlp['updateMusicInformation_slentry'].title = title
				logger.debug('SPlayer]callbackStationListError]Error:'%e)
			except:
				logger.exception('SPlayer]callbackStationListError]...?')


	def playServiceStream(self, url, slentry, index):
		logger.debug('SPlayer]playServiceStream]songID:{} url:{}'.format(slentry.songID, url))
		ref = eServiceReference(ENIGMA_MERLINPLAYER_ID, 0, url)
		self.session.nav.playService(ref)
		self.currentplayingslentry.filename = url # new song
		self.songlist[index][0].filename = url
		self.resetPlayState()
		slentry.tracknr = self.eventcounter
		self.radiopolltimer.start(1000, 0)
		deferToThread(self.addStreamToLastPlayedStationList, slentry).addErrback(self.errorAddStationToLastPlayedStation,)
		self.updateMusicInformation('Wait for metadata...', slentry)


	def retryPlayServiceStream(self):
		urlpool = self.hlp.get('urlpool', [])
		logger.debug('SPlayer]retryPlayServiceStream]urlpool {}'.format(urlpool))
		if urlpool:
			url = urlpool.pop(0)
			slentry, index = self.hlp.get('slentry')
			self.playServiceStream(url, slentry, index)
			self.hlp['urlpool'] = urlpool
		else:
			pass


	def resetPlayState(self):
		self.playtime_song = 0
		self.playtime_station = 0
		self.eventcounter = 0


	def __evUpdatedInfo(self):

		currPlay = self.session.nav.getCurrentService()
		if currPlay is not None:
			sTitle = currPlay.info().getInfoString(iServiceInformation.sTagTitle)

			if sTitle == self.evsongid:
				#logger.info('SPlayer]__evUpdatedInfo]Not new event:{}'.format(sTitle))
				return

			self.evsongid = sTitle
			self.playtime_song = 0
			slentry = self.getSonglistEntry()
			
			if sTitle and sTitle != 'n/a':
			
				self.eventcounter += 1
				is_good_event, event_artist, event_title = self.fitEvent(sTitle)
				
				slentry.songID = sTitle
				slentry.artist = event_artist
				slentry.title = event_title
				
				if sTitle in self.badevents:
					logger.debug('SPlayer]setBadEvent]{}'.format(sTitle))
					slentry.artist = 'n/a'
					slentry.title = 'n/a'
					self.showNoCover()


					
				elif is_good_event:
					slentry.text = sTitle
					self.startShazamThread(slentry)
					self.getNextSong(slentry)
				
			else:
				slentry.title = 'n/a'
				slentry.artist = 'n/a'
				self.showNoCover()


			self.startArtistart(slentry, '')
			self.getNextSong(slentry)
			logger.debug('SPlayer]__evUpdatedInfo]New event:{} eventcounter:{}'.format(sTitle, self.eventcounter))
			slentry.tracknr = self.eventcounter
			self.updateMusicInformation(slentry = slentry)
			

	def getNextSong(self, slentry):
		if self.nextEventtimer.isActive():
			logger.debug('SPlayer]getNextSong]stop nextEventtimerm, filetype:{}'.format(slentry.filetype))
			self.nextEventtimer.stop()	
		if slentry.filetype == 'LAUTFM':
			logger.debug('SPlayer]getNextSong]is LAUTFM, start new nextEventtimer')
			self.nextEventtimer.start(10*1000, 1)
		

	def onNextEventTimerTimeout(self):
		logger.debug('SPlayer]onNextEventTimerTimeout]get next event from LAUTFM....')
		slentry = self.currentplayingslentry
		url = 'station/{}/next_artists'.format(slentry.streamID)
		logger.debug('SPlayer]getNextSong]url:{}'.format(url))
		lautfm_getPage(url).addCallback(self.getNextSongAppend).addErrback(self.getPageError, 'getNextSong')


	def getNextSongAppend(self, result):
		logger.debug('SPlayer]getNextSongAppend]result:{}'.format(result))
		text = []
		for artist in json_loads(result):
			text.append(artist['artist']['name'].encode())
			self['stationnameornextevent'].setText('Next: ' + ', '.join(text) + '....')


	def getPageError(self, error, key):
		logger.error('SPlayer]getPageError]{} -> {}'.format(key, error))


	def fitEvent(self, sTitle):
		badevents = ('mp3-192_antenne-nds', 'publicita', 'antennemv', 'livestream.mp3', 'egqwgc0q52mtv', 'charts_pop_rock', 'livestream.mp3', 'chronisch_elektronisch', 'Vitamine|90', 'tannenbaumradio'
		, '.stream24.', 'partyzone90s_mobile_mp3', 'radio B2')
		for event in badevents:
			if event.lower() in sTitle.lower():
				return (False, 'No metadata', '')
				
		try:
			artist, title = sTitle.split(' - ', 1)
		except:
			try:
				artist, title = sTitle.split('-', 1)
			except:
				return (True, 'n/a', sTitle)
	
		return (True, artist, title)

		
	def errorAddStationToLastPlayedStation(self, error):
		logger.error('SPlayer]errorAddStationToLastPlayedStation]{}'.format(error))


	def __buffering(self):
		currPlay = self.session.nav.getCurrentService()
		if currPlay is not None:
			streamed = currPlay.streamed()
			if streamed is not None:
				bufferInfo = streamed.getBufferCharge()
				percent = bufferInfo[0]
				text = ""
				if percent != 100:
					text = "Buffering %d ..." % percent
				#if not self["console"].getVisible():
				#self["console"].show()
				self["console"].setText(text)


	def updateMusicInformation(self, info = '', slentry = Item()):
		self.hlp['updateMusicInformation_info'] = info
		self.hlp['updateMusicInformation_slentry'] = slentry
		if not self.embededsonglistisshown:
			logger.debug('SPlayer]updateMusicInformation]track:{}'.format(slentry.tracknr))
			track = 'Tr:{:03}'.format(slentry.tracknr)
			self['track'].setText(track)
			stationname, bitrateandcodec, stats, provider = joinDisplaytextStream(slentry)
			artist = slentry.artist
			if info:
				artist = info
			self['artist'].setText(artist)
			self['title'].setText(slentry.title)
			self['genre'].setParsedText(slentry.genre)
			self['bitrateandcodec'].setText(bitrateandcodec)
			self['stats'].setText(stats)
			self['stationnameornextevent'].setText(stationname)
			self['location'].setText(slentry.location)
			self['provider'].setText(provider)
			# lcd
			self.summaries.updateSlentry(slentry)

			if self.PixabayScreen:#artist, title, album_year_albumartist, track, genre, bitrate, length, ratingnum
				self.PixabayScreen.updateDisplayText(artist, slentry.title, '', track, slentry.genre, '', bitrateandcodec, '', 256)
				self.PixabayScreen.updateLCD(slentry)

			
	def loadCover(self, slentry, shazamimage=''):
		self.hlp['coverartloaderinstanceparameter'] = (slentry, shazamimage)
		self.onCoverArtIsFinishedWaitTimerTimeout()			


	def onCoverArtIsFinishedWaitTimerTimeout(self):
		if self.coverartloaderinstance.isRunning:
			logger.info('SPlayer]onCoverArtIsFinishedWaitTimerTimeout]start new timer')
			self.coverartwaittimer.start(100,1)
		else:
			res = self.hlp.pop('coverartloaderinstanceparameter')
			if res is not None:
				slentry, shazamimage = res
				self.coverartloaderinstance.Start(slentry, shazamimage)
			else:
				logger.error('SPlayer]onCoverArtIsFinishedWaitTimerTimeout] ????????????!!!!')


	def coverArtLoaderCallBack(self, msg):
		isrunned, slentry, pic_path, message = self.coverartloaderinstance.Message.pop()
		logger.debug('SPlayer]coverArtLoaderCallBack]isrunned:{} pic_path{} message:{}'.format(isrunned, pic_path, message))
		logger.debug('SPlayer]coverArtLoaderCallBack]slentry.songID:{} self.evsongid:{}'.format(slentry.songID, self.evsongid))
		if slentry.songID == self.evsongid:
			if isrunned:
				self.showCover(picpath = pic_path)
				
			else:
				self.showNoCover()
				
			if message is not None:
				self.session.toastManager.showToast(_(message), 3)
				
		else:	
			logger.info('SPlayer]coverArtLoaderCallBack]song changed, abort')

		
	def startShazamThread(self, slentry):
		self.hlp['shazam_slentry']=slentry
		self.shazamWaitTimerTimeout()

			
	def shazamWaitTimerTimeout(self):
		if self.shazamresolverinstance.isRunning:
			logger.debug('SPlayer]shazamWaitTimerTimeout]old thread, start new waittimer')
			self.shazamresolverinstance.cancel()
			self.shazamwaittimer.start(100, 1)
		else:
			slentry=self.hlp.get('shazam_slentry')
			self.shazamresolverinstance.Start(slentry, 'title')			

	
	def shazamResolverCallBack(self, result):
		res = self.shazamresolverinstance.Message.pop()
		status_ok = res[0]
		slentry = res[1]
		type = res[2]
		shazam_title_image = ''
		shazam_artist_image = ''
		
		if status_ok:
		
			ratio, shazam_artist_ID, shazam_title_ID, shazam_artist_text, shazam_title_text, shazam_artist_image, shazam_title_image = res[3:]

			if slentry.songID == self.evsongid:
				if shazam_artist_ID:
					self.getShazamArtistcount(shazam_artist_ID, slentry)
				if shazam_title_ID:
					self.getShazamTitlecount(shazam_title_ID, slentry)
			else:
				logger.info('SPlayer]shazamResolverCallBack]song is leaved, abort')

		if slentry.songID == self.evsongid and type == 'title':				
			self.loadCover(slentry, shazam_title_image)
			self.startArtistart(slentry, shazam_artist_image)


	def getShazamArtistcount(self, shazamartistID, slentry):
		url='''https://www.shazam.com/shazam/v1/de/DE/web/-/publisher/{}/followers/count'''.format(shazamartistID)
		logger.debug('SPlayer]getShazamArtistcount]{}'.format(url))
		mygetPage(url, timeout=TWISTED_TIMEOUT).addCallback(self.getShazamArtistcountCallback, slentry).addErrback(self.getShazamArtistcountError, slentry)

		
	def getShazamArtistcountCallback(self, counts, slentry):
		counts=json_loads(counts)
		if slentry.songID==self.evsongid:
			#self.songlist[self._currentplayingindex][0].shazamartistcounts=counts[u'count']
			if not self.embededsonglistisshown:
				artist = '{} ({:,} Shazams)'.format(slentry.artist, int(counts[u'count'])).replace(',','.')
				self.hlp['updateMusicInformation_slentry'].artist = artist
				self['artist'].setText(artist)

				
	def getShazamArtistcountError(self, error, slentry):
		logger.error('Player]getShazamArtistcountError]{}'.format(error))
		self.getShazamArtistcountCallback('{"count": "0"}', slentry)

		
	def getShazamTitlecount(self, shazamtitleID, slentry):
		url='''https://www.shazam.com/shazam/v1/de/DE/web/-/tagcounts/track/{}'''.format(shazamtitleID)
		logger.debug('SPlayer]getShazamTitlecount]{}'.format(url))
		mygetPage(url, timeout=TWISTED_TIMEOUT).addCallback(self.getShazamTitlecountCallback, slentry).addErrback(self.getShazamTitlecountError, slentry)

		
	def getShazamTitlecountCallback(self, result, slentry):
		counts=json_loads(result)
		if slentry.songID==self.evsongid:
			#self.songlist[self._currentplayingindex][0].shazamtitlecounts=counts[u'total']
			if not self.embededsonglistisshown:
				title = '{} ({:,} Shazams)'.format(slentry.title, int(counts['total'])).replace(',','.')
				self['title'].setText(title)
				self.hlp['updateMusicInformation_slentry'].title = title

				
	def getShazamTitlecountError(self, error, slentry):
		logger.error('Player]getShazamTitlecountError]{}'.format(error))
		self.getShazamTitlecountCallback('0', slentry)


	def showCover(self, picpath=''):

		if fileExists(picpath):
			logger.debug('SPlayer]showCover]picpath:{}'.format(picpath))
			if not config.plugins.musiccenter.visualization.roundcover.value:
				self['coverArt'].doshow(picpath)
			else:
				self['coverArtround'].setCover(picpath)
				
			if self.PixabayScreen:
				self.PixabayScreen.updateCover(picpath)
			# prevent crash on close player timing error...
			try: self.songlist[self._currentplayingindex][0].coverfn = picpath
			except: pass 
				
		else:
			logger.error('SPlayer]showCover]picpath:{}'.format(picpath))
			self.showNoCover('coverfile not found!')


	def showNoCover(self, text=''):
		self.showCover(picpath=self.no_cover_fn)


	def startArtistart(self, slentry, shazam_artist_image):
		self.hlp['slentry_for_artistart'] = slentry, shazam_artist_image
		self.onArtistArtWaitTimerTimeout()


	def onArtistArtWaitTimerTimeout(self):
		if self.artistartloaderinstance.isRunning:
			logger.info('SPlayer]onArtistArtWaitTimerTimeout]start new timer')
			self.artistartwaittimer.start(100,1)
		else:
			logger.info('SPlayer]onArtistArtWaitTimerTimeout]check is track leaved...')
			slentry, shazam_artist_image = self.hlp.get('slentry_for_artistart')
			if slentry.songID == self.evsongid:
				self.artistartloaderinstance.Start(slentry.artist, slentry.songID, shazam_artist_image)


	def artistArtLoaderCallBack(self, msg):
		isrunned, evsongID, pic_path, current_artist_directory, current_artist_directory_name, message, showtime = self.artistartloaderinstance.Message.pop()
		#logger.debug('SPlayer]artistArtLoaderCallBack]isrunned:{} evsongID:{} pic_path{} current_artist_directory:{} message:{}'.format(isrunned, evsongID, pic_path, current_artist_directory, message))
		
		if isrunned:
			#logger.debug('SPlayer]artistArtLoaderCallBack]check evsongID:{} __evsongID:{}'.format(evsongID,self.evsongid))
	
			if evsongID == self.evsongid:
				logger.debug('SPlayer]artistArtLoaderCallBack]event is actual'.format(evsongID,self.evsongid))
				self.current_artist_directory = current_artist_directory
				self.artistShow(pic_path)
				
			if message is not None:
				self.session.toastManager.showToast(_(message), showtime)
		

	def artistShow(self, picpath=''):
		if picpath != self['artistArt'].currentpic:
			self['artistArt'].doshow(picpath)


	def __evAudioDecodeError(self, isTrue):
		currPlay=self.session.nav.getCurrentService()
		sAudioType=currPlay.info().getInfoString(iServiceInformation.sUser+10)
		logger.error('''SPlayer]__evAudioDecodeError]audio-codec {} can't be decoded by hardware'''.format(sAudioType))
		if not isTrue:
			self.session.open(MessageBox, _("This Dreambox can't decode %s streams!") % sAudioType, type=MessageBox.TYPE_INFO, title="MusicCenter",timeout=20 )


	def __evPluginError(self):
		currPlay=self.session.nav.getCurrentService()
		message=currPlay.info().getInfoString(iServiceInformation.sUser+12)
		logger.error('SPlayer]__evPluginError]Error: %s' %message)
		self.session.open(MessageBox, message, type=MessageBox.TYPE_ERROR, title = "MusicCenter",timeout = 10 )		
		self.songlist[self._currentplayingindex][0].filename = 'n/a' # reset url!


	def doEofInternal(self, playing):
		logger.debug('SPlayer]doEofInternal]Start, playNext:{}'.format(playing))
		if playing:
			self.playNext()


	def checkSkipShowHideLock(self): # InfoBarSeek n�tig???
		pass


	def doSeekRelative(self, pts): # InfoBarSeek n�tig???
		skiptime=pts+self.hlp.get('skiptime',0)
		self.hlp['skiptime']=skiptime
		logger.debug('SPlayer]doSeekRelative]skiptime->%s' %skiptime)
		seekable=self.getSeek()
		if seekable is None:
			return
		prevstate=self.seekstate
		if self.seekstate==self.SEEK_STATE_EOF:
			if prevstate==self.SEEK_STATE_PAUSE:
				self.setSeekState(self.SEEK_STATE_PAUSE)
			else:
				self.setSeekState(self.SEEK_STATE_PLAY)
		seekable.seekRelative(pts<0 and -1 or 1, abs(pts))
		if abs(pts) > 100 and config.usage.show_infobar_on_skip.value:
			self.showAfterSeek()


	def stopPlay(self):
		logger.info('SPlayer]stopPlay]start')
		ret=self.setSeekState(self.SEEK_STATE_STOP, onlyGUI = True)
		logger.debug('SPlayer]stopPlay]stopService set SEEK_STATE_STOP {} self.seekstate {}'.format(ret, self.seekstate))
		self.session.nav.stopService()
		logger.debug('SPlayer]stopPlay]clear songlist now...')
		self.songlistorig=[]
		self.songlist=[]
		self.close()


	def rightPressed(self):
		if self.embededsonglistisshown=='list':
			self.currembededlist.pageDown()
		elif self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.MoveRight()
		else:
			self.playNext()


	def playNext(self):
		self._currentplayingindex=self.getNextSonglistIndex(self._currentplayingindex)
		logger.debug('SPlayer]playNext]index:{}'.format(self._currentplayingindex))
		self.playStation(self._currentplayingindex)


	def leftPressed(self):
		if self.embededsonglistisshown is False:
			self.playLast()
		elif self.embededsonglistisshown == 'list':
			self.currembededlist.pageUp()
		elif self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.MoveLeft()


	def playLast(self):
		if self._currentplayingindex-1 < 0:
			self._currentplayingindex=len(self.songlist) - 1
		else:
			self._currentplayingindex-= 1
		self.playStation(self._currentplayingindex)


	def shuffleList(self):
		if self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.NextPage()


	def repeatSong(self):
		if self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.PreviousPage()


	def updateLocationInfo(self, index=0):
		if self.updatelocationinfotimer.isActive():
			self.updatelocationinfotimer.stop()
		self.updatelocationinfotimer.start(450, 1)
		self.selindex=index


	def updateLocationtimerAppend(self):
		if self.embededsonglistisshown == 'list':
			self.songlistSimpleSelChanged()
		elif self.embededsonglistisshown in ('2dlist', 'coverwall'):
			self.songlist2DSelChanged(self.selindex)


	def showSongListUp(self):
		if self.embededsonglistisshown=='list':
			self.currembededlist.up()
		elif self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.MoveUp()
		else:
			self.showhideEmbededSonglist()


	def showSongListDown(self):
		if self.embededsonglistisshown=='list':
			self.currembededlist.down()
		elif self.embededsonglistisshown in('2dlist', 'coverwall'):
			self.currembededlist.MoveDown()
		else:
			self.showhideEmbededSonglist()


	def showhideEmbededSonglist(self):
		#("list", _("list")), ("2dlist", _("2D Coverflow")), ("coverwall", _("Coverwall"))
		if self.embededsonglistisshown:
			self['key_green'].setText("")
			self['key_yellow'].setText("")
			self['key_blue'].setText("")
			self['console'].show()
			self.setVisualisation()

			if self['slpage'].getVisible():
				self['slpage'].hide()
			self.currembededlist.hide()
			self.embededsonglistisshown = False
			slentry = self.hlp.get('updateMusicInformation_slentry')
			if slentry:
				self.updateMusicInformation(self.hlp.get('updateMusicInformation_info', ''), slentry)

		else: #-> show now songlist
			self['key_green'].setText("Reveret sort order")
			self['key_yellow'].setText("Sort list")
			self['key_blue'].setText("Select Liststyle")
			self['console'].hide()

			if self['rms0'].getVisible():
				self['rms0'].hide()
			if self['rms1'].getVisible():
				self['rms1'].hide()
			if self['coverArtround'].getVisible():
				self['coverArtround'].hide()
			if self['coverArt'].getVisible():
				self['coverArt'].hide()

			if config.plugins.musiccenter.songliststyle.value=='list':
				self['slpage'].hide()
				self.embededsonglistisshown = 'list'
				self['embededSonglistSimplelist'].show()
				self['embededSonglistSimplelist'].setList(self.songlist)
				self['embededSonglistSimplelist'].moveToIndex(self._currentplayingindex)
				self.currembededlist=self['embededSonglistSimplelist']

			elif config.plugins.musiccenter.songliststyle.value=='2dlist':
				self['slpage'].hide()
				self.embededsonglistisshown = '2dlist'
				self.buildAndShowCoverFlowlist(self._currentplayingindex)

			elif config.plugins.musiccenter.songliststyle.value=='coverwall':
				self['slpage'].show()
				self.embededsonglistisshown = 'coverwall'
				self.buildAndShowCoverFlowlist(self._currentplayingindex)

			else:
				logger.error('SPlayer]showhideEmbededSonglist]why here?')


	def errorCoverLoader(self, error):
		logger.error('SPlayer]errorCoverLoader]->%s' %error)


	def buildAndShowCoverFlowlist(self, selectedindex):
		logger.debug('SPlayer]buildAndShowCoverFlowlist]embededsonglistisshown {}'.format(self.embededsonglistisshown))
		list=[]
		covers=[]
		for fake, slentry in enumerate(self.songlist):
			list.append(((slentry),))
			cover=slentry[0].stationicon
			covers.append(cover)
		logger.debug('SPlayer]buildAndShowCoverFlowlist]set collection')
		if self.embededsonglistisshown=='2dlist':
			logger.debug('SPlayer]buildAndShowCoverFlowlist]set collection-> 2dlist')
			self.currembededlist=self['embededSonglist2DFlow']
		elif self.embededsonglistisshown=='coverwall':
			logger.debug('SPlayer]buildAndShowCoverFlowlist]set collection-> coverwall')
			self.currembededlist=self['embededSonglistCoverwall']
		else:
			logger.error('SPlayer]buildAndShowCoverFlowlist]uihh, what is wrong?')
			return
		self.currembededlist.setList(list, covers, selectedindex)
		self.currembededlist.show()


	def songlist2DSelChanged(self, index):
		logger.debug('SPlayer]songlist2DSelChanged]embededsonglistisshown is {}'.format(self.embededsonglistisshown))
		slentry=self.songlist[index][0]
		self['genre'].setParsedText(slentry.genre)
		self['slpage'].setText(_('Page {} | {}'.format(self.currembededlist.getCurrentPage(), self.currembededlist.getTotalPages())))
		self['artist'].setText(slentry.artist)
		self['title'].setText(slentry.title)
		stationname, bitrateandcodec, stats, provider = joinDisplaytextStream(slentry)
		self['bitrateandcodec'].setText(bitrateandcodec)
		self['stationnameornextevent'].setText(stationname)
		self['provider'].setText(provider)
		self['stats'].setText(stats)


	def songlistSimpleSelChanged(self):
		slentry=self['embededSonglistSimplelist'].getCurrent()
		if slentry is not None:
			slartistandtitle='{} - {}'.format(slentry.artist, slentry.title)
			stationname, bitrateandcodec, stats, provider = joinDisplaytextStream(slentry)


	def bluePressed(self):
		logger.debug('SPlayer]bluePressed]...')
		if self.embededsonglistisshown:
			logger.debug('SPlayer]bluePressed]is embededsonglistisshown, show selections')
			options=[]
			if config.plugins.musiccenter.songliststyle.value != 'list':
				options.append((_("Style: Listbox High"), 'list'),)
			if config.plugins.musiccenter.songliststyle.value != '2dlist':
				options.append((_("Style: 2D Coverflow"), '2dlist'),)
			if config.plugins.musiccenter.songliststyle.value != 'coverwall':
				options.append((_("Style: Coverwall"), 'coverwall'),)
			self.session.openWithCallback(self.bluePressedCallback, ChoiceBox, title=_("Select style..."), list=options,keys=MYKEYSORT, titlebartext=_("MusicCenter"))


	def bluePressedCallback(self, ret):
		if ret:
			logger.debug('SPlayer]bluePressedCallback]{}'.format(ret))
			config.plugins.musiccenter.songliststyle.value=ret[1]
			config.plugins.musiccenter.songliststyle.save()
			configfile.save()
			if self.embededsonglistisshown != config.plugins.musiccenter.songliststyle.value:
				logger.debug('SPlayer]bluePressedCallback]liststyle changed, update list')
				self.showhideEmbededSonglist()
				self.showhideEmbededSonglist()


	def redPressed(self):
		if not self.embededsonglistisshown:
			options=[]

			if not config.plugins.musiccenter.visualization.rms.value:
				options.append((_("Show RMS Meter"), self.changeRMSMeter),)
			else:
				options.append((_("Hide RMS Meter"), self.changeRMSMeter),)

			if not config.plugins.musiccenter.visualization.spectrum_small.value:
				options.append((_("Show Spectrumanalyser small"), self.changeSpectrumSmall),)
			else:
				options.append((_("Hide Spectrumanalyser small"), self.changeSpectrumSmall),)

			if not config.plugins.musiccenter.visualization.roundcover.value:
				options.append((_("Show Round Cover animated"), self.changeRoundCover),)
			else:
				options.append((_("Show square Cover"), self.changeRoundCover),)

			if options:
				self.session.openWithCallback(self.myCallback, ChoiceBox, title=_("Visualisation Options"), list=options, keys=MYKEYSORT, titlebartext=_("MusicCenter"))


	def changeRMSMeter(self):
		cpm = config.plugins.musiccenter
		cpm.visualization.rms.value = not cpm.visualization.rms.value
		cpm.visualization.roundcover.value = False
		cpm.visualization.spectrum_small.value = False
		self.saveNewConfig()


	def changeRoundCover(self):
		cpm = config.plugins.musiccenter
		cpm.visualization.rms.value = False
		cpm.visualization.roundcover.value = not cpm.visualization.roundcover.value
		cpm.visualization.spectrum_small.value = False
		self.saveNewConfig()


	def changeSpectrumSmall(self):
		cpm = config.plugins.musiccenter
		cpm.visualization.rms.value = False
		cpm.visualization.roundcover.value = False
		cpm.visualization.spectrum_small.value = not cpm.visualization.spectrum_small.value
		self.saveNewConfig()


	def saveNewConfig(self):
		cpm = config.plugins.musiccenter
		cpm.save()
		configfile.save()
		self.setVisualisation()


	def greenPressed(self):
		pass

	def yellowPressed(self):
		pass

	def myCallback(self, ret):
		ret and ret[1]()


	def updateEmbededSonglist(self, currsongID):
		new_songList_Index=[ song[0].songID for song in self.songlist].index(currsongID)
		logger.debug('SPlayer]updateEmbededSonglist]set list and move to new_songList_Index:{}'.format(new_songList_Index))
		if self.embededsonglistisshown=='list':
			self.currembededlist.setList(self.songlist)
			self.currembededlist.moveToIndex(new_songList_Index)
		elif self.embededsonglistisshown in ('2dlist', 'coverwall'):
			self.buildAndShowCoverFlowlist(new_songList_Index)
		self._currentplayingindex=new_songList_Index


	def startPicshow(self):
		from Plugins.Extensions.PicturePlayer.plugin import picshow
		self.session.open(picshow)


	def startPicshow2(self):
		from Plugins.Extensions.PicturePlayer2 import pictureplayer2
		self.session.open(pictureplayer2.picshow2)


	def onScreenSaverTimerTimeout(self):
		self.resetScreenSaverTimer(restart = False)
		logger.debug('SPlayer]onScreenSaverTimerTimeout]start Pixabay')
		if self.PixabayScreen:
			logger.debug('SPlayer]onScreenSaverTimerTimeout]delete old dialog')
			self.session.deleteDialog(self.PixabayScreen)
			self.PixabayScreen = None

		if JCcheckModuleIsUpdated('Pixabay'):
			reload(Pixabay)
		self.PixabayScreen=self.session.instantiateDialog(Pixabay.Pixabay, self)
		self.session.execDialog(self.PixabayScreen)

	
	def closePixabayScreen(self):
		logger.debug('SPlayer]closePixabayScreen]...')
		self.tmptimer = eTimer()
		self.tt_conn = self.tmptimer.timeout.connect(self.onClosePixabayScreenTimeout)
		self.tmptimer.start(500, 1)
		
		
	def onClosePixabayScreenTimeout(self):
		if self.PixabayScreen:
			logger.debug('SPlayer]closePixabayScreen]now...')
			self.session.deleteDialog(self.PixabayScreen)
			self.PixabayScreen = None
		self.tt_conn = None
		self.tmptimer = None


	def startStreamRipperDialog(self):
		logger.debug('SPlayer]startStreamRipperDialog]')
		self.session.openWithCallback(self.streamRipperSetTrackStartnumber, InputBox, windowTitle=_("Set recording length"),  title=_("Enter in minutes (0 means unlimited)"), text="0", type=Input.NUMBER)


	def streamRipperSetTrackStartnumber(self, record_length):
		if record_length is not None:
			self.hlp['record_length']=record_length
			if config.plugins.musiccenter.streamripper_addsequencenumber_on_outputfile.value in ('counter', 'date_and_counter'):
				self.session.openWithCallback(self.streamRipperSetMinimumSongLength, InputBox, windowTitle=_("Set track startnumber"),  title=_("Enter number"), text="0", type=Input.NUMBER)
			else:
				self.streamRipperSetMinimumSongLength(-1)


	def streamRipperSetMinimumSongLength(self, start_number):
		if start_number is not None:
			self.hlp['start_number']=int(start_number)
			self.session.openWithCallback(self.streamRipperSetMinimumSongLengthCallback, InputBox, windowTitle=_("Minimum song recording length"),  title=_("Enter in seconds (0 means unlimited)"), text="60", type=Input.NUMBER)


	def streamRipperSetMinimumSongLengthCallback(self, min_song_duration): # ret minimum song
	
		cpm = config.plugins.musiccenter

		if min_song_duration is not None:
			if not pathExists(cpm.streamripper_base_directory.value):
				createDir(cpm.streamripper_base_directory.value)

			slentry=self.songlist[self._currentplayingindex][0]
			url=self.currentplayingslentry.filename
			stationname=slentry.stationname
			genre=slentry.genre

			if cpm.use_different_streamripper_useragent_for_rip.value:
				user_agent=cpm.different_streamripper_useragent.value
			else:
				user_agent = None

			record_length= int(self.hlp.get('record_length')) * 60
			if record_length==0:
				record_length=-1

			base_directory = cpm.streamripper_base_directory.value
			check_for_dublicates = cpm.streamripper_check_for_dublicates.value
			save_dublicates = cpm.streamripper_save_dublicates.value

			streamripperinstance.Start(url, base_directory = base_directory, record_length=record_length, track_number_format=cpm.streamripper_addsequencenumber_on_outputfile.value, start_number=self.hlp.get('start_number'), min_song_duration=min_song_duration, user_agent=user_agent, stationname=stationname, genre=genre, check_for_dublicates=check_for_dublicates, save_dublicates=save_dublicates)
			logger.debug('SPlayer]inputBoxStartRecordingCallback]ripper started')


	def streamripperDataAvail(self, fake):
		msg=streamripperinstance.Message.pop()
		if msg[0]=='THREAD_WORKING' and not self.embededsonglistisshown:
			self['console'].setText('         {}'.format(msg[1]))


	def stopStreamRipper(self):
		self.session.openWithCallback(self.stopRecordingConfirmed, MessageBox, _("Do you really want to stop the recording?"))


	def stopRecordingConfirmed(self,val):
		if val:
			logger.debug('SPlayer]stopRecordingConfirmed]')
			streamripperinstance.Cancel()
			self['console'].setText("")


	def getNextSonglistIndex(self, index):
		if index +1 > len(self.songlist) -1:
			return 0
		else:
			return index+1


	def getSonglistEntry(self, index = None):
		try:
			if index is None:
				return self.songlist[self._currentplayingindex][0]
			else:
				return self.songlist[index][0]
		except:
			logger.exception('SPlayer]getSonglistEntry]no Songlist? len {} index {} self._currentplayingindex {}! Return default Item!'.format(len(self.songlist), index, self._currentplayingindex))
			return Item()


	def closePlayer(self):# called on exit and player running continius...
		if self.embededsonglistisshown:
			logger.debug('SPlayer]closePlayer]embededsonglist is shown, hideEmbededSonglist now')
			self.showhideEmbededSonglist()
		else:
			self.close()


	def __onClose(self):
		logger.info('SPlayer]__onClose]...')
		self.closePixabayScreen()
		self.shazamWaitTimer_mc_conn = None
		self.ca_conn = None
		self.ca_t_conn = None
		self.aa_conn = None
		self.aa_t_conn = None
		self.screensavertimer_mc_conn = None
		self.musicinfoupdatetimer_mc_conn = None
		self.radioPollTimer_mc_conn = None
		self.streamripper_conn = None
		self.sr_conn = None
		self.net_conn = None
		#eMerlinMusicPlayer.getInstance().setFunc(None)
		logger.debug('SPlayer]__onClose]del ePixmaps...')
		del self['coverArt'], self['stationicon'], self['coverArtround']


	def createSummary(self):
		if JCcheckModuleIsUpdated('LCDScreens'):
			reload(LCDScreens)
		return LCDScreens.LCDPlayer

