#	-*-	coding:	utf-8	-*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

'''
from sys import path as syspath
syspath.append('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter')
import SQLConnector
'''

try:

	from myLogger import logger
	from Components.config import config
	
except:

	print 'running outside e2'
	class objectview(object):
		def __init__(self, d):
			self.__dict__ = d

	config=objectview({'plugins':objectview({'musiccenter':objectview({'databasepath':objectview({'value':'/tmp/'})})})})
		
	class Logger(object):
		def exception(self,l):
			print '{}'.format(l)
		def info(self,l):
			print '{}'.format(l)
		def debug(self,l):
			print '{}'.format(l)			
		
	logger=Logger()

	
from twisted.enterprise import adbapi
from sqlite3 import dbapi2 as sqlite, Row as sqlite3_Row
from os.path import join as os_path_join, exists as os_path_exists
from os import access as os_access, W_OK as os_W_OK, utime as os_utime



def OpenDatabase():
	#logger.info('OpenDatabase]start')
	dbpath=os_path_join(config.plugins.musiccenter.databasepath.value ,"songs_v2.db")
	db_exists=os_path_exists(dbpath)
	try:
		connection=sqlite.connect(dbpath, isolation_level=None, timeout=6)# connection=sqlite.connect('cache.db', timeout=10)
		connection.execute("PRAGMA synchronous = OFF ") # OFF
		connection.execute("PRAGMA journal_mode = OFF") #MEMORY WAL
		if not os_access(dbpath, os_W_OK):
			logger.error("OpenDatabase]Error: database file needs to be writable, can not open %s for writing..." % dbpath)
			connection.close()
			return None
	except:
		logger.exception("OpenDatabase]unable to open database...")
		return None
	if not db_exists :
		connection.execute(
		'''CREATE TABLE IF NOT EXISTS Songs (song_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,  filename TEXT NOT NULL UNIQUE,  title TEXT DEFAULT 'n/a',  artist TEXT DEFAULT 'n/a',  album TEXT DEFAULT 'n/a',  albumartist TEXT DEFAULT 'n/a',  genre TEXT DEFAULT 'n/a',  date TEXT DEFAULT 'n/a', tracknumber INTEGER,  bitrate INTEGER, length TEXT DEFAULT '0', track TEXT DEFAULT 'n/a',  lyrics TEXT DEFAULT 'n/a',  filetype TEXT,  file_m_time INTEGER,  file_size INTEGER,  playcount INTEGER,  rating INTEGER,  wave INTEGER, scantime INTEGER, cover INTEGER , youtubeurl TEXT DEFAULT '', shazam_id TEXT DEFAULT '-1');'''
		)
		connection.execute('''CREATE TABLE IF NOT EXISTS Playlists (
		playlist_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
		playlist_text TEXT NOT NULL DEFAULT 'n/a'
		);''')
		connection.execute('''CREATE TABLE IF NOT EXISTS Playlist_Songs (
		id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
		playlist_id INTEGER NOT NULL,
		song_id INTEGER NOT NULL,
		length INTEGER
		);''')
		connection.execute('''CREATE TABLE IF NOT EXISTS Artists (artist_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, artist_text TEXT NOT NULL UNIQUE DEFAULT 'n/a', shazam_id TEXT DEFAULT '-1');''')
		connection.execute('''CREATE TABLE IF NOT EXISTS Albums (album_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, album_text TEXT NOT NULL UNIQUE DEFAULT 'n/a');''')
		connection.execute('''CREATE TABLE IF NOT EXISTS Albumartists (albumartist_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, albumartist_text TEXT NOT NULL UNIQUE DEFAULT 'n/a');''')
		connection.execute('''CREATE TABLE IF NOT EXISTS Genres (genre_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, genre_text TEXT NOT NULL UNIQUE DEFAULT 'n/a');''')
		connection.execute('''CREATE TABLE IF NOT EXISTS Dates (date_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, date_text TEXT NOT NULL UNIQUE DEFAULT 'n/a');''')
		connection.execute('''CREATE TABLE IF NOT EXISTS Playlists (playlist_id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, playlist_text TEXT NOT NULL DEFAULT 'n/a');''')
		connection.execute('''CREATE TABLE IF NOT EXISTS Playlist_Songs (id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, playlist_id INTEGER NOT NULL, song_id INTEGER NOT NULL DEFAULT 'n/a');''')

		connection.execute('''CREATE TRIGGER check_tablesentrys_after_song_inserted
		AFTER INSERT ON Songs
		FOR EACH ROW
		BEGIN
			INSERT INTO Artists (artist_text) SELECT NEW.artist WHERE (SELECT 1 FROM Artists WHERE artist_text=NEW.artist LIMIT 1) is Null;
			INSERT INTO Albums (album_text) SELECT NEW.album WHERE (SELECT 1 FROM Albums WHERE album_text=NEW.album LIMIT 1) is Null;
			INSERT INTO Albumartists (albumartist_text) SELECT NEW.albumartist WHERE (SELECT 1 FROM Albumartists WHERE albumartist_text=NEW.albumartist LIMIT 1) is Null;
			INSERT INTO Genres (genre_text) SELECT NEW.genre WHERE (SELECT 1 FROM Genres WHERE genre_text=NEW.genre LIMIT 1) is Null;
			INSERT INTO Dates (date_text) SELECT NEW.date WHERE (SELECT 1 FROM Dates WHERE date_text=NEW.date LIMIT 1) is Null;
		END;''')

		connection.execute('''CREATE TRIGGER check_tablesentrys_after_song_updated
		AFTER UPDATE ON Songs
		FOR EACH ROW
		BEGIN
			INSERT INTO Artists (artist_text) SELECT NEW.artist WHERE (SELECT 1 FROM Artists WHERE artist_text=NEW.artist LIMIT 1) is Null;
			INSERT INTO Albums (album_text) SELECT NEW.album WHERE (SELECT 1 FROM Albums WHERE album_text=NEW.album LIMIT 1) is Null;
			INSERT INTO Albumartists (albumartist_text) SELECT NEW.albumartist WHERE (SELECT 1 FROM Albumartists WHERE albumartist_text=NEW.albumartist LIMIT 1) is Null;
			INSERT INTO Genres (genre_text) SELECT NEW.genre WHERE (SELECT 1 FROM Genres WHERE genre_text=NEW.genre LIMIT 1) is Null;
			INSERT INTO Dates (date_text) SELECT NEW.date WHERE (SELECT 1 FROM Dates WHERE date_text=NEW.date LIMIT 1) is Null;
			DELETE FROM Artists WHERE artist_text=OLD.artist AND (SELECT 1 FROM Songs WHERE artist=OLD.artist LIMIT 1) is Null;
			DELETE FROM Albums WHERE album_text=OLD.album AND (SELECT 1 FROM Songs WHERE album=OLD.album LIMIT 1) is Null;
			DELETE FROM Albumartists WHERE albumartist_text=OLD.albumartist AND (SELECT 1 FROM Songs WHERE albumartist=OLD.albumartist LIMIT 1) is Null;
			DELETE FROM Genres WHERE genre_text=OLD.genre AND (SELECT 1 FROM Songs WHERE genre=OLD.genre LIMIT 1) is Null;
			DELETE FROM Dates WHERE date_text=OLD.date AND (SELECT 1 FROM Songs WHERE date=OLD.date LIMIT 1) is Null;
		END;''')
		#DELETE FROM Artists WHERE artist_text=OLD.artist AND (SELECT 1 FROM Songs WHERE artist=OLD.artist LIMIT 1) is Null;
		#DELETE FROM Albums WHERE album_text=OLD.album AND (SELECT 1 FROM Songs WHERE album=OLD.album LIMIT 1) is Null;
		#DELETE FROM Albumartists WHERE albumartist_text=OLD.albumartist AND (SELECT 1 FROM Songs WHERE albumartist=OLD.albumartist LIMIT 1) is Null;
		#DELETE FROM Genres WHERE genre_text=OLD.genre AND (SELECT 1 FROM Songs WHERE genre=OLD.genre LIMIT 1) is Null;
		#DELETE FROM Dates WHERE date_text=OLD.date AND (SELECT 1 FROM Songs WHERE date=OLD.date LIMIT 1) is Null;

		
		#connection.execute('''CREATE TRIGGER cleanup_tables_after_song_deleted
		#AFTER DELETE ON Songs
		#FOR EACH ROW
		#BEGIN
		#	DELETE FROM Artists WHERE artist_text=OLD.artist AND (SELECT 1 FROM Songs WHERE artist=OLD.artist LIMIT 1) is Null;
		#	DELETE FROM Albums WHERE album_text=OLD.album AND (SELECT 1 FROM Songs WHERE album=OLD.album LIMIT 1) is Null;
		#	DELETE FROM Albumartists WHERE albumartist_text=OLD.albumartist AND (SELECT 1 FROM Songs WHERE albumartist=OLD.albumartist LIMIT 1) is Null;
		#	DELETE FROM Genres WHERE genre_text=OLD.genre AND (SELECT 1 FROM Songs WHERE genre=OLD.genre LIMIT 1) is Null;
		#	DELETE FROM Dates WHERE date_text=OLD.date AND (SELECT 1 FROM Songs WHERE date=OLD.date LIMIT 1) is Null;
		#END;''')

		connection.execute('''CREATE VIEW table_entry_counts AS
		SELECT count(1), (SELECT count(distinct(artist_id)) FROM Artists AS artists), (SELECT count(distinct(album_id)) FROM Albums AS albums), (SELECT count(distinct(genre_id)) FROM Genres AS genres), (SELECT count(distinct(date_id)) FROM Dates AS dates), (SELECT count(1) FROM Songs AS songs), (SELECT count(1) FROM Songs AS playcounts WHERE playcount>0), (SELECT count(1) FROM Songs AS ratings WHERE rating <257) FROM Playlists AS playlists;''')
	#logger.info('OpenDatabase]end')

	return connection


def OpenDatabasePool():

	def setRowFactory(connection):
		connection.row_factory = sqlite3_Row
		connection.text_factory=str

	logger.info('OpenDatabasePool]start')
	dbpath=os_path_join(config.plugins.musiccenter.databasepath.value ,"songs_v2.db")
	db_exists=os_path_exists(dbpath)

	if not db_exists:
		logger.info('OpenDatabasePool]no database found create now...')
		c=OpenDatabase()
		c.close()

	if not os_access(dbpath, os_W_OK):
		logger.error("OpenDatabasePool]Error: database file needs to be writable, can not open %s for writing..." % dbpath)
		return None

	try:
		return adbapi.ConnectionPool("sqlite3", dbpath, check_same_thread=False, cp_openfun=setRowFactory)
	except:
		logger.exception('OpenDatabasePool]unable to open database...')
		return None


def sqlCommand(sql):
	logger.debug('sqlCommand]!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!->%s' %str(sql)[:300])
	c=OpenDatabase()
	if c is not None:
		with c:
			csr=c.cursor()
			csr.execute(sql)


def sqlCommandWithReturn(sql, db='songs'):
	logger.debug('sqlCommandWithReturn]!!!!!!!!!!!!!!!!!!!!!!!!!!!!!->%s' %str(sql)[:100])
	c=None
	if db=='songs':
		c=OpenDatabase()

	if c is not None:
		with c:
			c.row_factory = sqlite3_Row
			c.text_factory=str
			csr=c.cursor()
			csr.execute(sql)
	else:
		csr=None
	return csr


def execSQLCommand(sql, args = '',  con = None):
	logger.debug('execSQLCommand]sql:{} args:{}'.format(sql, str(args)))
	if con is None:
		con = OpenDatabase()
		
	if con is not None:
	
		with con:
			con.text_factory=str
			if args:
				con.execute(sql, args)
			else:
				con.execute(sql)


def execSQLCommandMany(sql, args = '',  con = None):
	logger.debug('execSQLCommandMany]sql:{} args:{}'.format(sql, str(args)))
	if con is None:
		con = OpenDatabase()
		
	if con is not None:
	
		with con:
			con.text_factory=str
			if args:
				con.executemany(sql, args)
			else:
				con.executemany(sql)


def execSQLCommandWithReturn(sql, args = '', con = None):
	logger.debug('execSQLCommandWithReturn]sql:{} args:{}'.format(sql, str(args)))
	if con is None:
		con = OpenDatabase()
		
	if con is not None:

		with con:
			con.row_factory = sqlite3_Row
			con.text_factory=str
			if args:
				return con.execute(sql, args)
			else:
				return con.execute(sql)

	else:
		logger.error('execSQLCommandWithReturn]error, no con!')
