# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.



from Globals import *
import SelectPath
from myLogger import logger, setLogLevel



class MusicCenterSetup(Screen, ConfigListScreen):

	if RESOLUTIONx>1800:
		skin='''<screen name="MusicCenterSetup" position="0,0" size="1920,1080" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="20,20" size="1900,100" zPosition="1" />
				<widget name="headertext" position="140,39" size="1760,42" font="SansReg;35" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
			<!-- Buttons -->
				<eLabel position="20,135" size="1900,40" backgroundColor="#191919" zPosition="1" />
				<!-- red -->
					<widget render="Label" font="SansReg;34" position="100,135" size="450,40" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<!-- green -->
					<widget render="Label" font="SansReg;34" position="510,135" size="450,40" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
			<widget name="config" position="35,190" size="1850,750" backgroundColor="#00000000" scrollbarMode="showOnDemand" />
			<widget source="help_text" render="Label" position="35,950" size="1850,120" font="SansReg;36" />
		</screen>'''

	else:
		skin='''<screen name="MusicCenterSetup" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="13,13" size="1266,66" zPosition="1" />
				<widget name="headertext" position="93,26" size="1173,28" font="SansReg;23" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
			<!-- Buttons -->
				<eLabel position="13,90" size="1266,33" backgroundColor="#191919" zPosition="1" />
				<!-- red -->
					<widget render="Label" font="SansReg;25" position="66,92" size="300,28" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<!-- green -->
					<widget render="Label" font="SansReg;25" position="340,92" size="300,28" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
			<widget name="config" position="24,126" size="1230,500" backgroundColor="#00000000" scrollbarMode="showOnDemand" />
			<widget source="help_text" render="Label" position="24,630" size="1850,110" font="SansReg;22" />
		</screen>'''


	def __init__(self, session, showsections = ('general', 'player', 'filemode', 'internetradio', 'streamripper', 'pixabay')):

		logger.info('MusicCenterSetup]__init__')
		Screen.__init__(self, session)


		self["key_red"] = StaticText(_("Cancel"))
		self["key_green"] = StaticText(_("OK"))
		self["help_text"] = StaticText()
		self['headertext']=Label('MusicCenter Setup')

		clst = []
		cpm = config.plugins.musiccenter
		if 'general' in showsections:
			clst.append(getConfigListEntry(_("-------- General Configuration --------"), cpm.fake,_("Start General Configuration")))
			self.databasepath = getConfigListEntry(_("Path to database"), cpm.databasepath, _("Select folder for storage database. Fast device is good!"))
			clst.append(self.databasepath)
			self.downloadcache = getConfigListEntry(_("Path to cache"), cpm.downloadcache, _("Select folder for store downloaded content. Please use usb, ssd or /data path with more then 2Gb free space!"))
			clst.append(self.downloadcache)
			clst.append(getConfigListEntry(_("Show MusicCenter in mainmenu"), cpm.musiccentermainmenu, _("Show MusicCenter in Mainmenu")))
			clst.append(getConfigListEntry(_("Show MusicCenter in extended-pluginlist"), cpm.musiccenterextendedpluginlist, _("Show MusicCenter in extended pluginlist")))
			clst.append(getConfigListEntry(_("Activate debug log"),cpm.setdebug, _("Select the loglevel. High level will slow down the performace")))

		if 'filemode' in showsections:
			clst.append(getConfigListEntry(_("-------- Filemode & Databasemode Configuration --------"), cpm.fake,_("Start Filemode Configuration")))
			self.defaultFileBrowserPath = getConfigListEntry(_("Musiclibrary root directory"), cpm.defaultfilebrowserpath, _("This path is the root directory to your musiclibrary. All files in this folder will by added to database. If saving last browserpath not set, start on this path, and this path is showed under bookmarks as first entry"))
			clst.append(self.defaultFileBrowserPath)
			clst.append(getConfigListEntry(_("Rescan Musiclibrary automaticly"), cpm.autodatabasescan, _("Rescan your Musiclibrary automaticly every night betwin 22:00 und 6:00 if stb is in standby")))

			clst.append(getConfigListEntry(_("Percent of playing  song to increase playcounter"), cpm.playcountertriggerprozent, _("Percent value to increase the playcounter in database and Songfile.")))
			clst.append(getConfigListEntry(_("Time of playing the song to increase playcounter"), cpm.playcountertriggertime, _("Time value to increase the playcounter in database and Songfile.")))

			clst.append(getConfigListEntry(_("Embed downloaded covers on songfile"), cpm.addcoverautotosong, _("This option embed cover on songfile if cover was found")))
			clst.append(getConfigListEntry(_("Remember last path of filebrowser"), cpm.rememberlastfilebrowserpath, _("Save last used filebrowserpath, and show after reopen")))
			if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/MediaPortal/plugin.py'):
				clst.append(getConfigListEntry(_("Youtube Resolver"),cpm.ytresolver, _("Select the Resolver to play Youtube Videos.")))
				
			self.ytcachedir = getConfigListEntry(_("Youtube cache directory"), cpm.ytcachedir, _("This folder will be used for cache youtube videos"))
			clst.append(self.ytcachedir)
			
		if 'internetradio' in showsections:
			clst.append(getConfigListEntry(_("-------- Internetradio Configuration --------"), cpm.fake,_("Start Internetradio Configuration")))
			clst.append(getConfigListEntry(_("Set min MP3 streaming bitrate:"), cpm.minmp3streamingrate, _("Set the minimum bitrate for showing MP3 streaming stations")))
			clst.append(getConfigListEntry(_("Set min AAC streaming bitrate:"), cpm.minaacstreamingrate, _("Set the minimum bitrate for showing AAC streaming stations")))
			clst.append(getConfigListEntry(_("Set min WMA streaming bitrate:"), cpm.minwmastreamingrate, _("Set the minimum bitrate for showing WMA streaming stations")))

		if 'streamripper' in showsections:
			clst.append(getConfigListEntry(_("-------- Streamripper Configuration --------"), cpm.fake,_("Start Streamripper Configuration")))
			self.defaultIRDirname = getConfigListEntry(_("Path to save song files"), cpm.streamripper_base_directory, _("Rootfolder for storing downloaded songs"))
			clst.append(self.defaultIRDirname)
			clst.append(getConfigListEntry(_("Add tracknumbers to song files:"), cpm.streamripper_addsequencenumber_on_outputfile, _("NO --> don`t add tracknumber\nCounter -->0000\nDate and >counter-->mmdd-000")))
			clst.append(getConfigListEntry(_("Check ripped songs for dublicates:"), cpm.streamripper_check_for_dublicates, _("Ripped songs will by checked for dublicate. If dublicate found, song was moved or deleted. Select it on next entry!")))
			clst.append(getConfigListEntry(_("Save dublicate songs?"), cpm.streamripper_save_dublicates, _("Selcect here if you want hold dublicate songs!")))
			clst.append(getConfigListEntry(_("Use different useragent for streamripper"), cpm.use_different_streamripper_useragent_for_rip,  _("If streamripper is blocked on radiostation, then set this option to get running ripping")))
			clst.append(getConfigListEntry(_("Useragent"), cpm.different_streamripper_useragent,  _("Set different useragent here")))
		
		if 'pixabay' in showsections:
			clst.append(getConfigListEntry(_("-------- Pixabay Screensaver Configuration --------"), cpm.fake,_("Start Streamripper Configuration")))
			clst.append(getConfigListEntry(_("Time to start Screensaver"), cpm.pixabay.starttime, _("After this time start the Pixabay Screensaver. 0 disable it.")))
			clst.append(getConfigListEntry(_("Time between moves"), cpm.pixabay.movetime, _("Timespawn between the image will be moved")))
			clst.append(getConfigListEntry(_("Fadetime duration"), cpm.pixabay.fadetime, _("Duration of fading")))


		ConfigListScreen.__init__(self, clst, session)


		self["setupActions"] = ActionMap(["SetupActions", "ColorActions"],
		{
			"green": self.keySave,
			"cancel": self.keyClose,
			"ok": self.keySelect,
		}, -2)

		def selectionChanged():
			if self["config"].current:
				self["config"].current[1].onDeselect(self.session)
			self["config"].current = self["config"].getCurrent()
			if self["config"].current:
				self["config"].current[1].onSelect(self.session)

			for x in self["config"].onSelectionChanged:
				x()

		self["config"].selectionChanged = selectionChanged
		self["config"].onSelectionChanged.append(self.updateHelp)


	def keySelect(self):
		cur = self["config"].getCurrent()
		cpm = config.plugins.musiccenter
		
		if cur == self.downloadcache:
			self.session.openWithCallback(self.selectedDownloadCacheDirectory, SelectPath.SelectPath, cpm.downloadcache.value)
		elif cur == self.databasepath:
			self.session.openWithCallback(self.selectedDatabaseDirectory, SelectPath.SelectPath, cpm.databasepath.value)
		elif cur == self.defaultFileBrowserPath:
			self.session.openWithCallback(self.selectedFilebrowserDirectory, SelectPath.SelectPath, cpm.defaultfilebrowserpath.value)
		elif cur == self.defaultIRDirname:
			self.session.openWithCallback(self.selectedStreamripperDirectory, SelectPath.SelectPath, cpm.streamripper_base_directory.value)
		elif cur == self.ytcachedir:
			self.session.openWithCallback(self.selectedYtcachedir, SelectPath.SelectPath, cpm.ytcachedir.value)


	def selectedDownloadCacheDirectory(self, directory):
		logger.debug('MusicCenterSetup]selectedDownloadCacheDirectory]{}'.format(directory))
		if directory is not None:
			config.plugins.musiccenter.downloadcache.value=directory[0]


	def selectedDatabaseDirectory(self, directory):
		logger.debug('MusicCenterSetup]selectedDatabaseDirectory]{}'.format(directory))
		if directory is not None:
			config.plugins.musiccenter.databasepath.value=directory[0]


	def selectedFilebrowserDirectory(self, directory):
		logger.debug('MusicCenterSetup]selectedFilebrowserDirectory]{}'.format(directory))
		if directory is not None:
			config.plugins.musiccenter.defaultfilebrowserpath.value=directory[0]


	def selectedStreamripperDirectory(self, directory):
		logger.debug('MusicCenterSetup]selectedStreamripperDirectory]{}'.format(directory))
		if directory is not None:
			config.plugins.musiccenter.streamripper_base_directory.value=directory[0]


	def selectedYtcachedir(self, directory):
		logger.debug('MusicCenterSetup]selectedYtcachedir]{}'.format(directory))
		if directory is not None:
			config.plugins.musiccenter.ytcachedir.value=directory[0]


	def keySave(self):
		setLogLevel(logger)
		for x in self["config"].list:
			x[1].save()
		configfile.save() # save config crash resistent
		self.initDirectorys()
		self.close(True)


	def initDirectorys(self):
		logger.info('MusicCenterSetup]initCacheAndDirectorys]start')
		cpm = config.plugins.musiccenter
		
		for entry in (cpm.downloadcache.value, ('artistpics', 'artistpics/Default', 'cache', 'covers', 'favoritestationicons', 'screensaver',  'shazam', 'waves')), (cpm.databasepath.value, ('',)), (cpm.defaultfilebrowserpath.value, ('',)), (cpm.streamripper_base_directory.value, ('',)):
			for dir in entry[1]:
				path = os_path_join(entry[0], dir)
				if not pathExists(path):
					logger.info('MusicCenterSetup]initCacheAndDirectorys]create path:{}'.format(path))
					createDir(path)
				else:
					logger.debug('MusicCenterSetup]initCacheAndDirectorys]checked path:{}'.format(path))
		logger.info('MusicCenterSetup]initCacheAndDirectorys]end')


	def keyClose(self):
		for x in self["config"].list:
			x[1].cancel()
		self.close(False)


	def updateHelp(self):
		cur = self["config"].getCurrent()
		if cur:
			self["help_text"].text = cur[2]

