# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

from Globals import *

class MusicCenterTasksScreen(Screen):# source from MyTube..

	if RESOLUTIONx>1800:
	
		skin = """
			<screen name="MusicCenter - Tasks"  position="0,0" size="1920,1080" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
				<!-- Header -->
					<eLabel backgroundColor="#191919" position="20,20" size="1880,100" zPosition="1" /> 
					<widget name="headertext" position="140,39" size="1760,42" font="SansReg;35" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
				<!-- Buttons -->
					<eLabel position="20,135" size="1880,40" backgroundColor="#191919" zPosition="1" /> 
					<widget render="Label" font="SansReg;34" position="100,138" size="450,40" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget render="Label" font="SansReg;34" position="510,138" size="450,40" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget render="Label" font="SansReg;34" position="960,138" size="450,40" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget render="Label" font="SansReg;34" position="1410,138" size="450,40" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>	
				<!-- lists -->
					<widget source="tasklist" render="Listbox" position="75,195" size="1800,855" zPosition="7" scrollbarMode="showOnDemand" >
						<convert type="TemplatedMultiContent">
							{"template": [
									MultiContentEntryText(pos = (0, 1), size = (1200, 36), font=1, flags = RT_HALIGN_LEFT, text = 1), # index 1 is the name
									MultiContentEntryText(pos = (1250, 1), size = (225, 36), font=1, flags = RT_HALIGN_RIGHT, text = 2), # index 2 is the state
									MultiContentEntryProgress(pos = (1500, 1), size = (150, 36), percent = -3), # index 3 should be progress
									MultiContentEntryText(pos = (1680, 1), size = (100, 36), font=1, flags = RT_HALIGN_RIGHT, text = 4), # index 4 is the percentage
								],
							"fonts": [gFont("SansReg", 33),gFont("SansReg", 27)],
							"itemHeight": 39
							}
						</convert>
					</widget>
			</screen>"""

	else:

		skin = """
			<screen name="MusicCenter - Tasks"  position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
				<!-- Header -->
					<eLabel backgroundColor="#191919" position="14,14" size="1253,66" zPosition="1" /> 
					<widget name="headertext" position="94,23" size="1173,28" font="SansReg;24" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
				<!-- Buttons -->
					<eLabel position="20,135" size="1253,27" backgroundColor="#191919" zPosition="1" /> 
					<widget render="Label" font="SansReg;24" position="66,92" size="300,24" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget render="Label" font="SansReg;24" position="340,92" size="300,24" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget render="Label" font="SansReg;24" position="640,92" size="300,24" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
					<widget render="Label" font="SansReg;24" position="940,92" size="300,24" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>	
				<!-- lists -->
					<widget source="tasklist" render="Listbox" position="50,130" size="1200,570" zPosition="7" scrollbarMode="showOnDemand" >
						<convert type="TemplatedMultiContent">
							{"template": [
									MultiContentEntryText(pos = (0, 1), size = (800, 24), font=1, flags = RT_HALIGN_LEFT, text = 1), # index 1 is the name
									MultiContentEntryText(pos = (833, 1), size = (150, 24), font=1, flags = RT_HALIGN_RIGHT, text = 2), # index 2 is the state
									MultiContentEntryProgress(pos = (1000, 1), size = (150, 36), percent = -3), # index 3 should be progress
									MultiContentEntryText(pos = (1120, 1), size = (66, 24), font=1, flags = RT_HALIGN_RIGHT, text = 4), # index 4 is the percentage
								],
							"fonts": [gFont("SansReg", 22),gFont("SansReg", 18)],
							"itemHeight": 26
							}
						</convert>
					</widget>
			</screen>"""


	def __init__(self, session):
	
		Screen.__init__(self, session)
		self.session = session
		
		self["tasklist"] = List([])

		self["shortcuts"] = ActionMap(["ShortcutActions", "WizardActions", "MediaPlayerActions"],
		{
			"ok": self.keyOK,
			"back": self.keyCancel,
			"red": self.keyCancel,
		}, -1)

		self["key_red"] = StaticText(_("Back"))
		self["key_green"] = StaticText(_("-"))
		self["key_yellow"] = StaticText(_("-"))
		self["key_blue"] = StaticText(_("-"))
		self["headertext"] = Label()

		self.onLayoutFinish.append(self._onlayoutFinished)
		self.onClose.append(self.__onClose)
		self.Timer = eTimer()
		self.Timer_mc_conn=self.Timer.timeout.connect(self.TimerFire)


	def __onClose(self):
		del self.Timer


	def _onlayoutFinished(self):
		self.buildTaskList()


	def TimerFire(self):
		self.Timer.stop()
		self.buildTaskList()


	def buildTaskList(self):
	
		jobs = musiccenterJobmanager.getPendingJobs()
		self["headertext"].setText(_("{} active jobs".format(len(jobs))))
		
		tasklist = []
		for job in jobs:
			tasklist.append((job,job.name,job.getStatustext(),int(100*job.progress/float(job.end)) ,str(100*job.progress/float(job.end)) + "%" ))
			
		self['tasklist'].setList(tasklist)
		self['tasklist'].updateList(tasklist)
		self.Timer.startLongTimer(2)


	def keyOK(self):
		current = self["tasklist"].getCurrent()
		print current
		if current:
			job = current[0]
			from Screens.TaskView import JobView
			self.session.openWithCallback(self.JobViewCB, JobView, job)


	def JobViewCB(self, why):
		pass


	def keyCancel(self):
		self.close()


	def keyCancel(self):
		self.close()
