# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.

#</div><div class="yt-lockup-content"><h3 class="yt-lockup-title "><a href=.*?title="(.*?)" rel="spf-prefetch".*?dir="ltr">(.*?)</a><span class="accessible-description" id=.*?> - Dauer: (.*?)</span></h3><div class="yt-lockup-byline ">.*? >(.*?)</a></div><div class="yt-lockup-meta "><ul class="yt-lockup-meta-info"><li>(.*?)</li><li>(.*?)</li></ul>
# 'https://www.youtube.com/results?search_query=Eros+Ramazzotti+%26+Helene+Fischer+-+Per+Il+Resto+Tutto+Bene'
#(u'Helene Fischer + Eros Ramazzotti - per il resto tutto bene', u'Helene Fischer + Eros Ramazzotti - per il resto tutto bene', u'3:31', u'christina werkman', u'vor 1 Woche', u'69.376 Aufrufe')

from Globals import *

from myLogger import logger
from JobCenter import *
	
from base64 import decodestring as base64_decodestring, b64decode as base64_b64decode


def youtubeentry(match, tumbfn, zoomfactor, size, oldvidurl):

	vidurl, title, x, y, iname, uploaddate, descripion=match
	
	def cleanchars(text):
		cleanhtml = re_compile('<.*?>')
		return re_sub(cleanhtml, '', text).replace('&quot;','').decode('utf-8')

	xptr, yptr=size

	selcolor = parseColor("#ffffff").argb()# white
	color = parseColor("#C6C6C6").argb()#fast weiß
	if vidurl==oldvidurl:
		color = parseColor("#17C423").argb()#grün

	res = [vidurl]
	ptr=LoadPixmap(cached=False, path=tumbfn)
	res.append((eListboxPythonMultiContent.TYPE_PIXMAP,  int(10*zoomfactor), 0, xptr, yptr, ptr))
	xoffset=int(xptr+20*zoomfactor)
	res.append((eListboxPythonMultiContent.TYPE_TEXT, xoffset,  int(5*zoomfactor), int((1250-xoffset)*zoomfactor), int(30*zoomfactor), 0, RT_HALIGN_LEFT|RT_VALIGN_CENTER, title, color, selcolor)) # url
	res.append((eListboxPythonMultiContent.TYPE_TEXT, xoffset,  int(35*zoomfactor), int((1250-xoffset)*zoomfactor), int(30*zoomfactor), 1, RT_HALIGN_LEFT|RT_VALIGN_CENTER, '{} - {}'.format(uploaddate, cleanchars(descripion),), color, selcolor))
	res.append((eListboxPythonMultiContent.TYPE_TEXT, xoffset,  int(65*zoomfactor), int((1250-xoffset)*zoomfactor), int(30*zoomfactor), 2, RT_HALIGN_LEFT|RT_VALIGN_CENTER, vidurl, color, selcolor)) # resolution
	
	return res


class YoutubeSearchScreen(Screen):


	if RESOLUTIONx>1800:
		skin = """
			<screen name="YoutubeSearchScreen"  position="0,0" size="1920,1080" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="20,20" size="1880,100" zPosition="1" /> 
				<widget name="headertext" position="140,39" size="1760,42" font="SansReg;35" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
				<ePixmap position="20,20" size="100,100" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/google_200x200.png" scale="1" zPosition="2"/>
			<!-- Buttons -->
				<eLabel position="20,135" size="1880,40" backgroundColor="#191919" zPosition="1" /> 
				<widget render="Label" font="SansReg;34" position="100,138" size="450,40" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;34" position="510,138" size="450,40" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;34" position="960,138" size="450,40" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;34" position="1410,138" size="450,40" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>	
			<!-- lists -->
				<widget name="resultlist" position="75,195" zPosition="1" size="1800,855" scrollbarMode="showOnDemand" backgroundColor="#00000000"/>
			</screen>"""
	else:
		skin = """
			<screen name="YoutubeSearchScreen"  position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000" zPosition="0">
			<!-- Header -->
				<eLabel backgroundColor="#191919" position="13,13" size="1253,67" zPosition="1" /> 
				<widget name="headertext" position="96,26" size="1173,28" font="SansReg;25" foregroundColor="#ffffff" backgroundColor="#191919" halign="center" valign="center" zPosition="3" />
				<ePixmap position="13,13" size="67,67" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/images/google_200x200.png" scale="1" zPosition="2"/>
			<!-- Buttons -->
				<eLabel position="13,90" size="1253,27" backgroundColor="#191919" zPosition="1" /> 
				<widget render="Label" font="SansReg;22" position="67,96" size="300,27" source="key_red" foregroundColor="#ff0000" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;22" position="340,96" size="300,27" source="key_green" foregroundColor="#00ff21" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;22" position="640,96" size="300,27" source="key_yellow" foregroundColor="#FFD800" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>
				<widget render="Label" font="SansReg;22" position="940,96" size="300,27" source="key_blue" foregroundColor="#3D8DFF" backgroundColor="#191919" halign="center" valign="center" zPosition="2"/>	
			<!-- lists -->
				<widget name="resultlist" position="50,130" zPosition="1" size="1200,570" scrollbarMode="showOnDemand" backgroundColor="#00000000"/>
			</screen>"""
		
	def __init__(self, session, searchterm, slentry):

		logger.info('YoutubeSearchScreen]__init__')

		self.session = session

		Screen.__init__(self, session)

		self['headertext'] = Label()
		self["key_red"] = StaticText(_("Back"))
		self["key_green"] = StaticText(_("Use selected Entry"))
		self["key_yellow"] = StaticText(_("Edit Serachstring"))
		self["key_blue"] = StaticText("")
		self["actions"]  = ActionMap(["OkCancelActions", "WizardActions", "ColorActions", "SetupActions", "MenuActions", "EPGSelectActions"], {
			"cancel": self.keyCancel,
			"red": self.keyCancel,
			"green" : self.greenPressed,
			"yellow" : self.yellowPressed,
			"blue" : self.bluePressed,
			}, -1)
		
		self['resultlist'] = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		if RESOLUTIONx>1800:
			zoomfactor=1.5
		else:
			zoomfactor=1
		self['resultlist'].l.setFont(0, gFont("SansReg", int(26*zoomfactor)))
		self['resultlist'].l.setFont(1, gFont("SansReg", int(22*zoomfactor)))
		self['resultlist'].l.setFont(2, gFont("SansReg", int(18*zoomfactor)))
		itemhigth=100*zoomfactor
		self['resultlist'].l.setItemHeight(int(itemhigth))
		self.zoomfactor=zoomfactor
		
		self.searchterm = searchterm
		self.slentry = slentry
		self.vidurl=slentry.youtubeurl
		self.matchlist=[]
		factor=16/9.0
		yptr=itemhigth
		xptr=float(factor)*yptr
		self.size=xptr,yptr
		logger.debug('YoutubeSearchScreen]__init__]xptr->{} yptr->{}'.format(xptr,yptr))
		
		self.onLayoutFinish.append(self._onLayoutFinishRun)


	def _onLayoutFinishRun(self):
		logger.debug('YoutubeSearchScreen]_onLayoutFinishRun]searchterm {}'.format(self.searchterm))		
		self.getYoutubeSearch()
		self['headertext'].setText('Youtube search start {}'.format(self.searchterm))


	def yellowPressed(self):
		options=[]
		term='{} HD'.format(self.searchterm)
		options.append((_(term), self.stringEditedCallback, term),)
		term='{} HQ'.format(self.searchterm)
		options.append((_(term), self.stringEditedCallback, term),)
		term='{} Offical'.format(self.searchterm)
		options.append((_(term), self.stringEditedCallback, term),)
		term='{} (Official Music Video)'.format(self.searchterm)
		options.append((_(term), self.stringEditedCallback, term),)
		options.append((_('Edit Searchstring'), self.openStringEdit),)
		self.session.openWithCallback(self.yellowPressedCallback, ChoiceBox, title=_('Searchchoices'), list=options, keys=MYKEYSORT, titlebartext=_('MusicCenter'))


	def yellowPressedCallback(self, ret):
		if ret:
			if len(ret)==2:
				ret[1]()
			elif len(ret)==3:
				ret[1](ret[2])

				
	def openStringEdit(self):	
		self.session.openWithCallback(self.stringEditedCallback, vInputBox, title=_("old:  "+self.searchterm), windowTitle=_('MusicCenter Edit Searchstring'), text=self.searchterm)
		

	def stringEditedCallback(self, answer):
		logger.debug('YoutubeSearchScreen]stringEditedCallback]->{}'.format(answer))
		if answer is not None:
			self['resultlist'].setList([])
			self.matchlist=[]
			self.searchterm=answer
			self._onLayoutFinishRun()

			
	def greenPressed(self):
		vidurl=self['resultlist'].getCurrent()
		if vidurl is not None:	
			logger.debug('YoutubeSearchScreen]greenPressed]vidurl:{}'.format(vidurl[0]))
			self.close(vidurl[0], self.slentry)

			
	def keyCancel(self):
		self.close(None, None)
			
			
	def getYoutubeSearch(self):
		#url='https://www.google.de/search?q={}&num=4&source=lnms&tbm=vid'.format(self.searchterm)
		resultcount = 8
		url='https://www.google.de/search?q={}&num={}&source=lnms&tbm=vid&tbs=hq:h,srcf:H4sIAAAAAAAAACWKQQrAIAzAftPLwD-12lHRUnHtxn4_1cacQkuO18CBO2RQesQt1dC5bqfZOhvM3qT5wYlmrwImZyazton4vpmjwASf_1sYtOAAAA'.format(quote(self.searchterm), resultcount)
		logger.info('YoutubeSearchScreen]getYoutubeSearch]url->%s' %url)
		getPage(url, timeout=TWISTED_TIMEOUT, agent='Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.17 (KHTML, like Gecko) Chrome/24.0.1312.56 Safari/537.17').addCallback(self.getYoutubeSearchCallback,).addErrback(self.getYoutubeSearchErrback, 'getYoutubeSearch')

		
	def getYoutubeSearchCallback(self, html):

		# out 31.01.2019 maske='''r"><a href="(.*?)" ping=.*?"LC20lb">(.*?)</h3><br><div style=".*?style="height:(.*?)px;width:(.*?)px"><a.*?px"><img id="(.*?)" src=".*?><div class="slp f">(.*?)</div><span class="st">(.*?)</span></div><div'''
		# out 22.10.2019 maske='''<div class="r"><a href="(.*?)" ping=.*?class="LC20lb">(.*?)</h3><br><div.*?style="height:(.*?)px;width:(.*?)px"><a.*?px"><img id="(.*?)" src=".*?><div class="slp f">(.*?)</div><span class="st">(.*?)</span></div><div'''
		maske='''<div class="r"><a href="(.*?)" ping=.*?class="LC20lb">(.*?)</h3><br><div.*?style="height:(.*?)px;width:(.*?)px" href.*?px"><img id="(.*?)" src=".*?><div class="slp f">(.*?)</div><span class="st">(.*?)</span></div><div'''
		matches=re_findall(maske, html) #url, title, ix,iy, iname, uploaddate, descripion
		images=re_findall('''var s=\'data\:image\/(.*?)\;base64\,(.*?)\';var ii=\[\'(.*?)\'\]''', html)# type, base64, id
	
		if matches:
		
			for match in matches:
			
				vidurl, title, ix,iy, iname, uploaddate, descripion=match
				
				local_filename = ''
				#image=re_findall('''var _image_src=\'(.*?)\';var _image_ids=\['{}'''.format(iname), html)
				if images:
				
					for image in images:
						if image[2]==iname:
									
							logger.info('YoutubeSearchScreen]getYoutubeSearch]image id:{}'.format(iname))		
							if image[0]=='jpeg':
								imagetype='jpg'
								data=self.decodeImage(image[1])
							elif image[0]=='png':
								imagetype='png'
								data=self.decodeImage(image[1])
							else:
								logger.info('YoutubeSearchScreen]getYoutubeSearch]image data->%s' %image[0])		
								data=None

							if data:
								local_filename = '/tmp/mc/{}.{}'.format(iname, imagetype)
								with open(local_filename, 'wb') as f:
									f.write(data)
							data=None
							
							break
				else:
					logger.error('YoutubeSearchScreen]getYoutubeSearchCallback]No image found, write result to file')
					with open ('/tmp/mc/youtube_error_image.result', 'wb') as f:
						f.write(html)
	
				self.matchlist.append(youtubeentry(match, local_filename, self.zoomfactor, self.size, self.vidurl))

			
			match='disable', 'disable youtube play', 0, 0, '', '', 'disable'
			local_filename = '/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/pics/novideo.png'
			self.matchlist.append(youtubeentry(match, local_filename, self.zoomfactor, self.size, self.vidurl))

		else:
			logger.error('YoutubeSearchScreen]getYoutubeSearchCallback]No url found, write result to /tmp/result')
			with open ('/tmp/youtube_error_url.result', 'wb') as f:
				f.write(html)
			self['headertext'].setText('Nothing found...')
			return
			
		html=None
		
		self['resultlist'].setList(self.matchlist)
		lenurllist=len(self.matchlist)
		if lenurllist:
			self['headertext'].setText('{} videos -> {}'.format(lenurllist, self.searchterm))
		else:
			self['headertext'].setText("No videos found, press yellow key for edit search")


	def decodeImage(self, data):
		anz_paddings = (len(data) % 3)+1
		if anz_paddings > 1:
			data += b'=' * anz_paddings
		try:
			data=base64_decodestring(data)
			return data
		except:
			logger.exception('YoutubeSearchScreen]decodeImage]data:{}'.format(data))
			try:
				data=base64_b64decode(data, "/ ")
			except:
				logger.exception('YoutubeSearchScreen]decodeImage]data:{}'.format(data))			
			
			return None


	def getYoutubeSearchErrback(self, error, jobname):
		logger.error('YoutubeSearchScreen]getYoutubeSearchErrback]{} -> {}'.format(jobname, error))
		self['headertext'].setText('error->{} ->{}'.format(jobname, error))


	def bluePressed(self):
		logger.debug('YoutubeSearchScreen]bluePressed]...')