# -*- coding: UTF-8 -*-

#  Music Center E2
#
#  Coded by bobo71 (c) 2014
#  Support: www.dreambox-tools.info
#
#  All Files of this Software are licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported
#  License if not stated otherwise in a Files Head. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

#  Additionally, this plugin may only be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#  This applies to the source code as a whole as well as to parts of it, unless
#  explicitely stated otherwise.


from Plugins.Plugin import PluginDescriptor
from Components.config import config, ConfigYesNo, ConfigSubsection, ConfigInteger, ConfigDirectory, ConfigSelection, ConfigText, NoSave, ConfigNothing, ConfigSelectionNumber
from myLogger import logger, setLogLevel
from Tools.HardwareInfo import HardwareInfo



config.plugins.musiccenter=ConfigSubsection()
config.plugins.musiccenter.useartistart=ConfigYesNo(default=True)
config.plugins.musiccenter.addcoverautotosong=ConfigYesNo(default=True)
config.plugins.musiccenter.musiccenterextendedpluginlist=ConfigYesNo(default=True)
config.plugins.musiccenter.defaultfilebrowserpath=ConfigDirectory(default="/media/hdd/")
config.plugins.musiccenter.rememberlastfilebrowserpath=ConfigYesNo(default=True)
config.plugins.musiccenter.musiccentermainmenu=ConfigYesNo(default=True)
config.plugins.musiccenter.setdebug=ConfigSelection(default="error", choices=[("off",_("off")), ("error",_("error")), ("info",_("info")), ("debug",_("debug"))])
config.plugins.musiccenter.copydestin=ConfigText(default="/")
config.plugins.musiccenter.lastusedpath=ConfigText(default="/media/")
config.plugins.musiccenter.ytcachedir = ConfigDirectory(default="/media/hdd/")

# streamripper
config.plugins.musiccenter.minmp3streamingrate=ConfigSelection(default="0", choices=[("0",_("All")), ("64",_(">= 64 kbps")), ("96",_(">= 96 kbps")), ("128",_(">= 128 kbps")), ("160",_(">= 160 kbps")), ("192",_(">= 192 kbps")), ("256",_(">= 256 kbps"))])
config.plugins.musiccenter.minaacstreamingrate=ConfigSelection(default="0", choices=[("0",_("All")), ("64",_(">= 64 kbps")), ("96",_(">= 96 kbps")), ("128",_(">= 128 kbps")), ("160",_(">= 160 kbps")), ("192",_(">= 192 kbps")), ("256",_(">= 256 kbps"))])
config.plugins.musiccenter.minwmastreamingrate=ConfigSelection(default="0", choices=[("0",_("All")), ("64",_(">= 64 kbps")), ("96",_(">= 96 kbps")), ("128",_(">= 128 kbps")), ("160",_(">= 160 kbps")), ("192",_(">= 192 kbps")), ("256",_(">= 256 kbps"))])
config.plugins.musiccenter.streamripper_base_directory=ConfigDirectory(default="/media/hdd/streamripper/")
config.plugins.musiccenter.streamripper_addsequencenumber_on_outputfile=ConfigSelection(default="no", choices=[("no",_("No")), ("counter",_("Counter")), ("date_and_counter",_("Date and counter"))])
config.plugins.musiccenter.use_different_streamripper_useragent_for_rip=ConfigYesNo(default=False)
config.plugins.musiccenter.different_streamripper_useragent=ConfigText(default='SimplePlayer/1.x', fixed_size=False)
config.plugins.musiccenter.streamripper_check_for_dublicates=ConfigYesNo(default=True)
config.plugins.musiccenter.streamripper_save_dublicates=ConfigYesNo(default=False)
#soundcloud
config.plugins.musiccenter.sc_downloadfolder=ConfigDirectory(default="/media/hdd/")
config.plugins.musiccenter.sc_search= NoSave(ConfigText(default='Searchword', fixed_size=False))
config.plugins.musiccenter.sc_username=ConfigText(default="username", fixed_size=False)
config.plugins.musiccenter.sc_password=ConfigText(default="password", fixed_size=False)
config.plugins.musiccenter.sc_autoloadnextfeeds=ConfigYesNo(default=True)
config.plugins.musiccenter.downloadcache=ConfigDirectory(default="/media/hdd/")
config.plugins.musiccenter.playcountertriggerprozent=ConfigSelection(default="33", choices=[("10",_("10")), ("25",_("25%")), ("33",_("33%")), ("50",_("50%")), ("66",_("66%")), ("75",_("75%")), ("90",_("90%")), ("100",_("100%"))])
config.plugins.musiccenter.playcountertriggertime=ConfigInteger(5, limits=(1, 20))
config.plugins.musiccenter.openHelp=ConfigNothing()
config.plugins.musiccenter.ytresolver = ConfigSelection(default="intern", choices=[("intern",_("intern")), ("mediaportal",_("mediaportal"))])
config.plugins.musiccenter.databasepath=ConfigDirectory(default="/etc/enigma2/")
config.plugins.musiccenter.songliststyle=ConfigSelection(choices = [("list", _("list")), ("2dlist", _("2D Coverflow")), ("coverwall", _("Coverwall"))], default = "list")
config.plugins.musiccenter.fake=NoSave(ConfigText(default=''))
config.plugins.musiccenter.autodatabasescan=ConfigYesNo(default=True)

config.plugins.musiccenter.visualization = ConfigSubsection()
config.plugins.musiccenter.visualization.rms=ConfigYesNo(default=True)
config.plugins.musiccenter.visualization.roundcover=ConfigYesNo(default=False)
config.plugins.musiccenter.visualization.spectrum_small=ConfigYesNo(default=False)


config.plugins.musiccenter.pixabay = ConfigSubsection()
config.plugins.musiccenter.pixabay.starttime = ConfigInteger(15, limits=(0, 60))#, wraparound=True)
config.plugins.musiccenter.pixabay.movetime = ConfigSelectionNumber(5, 30, 5, default=10, wraparound=True)
config.plugins.musiccenter.pixabay.fadetime = ConfigSelectionNumber(1, 5, 1, default=3, wraparound=True)
# suche gloabl
config.plugins.musiccenter.searchname= NoSave(ConfigText(default='word', fixed_size=False))



from Globals import JCcheckModuleIsUpdated
from enigma import addFont

try:
	logger.info('plugin.py]addFont]try first...')
	addFont('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf', 'SansReg', 100, False) #

except Exception as ex:
	logger.error('plugin.py]addFont]exception:{}'.format(ex))
	addFont('/usr/lib/enigma2/python/Plugins/Extensions/MusicCenter/fonts/sans.ttf', 'SansReg', 100, False, 0)


import MusicCenter


def musiccenterstart(session, **kwargs):
 
	try:
		if JCcheckModuleIsUpdated('MusicCenter'):
			logger.info('plugin.py]musiccenterstart]reload MusicCenter Module')
			reload(MusicCenter)

		if kwargs.has_key("servicelist"):
			servicelist = kwargs["servicelist"]
		else:
			from Screens.InfoBar import InfoBar
			servicelist = InfoBar.instance.servicelist

		logger.info('plugin.py]musiccenterstart]call MusicCenterMain')
		session.open(MusicCenter.MusicCenterMain, servicelist)
		
	except Exception, e:
		print 'musiccenterstart]plugin] Function Error:{}'.format(e)
		logger.error('musiccenterstart]plugin] Function Error:{}'.format(e))
		
		from Screens.MessageBox import MessageBox
		session.open(MessageBox, _("Error MusicCenter\n{}".format(e)), type=MessageBox.TYPE_ERROR)


def menu_musiccenter(menuid, **kwargs):
	if menuid == "mainmenu":
		return [(_("MusicCenter"), musiccenterstart, "Dreambox Multi Music Player", 30)]
		
	return []


# Autostart
def autostart(reason, **kwargs):

	print 'MusicCenter set loggerlevel:{}'.format(config.plugins.musiccenter.setdebug.value)
	setLogLevel(logger)

	from JobCenter import databaseScannerTimer

	if reason == 0:#start
		logger.info('plugin]autostart]start databaseScannerTimer')
		databaseScannerTimer.start()
		
	elif reason == 1:# shutdown
		from StreamRipper import streamripperinstance
		logger.info('plugin]autostart]reason 1 -> check  streamripperinstance isRunning...')
		if streamripperinstance.isRunning:
			logger.info('plugin]autostart]streamripperinstance kill...')
			streamripperinstance.shutdown()
		streamripperinstance = None
		
		databaseScannerTimer.stop()
		logger.info('plugin]autostart]databaseScannerTimer.stop...')
		databaseScannerTimer = None

		
def Plugins(**kwargs):

	list = [PluginDescriptor(name = "MusicCenter",description=_("Dreambox Multi Music Player"), where=[PluginDescriptor.WHERE_PLUGINMENU], icon="pics/MusicCenter.png", fnc = musiccenterstart)]
	list.append(PluginDescriptor(name = "MusicCenter", where = [PluginDescriptor.WHERE_AUTOSTART], fnc = autostart))
	
	if config.plugins.musiccenter.musiccenterextendedpluginlist.value:
		list.append(PluginDescriptor(name="MusicCenter", description=_("Dreambox Multi Music Player"), where=[PluginDescriptor.WHERE_EXTENSIONSMENU], fnc = musiccenterstart))
		
	if config.plugins.musiccenter.musiccentermainmenu.value:
		list.append(PluginDescriptor(name="MusicCenter", description=_("Dreambox Multi Music Player"), where=[PluginDescriptor.WHERE_MENU], fnc = menu_musiccenter))
		
	return list
